/**
 * vis-timeline - timeline-graph2d
 * https://github.com/visjs/vis-timeline
 *
 * Create a fully customizable, interactive timeline with items and ranges.
 *
 * @version 0.0.0-no-version
 * @date    2019-11-08T14:16:29Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2018-2019 visjs contributors, https://github.com/visjs
 *
 * @license 
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function i(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function n(t,e){return t(e={exports:{}},e.exports),e.exports}var r,o,s,a="object",h=function(t){return t&&t.Math==Math&&t},l=h(typeof globalThis==a&&globalThis)||h(typeof window==a&&window)||h(typeof self==a&&self)||h(typeof e==a&&e)||Function("return this")(),u=function(t){try{return!!t()}catch(t){return!0}},d=!u((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),c={}.propertyIsEnumerable,f=Object.getOwnPropertyDescriptor,p={f:f&&!c.call({1:2},1)?function(t){var e=f(this,t);return!!e&&e.enumerable}:c},m=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},g={}.toString,v=function(t){return g.call(t).slice(8,-1)},y="".split,_=u((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==v(t)?y.call(t,""):Object(t)}:Object,b=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},w=function(t){return _(b(t))},k=function(t){return"object"==typeof t?null!==t:"function"==typeof t},D=function(t,e){if(!k(t))return t;var i,n;if(e&&"function"==typeof(i=t.toString)&&!k(n=i.call(t)))return n;if("function"==typeof(i=t.valueOf)&&!k(n=i.call(t)))return n;if(!e&&"function"==typeof(i=t.toString)&&!k(n=i.call(t)))return n;throw TypeError("Can't convert object to primitive value")},S={}.hasOwnProperty,x=function(t,e){return S.call(t,e)},M=l.document,T=k(M)&&k(M.createElement),O=function(t){return T?M.createElement(t):{}},C=!d&&!u((function(){return 7!=Object.defineProperty(O("div"),"a",{get:function(){return 7}}).a})),E=Object.getOwnPropertyDescriptor,Y={f:d?E:function(t,e){if(t=w(t),e=D(e,!0),C)try{return E(t,e)}catch(t){}if(x(t,e))return m(!p.f.call(t,e),t[e])}},P=function(t){if(!k(t))throw TypeError(String(t)+" is not an object");return t},I=Object.defineProperty,A={f:d?I:function(t,e,i){if(P(t),e=D(e,!0),P(i),C)try{return I(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},L=d?function(t,e,i){return A.f(t,e,m(1,i))}:function(t,e,i){return t[e]=i,t},N=function(t,e){try{L(l,t,e)}catch(i){l[t]=e}return e},R=n((function(t){var e=l["__core-js_shared__"]||N("__core-js_shared__",{});(t.exports=function(t,i){return e[t]||(e[t]=void 0!==i?i:{})})("versions",[]).push({version:"3.2.1",mode:"global",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})})),j=R("native-function-to-string",Function.toString),F=l.WeakMap,H="function"==typeof F&&/native code/.test(j.call(F)),W=0,G=Math.random(),U=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++W+G).toString(36)},z=R("keys"),V=function(t){return z[t]||(z[t]=U(t))},B={},X=l.WeakMap;if(H){var q=new X,Z=q.get,$=q.has,J=q.set;r=function(t,e){return J.call(q,t,e),e},o=function(t){return Z.call(q,t)||{}},s=function(t){return $.call(q,t)}}else{var K=V("state");B[K]=!0,r=function(t,e){return L(t,K,e),e},o=function(t){return x(t,K)?t[K]:{}},s=function(t){return x(t,K)}}var Q={set:r,get:o,has:s,enforce:function(t){return s(t)?o(t):r(t,{})},getterFor:function(t){return function(e){var i;if(!k(e)||(i=o(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},tt=n((function(t){var e=Q.get,i=Q.enforce,n=String(j).split("toString");R("inspectSource",(function(t){return j.call(t)})),(t.exports=function(t,e,r,o){var s=!!o&&!!o.unsafe,a=!!o&&!!o.enumerable,h=!!o&&!!o.noTargetGet;"function"==typeof r&&("string"!=typeof e||x(r,"name")||L(r,"name",e),i(r).source=n.join("string"==typeof e?e:"")),t!==l?(s?!h&&t[e]&&(a=!0):delete t[e],a?t[e]=r:L(t,e,r)):a?t[e]=r:N(e,r)})(Function.prototype,"toString",(function(){return"function"==typeof this&&e(this).source||j.call(this)}))})),et=l,it=function(t){return"function"==typeof t?t:void 0},nt=function(t,e){return arguments.length<2?it(et[t])||it(l[t]):et[t]&&et[t][e]||l[t]&&l[t][e]},rt=Math.ceil,ot=Math.floor,st=function(t){return isNaN(t=+t)?0:(t>0?ot:rt)(t)},at=Math.min,ht=function(t){return t>0?at(st(t),9007199254740991):0},lt=Math.max,ut=Math.min,dt=function(t,e){var i=st(t);return i<0?lt(i+e,0):ut(i,e)},ct=function(t){return function(e,i,n){var r,o=w(e),s=ht(o.length),a=dt(n,s);if(t&&i!=i){for(;s>a;)if((r=o[a++])!=r)return!0}else for(;s>a;a++)if((t||a in o)&&o[a]===i)return t||a||0;return!t&&-1}},ft={includes:ct(!0),indexOf:ct(!1)},pt=ft.indexOf,mt=function(t,e){var i,n=w(t),r=0,o=[];for(i in n)!x(B,i)&&x(n,i)&&o.push(i);for(;e.length>r;)x(n,i=e[r++])&&(~pt(o,i)||o.push(i));return o},gt=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],vt=gt.concat("length","prototype"),yt={f:Object.getOwnPropertyNames||function(t){return mt(t,vt)}},_t={f:Object.getOwnPropertySymbols},bt=nt("Reflect","ownKeys")||function(t){var e=yt.f(P(t)),i=_t.f;return i?e.concat(i(t)):e},wt=function(t,e){for(var i=bt(e),n=A.f,r=Y.f,o=0;o<i.length;o++){var s=i[o];x(t,s)||n(t,s,r(e,s))}},kt=/#|\.prototype\./,Dt=function(t,e){var i=xt[St(t)];return i==Tt||i!=Mt&&("function"==typeof e?u(e):!!e)},St=Dt.normalize=function(t){return String(t).replace(kt,".").toLowerCase()},xt=Dt.data={},Mt=Dt.NATIVE="N",Tt=Dt.POLYFILL="P",Ot=Dt,Ct=Y.f,Et=function(t,e){var i,n,r,o,s,a=t.target,h=t.global,u=t.stat;if(i=h?l:u?l[a]||N(a,{}):(l[a]||{}).prototype)for(n in e){if(o=e[n],r=t.noTargetGet?(s=Ct(i,n))&&s.value:i[n],!Ot(h?n:a+(u?".":"#")+n,t.forced)&&void 0!==r){if(typeof o==typeof r)continue;wt(o,r)}(t.sham||r&&r.sham)&&L(o,"sham",!0),tt(i,n,o,t)}},Yt=!!Object.getOwnPropertySymbols&&!u((function(){return!String(Symbol())})),Pt=Array.isArray||function(t){return"Array"==v(t)},It=function(t){return Object(b(t))},At=Object.keys||function(t){return mt(t,gt)},Lt=d?Object.defineProperties:function(t,e){P(t);for(var i,n=At(e),r=n.length,o=0;r>o;)A.f(t,i=n[o++],e[i]);return t},Nt=nt("document","documentElement"),Rt=V("IE_PROTO"),jt=function(){},Ft=function(){var t,e=O("iframe"),i=gt.length;for(e.style.display="none",Nt.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write("<script>document.F=Object<\/script>"),t.close(),Ft=t.F;i--;)delete Ft.prototype[gt[i]];return Ft()},Ht=Object.create||function(t,e){var i;return null!==t?(jt.prototype=P(t),i=new jt,jt.prototype=null,i[Rt]=t):i=Ft(),void 0===e?i:Lt(i,e)};B[Rt]=!0;var Wt=yt.f,Gt={}.toString,Ut="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],zt={f:function(t){return Ut&&"[object Window]"==Gt.call(t)?function(t){try{return Wt(t)}catch(t){return Ut.slice()}}(t):Wt(w(t))}},Vt=l.Symbol,Bt=R("wks"),Xt=function(t){return Bt[t]||(Bt[t]=Yt&&Vt[t]||(Yt?Vt:U)("Symbol."+t))},qt={f:Xt},Zt=A.f,$t=function(t){var e=et.Symbol||(et.Symbol={});x(e,t)||Zt(e,t,{value:qt.f(t)})},Jt=A.f,Kt=Xt("toStringTag"),Qt=function(t,e,i){t&&!x(t=i?t:t.prototype,Kt)&&Jt(t,Kt,{configurable:!0,value:e})},te=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},ee=function(t,e,i){if(te(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,n){return t.call(e,i,n)};case 3:return function(i,n,r){return t.call(e,i,n,r)}}return function(){return t.apply(e,arguments)}},ie=Xt("species"),ne=function(t,e){var i;return Pt(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!Pt(i.prototype)?k(i)&&null===(i=i[ie])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},re=[].push,oe=function(t){var e=1==t,i=2==t,n=3==t,r=4==t,o=6==t,s=5==t||o;return function(a,h,l,u){for(var d,c,f=It(a),p=_(f),m=ee(h,l,3),g=ht(p.length),v=0,y=u||ne,b=e?y(a,g):i?y(a,0):void 0;g>v;v++)if((s||v in p)&&(c=m(d=p[v],v,f),t))if(e)b[v]=c;else if(c)switch(t){case 3:return!0;case 5:return d;case 6:return v;case 2:re.call(b,d)}else if(r)return!1;return o?-1:n||r?r:b}},se={forEach:oe(0),map:oe(1),filter:oe(2),some:oe(3),every:oe(4),find:oe(5),findIndex:oe(6)},ae=se.forEach,he=V("hidden"),le=Xt("toPrimitive"),ue=Q.set,de=Q.getterFor("Symbol"),ce=Object.prototype,fe=l.Symbol,pe=l.JSON,me=pe&&pe.stringify,ge=Y.f,ve=A.f,ye=zt.f,_e=p.f,be=R("symbols"),we=R("op-symbols"),ke=R("string-to-symbol-registry"),De=R("symbol-to-string-registry"),Se=R("wks"),xe=l.QObject,Me=!xe||!xe.prototype||!xe.prototype.findChild,Te=d&&u((function(){return 7!=Ht(ve({},"a",{get:function(){return ve(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=ge(ce,e);n&&delete ce[e],ve(t,e,i),n&&t!==ce&&ve(ce,e,n)}:ve,Oe=function(t,e){var i=be[t]=Ht(fe.prototype);return ue(i,{type:"Symbol",tag:t,description:e}),d||(i.description=e),i},Ce=Yt&&"symbol"==typeof fe.iterator?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof fe},Ee=function(t,e,i){t===ce&&Ee(we,e,i),P(t);var n=D(e,!0);return P(i),x(be,n)?(i.enumerable?(x(t,he)&&t[he][n]&&(t[he][n]=!1),i=Ht(i,{enumerable:m(0,!1)})):(x(t,he)||ve(t,he,m(1,{})),t[he][n]=!0),Te(t,n,i)):ve(t,n,i)},Ye=function(t,e){P(t);var i=w(e),n=At(i).concat(Le(i));return ae(n,(function(e){d&&!Pe.call(i,e)||Ee(t,e,i[e])})),t},Pe=function(t){var e=D(t,!0),i=_e.call(this,e);return!(this===ce&&x(be,e)&&!x(we,e))&&(!(i||!x(this,e)||!x(be,e)||x(this,he)&&this[he][e])||i)},Ie=function(t,e){var i=w(t),n=D(e,!0);if(i!==ce||!x(be,n)||x(we,n)){var r=ge(i,n);return!r||!x(be,n)||x(i,he)&&i[he][n]||(r.enumerable=!0),r}},Ae=function(t){var e=ye(w(t)),i=[];return ae(e,(function(t){x(be,t)||x(B,t)||i.push(t)})),i},Le=function(t){var e=t===ce,i=ye(e?we:w(t)),n=[];return ae(i,(function(t){!x(be,t)||e&&!x(ce,t)||n.push(be[t])})),n};Yt||(tt((fe=function(){if(this instanceof fe)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=U(t),i=function(t){this===ce&&i.call(we,t),x(this,he)&&x(this[he],e)&&(this[he][e]=!1),Te(this,e,m(1,t))};return d&&Me&&Te(ce,e,{configurable:!0,set:i}),Oe(e,t)}).prototype,"toString",(function(){return de(this).tag})),p.f=Pe,A.f=Ee,Y.f=Ie,yt.f=zt.f=Ae,_t.f=Le,d&&(ve(fe.prototype,"description",{configurable:!0,get:function(){return de(this).description}}),tt(ce,"propertyIsEnumerable",Pe,{unsafe:!0})),qt.f=function(t){return Oe(Xt(t),t)}),Et({global:!0,wrap:!0,forced:!Yt,sham:!Yt},{Symbol:fe}),ae(At(Se),(function(t){$t(t)})),Et({target:"Symbol",stat:!0,forced:!Yt},{for:function(t){var e=String(t);if(x(ke,e))return ke[e];var i=fe(e);return ke[e]=i,De[i]=e,i},keyFor:function(t){if(!Ce(t))throw TypeError(t+" is not a symbol");if(x(De,t))return De[t]},useSetter:function(){Me=!0},useSimple:function(){Me=!1}}),Et({target:"Object",stat:!0,forced:!Yt,sham:!d},{create:function(t,e){return void 0===e?Ht(t):Ye(Ht(t),e)},defineProperty:Ee,defineProperties:Ye,getOwnPropertyDescriptor:Ie}),Et({target:"Object",stat:!0,forced:!Yt},{getOwnPropertyNames:Ae,getOwnPropertySymbols:Le}),Et({target:"Object",stat:!0,forced:u((function(){_t.f(1)}))},{getOwnPropertySymbols:function(t){return _t.f(It(t))}}),pe&&Et({target:"JSON",stat:!0,forced:!Yt||u((function(){var t=fe();return"[null]"!=me([t])||"{}"!=me({a:t})||"{}"!=me(Object(t))}))},{stringify:function(t){for(var e,i,n=[t],r=1;arguments.length>r;)n.push(arguments[r++]);if(i=e=n[1],(k(e)||void 0!==t)&&!Ce(t))return Pt(e)||(e=function(t,e){if("function"==typeof i&&(e=i.call(this,t,e)),!Ce(e))return e}),n[1]=e,me.apply(pe,n)}}),fe.prototype[le]||L(fe.prototype,le,fe.prototype.valueOf),Qt(fe,"Symbol"),B[he]=!0;var Ne=A.f,Re=l.Symbol;if(d&&"function"==typeof Re&&(!("description"in Re.prototype)||void 0!==Re().description)){var je={},Fe=function(){var t=arguments.length<1||void 0===arguments[0]?void 0:String(arguments[0]),e=this instanceof Fe?new Re(t):void 0===t?Re():Re(t);return""===t&&(je[e]=!0),e};wt(Fe,Re);var He=Fe.prototype=Re.prototype;He.constructor=Fe;var We=He.toString,Ge="Symbol(test)"==String(Re("test")),Ue=/^Symbol\((.*)\)[^)]+$/;Ne(He,"description",{configurable:!0,get:function(){var t=k(this)?this.valueOf():this,e=We.call(t);if(x(je,t))return"";var i=Ge?e.slice(7,-1):e.replace(Ue,"$1");return""===i?void 0:i}}),Et({global:!0,forced:!0},{Symbol:Fe})}$t("iterator");var ze=function(t,e,i){var n=D(e);n in t?A.f(t,n,m(0,i)):t[n]=i},Ve=Xt("species"),Be=function(t){return!u((function(){var e=[];return(e.constructor={})[Ve]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Xe=Xt("isConcatSpreadable"),qe=!u((function(){var t=[];return t[Xe]=!1,t.concat()[0]!==t})),Ze=Be("concat"),$e=function(t){if(!k(t))return!1;var e=t[Xe];return void 0!==e?!!e:Pt(t)};Et({target:"Array",proto:!0,forced:!qe||!Ze},{concat:function(t){var e,i,n,r,o,s=It(this),a=ne(s,0),h=0;for(e=-1,n=arguments.length;e<n;e++)if(o=-1===e?s:arguments[e],$e(o)){if(h+(r=ht(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<r;i++,h++)i in o&&ze(a,h,o[i])}else{if(h>=9007199254740991)throw TypeError("Maximum allowed index exceeded");ze(a,h++,o)}return a.length=h,a}});var Je=se.filter;Et({target:"Array",proto:!0,forced:!Be("filter")},{filter:function(t){return Je(this,t,arguments.length>1?arguments[1]:void 0)}});var Ke=function(t,e){var i=[][t];return!i||!u((function(){i.call(null,e||function(){throw 1},1)}))},Qe=se.forEach,ti=Ke("forEach")?function(t){return Qe(this,t,arguments.length>1?arguments[1]:void 0)}:[].forEach;Et({target:"Array",proto:!0,forced:[].forEach!=ti},{forEach:ti});var ei=function(t,e,i,n){try{return n?e(P(i)[0],i[1]):e(i)}catch(e){var r=t.return;throw void 0!==r&&P(r.call(t)),e}},ii={},ni=Xt("iterator"),ri=Array.prototype,oi=function(t){return void 0!==t&&(ii.Array===t||ri[ni]===t)},si=Xt("toStringTag"),ai="Arguments"==v(function(){return arguments}()),hi=function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),si))?i:ai?v(e):"Object"==(n=v(e))&&"function"==typeof e.callee?"Arguments":n},li=Xt("iterator"),ui=function(t){if(null!=t)return t[li]||t["@@iterator"]||ii[hi(t)]},di=Xt("iterator"),ci=!1;try{var fi=0,pi={next:function(){return{done:!!fi++}},return:function(){ci=!0}};pi[di]=function(){return this},Array.from(pi,(function(){throw 2}))}catch(t){}var mi=function(t,e){if(!e&&!ci)return!1;var i=!1;try{var n={};n[di]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i},gi=!mi((function(t){Array.from(t)}));Et({target:"Array",stat:!0,forced:gi},{from:function(t){var e,i,n,r,o=It(t),s="function"==typeof this?this:Array,a=arguments.length,h=a>1?arguments[1]:void 0,l=void 0!==h,u=0,d=ui(o);if(l&&(h=ee(h,a>2?arguments[2]:void 0,2)),null==d||s==Array&&oi(d))for(i=new s(e=ht(o.length));e>u;u++)ze(i,u,l?h(o[u],u):o[u]);else for(r=d.call(o),i=new s;!(n=r.next()).done;u++)ze(i,u,l?ei(r,h,[n.value,u],!0):n.value);return i.length=u,i}});var vi=ft.indexOf,yi=[].indexOf,_i=!!yi&&1/[1].indexOf(1,-0)<0,bi=Ke("indexOf");Et({target:"Array",proto:!0,forced:_i||bi},{indexOf:function(t){return _i?yi.apply(this,arguments)||0:vi(this,t,arguments.length>1?arguments[1]:void 0)}});var wi=Xt("unscopables"),ki=Array.prototype;null==ki[wi]&&L(ki,wi,Ht(null));var Di,Si,xi,Mi=function(t){ki[wi][t]=!0},Ti=!u((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Oi=V("IE_PROTO"),Ci=Object.prototype,Ei=Ti?Object.getPrototypeOf:function(t){return t=It(t),x(t,Oi)?t[Oi]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Ci:null},Yi=Xt("iterator"),Pi=!1;[].keys&&("next"in(xi=[].keys())?(Si=Ei(Ei(xi)))!==Object.prototype&&(Di=Si):Pi=!0),null==Di&&(Di={}),x(Di,Yi)||L(Di,Yi,(function(){return this}));var Ii={IteratorPrototype:Di,BUGGY_SAFARI_ITERATORS:Pi},Ai=Ii.IteratorPrototype,Li=function(){return this},Ni=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return P(i),function(t){if(!k(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(i,n):i.__proto__=n,i}}():void 0),Ri=Ii.IteratorPrototype,ji=Ii.BUGGY_SAFARI_ITERATORS,Fi=Xt("iterator"),Hi=function(){return this},Wi=function(t,e,i,n,r,o,s){!function(t,e,i){var n=e+" Iterator";t.prototype=Ht(Ai,{next:m(1,i)}),Qt(t,n,!1),ii[n]=Li}(i,e,n);var a,h,l,u=function(t){if(t===r&&g)return g;if(!ji&&t in f)return f[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},d=e+" Iterator",c=!1,f=t.prototype,p=f[Fi]||f["@@iterator"]||r&&f[r],g=!ji&&p||u(r),v="Array"==e&&f.entries||p;if(v&&(a=Ei(v.call(new t)),Ri!==Object.prototype&&a.next&&(Ei(a)!==Ri&&(Ni?Ni(a,Ri):"function"!=typeof a[Fi]&&L(a,Fi,Hi)),Qt(a,d,!0))),"values"==r&&p&&"values"!==p.name&&(c=!0,g=function(){return p.call(this)}),f[Fi]!==g&&L(f,Fi,g),ii[e]=g,r)if(h={values:u("values"),keys:o?g:u("keys"),entries:u("entries")},s)for(l in h)!ji&&!c&&l in f||tt(f,l,h[l]);else Et({target:e,proto:!0,forced:ji||c},h);return h},Gi=Q.set,Ui=Q.getterFor("Array Iterator"),zi=Wi(Array,"Array",(function(t,e){Gi(this,{type:"Array Iterator",target:w(t),index:0,kind:e})}),(function(){var t=Ui(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:n,done:!1}:"values"==i?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");ii.Arguments=ii.Array,Mi("keys"),Mi("values"),Mi("entries");var Vi=[].join,Bi=_!=Object,Xi=Ke("join",",");Et({target:"Array",proto:!0,forced:Bi||Xi},{join:function(t){return Vi.call(w(this),void 0===t?",":t)}});var qi=se.map;Et({target:"Array",proto:!0,forced:!Be("map")},{map:function(t){return qi(this,t,arguments.length>1?arguments[1]:void 0)}});var Zi=Xt("species"),$i=[].slice,Ji=Math.max;Et({target:"Array",proto:!0,forced:!Be("slice")},{slice:function(t,e){var i,n,r,o=w(this),s=ht(o.length),a=dt(t,s),h=dt(void 0===e?s:e,s);if(Pt(o)&&("function"!=typeof(i=o.constructor)||i!==Array&&!Pt(i.prototype)?k(i)&&null===(i=i[Zi])&&(i=void 0):i=void 0,i===Array||void 0===i))return $i.call(o,a,h);for(n=new(void 0===i?Array:i)(Ji(h-a,0)),r=0;a<h;a++,r++)a in o&&ze(n,r,o[a]);return n.length=r,n}});var Ki=se.some;Et({target:"Array",proto:!0,forced:Ke("some")},{some:function(t){return Ki(this,t,arguments.length>1?arguments[1]:void 0)}});var Qi=[].sort,tn=[1,2,3],en=u((function(){tn.sort(void 0)})),nn=u((function(){tn.sort(null)})),rn=Ke("sort");Et({target:"Array",proto:!0,forced:en||!nn||rn},{sort:function(t){return void 0===t?Qi.call(It(this)):Qi.call(It(this),te(t))}});var on,sn=A.f,an=l.DataView,hn=an&&an.prototype,ln=l.Int8Array,un=ln&&ln.prototype,dn=l.Uint8ClampedArray,cn=dn&&dn.prototype,fn=ln&&Ei(ln),pn=un&&Ei(un),mn=Object.prototype,gn=mn.isPrototypeOf,vn=Xt("toStringTag"),yn=U("TYPED_ARRAY_TAG"),_n=!(!l.ArrayBuffer||!an),bn=_n&&!!Ni&&"Opera"!==hi(l.opera),wn=!1,kn={Int8Array:1,Uint8Array:1,Uint8ClampedArray:1,Int16Array:2,Uint16Array:2,Int32Array:4,Uint32Array:4,Float32Array:4,Float64Array:8},Dn=function(t){return k(t)&&x(kn,hi(t))};for(on in kn)l[on]||(bn=!1);if((!bn||"function"!=typeof fn||fn===Function.prototype)&&(fn=function(){throw TypeError("Incorrect invocation")},bn))for(on in kn)l[on]&&Ni(l[on],fn);if((!bn||!pn||pn===mn)&&(pn=fn.prototype,bn))for(on in kn)l[on]&&Ni(l[on].prototype,pn);if(bn&&Ei(cn)!==pn&&Ni(cn,pn),d&&!x(pn,vn))for(on in wn=!0,sn(pn,vn,{get:function(){return k(this)?this[yn]:void 0}}),kn)l[on]&&L(l[on],yn,on);_n&&Ni&&Ei(hn)!==mn&&Ni(hn,mn);var Sn={NATIVE_ARRAY_BUFFER:_n,NATIVE_ARRAY_BUFFER_VIEWS:bn,TYPED_ARRAY_TAG:wn&&yn,aTypedArray:function(t){if(Dn(t))return t;throw TypeError("Target is not a typed array")},aTypedArrayConstructor:function(t){if(Ni){if(gn.call(fn,t))return t}else for(var e in kn)if(x(kn,on)){var i=l[e];if(i&&(t===i||gn.call(i,t)))return t}throw TypeError("Target is not a typed array constructor")},exportProto:function(t,e,i){if(d){if(i)for(var n in kn){var r=l[n];r&&x(r.prototype,t)&&delete r.prototype[t]}pn[t]&&!i||tt(pn,t,i?e:bn&&un[t]||e)}},exportStatic:function(t,e,i){var n,r;if(d){if(Ni){if(i)for(n in kn)(r=l[n])&&x(r,t)&&delete r[t];if(fn[t]&&!i)return;try{return tt(fn,t,i?e:bn&&ln[t]||e)}catch(t){}}for(n in kn)!(r=l[n])||r[t]&&!i||tt(r,t,e)}},isView:function(t){var e=hi(t);return"DataView"===e||x(kn,e)},isTypedArray:Dn,TypedArray:fn,TypedArrayPrototype:pn},xn=function(t,e,i){for(var n in e)tt(t,n,e[n],i);return t},Mn=function(t,e,i){if(!(t instanceof e))throw TypeError("Incorrect "+(i?i+" ":"")+"invocation");return t},Tn=function(t){if(void 0===t)return 0;var e=st(t),i=ht(e);if(e!==i)throw RangeError("Wrong length or index");return i},On=function(t){for(var e=It(this),i=ht(e.length),n=arguments.length,r=dt(n>1?arguments[1]:void 0,i),o=n>2?arguments[2]:void 0,s=void 0===o?i:dt(o,i);s>r;)e[r++]=t;return e},Cn=n((function(t,e){var i=Sn.NATIVE_ARRAY_BUFFER,n=yt.f,r=A.f,o=Q.get,s=Q.set,a=l.ArrayBuffer,h=a,c=l.DataView,f=l.Math,p=l.RangeError,m=f.abs,g=f.pow,v=f.floor,y=f.log,_=f.LN2,b=function(t,e,i){var n,r,o,s=new Array(i),a=8*i-e-1,h=(1<<a)-1,l=h>>1,u=23===e?g(2,-24)-g(2,-77):0,d=t<0||0===t&&1/t<0?1:0,c=0;for((t=m(t))!=t||t===1/0?(r=t!=t?1:0,n=h):(n=v(y(t)/_),t*(o=g(2,-n))<1&&(n--,o*=2),(t+=n+l>=1?u/o:u*g(2,1-l))*o>=2&&(n++,o/=2),n+l>=h?(r=0,n=h):n+l>=1?(r=(t*o-1)*g(2,e),n+=l):(r=t*g(2,l-1)*g(2,e),n=0));e>=8;s[c++]=255&r,r/=256,e-=8);for(n=n<<e|r,a+=e;a>0;s[c++]=255&n,n/=256,a-=8);return s[--c]|=128*d,s},w=function(t,e){var i,n=t.length,r=8*n-e-1,o=(1<<r)-1,s=o>>1,a=r-7,h=n-1,l=t[h--],u=127&l;for(l>>=7;a>0;u=256*u+t[h],h--,a-=8);for(i=u&(1<<-a)-1,u>>=-a,a+=e;a>0;i=256*i+t[h],h--,a-=8);if(0===u)u=1-s;else{if(u===o)return i?NaN:l?-1/0:1/0;i+=g(2,e),u-=s}return(l?-1:1)*i*g(2,u-e)},k=function(t){return t[3]<<24|t[2]<<16|t[1]<<8|t[0]},D=function(t){return[255&t]},S=function(t){return[255&t,t>>8&255]},x=function(t){return[255&t,t>>8&255,t>>16&255,t>>24&255]},M=function(t){return b(t,23,4)},T=function(t){return b(t,52,8)},O=function(t,e){r(t.prototype,e,{get:function(){return o(this)[e]}})},C=function(t,e,i,n){var r=Tn(+i),s=o(t);if(r+e>s.byteLength)throw p("Wrong index");var a=o(s.buffer).bytes,h=r+s.byteOffset,l=a.slice(h,h+e);return n?l:l.reverse()},E=function(t,e,i,n,r,s){var a=Tn(+i),h=o(t);if(a+e>h.byteLength)throw p("Wrong index");for(var l=o(h.buffer).bytes,u=a+h.byteOffset,d=n(+r),c=0;c<e;c++)l[u+c]=d[s?c:e-c-1]};if(i){if(!u((function(){a(1)}))||!u((function(){new a(-1)}))||u((function(){return new a,new a(1.5),new a(NaN),"ArrayBuffer"!=a.name}))){for(var Y,P=(h=function(t){return Mn(this,h),new a(Tn(t))}).prototype=a.prototype,I=n(a),N=0;I.length>N;)(Y=I[N++])in h||L(h,Y,a[Y]);P.constructor=h}var R=new c(new h(2)),j=c.prototype.setInt8;R.setInt8(0,2147483648),R.setInt8(1,2147483649),!R.getInt8(0)&&R.getInt8(1)||xn(c.prototype,{setInt8:function(t,e){j.call(this,t,e<<24>>24)},setUint8:function(t,e){j.call(this,t,e<<24>>24)}},{unsafe:!0})}else h=function(t){Mn(this,h,"ArrayBuffer");var e=Tn(t);s(this,{bytes:On.call(new Array(e),0),byteLength:e}),d||(this.byteLength=e)},c=function(t,e,i){Mn(this,c,"DataView"),Mn(t,h,"DataView");var n=o(t).byteLength,r=st(e);if(r<0||r>n)throw p("Wrong offset");if(r+(i=void 0===i?n-r:ht(i))>n)throw p("Wrong length");s(this,{buffer:t,byteLength:i,byteOffset:r}),d||(this.buffer=t,this.byteLength=i,this.byteOffset=r)},d&&(O(h,"byteLength"),O(c,"buffer"),O(c,"byteLength"),O(c,"byteOffset")),xn(c.prototype,{getInt8:function(t){return C(this,1,t)[0]<<24>>24},getUint8:function(t){return C(this,1,t)[0]},getInt16:function(t){var e=C(this,2,t,arguments.length>1?arguments[1]:void 0);return(e[1]<<8|e[0])<<16>>16},getUint16:function(t){var e=C(this,2,t,arguments.length>1?arguments[1]:void 0);return e[1]<<8|e[0]},getInt32:function(t){return k(C(this,4,t,arguments.length>1?arguments[1]:void 0))},getUint32:function(t){return k(C(this,4,t,arguments.length>1?arguments[1]:void 0))>>>0},getFloat32:function(t){return w(C(this,4,t,arguments.length>1?arguments[1]:void 0),23)},getFloat64:function(t){return w(C(this,8,t,arguments.length>1?arguments[1]:void 0),52)},setInt8:function(t,e){E(this,1,t,D,e)},setUint8:function(t,e){E(this,1,t,D,e)},setInt16:function(t,e){E(this,2,t,S,e,arguments.length>2?arguments[2]:void 0)},setUint16:function(t,e){E(this,2,t,S,e,arguments.length>2?arguments[2]:void 0)},setInt32:function(t,e){E(this,4,t,x,e,arguments.length>2?arguments[2]:void 0)},setUint32:function(t,e){E(this,4,t,x,e,arguments.length>2?arguments[2]:void 0)},setFloat32:function(t,e){E(this,4,t,M,e,arguments.length>2?arguments[2]:void 0)},setFloat64:function(t,e){E(this,8,t,T,e,arguments.length>2?arguments[2]:void 0)}});Qt(h,"ArrayBuffer"),Qt(c,"DataView"),e.ArrayBuffer=h,e.DataView=c})),En=Xt("species"),Yn=function(t,e){var i,n=P(t).constructor;return void 0===n||null==(i=P(n)[En])?e:te(i)},Pn=Cn.ArrayBuffer,In=Cn.DataView,An=Pn.prototype.slice,Ln=u((function(){return!new Pn(2).slice(1,void 0).byteLength}));Et({target:"ArrayBuffer",proto:!0,unsafe:!0,forced:Ln},{slice:function(t,e){if(void 0!==An&&void 0===e)return An.call(P(this),t);for(var i=P(this).byteLength,n=dt(t,i),r=dt(void 0===e?i:e,i),o=new(Yn(this,Pn))(ht(r-n)),s=new In(this),a=new In(o),h=0;n<r;)a.setUint8(h++,s.getUint8(n++));return o}});var Nn="".repeat||function(t){var e=String(b(this)),i="",n=st(t);if(n<0||n==1/0)throw RangeError("Wrong number of repetitions");for(;n>0;(n>>>=1)&&(e+=e))1&n&&(i+=e);return i},Rn=Math.ceil,jn=function(t){return function(e,i,n){var r,o,s=String(b(e)),a=s.length,h=void 0===n?" ":String(n),l=ht(i);return l<=a||""==h?s:(r=l-a,(o=Nn.call(h,Rn(r/h.length))).length>r&&(o=o.slice(0,r)),t?s+o:o+s)}},Fn={start:jn(!1),end:jn(!0)}.start,Hn=Math.abs,Wn=Date.prototype,Gn=Wn.getTime,Un=Wn.toISOString,zn=u((function(){return"0385-07-25T07:06:39.999Z"!=Un.call(new Date(-5e13-1))}))||!u((function(){Un.call(new Date(NaN))}))?function(){if(!isFinite(Gn.call(this)))throw RangeError("Invalid time value");var t=this.getUTCFullYear(),e=this.getUTCMilliseconds(),i=t<0?"-":t>9999?"+":"";return i+Fn(Hn(t),i?6:4,0)+"-"+Fn(this.getUTCMonth()+1,2,0)+"-"+Fn(this.getUTCDate(),2,0)+"T"+Fn(this.getUTCHours(),2,0)+":"+Fn(this.getUTCMinutes(),2,0)+":"+Fn(this.getUTCSeconds(),2,0)+"."+Fn(e,3,0)+"Z"}:Un;Et({target:"Date",proto:!0,forced:Date.prototype.toISOString!==zn},{toISOString:zn});var Vn=u((function(){return null!==new Date(NaN).toJSON()||1!==Date.prototype.toJSON.call({toISOString:function(){return 1}})}));Et({target:"Date",proto:!0,forced:Vn},{toJSON:function(t){var e=It(this),i=D(e);return"number"!=typeof i||isFinite(i)?e.toISOString():null}});var Bn=Date.prototype,Xn=Bn.toString,qn=Bn.getTime;new Date(NaN)+""!="Invalid Date"&&tt(Bn,"toString",(function(){var t=qn.call(this);return t==t?Xn.call(this):"Invalid Date"}));var Zn=A.f,$n=Function.prototype,Jn=$n.toString,Kn=/^\s*function ([^ (]*)/;!d||"name"in $n||Zn($n,"name",{configurable:!0,get:function(){try{return Jn.call(this).match(Kn)[1]}catch(t){return""}}});var Qn=function(t,e,i){var n,r;return Ni&&"function"==typeof(n=e.constructor)&&n!==i&&k(r=n.prototype)&&r!==i.prototype&&Ni(t,r),t},tr="\t\n\v\f\r                　\u2028\u2029\ufeff",er="["+tr+"]",ir=RegExp("^"+er+er+"*"),nr=RegExp(er+er+"*$"),rr=function(t){return function(e){var i=String(b(e));return 1&t&&(i=i.replace(ir,"")),2&t&&(i=i.replace(nr,"")),i}},or={start:rr(1),end:rr(2),trim:rr(3)},sr=yt.f,ar=Y.f,hr=A.f,lr=or.trim,ur=l.Number,dr=ur.prototype,cr="Number"==v(Ht(dr)),fr=function(t){var e,i,n,r,o,s,a,h,l=D(t,!1);if("string"==typeof l&&l.length>2)if(43===(e=(l=lr(l)).charCodeAt(0))||45===e){if(88===(i=l.charCodeAt(2))||120===i)return NaN}else if(48===e){switch(l.charCodeAt(1)){case 66:case 98:n=2,r=49;break;case 79:case 111:n=8,r=55;break;default:return+l}for(s=(o=l.slice(2)).length,a=0;a<s;a++)if((h=o.charCodeAt(a))<48||h>r)return NaN;return parseInt(o,n)}return+l};if(Ot("Number",!ur(" 0o1")||!ur("0b1")||ur("+0x1"))){for(var pr,mr=function(t){var e=arguments.length<1?0:t,i=this;return i instanceof mr&&(cr?u((function(){dr.valueOf.call(i)})):"Number"!=v(i))?Qn(new ur(fr(e)),i,mr):fr(e)},gr=d?sr(ur):"MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,EPSILON,isFinite,isInteger,isNaN,isSafeInteger,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,parseFloat,parseInt,isInteger".split(","),vr=0;gr.length>vr;vr++)x(ur,pr=gr[vr])&&!x(mr,pr)&&hr(mr,pr,ar(ur,pr));mr.prototype=dr,dr.constructor=mr,tt(l,"Number",mr)}var yr=function(t){if("number"!=typeof t&&"Number"!=v(t))throw TypeError("Incorrect invocation");return+t},_r=1..toFixed,br=Math.floor,wr=function(t,e,i){return 0===e?i:e%2==1?wr(t,e-1,i*t):wr(t*t,e/2,i)},kr=_r&&("0.000"!==8e-5.toFixed(3)||"1"!==.9.toFixed(0)||"1.25"!==1.255.toFixed(2)||"1000000000000000128"!==(0xde0b6b3a7640080).toFixed(0))||!u((function(){_r.call({})}));Et({target:"Number",proto:!0,forced:kr},{toFixed:function(t){var e,i,n,r,o=yr(this),s=st(t),a=[0,0,0,0,0,0],h="",l="0",u=function(t,e){for(var i=-1,n=e;++i<6;)n+=t*a[i],a[i]=n%1e7,n=br(n/1e7)},d=function(t){for(var e=6,i=0;--e>=0;)i+=a[e],a[e]=br(i/t),i=i%t*1e7},c=function(){for(var t=6,e="";--t>=0;)if(""!==e||0===t||0!==a[t]){var i=String(a[t]);e=""===e?i:e+Nn.call("0",7-i.length)+i}return e};if(s<0||s>20)throw RangeError("Incorrect fraction digits");if(o!=o)return"NaN";if(o<=-1e21||o>=1e21)return String(o);if(o<0&&(h="-",o=-o),o>1e-21)if(i=(e=function(t){for(var e=0,i=t;i>=4096;)e+=12,i/=4096;for(;i>=2;)e+=1,i/=2;return e}(o*wr(2,69,1))-69)<0?o*wr(2,-e,1):o/wr(2,e,1),i*=4503599627370496,(e=52-e)>0){for(u(0,i),n=s;n>=7;)u(1e7,0),n-=7;for(u(wr(10,n,1),0),n=e-1;n>=23;)d(1<<23),n-=23;d(1<<n),u(1,1),d(2),l=c()}else u(0,i),u(1<<-e,0),l=c()+Nn.call("0",s);return l=s>0?h+((r=l.length)<=s?"0."+Nn.call("0",s-r)+l:l.slice(0,r-s)+"."+l.slice(r-s)):h+l}});var Dr=Object.assign,Sr=!Dr||u((function(){var t={},e={},i=Symbol();return t[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=Dr({},t)[i]||"abcdefghijklmnopqrst"!=At(Dr({},e)).join("")}))?function(t,e){for(var i=It(t),n=arguments.length,r=1,o=_t.f,s=p.f;n>r;)for(var a,h=_(arguments[r++]),l=o?At(h).concat(o(h)):At(h),u=l.length,c=0;u>c;)a=l[c++],d&&!s.call(h,a)||(i[a]=h[a]);return i}:Dr;Et({target:"Object",stat:!0,forced:Object.assign!==Sr},{assign:Sr}),Et({target:"Object",stat:!0,forced:!d,sham:!d},{defineProperties:Lt}),Et({target:"Object",stat:!0,forced:!d,sham:!d},{defineProperty:A.f});var xr=!u((function(){return Object.isExtensible(Object.preventExtensions({}))})),Mr=n((function(t){var e=A.f,i=U("meta"),n=0,r=Object.isExtensible||function(){return!0},o=function(t){e(t,i,{value:{objectID:"O"+ ++n,weakData:{}}})},s=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!k(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!x(t,i)){if(!r(t))return"F";if(!e)return"E";o(t)}return t[i].objectID},getWeakData:function(t,e){if(!x(t,i)){if(!r(t))return!0;if(!e)return!1;o(t)}return t[i].weakData},onFreeze:function(t){return xr&&s.REQUIRED&&r(t)&&!x(t,i)&&o(t),t}};B[i]=!0})),Tr=(Mr.REQUIRED,Mr.fastKey,Mr.getWeakData,Mr.onFreeze,Mr.onFreeze),Or=Object.freeze,Cr=u((function(){Or(1)}));Et({target:"Object",stat:!0,forced:Cr,sham:!xr},{freeze:function(t){return Or&&k(t)?Or(Tr(t)):t}});var Er=Y.f,Yr=u((function(){Er(1)}));Et({target:"Object",stat:!0,forced:!d||Yr,sham:!d},{getOwnPropertyDescriptor:function(t,e){return Er(w(t),e)}}),Et({target:"Object",stat:!0,sham:!d},{getOwnPropertyDescriptors:function(t){for(var e,i,n=w(t),r=Y.f,o=bt(n),s={},a=0;o.length>a;)void 0!==(i=r(n,e=o[a++]))&&ze(s,e,i);return s}});var Pr=zt.f,Ir=u((function(){return!Object.getOwnPropertyNames(1)}));Et({target:"Object",stat:!0,forced:Ir},{getOwnPropertyNames:Pr});var Ar=Object.isFrozen,Lr=u((function(){Ar(1)}));Et({target:"Object",stat:!0,forced:Lr},{isFrozen:function(t){return!k(t)||!!Ar&&Ar(t)}});var Nr=u((function(){At(1)}));Et({target:"Object",stat:!0,forced:Nr},{keys:function(t){return At(It(t))}});var Rr={};Rr[Xt("toStringTag")]="z";var jr="[object z]"!==String(Rr)?function(){return"[object "+hi(this)+"]"}:Rr.toString,Fr=Object.prototype;jr!==Fr.toString&&tt(Fr,"toString",jr,{unsafe:!0});var Hr=p.f,Wr=function(t){return function(e){for(var i,n=w(e),r=At(n),o=r.length,s=0,a=[];o>s;)i=r[s++],d&&!Hr.call(n,i)||a.push(t?[i,n[i]]:n[i]);return a}},Gr={entries:Wr(!0),values:Wr(!1)}.values;Et({target:"Object",stat:!0},{values:function(t){return Gr(t)}});var Ur=or.trim,zr=l.parseFloat,Vr=1/zr(tr+"-0")!=-1/0?function(t){var e=Ur(String(t)),i=zr(e);return 0===i&&"-"==e.charAt(0)?-0:i}:zr;Et({global:!0,forced:parseFloat!=Vr},{parseFloat:Vr});var Br=or.trim,Xr=l.parseInt,qr=/^[+-]?0[Xx]/,Zr=8!==Xr(tr+"08")||22!==Xr(tr+"0x16")?function(t,e){var i=Br(String(t));return Xr(i,e>>>0||(qr.test(i)?16:10))}:Xr;Et({global:!0,forced:parseInt!=Zr},{parseInt:Zr});var $r=Xt("match"),Jr=function(t){var e;return k(t)&&(void 0!==(e=t[$r])?!!e:"RegExp"==v(t))},Kr=function(){var t=P(this),e="";return t.global&&(e+="g"),t.ignoreCase&&(e+="i"),t.multiline&&(e+="m"),t.dotAll&&(e+="s"),t.unicode&&(e+="u"),t.sticky&&(e+="y"),e},Qr=Xt("species"),to=function(t){var e=nt(t),i=A.f;d&&e&&!e[Qr]&&i(e,Qr,{configurable:!0,get:function(){return this}})},eo=A.f,io=yt.f,no=Xt("match"),ro=l.RegExp,oo=ro.prototype,so=/a/g,ao=/a/g,ho=new ro(so)!==so;if(d&&Ot("RegExp",!ho||u((function(){return ao[no]=!1,ro(so)!=so||ro(ao)==ao||"/a/i"!=ro(so,"i")})))){for(var lo=function(t,e){var i=this instanceof lo,n=Jr(t),r=void 0===e;return!i&&n&&t.constructor===lo&&r?t:Qn(ho?new ro(n&&!r?t.source:t,e):ro((n=t instanceof lo)?t.source:t,n&&r?Kr.call(t):e),i?this:oo,lo)},uo=function(t){t in lo||eo(lo,t,{configurable:!0,get:function(){return ro[t]},set:function(e){ro[t]=e}})},co=io(ro),fo=0;co.length>fo;)uo(co[fo++]);oo.constructor=lo,lo.prototype=oo,tt(l,"RegExp",lo)}to("RegExp");var po=RegExp.prototype.exec,mo=String.prototype.replace,go=po,vo=function(){var t=/a/,e=/b*/g;return po.call(t,"a"),po.call(e,"a"),0!==t.lastIndex||0!==e.lastIndex}(),yo=void 0!==/()??/.exec("")[1];(vo||yo)&&(go=function(t){var e,i,n,r,o=this;return yo&&(i=new RegExp("^"+o.source+"$(?!\\s)",Kr.call(o))),vo&&(e=o.lastIndex),n=po.call(o,t),vo&&n&&(o.lastIndex=o.global?n.index+n[0].length:e),yo&&n&&n.length>1&&mo.call(n[0],i,(function(){for(r=1;r<arguments.length-2;r++)void 0===arguments[r]&&(n[r]=void 0)})),n});var _o=go;Et({target:"RegExp",proto:!0,forced:/./.exec!==_o},{exec:_o});var bo=RegExp.prototype,wo=bo.toString,ko=u((function(){return"/a/b"!=wo.call({source:"a",flags:"b"})})),Do="toString"!=wo.name;(ko||Do)&&tt(RegExp.prototype,"toString",(function(){var t=P(this),e=String(t.source),i=t.flags;return"/"+e+"/"+String(void 0===i&&t instanceof RegExp&&!("flags"in bo)?Kr.call(t):i)}),{unsafe:!0});var So=function(t){return function(e,i){var n,r,o=String(b(e)),s=st(i),a=o.length;return s<0||s>=a?t?"":void 0:(n=o.charCodeAt(s))<55296||n>56319||s+1===a||(r=o.charCodeAt(s+1))<56320||r>57343?t?o.charAt(s):n:t?o.slice(s,s+2):r-56320+(n-55296<<10)+65536}},xo={codeAt:So(!1),charAt:So(!0)},Mo=xo.charAt,To=Q.set,Oo=Q.getterFor("String Iterator");Wi(String,"String",(function(t){To(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Oo(this),i=e.string,n=e.index;return n>=i.length?{value:void 0,done:!0}:(t=Mo(i,n),e.index+=t.length,{value:t,done:!1})}));var Co=Xt("species"),Eo=!u((function(){var t=/./;return t.exec=function(){var t=[];return t.groups={a:"7"},t},"7"!=="".replace(t,"$<a>")})),Yo=!u((function(){var t=/(?:)/,e=t.exec;t.exec=function(){return e.apply(this,arguments)};var i="ab".split(t);return 2!==i.length||"a"!==i[0]||"b"!==i[1]})),Po=function(t,e,i,n){var r=Xt(t),o=!u((function(){var e={};return e[r]=function(){return 7},7!=""[t](e)})),s=o&&!u((function(){var e=!1,i=/a/;return i.exec=function(){return e=!0,null},"split"===t&&(i.constructor={},i.constructor[Co]=function(){return i}),i[r](""),!e}));if(!o||!s||"replace"===t&&!Eo||"split"===t&&!Yo){var a=/./[r],h=i(r,""[t],(function(t,e,i,n,r){return e.exec===_o?o&&!r?{done:!0,value:a.call(e,i,n)}:{done:!0,value:t.call(i,e,n)}:{done:!1}})),l=h[0],d=h[1];tt(String.prototype,t,l),tt(RegExp.prototype,r,2==e?function(t,e){return d.call(t,this,e)}:function(t){return d.call(t,this)}),n&&L(RegExp.prototype[r],"sham",!0)}},Io=xo.charAt,Ao=function(t,e,i){return e+(i?Io(t,e).length:1)},Lo=function(t,e){var i=t.exec;if("function"==typeof i){var n=i.call(t,e);if("object"!=typeof n)throw TypeError("RegExp exec method returned something other than an Object or null");return n}if("RegExp"!==v(t))throw TypeError("RegExp#exec called on incompatible receiver");return _o.call(t,e)};Po("match",1,(function(t,e,i){return[function(e){var i=b(this),n=null==e?void 0:e[t];return void 0!==n?n.call(e,i):new RegExp(e)[t](String(i))},function(t){var n=i(e,t,this);if(n.done)return n.value;var r=P(t),o=String(this);if(!r.global)return Lo(r,o);var s=r.unicode;r.lastIndex=0;for(var a,h=[],l=0;null!==(a=Lo(r,o));){var u=String(a[0]);h[l]=u,""===u&&(r.lastIndex=Ao(o,ht(r.lastIndex),s)),l++}return 0===l?null:h}]}));var No=Math.max,Ro=Math.min,jo=Math.floor,Fo=/\$([$&'`]|\d\d?|<[^>]*>)/g,Ho=/\$([$&'`]|\d\d?)/g,Wo=function(t){return void 0===t?t:String(t)};Po("replace",2,(function(t,e,i){return[function(i,n){var r=b(this),o=null==i?void 0:i[t];return void 0!==o?o.call(i,r,n):e.call(String(r),i,n)},function(t,r){var o=i(e,t,this,r);if(o.done)return o.value;var s=P(t),a=String(this),h="function"==typeof r;h||(r=String(r));var l=s.global;if(l){var u=s.unicode;s.lastIndex=0}for(var d=[];;){var c=Lo(s,a);if(null===c)break;if(d.push(c),!l)break;""===String(c[0])&&(s.lastIndex=Ao(a,ht(s.lastIndex),u))}for(var f="",p=0,m=0;m<d.length;m++){c=d[m];for(var g=String(c[0]),v=No(Ro(st(c.index),a.length),0),y=[],_=1;_<c.length;_++)y.push(Wo(c[_]));var b=c.groups;if(h){var w=[g].concat(y,v,a);void 0!==b&&w.push(b);var k=String(r.apply(void 0,w))}else k=n(g,a,v,y,b,r);v>=p&&(f+=a.slice(p,v)+k,p=v+g.length)}return f+a.slice(p)}];function n(t,i,n,r,o,s){var a=n+t.length,h=r.length,l=Ho;return void 0!==o&&(o=It(o),l=Fo),e.call(s,l,(function(e,s){var l;switch(s.charAt(0)){case"$":return"$";case"&":return t;case"`":return i.slice(0,n);case"'":return i.slice(a);case"<":l=o[s.slice(1,-1)];break;default:var u=+s;if(0===u)return e;if(u>h){var d=jo(u/10);return 0===d?e:d<=h?void 0===r[d-1]?s.charAt(1):r[d-1]+s.charAt(1):e}l=r[u-1]}return void 0===l?"":l}))}}));var Go=[].push,Uo=Math.min,zo=!u((function(){return!RegExp(4294967295,"y")}));Po("split",2,(function(t,e,i){var n;return n="c"=="abbc".split(/(b)*/)[1]||4!="test".split(/(?:)/,-1).length||2!="ab".split(/(?:ab)*/).length||4!=".".split(/(.?)(.?)/).length||".".split(/()()/).length>1||"".split(/.?/).length?function(t,i){var n=String(b(this)),r=void 0===i?4294967295:i>>>0;if(0===r)return[];if(void 0===t)return[n];if(!Jr(t))return e.call(n,t,r);for(var o,s,a,h=[],l=(t.ignoreCase?"i":"")+(t.multiline?"m":"")+(t.unicode?"u":"")+(t.sticky?"y":""),u=0,d=new RegExp(t.source,l+"g");(o=_o.call(d,n))&&!((s=d.lastIndex)>u&&(h.push(n.slice(u,o.index)),o.length>1&&o.index<n.length&&Go.apply(h,o.slice(1)),a=o[0].length,u=s,h.length>=r));)d.lastIndex===o.index&&d.lastIndex++;return u===n.length?!a&&d.test("")||h.push(""):h.push(n.slice(u)),h.length>r?h.slice(0,r):h}:"0".split(void 0,0).length?function(t,i){return void 0===t&&0===i?[]:e.call(this,t,i)}:e,[function(e,i){var r=b(this),o=null==e?void 0:e[t];return void 0!==o?o.call(e,r,i):n.call(String(r),e,i)},function(t,r){var o=i(n,t,this,r,n!==e);if(o.done)return o.value;var s=P(t),a=String(this),h=Yn(s,RegExp),l=s.unicode,u=(s.ignoreCase?"i":"")+(s.multiline?"m":"")+(s.unicode?"u":"")+(zo?"y":"g"),d=new h(zo?s:"^(?:"+s.source+")",u),c=void 0===r?4294967295:r>>>0;if(0===c)return[];if(0===a.length)return null===Lo(d,a)?[a]:[];for(var f=0,p=0,m=[];p<a.length;){d.lastIndex=zo?p:0;var g,v=Lo(d,zo?a:a.slice(p));if(null===v||(g=Uo(ht(d.lastIndex+(zo?0:p)),a.length))===f)p=Ao(a,p,l);else{if(m.push(a.slice(f,p)),m.length===c)return m;for(var y=1;y<=v.length-1;y++)if(m.push(v[y]),m.length===c)return m;p=f=g}}return m.push(a.slice(f)),m}]}),!zo);var Vo=or.trim;Et({target:"String",proto:!0,forced:function(t){return u((function(){return!!tr[t]()||"​᠎"!="​᠎"[t]()||tr[t].name!==t}))}("trim")},{trim:function(){return Vo(this)}});var Bo=Sn.NATIVE_ARRAY_BUFFER_VIEWS,Xo=l.ArrayBuffer,qo=l.Int8Array,Zo=!Bo||!u((function(){qo(1)}))||!u((function(){new qo(-1)}))||!mi((function(t){new qo,new qo(null),new qo(1.5),new qo(t)}),!0)||u((function(){return 1!==new qo(new Xo(2),1,void 0).length})),$o=function(t,e){var i=st(t);if(i<0||i%e)throw RangeError("Wrong offset");return i},Jo=Sn.aTypedArrayConstructor,Ko=function(t){var e,i,n,r,o,s=It(t),a=arguments.length,h=a>1?arguments[1]:void 0,l=void 0!==h,u=ui(s);if(null!=u&&!oi(u))for(o=u.call(s),s=[];!(r=o.next()).done;)s.push(r.value);for(l&&a>2&&(h=ee(h,arguments[2],2)),i=ht(s.length),n=new(Jo(this))(i),e=0;i>e;e++)n[e]=l?h(s[e],e):s[e];return n};n((function(t){var e=yt.f,i=se.forEach,n=Q.get,r=Q.set,o=A.f,s=Y.f,a=Math.round,h=l.RangeError,u=Cn.ArrayBuffer,c=Cn.DataView,f=Sn.NATIVE_ARRAY_BUFFER_VIEWS,p=Sn.TYPED_ARRAY_TAG,g=Sn.TypedArray,v=Sn.TypedArrayPrototype,y=Sn.aTypedArrayConstructor,_=Sn.isTypedArray,b=function(t,e){for(var i=0,n=e.length,r=new(y(t))(n);n>i;)r[i]=e[i++];return r},w=function(t,e){o(t,e,{get:function(){return n(this)[e]}})},S=function(t){var e;return t instanceof u||"ArrayBuffer"==(e=hi(t))||"SharedArrayBuffer"==e},M=function(t,e){return _(t)&&"symbol"!=typeof e&&e in t&&String(+e)==String(e)},T=function(t,e){return M(t,e=D(e,!0))?m(2,t[e]):s(t,e)},O=function(t,e,i){return!(M(t,e=D(e,!0))&&k(i)&&x(i,"value"))||x(i,"get")||x(i,"set")||i.configurable||x(i,"writable")&&!i.writable||x(i,"enumerable")&&!i.enumerable?o(t,e,i):(t[e]=i.value,t)};d?(f||(Y.f=T,A.f=O,w(v,"buffer"),w(v,"byteOffset"),w(v,"byteLength"),w(v,"length")),Et({target:"Object",stat:!0,forced:!f},{getOwnPropertyDescriptor:T,defineProperty:O}),t.exports=function(t,s,d,m){var y=t+(m?"Clamped":"")+"Array",w="get"+t,D="set"+t,x=l[y],M=x,T=M&&M.prototype,O={},C=function(t,e){o(t,e,{get:function(){return function(t,e){var i=n(t);return i.view[w](e*s+i.byteOffset,!0)}(this,e)},set:function(t){return function(t,e,i){var r=n(t);m&&(i=(i=a(i))<0?0:i>255?255:255&i),r.view[D](e*s+r.byteOffset,i,!0)}(this,e,t)},enumerable:!0})};f?Zo&&(M=d((function(t,e,i,n){return Mn(t,M,y),k(e)?S(e)?void 0!==n?new x(e,$o(i,s),n):void 0!==i?new x(e,$o(i,s)):new x(e):_(e)?b(M,e):Ko.call(M,e):new x(Tn(e))})),Ni&&Ni(M,g),i(e(x),(function(t){t in M||L(M,t,x[t])})),M.prototype=T):(M=d((function(t,e,i,n){Mn(t,M,y);var o,a,l,d=0,f=0;if(k(e)){if(!S(e))return _(e)?b(M,e):Ko.call(M,e);o=e,f=$o(i,s);var p=e.byteLength;if(void 0===n){if(p%s)throw h("Wrong length");if((a=p-f)<0)throw h("Wrong length")}else if((a=ht(n)*s)+f>p)throw h("Wrong length");l=a/s}else l=Tn(e),o=new u(a=l*s);for(r(t,{buffer:o,byteOffset:f,byteLength:a,length:l,view:new c(o)});d<l;)C(t,d++)})),Ni&&Ni(M,g),T=M.prototype=Ht(v)),T.constructor!==M&&L(T,"constructor",M),p&&L(T,p,y),O[y]=M,Et({global:!0,forced:M!=x,sham:!f},O),"BYTES_PER_ELEMENT"in M||L(M,"BYTES_PER_ELEMENT",s),"BYTES_PER_ELEMENT"in T||L(T,"BYTES_PER_ELEMENT",s),to(y)}):t.exports=function(){}}))("Uint8",1,(function(t){return function(e,i,n){return t(this,e,i,n)}}));var Qo=Math.min,ts=[].copyWithin||function(t,e){var i=It(this),n=ht(i.length),r=dt(t,n),o=dt(e,n),s=arguments.length>2?arguments[2]:void 0,a=Qo((void 0===s?n:dt(s,n))-o,n-r),h=1;for(o<r&&r<o+a&&(h=-1,o+=a-1,r+=a-1);a-- >0;)o in i?i[r]=i[o]:delete i[r],r+=h,o+=h;return i},es=Sn.aTypedArray;Sn.exportProto("copyWithin",(function(t,e){return ts.call(es(this),t,e,arguments.length>2?arguments[2]:void 0)}));var is=se.every,ns=Sn.aTypedArray;Sn.exportProto("every",(function(t){return is(ns(this),t,arguments.length>1?arguments[1]:void 0)}));var rs=Sn.aTypedArray;Sn.exportProto("fill",(function(t){return On.apply(rs(this),arguments)}));var os=se.filter,ss=Sn.aTypedArray,as=Sn.aTypedArrayConstructor;Sn.exportProto("filter",(function(t){for(var e=os(ss(this),t,arguments.length>1?arguments[1]:void 0),i=Yn(this,this.constructor),n=0,r=e.length,o=new(as(i))(r);r>n;)o[n]=e[n++];return o}));var hs=se.find,ls=Sn.aTypedArray;Sn.exportProto("find",(function(t){return hs(ls(this),t,arguments.length>1?arguments[1]:void 0)}));var us=se.findIndex,ds=Sn.aTypedArray;Sn.exportProto("findIndex",(function(t){return us(ds(this),t,arguments.length>1?arguments[1]:void 0)}));var cs=se.forEach,fs=Sn.aTypedArray;Sn.exportProto("forEach",(function(t){cs(fs(this),t,arguments.length>1?arguments[1]:void 0)}));var ps=ft.includes,ms=Sn.aTypedArray;Sn.exportProto("includes",(function(t){return ps(ms(this),t,arguments.length>1?arguments[1]:void 0)}));var gs=ft.indexOf,vs=Sn.aTypedArray;Sn.exportProto("indexOf",(function(t){return gs(vs(this),t,arguments.length>1?arguments[1]:void 0)}));var ys=Xt("iterator"),_s=l.Uint8Array,bs=zi.values,ws=zi.keys,ks=zi.entries,Ds=Sn.aTypedArray,Ss=Sn.exportProto,xs=_s&&_s.prototype[ys],Ms=!!xs&&("values"==xs.name||null==xs.name),Ts=function(){return bs.call(Ds(this))};Ss("entries",(function(){return ks.call(Ds(this))})),Ss("keys",(function(){return ws.call(Ds(this))})),Ss("values",Ts,!Ms),Ss(ys,Ts,!Ms);var Os=Sn.aTypedArray,Cs=[].join;Sn.exportProto("join",(function(t){return Cs.apply(Os(this),arguments)}));var Es=Math.min,Ys=[].lastIndexOf,Ps=!!Ys&&1/[1].lastIndexOf(1,-0)<0,Is=Ke("lastIndexOf"),As=Ps||Is?function(t){if(Ps)return Ys.apply(this,arguments)||0;var e=w(this),i=ht(e.length),n=i-1;for(arguments.length>1&&(n=Es(n,st(arguments[1]))),n<0&&(n=i+n);n>=0;n--)if(n in e&&e[n]===t)return n||0;return-1}:Ys,Ls=Sn.aTypedArray;Sn.exportProto("lastIndexOf",(function(t){return As.apply(Ls(this),arguments)}));var Ns=se.map,Rs=Sn.aTypedArray,js=Sn.aTypedArrayConstructor;Sn.exportProto("map",(function(t){return Ns(Rs(this),t,arguments.length>1?arguments[1]:void 0,(function(t,e){return new(js(Yn(t,t.constructor)))(e)}))}));var Fs=function(t){return function(e,i,n,r){te(i);var o=It(e),s=_(o),a=ht(o.length),h=t?a-1:0,l=t?-1:1;if(n<2)for(;;){if(h in s){r=s[h],h+=l;break}if(h+=l,t?h<0:a<=h)throw TypeError("Reduce of empty array with no initial value")}for(;t?h>=0:a>h;h+=l)h in s&&(r=i(r,s[h],h,o));return r}},Hs={left:Fs(!1),right:Fs(!0)},Ws=Hs.left,Gs=Sn.aTypedArray;Sn.exportProto("reduce",(function(t){return Ws(Gs(this),t,arguments.length,arguments.length>1?arguments[1]:void 0)}));var Us=Hs.right,zs=Sn.aTypedArray;Sn.exportProto("reduceRight",(function(t){return Us(zs(this),t,arguments.length,arguments.length>1?arguments[1]:void 0)}));var Vs=Sn.aTypedArray,Bs=Math.floor;Sn.exportProto("reverse",(function(){for(var t,e=Vs(this).length,i=Bs(e/2),n=0;n<i;)t=this[n],this[n++]=this[--e],this[e]=t;return this}));var Xs=Sn.aTypedArray,qs=u((function(){new Int8Array(1).set({})}));Sn.exportProto("set",(function(t){Xs(this);var e=$o(arguments.length>1?arguments[1]:void 0,1),i=this.length,n=It(t),r=ht(n.length),o=0;if(r+e>i)throw RangeError("Wrong length");for(;o<r;)this[e+o]=n[o++]}),qs);var Zs=Sn.aTypedArray,$s=Sn.aTypedArrayConstructor,Js=[].slice,Ks=u((function(){new Int8Array(1).slice()}));Sn.exportProto("slice",(function(t,e){for(var i=Js.call(Zs(this),t,e),n=Yn(this,this.constructor),r=0,o=i.length,s=new($s(n))(o);o>r;)s[r]=i[r++];return s}),Ks);var Qs=se.some,ta=Sn.aTypedArray;Sn.exportProto("some",(function(t){return Qs(ta(this),t,arguments.length>1?arguments[1]:void 0)}));var ea=Sn.aTypedArray,ia=[].sort;Sn.exportProto("sort",(function(t){return ia.call(ea(this),t)}));var na=Sn.aTypedArray;Sn.exportProto("subarray",(function(t,e){var i=na(this),n=i.length,r=dt(t,n);return new(Yn(i,i.constructor))(i.buffer,i.byteOffset+r*i.BYTES_PER_ELEMENT,ht((void 0===e?n:dt(e,n))-r))}));var ra=l.Int8Array,oa=Sn.aTypedArray,sa=[].toLocaleString,aa=[].slice,ha=!!ra&&u((function(){sa.call(new ra(1))})),la=u((function(){return[1,2].toLocaleString()!=new ra([1,2]).toLocaleString()}))||!u((function(){ra.prototype.toLocaleString.call([1,2])}));Sn.exportProto("toLocaleString",(function(){return sa.apply(ha?aa.call(oa(this)):oa(this),arguments)}),la);var ua=l.Uint8Array,da=ua&&ua.prototype,ca=[].toString,fa=[].join;u((function(){ca.call({})}))&&(ca=function(){return fa.call(this)}),Sn.exportProto("toString",ca,(da||{}).toString!=ca);var pa={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0};for(var ma in pa){var ga=l[ma],va=ga&&ga.prototype;if(va&&va.forEach!==ti)try{L(va,"forEach",ti)}catch(t){va.forEach=ti}}var ya=Xt("iterator"),_a=Xt("toStringTag"),ba=zi.values;for(var wa in pa){var ka=l[wa],Da=ka&&ka.prototype;if(Da){if(Da[ya]!==ba)try{L(Da,ya,ba)}catch(t){Da[ya]=ba}if(Da[_a]||L(Da,_a,wa),pa[wa])for(var Sa in zi)if(Da[Sa]!==zi[Sa])try{L(Da,Sa,zi[Sa])}catch(t){Da[Sa]=zi[Sa]}}}function xa(t){return(xa="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function Ma(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function Ta(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}function Oa(t,e,i){return e&&Ta(t.prototype,e),i&&Ta(t,i),t}function Ca(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Ya(t,e)}function Ea(t){return(Ea=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)})(t)}function Ya(t,e){return(Ya=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t})(t,e)}function Pa(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}function Ia(t,e){return!e||"object"!=typeof e&&"function"!=typeof e?Pa(t):e}function Aa(t){return function(t){if(Array.isArray(t)){for(var e=0,i=new Array(t.length);e<t.length;e++)i[e]=t[e];return i}}(t)||function(t){if(Symbol.iterator in Object(t)||"[object Arguments]"===Object.prototype.toString.call(t))return Array.from(t)}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}Et({target:"URL",proto:!0,enumerable:!0},{toJSON:function(){return URL.prototype.toString.call(this)}});var La=function(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t};var Na=function(t){if(Array.isArray(t)){for(var e=0,i=new Array(t.length);e<t.length;e++)i[e]=t[e];return i}};var Ra=function(t){if(Symbol.iterator in Object(t)||"[object Arguments]"===Object.prototype.toString.call(t))return Array.from(t)};var ja=function(){throw new TypeError("Invalid attempt to spread non-iterable instance")};var Fa=function(t){return Na(t)||Ra(t)||ja()};"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Ha(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function Wa(t,e){return t(e={exports:{}},e.exports),e.exports}for(var Ga=Wa((function(t){function e(t){return(e="function"==typeof Symbol&&"symbol"===xa(Symbol.iterator)?function(t){return xa(t)}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":xa(t)})(t)}function i(n){return"function"==typeof Symbol&&"symbol"===e(Symbol.iterator)?t.exports=i=function(t){return e(t)}:t.exports=i=function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":e(t)},i(n)}t.exports=i})),Ua=Wa((function(t,e){t.exports=function(){var e,i;function n(){return e.apply(null,arguments)}function r(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function s(t){return void 0===t}function a(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function h(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function l(t,e){var i,n=[];for(i=0;i<t.length;++i)n.push(e(t[i],i));return n}function u(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function d(t,e){for(var i in e)u(e,i)&&(t[i]=e[i]);return u(e,"toString")&&(t.toString=e.toString),u(e,"valueOf")&&(t.valueOf=e.valueOf),t}function c(t,e,i,n){return Pe(t,e,i,n,!0).utc()}function f(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function p(t){if(null==t._isValid){var e=f(t),n=i.call(e.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function m(t){var e=c(NaN);return null!=t?d(f(e),t):f(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),i=e.length>>>0,n=0;n<i;n++)if(n in e&&t.call(this,e[n],n,e))return!0;return!1};var g=n.momentProperties=[];function v(t,e){var i,n,r;if(s(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),s(e._i)||(t._i=e._i),s(e._f)||(t._f=e._f),s(e._l)||(t._l=e._l),s(e._strict)||(t._strict=e._strict),s(e._tzm)||(t._tzm=e._tzm),s(e._isUTC)||(t._isUTC=e._isUTC),s(e._offset)||(t._offset=e._offset),s(e._pf)||(t._pf=f(e)),s(e._locale)||(t._locale=e._locale),g.length>0)for(i=0;i<g.length;i++)s(r=e[n=g[i]])||(t[n]=r);return t}var y=!1;function _(t){v(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===y&&(y=!0,n.updateOffset(this),y=!1)}function b(t){return t instanceof _||null!=t&&null!=t._isAMomentObject}function w(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function k(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=w(e)),i}function D(t,e,i){var n,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),s=0;for(n=0;n<r;n++)(i&&t[n]!==e[n]||!i&&k(t[n])!==k(e[n]))&&s++;return s+o}function S(t){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function x(t,e){var i=!0;return d((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,t),i){for(var r,o=[],s=0;s<arguments.length;s++){if(r="","object"===xa(arguments[s])){for(var a in r+="\n["+s+"] ",arguments[0])r+=a+": "+arguments[0][a]+", ";r=r.slice(0,-2)}else r=arguments[s];o.push(r)}S(t+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var M,T={};function O(t,e){null!=n.deprecationHandler&&n.deprecationHandler(t,e),T[t]||(S(e),T[t]=!0)}function C(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function E(t,e){var i,n=d({},t);for(i in e)u(e,i)&&(o(t[i])&&o(e[i])?(n[i]={},d(n[i],t[i]),d(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)u(t,i)&&!u(e,i)&&o(t[i])&&(n[i]=d({},n[i]));return n}function Y(t){null!=t&&this.set(t)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,M=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)u(t,e)&&i.push(e);return i};var P={};function I(t,e){var i=t.toLowerCase();P[i]=P[i+"s"]=P[e]=t}function A(t){return"string"==typeof t?P[t]||P[t.toLowerCase()]:void 0}function L(t){var e,i,n={};for(i in t)u(t,i)&&(e=A(i))&&(n[e]=t[i]);return n}var N={};function R(t,e){N[t]=e}function j(t,e,i){var n=""+Math.abs(t),r=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+n}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,H=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,W={},G={};function U(t,e,i,n){var r=n;"string"==typeof n&&(r=function(){return this[n]()}),t&&(G[t]=r),e&&(G[e[0]]=function(){return j(r.apply(this,arguments),e[1],e[2])}),i&&(G[i]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function z(t,e){return t.isValid()?(e=V(e,t.localeData()),W[e]=W[e]||function(t){var e,i,n,r=t.match(F);for(e=0,i=r.length;e<i;e++)G[r[e]]?r[e]=G[r[e]]:r[e]=(n=r[e]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(e){var n,o="";for(n=0;n<i;n++)o+=C(r[n])?r[n].call(e,t):r[n];return o}}(e),W[e](t)):t.localeData().invalidDate()}function V(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(H.lastIndex=0;i>=0&&H.test(t);)t=t.replace(H,n),H.lastIndex=0,i-=1;return t}var B=/\d/,X=/\d\d/,q=/\d{3}/,Z=/\d{4}/,$=/[+-]?\d{6}/,J=/\d\d?/,K=/\d\d\d\d?/,Q=/\d\d\d\d\d\d?/,tt=/\d{1,3}/,et=/\d{1,4}/,it=/[+-]?\d{1,6}/,nt=/\d+/,rt=/[+-]?\d+/,ot=/Z|[+-]\d\d:?\d\d/gi,st=/Z|[+-]\d\d(?::?\d\d)?/gi,at=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,ht={};function lt(t,e,i){ht[t]=C(e)?e:function(t,n){return t&&i?i:e}}function ut(t,e){return u(ht,t)?ht[t](e._strict,e._locale):new RegExp(dt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,r){return e||i||n||r}))))}function dt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ct={};function ft(t,e){var i,n=e;for("string"==typeof t&&(t=[t]),a(e)&&(n=function(t,i){i[e]=k(t)}),i=0;i<t.length;i++)ct[t[i]]=n}function pt(t,e){ft(t,(function(t,i,n,r){n._w=n._w||{},e(t,n._w,n,r)}))}function mt(t,e,i){null!=e&&u(ct,t)&&ct[t](e,i._a,i,t)}var gt=0,vt=1,yt=2,_t=3,bt=4,wt=5,kt=6,Dt=7,St=8;function xt(t){return Mt(t)?366:365}function Mt(t){return t%4==0&&t%100!=0||t%400==0}U("Y",0,0,(function(){var t=this.year();return t<=9999?""+t:"+"+t})),U(0,["YY",2],0,(function(){return this.year()%100})),U(0,["YYYY",4],0,"year"),U(0,["YYYYY",5],0,"year"),U(0,["YYYYYY",6,!0],0,"year"),I("year","y"),R("year",1),lt("Y",rt),lt("YY",J,X),lt("YYYY",et,Z),lt("YYYYY",it,$),lt("YYYYYY",it,$),ft(["YYYYY","YYYYYY"],gt),ft("YYYY",(function(t,e){e[gt]=2===t.length?n.parseTwoDigitYear(t):k(t)})),ft("YY",(function(t,e){e[gt]=n.parseTwoDigitYear(t)})),ft("Y",(function(t,e){e[gt]=parseInt(t,10)})),n.parseTwoDigitYear=function(t){return k(t)+(k(t)>68?1900:2e3)};var Tt,Ot=Ct("FullYear",!0);function Ct(t,e){return function(i){return null!=i?(Yt(this,t,i),n.updateOffset(this,e),this):Et(this,t)}}function Et(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Yt(t,e,i){t.isValid()&&!isNaN(i)&&("FullYear"===e&&Mt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](i,t.month(),Pt(i,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](i))}function Pt(t,e){if(isNaN(t)||isNaN(e))return NaN;var i,n=(e%(i=12)+i)%i;return t+=(e-n)/12,1===n?Mt(t)?29:28:31-n%7%2}Tt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},U("M",["MM",2],"Mo",(function(){return this.month()+1})),U("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),U("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),I("month","M"),R("month",8),lt("M",J),lt("MM",J,X),lt("MMM",(function(t,e){return e.monthsShortRegex(t)})),lt("MMMM",(function(t,e){return e.monthsRegex(t)})),ft(["M","MM"],(function(t,e){e[vt]=k(t)-1})),ft(["MMM","MMMM"],(function(t,e,i,n){var r=i._locale.monthsParse(t,n,i._strict);null!=r?e[vt]=r:f(i).invalidMonth=t}));var It=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,At="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Lt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Nt(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)o=c([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(o,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(r=Tt.call(this._shortMonthsParse,s))?r:null:-1!==(r=Tt.call(this._longMonthsParse,s))?r:null:"MMM"===e?-1!==(r=Tt.call(this._shortMonthsParse,s))?r:-1!==(r=Tt.call(this._longMonthsParse,s))?r:null:-1!==(r=Tt.call(this._longMonthsParse,s))?r:-1!==(r=Tt.call(this._shortMonthsParse,s))?r:null}function Rt(t,e){var i;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=k(e);else if(!a(e=t.localeData().monthsParse(e)))return t;return i=Math.min(t.date(),Pt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,i),t}function jt(t){return null!=t?(Rt(this,t),n.updateOffset(this,!0),this):Et(this,"Month")}var Ft=at,Ht=at;function Wt(){function t(t,e){return e.length-t.length}var e,i,n=[],r=[],o=[];for(e=0;e<12;e++)i=c([2e3,e]),n.push(this.monthsShort(i,"")),r.push(this.months(i,"")),o.push(this.months(i,"")),o.push(this.monthsShort(i,""));for(n.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)n[e]=dt(n[e]),r[e]=dt(r[e]);for(e=0;e<24;e++)o[e]=dt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function Gt(t,e,i,n,r,o,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,r,o,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,r,o,s),a}function Ut(t){var e;if(t<100&&t>=0){var i=Array.prototype.slice.call(arguments);i[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function zt(t,e,i){var n=7+e-i;return-(7+Ut(t,0,n).getUTCDay()-e)%7+n-1}function Vt(t,e,i,n,r){var o,s,a=1+7*(e-1)+(7+i-n)%7+zt(t,n,r);return a<=0?s=xt(o=t-1)+a:a>xt(t)?(o=t+1,s=a-xt(t)):(o=t,s=a),{year:o,dayOfYear:s}}function Bt(t,e,i){var n,r,o=zt(t.year(),e,i),s=Math.floor((t.dayOfYear()-o-1)/7)+1;return s<1?n=s+Xt(r=t.year()-1,e,i):s>Xt(t.year(),e,i)?(n=s-Xt(t.year(),e,i),r=t.year()+1):(r=t.year(),n=s),{week:n,year:r}}function Xt(t,e,i){var n=zt(t,e,i),r=zt(t+1,e,i);return(xt(t)-n+r)/7}function qt(t,e){return t.slice(e,7).concat(t.slice(0,e))}U("w",["ww",2],"wo","week"),U("W",["WW",2],"Wo","isoWeek"),I("week","w"),I("isoWeek","W"),R("week",5),R("isoWeek",5),lt("w",J),lt("ww",J,X),lt("W",J),lt("WW",J,X),pt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=k(t)})),U("d",0,"do","day"),U("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),U("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),U("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),U("e",0,0,"weekday"),U("E",0,0,"isoWeekday"),I("day","d"),I("weekday","e"),I("isoWeekday","E"),R("day",11),R("weekday",11),R("isoWeekday",11),lt("d",J),lt("e",J),lt("E",J),lt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),lt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),lt("dddd",(function(t,e){return e.weekdaysRegex(t)})),pt(["dd","ddd","dddd"],(function(t,e,i,n){var r=i._locale.weekdaysParse(t,n,i._strict);null!=r?e.d=r:f(i).invalidWeekday=t})),pt(["d","e","E"],(function(t,e,i,n){e[n]=k(t)}));var Zt="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),$t="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Jt="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Kt(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)o=c([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(o,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(r=Tt.call(this._weekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:null:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:null:"dddd"===e?-1!==(r=Tt.call(this._weekdaysParse,s))?r:-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:-1!==(r=Tt.call(this._weekdaysParse,s))?r:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:null:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:-1!==(r=Tt.call(this._weekdaysParse,s))?r:-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:null}var Qt=at,te=at,ee=at;function ie(){function t(t,e){return e.length-t.length}var e,i,n,r,o,s=[],a=[],h=[],l=[];for(e=0;e<7;e++)i=c([2e3,1]).day(e),n=this.weekdaysMin(i,""),r=this.weekdaysShort(i,""),o=this.weekdays(i,""),s.push(n),a.push(r),h.push(o),l.push(n),l.push(r),l.push(o);for(s.sort(t),a.sort(t),h.sort(t),l.sort(t),e=0;e<7;e++)a[e]=dt(a[e]),h[e]=dt(h[e]),l[e]=dt(l[e]);this._weekdaysRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function ne(){return this.hours()%12||12}function re(t,e){U(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function oe(t,e){return e._meridiemParse}U("H",["HH",2],0,"hour"),U("h",["hh",2],0,ne),U("k",["kk",2],0,(function(){return this.hours()||24})),U("hmm",0,0,(function(){return""+ne.apply(this)+j(this.minutes(),2)})),U("hmmss",0,0,(function(){return""+ne.apply(this)+j(this.minutes(),2)+j(this.seconds(),2)})),U("Hmm",0,0,(function(){return""+this.hours()+j(this.minutes(),2)})),U("Hmmss",0,0,(function(){return""+this.hours()+j(this.minutes(),2)+j(this.seconds(),2)})),re("a",!0),re("A",!1),I("hour","h"),R("hour",13),lt("a",oe),lt("A",oe),lt("H",J),lt("h",J),lt("k",J),lt("HH",J,X),lt("hh",J,X),lt("kk",J,X),lt("hmm",K),lt("hmmss",Q),lt("Hmm",K),lt("Hmmss",Q),ft(["H","HH"],_t),ft(["k","kk"],(function(t,e,i){var n=k(t);e[_t]=24===n?0:n})),ft(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),ft(["h","hh"],(function(t,e,i){e[_t]=k(t),f(i).bigHour=!0})),ft("hmm",(function(t,e,i){var n=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n)),f(i).bigHour=!0})),ft("hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n,2)),e[wt]=k(t.substr(r)),f(i).bigHour=!0})),ft("Hmm",(function(t,e,i){var n=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n))})),ft("Hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n,2)),e[wt]=k(t.substr(r))}));var se,ae=Ct("Hours",!0),he={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:At,monthsShort:Lt,week:{dow:0,doy:6},weekdays:Zt,weekdaysMin:Jt,weekdaysShort:$t,meridiemParse:/[ap]\.?m?\.?/i},le={},ue={};function de(t){return t?t.toLowerCase().replace("_","-"):t}function ce(e){var i=null;if(!le[e]&&t&&t.exports)try{i=se._abbr,Ha(),fe(i)}catch(t){}return le[e]}function fe(t,e){var i;return t&&((i=s(e)?me(t):pe(t,e))?se=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),se._abbr}function pe(t,e){if(null!==e){var i,n=he;if(e.abbr=t,null!=le[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=le[t]._config;else if(null!=e.parentLocale)if(null!=le[e.parentLocale])n=le[e.parentLocale]._config;else{if(null==(i=ce(e.parentLocale)))return ue[e.parentLocale]||(ue[e.parentLocale]=[]),ue[e.parentLocale].push({name:t,config:e}),null;n=i._config}return le[t]=new Y(E(n,e)),ue[t]&&ue[t].forEach((function(t){pe(t.name,t.config)})),fe(t),le[t]}return delete le[t],null}function me(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return se;if(!r(t)){if(e=ce(t))return e;t=[t]}return function(t){for(var e,i,n,r,o=0;o<t.length;){for(e=(r=de(t[o]).split("-")).length,i=(i=de(t[o+1]))?i.split("-"):null;e>0;){if(n=ce(r.slice(0,e).join("-")))return n;if(i&&i.length>=e&&D(r,i,!0)>=e-1)break;e--}o++}return se}(t)}function ge(t){var e,i=t._a;return i&&-2===f(t).overflow&&(e=i[vt]<0||i[vt]>11?vt:i[yt]<1||i[yt]>Pt(i[gt],i[vt])?yt:i[_t]<0||i[_t]>24||24===i[_t]&&(0!==i[bt]||0!==i[wt]||0!==i[kt])?_t:i[bt]<0||i[bt]>59?bt:i[wt]<0||i[wt]>59?wt:i[kt]<0||i[kt]>999?kt:-1,f(t)._overflowDayOfYear&&(e<gt||e>yt)&&(e=yt),f(t)._overflowWeeks&&-1===e&&(e=Dt),f(t)._overflowWeekday&&-1===e&&(e=St),f(t).overflow=e),t}function ve(t,e,i){return null!=t?t:null!=e?e:i}function ye(t){var e,i,r,o,s,a=[];if(!t._d){for(r=function(t){var e=new Date(n.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[yt]&&null==t._a[vt]&&function(t){var e,i,n,r,o,s,a,h;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)o=1,s=4,i=ve(e.GG,t._a[gt],Bt(Ie(),1,4).year),n=ve(e.W,1),((r=ve(e.E,1))<1||r>7)&&(h=!0);else{o=t._locale._week.dow,s=t._locale._week.doy;var l=Bt(Ie(),o,s);i=ve(e.gg,t._a[gt],l.year),n=ve(e.w,l.week),null!=e.d?((r=e.d)<0||r>6)&&(h=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(h=!0)):r=o}n<1||n>Xt(i,o,s)?f(t)._overflowWeeks=!0:null!=h?f(t)._overflowWeekday=!0:(a=Vt(i,n,r,o,s),t._a[gt]=a.year,t._dayOfYear=a.dayOfYear)}(t),null!=t._dayOfYear&&(s=ve(t._a[gt],r[gt]),(t._dayOfYear>xt(s)||0===t._dayOfYear)&&(f(t)._overflowDayOfYear=!0),i=Ut(s,0,t._dayOfYear),t._a[vt]=i.getUTCMonth(),t._a[yt]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=a[e]=r[e];for(;e<7;e++)t._a[e]=a[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[_t]&&0===t._a[bt]&&0===t._a[wt]&&0===t._a[kt]&&(t._nextDay=!0,t._a[_t]=0),t._d=(t._useUTC?Ut:Gt).apply(null,a),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[_t]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(f(t).weekdayMismatch=!0)}}var _e=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,be=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,we=/Z|[+-]\d\d(?::?\d\d)?/,ke=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],De=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Se=/^\/?Date\((\-?\d+)/i;function xe(t){var e,i,n,r,o,s,a=t._i,h=_e.exec(a)||be.exec(a);if(h){for(f(t).iso=!0,e=0,i=ke.length;e<i;e++)if(ke[e][1].exec(h[1])){r=ke[e][0],n=!1!==ke[e][2];break}if(null==r)return void(t._isValid=!1);if(h[3]){for(e=0,i=De.length;e<i;e++)if(De[e][1].exec(h[3])){o=(h[2]||" ")+De[e][0];break}if(null==o)return void(t._isValid=!1)}if(!n&&null!=o)return void(t._isValid=!1);if(h[4]){if(!we.exec(h[4]))return void(t._isValid=!1);s="Z"}t._f=r+(o||"")+(s||""),Ee(t)}else t._isValid=!1}var Me=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Te(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}var Oe={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Ce(t){var e,i,n,r,o,s,a,h=Me.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(h){var l=(e=h[4],i=h[3],n=h[2],r=h[5],o=h[6],s=h[7],a=[Te(e),Lt.indexOf(i),parseInt(n,10),parseInt(r,10),parseInt(o,10)],s&&a.push(parseInt(s,10)),a);if(!function(t,e,i){return!t||$t.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(f(i).weekdayMismatch=!0,i._isValid=!1,!1)}(h[1],l,t))return;t._a=l,t._tzm=function(t,e,i){if(t)return Oe[t];if(e)return 0;var n=parseInt(i,10),r=n%100;return(n-r)/100*60+r}(h[8],h[9],h[10]),t._d=Ut.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),f(t).rfc2822=!0}else t._isValid=!1}function Ee(t){if(t._f!==n.ISO_8601)if(t._f!==n.RFC_2822){t._a=[],f(t).empty=!0;var e,i,r,o,s,a=""+t._i,h=a.length,l=0;for(r=V(t._f,t._locale).match(F)||[],e=0;e<r.length;e++)o=r[e],(i=(a.match(ut(o,t))||[])[0])&&((s=a.substr(0,a.indexOf(i))).length>0&&f(t).unusedInput.push(s),a=a.slice(a.indexOf(i)+i.length),l+=i.length),G[o]?(i?f(t).empty=!1:f(t).unusedTokens.push(o),mt(o,i,t)):t._strict&&!i&&f(t).unusedTokens.push(o);f(t).charsLeftOver=h-l,a.length>0&&f(t).unusedInput.push(a),t._a[_t]<=12&&!0===f(t).bigHour&&t._a[_t]>0&&(f(t).bigHour=void 0),f(t).parsedDateParts=t._a.slice(0),f(t).meridiem=t._meridiem,t._a[_t]=function(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}(t._locale,t._a[_t],t._meridiem),ye(t),ge(t)}else Ce(t);else xe(t)}function Ye(t){var e=t._i,i=t._f;return t._locale=t._locale||me(t._l),null===e||void 0===i&&""===e?m({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),b(e)?new _(ge(e)):(h(e)?t._d=e:r(i)?function(t){var e,i,n,r,o;if(0===t._f.length)return f(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<t._f.length;r++)o=0,e=v({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],Ee(e),p(e)&&(o+=f(e).charsLeftOver,o+=10*f(e).unusedTokens.length,f(e).score=o,(null==n||o<n)&&(n=o,i=e));d(t,i||e)}(t):i?Ee(t):function(t){var e=t._i;s(e)?t._d=new Date(n.now()):h(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=Se.exec(t._i);null===e?(xe(t),!1===t._isValid&&(delete t._isValid,Ce(t),!1===t._isValid&&(delete t._isValid,n.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):r(e)?(t._a=l(e.slice(0),(function(t){return parseInt(t,10)})),ye(t)):o(e)?function(t){if(!t._d){var e=L(t._i);t._a=l([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),ye(t)}}(t):a(e)?t._d=new Date(e):n.createFromInputFallback(t)}(t),p(t)||(t._d=null),t))}function Pe(t,e,i,n,s){var a,h={};return!0!==i&&!1!==i||(n=i,i=void 0),(o(t)&&function(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}(t)||r(t)&&0===t.length)&&(t=void 0),h._isAMomentObject=!0,h._useUTC=h._isUTC=s,h._l=i,h._i=t,h._f=e,h._strict=n,(a=new _(ge(Ye(h))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Ie(t,e,i,n){return Pe(t,e,i,n,!1)}n.createFromInputFallback=x("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Ae=x("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ie.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:m()})),Le=x("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ie.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:m()}));function Ne(t,e){var i,n;if(1===e.length&&r(e[0])&&(e=e[0]),!e.length)return Ie();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}var Re=["year","quarter","month","week","day","hour","minute","second","millisecond"];function je(t){var e=L(t),i=e.year||0,n=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,a=e.hour||0,h=e.minute||0,l=e.second||0,u=e.millisecond||0;this._isValid=function(t){for(var e in t)if(-1===Tt.call(Re,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var i=!1,n=0;n<Re.length;++n)if(t[Re[n]]){if(i)return!1;parseFloat(t[Re[n]])!==k(t[Re[n]])&&(i=!0)}return!0}(e),this._milliseconds=+u+1e3*l+6e4*h+1e3*a*60*60,this._days=+s+7*o,this._months=+r+3*n+12*i,this._data={},this._locale=me(),this._bubble()}function Fe(t){return t instanceof je}function He(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function We(t,e){U(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+j(~~(t/60),2)+e+j(~~t%60,2)}))}We("Z",":"),We("ZZ",""),lt("Z",st),lt("ZZ",st),ft(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=Ue(st,t)}));var Ge=/([\+\-]|\d\d)/gi;function Ue(t,e){var i=(e||"").match(t);if(null===i)return null;var n=((i[i.length-1]||[])+"").match(Ge)||["-",0,0],r=60*n[1]+k(n[2]);return 0===r?0:"+"===n[0]?r:-r}function ze(t,e){var i,r;return e._isUTC?(i=e.clone(),r=(b(t)||h(t)?t.valueOf():Ie(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+r),n.updateOffset(i,!1),i):Ie(t).local()}function Ve(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function Be(){return!!this.isValid()&&this._isUTC&&0===this._offset}n.updateOffset=function(){};var Xe=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,qe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ze(t,e){var i,n,r,o,s,h,l=t,d=null;return Fe(t)?l={ms:t._milliseconds,d:t._days,M:t._months}:a(t)?(l={},e?l[e]=t:l.milliseconds=t):(d=Xe.exec(t))?(i="-"===d[1]?-1:1,l={y:0,d:k(d[yt])*i,h:k(d[_t])*i,m:k(d[bt])*i,s:k(d[wt])*i,ms:k(He(1e3*d[kt]))*i}):(d=qe.exec(t))?(i="-"===d[1]?-1:1,l={y:$e(d[2],i),M:$e(d[3],i),w:$e(d[4],i),d:$e(d[5],i),h:$e(d[6],i),m:$e(d[7],i),s:$e(d[8],i)}):null==l?l={}:"object"===xa(l)&&("from"in l||"to"in l)&&(o=Ie(l.from),s=Ie(l.to),r=o.isValid()&&s.isValid()?(s=ze(s,o),o.isBefore(s)?h=Je(o,s):((h=Je(s,o)).milliseconds=-h.milliseconds,h.months=-h.months),h):{milliseconds:0,months:0},(l={}).ms=r.milliseconds,l.M=r.months),n=new je(l),Fe(t)&&u(t,"_locale")&&(n._locale=t._locale),n}function $e(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Je(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function Ke(t,e){return function(i,n){var r;return null===n||isNaN(+n)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=i,i=n,n=r),Qe(this,Ze(i="string"==typeof i?+i:i,n),t),this}}function Qe(t,e,i,r){var o=e._milliseconds,s=He(e._days),a=He(e._months);t.isValid()&&(r=null==r||r,a&&Rt(t,Et(t,"Month")+a*i),s&&Yt(t,"Date",Et(t,"Date")+s*i),o&&t._d.setTime(t._d.valueOf()+o*i),r&&n.updateOffset(t,s||a))}Ze.fn=je.prototype,Ze.invalid=function(){return Ze(NaN)};var ti=Ke(1,"add"),ei=Ke(-1,"subtract");function ii(t,e){var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function ni(t){var e;return void 0===t?this._locale._abbr:(null!=(e=me(t))&&(this._locale=e),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var ri=x("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function oi(){return this._locale}var si=1e3,ai=60*si,hi=60*ai,li=3506328*hi;function ui(t,e){return(t%e+e)%e}function di(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-li:new Date(t,e,i).valueOf()}function ci(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-li:Date.UTC(t,e,i)}function fi(t,e){U(0,[t,t.length],0,e)}function pi(t,e,i,n,r){var o;return null==t?Bt(this,n,r).year:(e>(o=Xt(t,n,r))&&(e=o),mi.call(this,t,e,i,n,r))}function mi(t,e,i,n,r){var o=Vt(t,e,i,n,r),s=Ut(o.year,0,o.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}U(0,["gg",2],0,(function(){return this.weekYear()%100})),U(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),fi("gggg","weekYear"),fi("ggggg","weekYear"),fi("GGGG","isoWeekYear"),fi("GGGGG","isoWeekYear"),I("weekYear","gg"),I("isoWeekYear","GG"),R("weekYear",1),R("isoWeekYear",1),lt("G",rt),lt("g",rt),lt("GG",J,X),lt("gg",J,X),lt("GGGG",et,Z),lt("gggg",et,Z),lt("GGGGG",it,$),lt("ggggg",it,$),pt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=k(t)})),pt(["gg","GG"],(function(t,e,i,r){e[r]=n.parseTwoDigitYear(t)})),U("Q",0,"Qo","quarter"),I("quarter","Q"),R("quarter",7),lt("Q",B),ft("Q",(function(t,e){e[vt]=3*(k(t)-1)})),U("D",["DD",2],"Do","date"),I("date","D"),R("date",9),lt("D",J),lt("DD",J,X),lt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),ft(["D","DD"],yt),ft("Do",(function(t,e){e[yt]=k(t.match(J)[0])}));var gi=Ct("Date",!0);U("DDD",["DDDD",3],"DDDo","dayOfYear"),I("dayOfYear","DDD"),R("dayOfYear",4),lt("DDD",tt),lt("DDDD",q),ft(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=k(t)})),U("m",["mm",2],0,"minute"),I("minute","m"),R("minute",14),lt("m",J),lt("mm",J,X),ft(["m","mm"],bt);var vi=Ct("Minutes",!1);U("s",["ss",2],0,"second"),I("second","s"),R("second",15),lt("s",J),lt("ss",J,X),ft(["s","ss"],wt);var yi,_i=Ct("Seconds",!1);for(U("S",0,0,(function(){return~~(this.millisecond()/100)})),U(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),U(0,["SSS",3],0,"millisecond"),U(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),U(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),U(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),U(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),U(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),U(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),I("millisecond","ms"),R("millisecond",16),lt("S",tt,B),lt("SS",tt,X),lt("SSS",tt,q),yi="SSSS";yi.length<=9;yi+="S")lt(yi,nt);function bi(t,e){e[kt]=k(1e3*("0."+t))}for(yi="S";yi.length<=9;yi+="S")ft(yi,bi);var wi=Ct("Milliseconds",!1);U("z",0,0,"zoneAbbr"),U("zz",0,0,"zoneName");var ki=_.prototype;function Di(t){return t}ki.add=ti,ki.calendar=function(t,e){var i=t||Ie(),r=ze(i,this).startOf("day"),o=n.calendarFormat(this,r)||"sameElse",s=e&&(C(e[o])?e[o].call(this,i):e[o]);return this.format(s||this.localeData().calendar(o,this,Ie(i)))},ki.clone=function(){return new _(this)},ki.diff=function(t,e,i){var n,r,o;if(!this.isValid())return NaN;if(!(n=ze(t,this)).isValid())return NaN;switch(r=6e4*(n.utcOffset()-this.utcOffset()),e=A(e)){case"year":o=ii(this,n)/12;break;case"month":o=ii(this,n);break;case"quarter":o=ii(this,n)/3;break;case"second":o=(this-n)/1e3;break;case"minute":o=(this-n)/6e4;break;case"hour":o=(this-n)/36e5;break;case"day":o=(this-n-r)/864e5;break;case"week":o=(this-n-r)/6048e5;break;default:o=this-n}return i?o:w(o)},ki.endOf=function(t){var e;if(void 0===(t=A(t))||"millisecond"===t||!this.isValid())return this;var i=this._isUTC?ci:di;switch(t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=hi-ui(e+(this._isUTC?0:this.utcOffset()*ai),hi)-1;break;case"minute":e=this._d.valueOf(),e+=ai-ui(e,ai)-1;break;case"second":e=this._d.valueOf(),e+=si-ui(e,si)-1}return this._d.setTime(e),n.updateOffset(this,!0),this},ki.format=function(t){t||(t=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var e=z(this,t);return this.localeData().postformat(e)},ki.from=function(t,e){return this.isValid()&&(b(t)&&t.isValid()||Ie(t).isValid())?Ze({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},ki.fromNow=function(t){return this.from(Ie(),t)},ki.to=function(t,e){return this.isValid()&&(b(t)&&t.isValid()||Ie(t).isValid())?Ze({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},ki.toNow=function(t){return this.to(Ie(),t)},ki.get=function(t){return C(this[t=A(t)])?this[t]():this},ki.invalidAt=function(){return f(this).overflow},ki.isAfter=function(t,e){var i=b(t)?t:Ie(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=A(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())},ki.isBefore=function(t,e){var i=b(t)?t:Ie(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=A(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())},ki.isBetween=function(t,e,i,n){var r=b(t)?t:Ie(t),o=b(e)?e:Ie(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(n=n||"()")[0]?this.isAfter(r,i):!this.isBefore(r,i))&&(")"===n[1]?this.isBefore(o,i):!this.isAfter(o,i))},ki.isSame=function(t,e){var i,n=b(t)?t:Ie(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=A(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))},ki.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},ki.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},ki.isValid=function(){return p(this)},ki.lang=ri,ki.locale=ni,ki.localeData=oi,ki.max=Le,ki.min=Ae,ki.parsingFlags=function(){return d({},f(this))},ki.set=function(t,e){if("object"===xa(t))for(var i=function(t){var e=[];for(var i in t)e.push({unit:i,priority:N[i]});return e.sort((function(t,e){return t.priority-e.priority})),e}(t=L(t)),n=0;n<i.length;n++)this[i[n].unit](t[i[n].unit]);else if(C(this[t=A(t)]))return this[t](e);return this},ki.startOf=function(t){var e;if(void 0===(t=A(t))||"millisecond"===t||!this.isValid())return this;var i=this._isUTC?ci:di;switch(t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=ui(e+(this._isUTC?0:this.utcOffset()*ai),hi);break;case"minute":e=this._d.valueOf(),e-=ui(e,ai);break;case"second":e=this._d.valueOf(),e-=ui(e,si)}return this._d.setTime(e),n.updateOffset(this,!0),this},ki.subtract=ei,ki.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},ki.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},ki.toDate=function(){return new Date(this.valueOf())},ki.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?z(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):C(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",z(i,"Z")):z(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},ki.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var i="["+t+'("]',n=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",r=e+'[")]';return this.format(i+n+"-MM-DD[T]HH:mm:ss.SSS"+r)},ki.toJSON=function(){return this.isValid()?this.toISOString():null},ki.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},ki.unix=function(){return Math.floor(this.valueOf()/1e3)},ki.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},ki.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},ki.year=Ot,ki.isLeapYear=function(){return Mt(this.year())},ki.weekYear=function(t){return pi.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},ki.isoWeekYear=function(t){return pi.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},ki.quarter=ki.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},ki.month=jt,ki.daysInMonth=function(){return Pt(this.year(),this.month())},ki.week=ki.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},ki.isoWeek=ki.isoWeeks=function(t){var e=Bt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},ki.weeksInYear=function(){var t=this.localeData()._week;return Xt(this.year(),t.dow,t.doy)},ki.isoWeeksInYear=function(){return Xt(this.year(),1,4)},ki.date=gi,ki.day=ki.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},ki.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},ki.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},ki.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},ki.hour=ki.hours=ae,ki.minute=ki.minutes=vi,ki.second=ki.seconds=_i,ki.millisecond=ki.milliseconds=wi,ki.utcOffset=function(t,e,i){var r,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ue(st,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(r=Ve(this)),this._offset=t,this._isUTC=!0,null!=r&&this.add(r,"m"),o!==t&&(!e||this._changeInProgress?Qe(this,Ze(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:Ve(this)},ki.utc=function(t){return this.utcOffset(0,t)},ki.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Ve(this),"m")),this},ki.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ue(ot,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},ki.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ie(t).utcOffset():0,(this.utcOffset()-t)%60==0)},ki.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},ki.isLocal=function(){return!!this.isValid()&&!this._isUTC},ki.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},ki.isUtc=Be,ki.isUTC=Be,ki.zoneAbbr=function(){return this._isUTC?"UTC":""},ki.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},ki.dates=x("dates accessor is deprecated. Use date instead.",gi),ki.months=x("months accessor is deprecated. Use month instead",jt),ki.years=x("years accessor is deprecated. Use year instead",Ot),ki.zone=x("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),ki.isDSTShifted=x("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!s(this._isDSTShifted))return this._isDSTShifted;var t={};if(v(t,this),(t=Ye(t))._a){var e=t._isUTC?c(t._a):Ie(t._a);this._isDSTShifted=this.isValid()&&D(t._a,e.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var Si=Y.prototype;function xi(t,e,i,n){var r=me(),o=c().set(n,e);return r[i](o,t)}function Mi(t,e,i){if(a(t)&&(e=t,t=void 0),t=t||"",null!=e)return xi(t,e,i,"month");var n,r=[];for(n=0;n<12;n++)r[n]=xi(t,n,i,"month");return r}function Ti(t,e,i,n){"boolean"==typeof t?(a(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,a(e)&&(i=e,e=void 0),e=e||"");var r,o=me(),s=t?o._week.dow:0;if(null!=i)return xi(e,(i+s)%7,n,"day");var h=[];for(r=0;r<7;r++)h[r]=xi(e,(r+s)%7,n,"day");return h}Si.calendar=function(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return C(n)?n.call(e,i):n},Si.longDateFormat=function(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.replace(/MMMM|MM|DD|dddd/g,(function(t){return t.slice(1)})),this._longDateFormat[t])},Si.invalidDate=function(){return this._invalidDate},Si.ordinal=function(t){return this._ordinal.replace("%d",t)},Si.preparse=Di,Si.postformat=Di,Si.relativeTime=function(t,e,i,n){var r=this._relativeTime[i];return C(r)?r(t,e,i,n):r.replace(/%d/i,t)},Si.pastFuture=function(t,e){var i=this._relativeTime[t>0?"future":"past"];return C(i)?i(e):i.replace(/%s/i,e)},Si.set=function(t){var e,i;for(i in t)C(e=t[i])?this[i]=e:this["_"+i]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},Si.months=function(t,e){return t?r(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||It).test(e)?"format":"standalone"][t.month()]:r(this._months)?this._months:this._months.standalone},Si.monthsShort=function(t,e){return t?r(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[It.test(e)?"format":"standalone"][t.month()]:r(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},Si.monthsParse=function(t,e,i){var n,r,o;if(this._monthsParseExact)return Nt.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(r=c([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[n]=new RegExp(o.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}},Si.monthsRegex=function(t){return this._monthsParseExact?(u(this,"_monthsRegex")||Wt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(u(this,"_monthsRegex")||(this._monthsRegex=Ht),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},Si.monthsShortRegex=function(t){return this._monthsParseExact?(u(this,"_monthsRegex")||Wt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(u(this,"_monthsShortRegex")||(this._monthsShortRegex=Ft),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},Si.week=function(t){return Bt(t,this._week.dow,this._week.doy).week},Si.firstDayOfYear=function(){return this._week.doy},Si.firstDayOfWeek=function(){return this._week.dow},Si.weekdays=function(t,e){var i=r(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?qt(i,this._week.dow):t?i[t.day()]:i},Si.weekdaysMin=function(t){return!0===t?qt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},Si.weekdaysShort=function(t){return!0===t?qt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},Si.weekdaysParse=function(t,e,i){var n,r,o;if(this._weekdaysParseExact)return Kt.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(r=c([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[n]=new RegExp(o.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}},Si.weekdaysRegex=function(t){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||ie.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(u(this,"_weekdaysRegex")||(this._weekdaysRegex=Qt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},Si.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||ie.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(u(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=te),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},Si.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||ie.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(u(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=ee),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},Si.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},Si.meridiem=function(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"},fe("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===k(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),n.lang=x("moment.lang is deprecated. Use moment.locale instead.",fe),n.langData=x("moment.langData is deprecated. Use moment.localeData instead.",me);var Oi=Math.abs;function Ci(t,e,i,n){var r=Ze(e,i);return t._milliseconds+=n*r._milliseconds,t._days+=n*r._days,t._months+=n*r._months,t._bubble()}function Ei(t){return t<0?Math.floor(t):Math.ceil(t)}function Yi(t){return 4800*t/146097}function Pi(t){return 146097*t/4800}function Ii(t){return function(){return this.as(t)}}var Ai=Ii("ms"),Li=Ii("s"),Ni=Ii("m"),Ri=Ii("h"),ji=Ii("d"),Fi=Ii("w"),Hi=Ii("M"),Wi=Ii("Q"),Gi=Ii("y");function Ui(t){return function(){return this.isValid()?this._data[t]:NaN}}var zi=Ui("milliseconds"),Vi=Ui("seconds"),Bi=Ui("minutes"),Xi=Ui("hours"),qi=Ui("days"),Zi=Ui("months"),$i=Ui("years"),Ji=Math.round,Ki={ss:44,s:45,m:45,h:22,d:26,M:11};function Qi(t,e,i,n,r){return r.relativeTime(e||1,!!i,t,n)}var tn=Math.abs;function en(t){return(t>0)-(t<0)||+t}function nn(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i=tn(this._milliseconds)/1e3,n=tn(this._days),r=tn(this._months);t=w(i/60),e=w(t/60),i%=60,t%=60;var o=w(r/12),s=r%=12,a=n,h=e,l=t,u=i?i.toFixed(3).replace(/\.?0+$/,""):"",d=this.asSeconds();if(!d)return"P0D";var c=d<0?"-":"",f=en(this._months)!==en(d)?"-":"",p=en(this._days)!==en(d)?"-":"",m=en(this._milliseconds)!==en(d)?"-":"";return c+"P"+(o?f+o+"Y":"")+(s?f+s+"M":"")+(a?p+a+"D":"")+(h||l||u?"T":"")+(h?m+h+"H":"")+(l?m+l+"M":"")+(u?m+u+"S":"")}var rn=je.prototype;return rn.isValid=function(){return this._isValid},rn.abs=function(){var t=this._data;return this._milliseconds=Oi(this._milliseconds),this._days=Oi(this._days),this._months=Oi(this._months),t.milliseconds=Oi(t.milliseconds),t.seconds=Oi(t.seconds),t.minutes=Oi(t.minutes),t.hours=Oi(t.hours),t.months=Oi(t.months),t.years=Oi(t.years),this},rn.add=function(t,e){return Ci(this,t,e,1)},rn.subtract=function(t,e){return Ci(this,t,e,-1)},rn.as=function(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=A(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Yi(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Pi(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}},rn.asMilliseconds=Ai,rn.asSeconds=Li,rn.asMinutes=Ni,rn.asHours=Ri,rn.asDays=ji,rn.asWeeks=Fi,rn.asMonths=Hi,rn.asQuarters=Wi,rn.asYears=Gi,rn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*k(this._months/12):NaN},rn._bubble=function(){var t,e,i,n,r,o=this._milliseconds,s=this._days,a=this._months,h=this._data;return o>=0&&s>=0&&a>=0||o<=0&&s<=0&&a<=0||(o+=864e5*Ei(Pi(a)+s),s=0,a=0),h.milliseconds=o%1e3,t=w(o/1e3),h.seconds=t%60,e=w(t/60),h.minutes=e%60,i=w(e/60),h.hours=i%24,s+=w(i/24),r=w(Yi(s)),a+=r,s-=Ei(Pi(r)),n=w(a/12),a%=12,h.days=s,h.months=a,h.years=n,this},rn.clone=function(){return Ze(this)},rn.get=function(t){return t=A(t),this.isValid()?this[t+"s"]():NaN},rn.milliseconds=zi,rn.seconds=Vi,rn.minutes=Bi,rn.hours=Xi,rn.days=qi,rn.weeks=function(){return w(this.days()/7)},rn.months=Zi,rn.years=$i,rn.humanize=function(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),i=function(t,e,i){var n=Ze(t).abs(),r=Ji(n.as("s")),o=Ji(n.as("m")),s=Ji(n.as("h")),a=Ji(n.as("d")),h=Ji(n.as("M")),l=Ji(n.as("y")),u=r<=Ki.ss&&["s",r]||r<Ki.s&&["ss",r]||o<=1&&["m"]||o<Ki.m&&["mm",o]||s<=1&&["h"]||s<Ki.h&&["hh",s]||a<=1&&["d"]||a<Ki.d&&["dd",a]||h<=1&&["M"]||h<Ki.M&&["MM",h]||l<=1&&["y"]||["yy",l];return u[2]=e,u[3]=+t>0,u[4]=i,Qi.apply(null,u)}(this,!t,e);return t&&(i=e.pastFuture(+this,i)),e.postformat(i)},rn.toISOString=nn,rn.toString=nn,rn.toJSON=nn,rn.locale=ni,rn.localeData=oi,rn.toIsoString=x("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",nn),rn.lang=ri,U("X",0,0,"unix"),U("x",0,0,"valueOf"),lt("x",rt),lt("X",/[+-]?\d+(\.\d{1,3})?/),ft("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t,10))})),ft("x",(function(t,e,i){i._d=new Date(k(t))})),n.version="2.24.0",e=Ie,n.fn=ki,n.min=function(){return Ne("isBefore",[].slice.call(arguments,0))},n.max=function(){return Ne("isAfter",[].slice.call(arguments,0))},n.now=function(){return Date.now?Date.now():+new Date},n.utc=c,n.unix=function(t){return Ie(1e3*t)},n.months=function(t,e){return Mi(t,e,"months")},n.isDate=h,n.locale=fe,n.invalid=m,n.duration=Ze,n.isMoment=b,n.weekdays=function(t,e,i){return Ti(t,e,i,"weekdays")},n.parseZone=function(){return Ie.apply(null,arguments).parseZone()},n.localeData=me,n.isDuration=Fe,n.monthsShort=function(t,e){return Mi(t,e,"monthsShort")},n.weekdaysMin=function(t,e,i){return Ti(t,e,i,"weekdaysMin")},n.defineLocale=pe,n.updateLocale=function(t,e){if(null!=e){var i,n,r=he;null!=(n=ce(t))&&(r=n._config),e=E(r,e),(i=new Y(e)).parentLocale=le[t],le[t]=i,fe(t)}else null!=le[t]&&(null!=le[t].parentLocale?le[t]=le[t].parentLocale:null!=le[t]&&delete le[t]);return le[t]},n.locales=function(){return M(le)},n.weekdaysShort=function(t,e,i){return Ti(t,e,i,"weekdaysShort")},n.normalizeUnits=A,n.relativeTimeRounding=function(t){return void 0===t?Ji:"function"==typeof t&&(Ji=t,!0)},n.relativeTimeThreshold=function(t,e){return void 0!==Ki[t]&&(void 0===e?Ki[t]:(Ki[t]=e,"s"===t&&(Ki.ss=e-1),!0))},n.calendarFormat=function(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},n.prototype=ki,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n}()})),za=[],Va=0;Va<256;Va++)za[Va]=(Va+256).toString(16).substr(1);for(var Ba=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var e=new Array(16);return function(){for(var t,i=0;i<16;i++)0==(3&i)&&(t=4294967296*Math.random()),e[i]=t>>>((3&i)<<3)&255;return e}}(),Xa=[],qa=0;qa<256;qa++)Xa[qa]=(qa+256).toString(16).substr(1);var Za=Ba();Za[0],Za[1],Za[2],Za[3],Za[4],Za[5],Za[6],Za[7];function $a(t,e){var i=Object.keys(t);return Object.getOwnPropertySymbols&&i.push.apply(i,Object.getOwnPropertySymbols(t)),e&&(i=i.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),i}var Ja=/^\/?Date\((-?\d+)/i,Ka=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Qa=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function th(t){return t instanceof Number||"number"==typeof t}function eh(t){return t instanceof String||"string"==typeof t}function ih(t){return"object"===Ga(t)&&null!==t}function nh(t){return Ua.isMoment(t)}function rh(t,e,i,n){var r=!1;!0===n&&(r=null===e[i]&&void 0!==t[i]),r?delete t[i]:t[i]=e[i]}var oh=Object.assign;function sh(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)||!0===i)if(e[r]&&e[r].constructor===Object)void 0===t[r]&&(t[r]={}),t[r].constructor===Object?sh(t[r],e[r],i):rh(t,e,r,n);else if(Array.isArray(e[r])){t[r]=[];for(var o=0;o<e[r].length;o++)t[r].push(e[r][o])}else rh(t,e,r,n);return t}function ah(t){var e=Ga(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Array.isArray(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}var hh=Object.values;var lh={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),eh(t)?t:th(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function uh(t){var e;switch(t.length){case 3:case 4:return(e=Qa.exec(t))?{r:parseInt(e[1]+e[1],16),g:parseInt(e[2]+e[2],16),b:parseInt(e[3]+e[3],16)}:null;case 6:case 7:return(e=Ka.exec(t))?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16)}:null;default:return null}}function dh(t,e,i){return"#"+((1<<24)+(t<<16)+(e<<8)+i).toString(16).slice(1)}function ch(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),r=Math.max(t,Math.max(e,i));return n===r?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(r-n))/360,s:(r-n)/r,v:r}}var fh={split:function(t){var e={};return t.split(";").forEach((function(t){if(""!=t.trim()){var i=t.split(":"),n=i[0].trim(),r=i[1].trim();e[n]=r}})),e},join:function(t){return Object.keys(t).map((function(e){return e+": "+t[e]})).join("; ")}};function ph(t,e,i){var n,r,o,s=Math.floor(6*t),a=6*t-s,h=i*(1-e),l=i*(1-a*e),u=i*(1-(1-a)*e);switch(s%6){case 0:n=i,r=u,o=h;break;case 1:n=l,r=i,o=h;break;case 2:n=h,r=i,o=u;break;case 3:n=h,r=l,o=i;break;case 4:n=u,r=h,o=i;break;case 5:n=i,r=h,o=l}return{r:Math.floor(255*n),g:Math.floor(255*r),b:Math.floor(255*o)}}function mh(t,e,i){var n=ph(t,e,i);return dh(n.r,n.g,n.b)}function gh(t){var e=uh(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return ch(e.r,e.g,e.b)}function vh(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function yh(t){return t=t.replace(" ",""),/rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/i.test(t)}function _h(t){if(null===t||"object"!==Ga(t))return null;if(t instanceof Element)return t;var e=Object.create(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Ga(t[i])&&(e[i]=_h(t[i]));return e}var bh=Object.freeze({isNumber:th,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},isString:eh,isObject:ih,isDate:function(t){if(t instanceof Date)return!0;if(eh(t)){if(Ja.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isMoment:nh,fillIfDefined:function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var r in e)if(void 0!==i[r])if(null===i[r]||"object"!==Ga(i[r]))rh(e,i,r,n);else{var o=e[r],s=i[r];ih(o)&&ih(s)&&t(o,s,n)}},extend:oh,selectiveExtend:function(t,e){if(!Array.isArray(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),r=2;r<i;r++)n[r-2]=arguments[r];for(var o=0,s=n;o<s.length;o++)for(var a=s[o],h=0;h<t.length;h++){var l=t[h];a&&Object.prototype.hasOwnProperty.call(a,l)&&(e[l]=a[l])}return e},selectiveDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Array.isArray(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r=0;r<t.length;r++){var o=t[r];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?sh(e[o],i[o],!1,n):rh(e,i,o,n);else{if(Array.isArray(i[o]))throw new TypeError("Arrays are not supported by deepExtend");rh(e,i,o,n)}}return e},selectiveNotDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Array.isArray(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r in i)if(Object.prototype.hasOwnProperty.call(i,r)&&-1===t.indexOf(r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?sh(e[r],i[r]):rh(e,i,r,n);else if(Array.isArray(i[r])){e[r]=[];for(var o=0;o<i[r].length;o++)e[r].push(i[r][o])}else rh(e,i,r,n);return e},deepExtend:sh,equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},convert:function(t,e){var i;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return eh(t)&&!isNaN(Date.parse(t))?Ua(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(th(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(nh(t))return new Date(t.valueOf());if(eh(t))return(i=Ja.exec(t))?new Date(Number(i[1])):Ua(new Date(t)).toDate();throw new Error("Cannot convert object of type "+ah(t)+" to type Date");case"Moment":if(th(t))return Ua(t);if(t instanceof Date)return Ua(t.valueOf());if(nh(t))return Ua(t);if(eh(t))return i=Ja.exec(t),Ua(i?Number(i[1]):t);throw new Error("Cannot convert object of type "+ah(t)+" to type Date");case"ISODate":if(th(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(nh(t))return t.toDate().toISOString();if(eh(t))return(i=Ja.exec(t))?new Date(Number(i[1])).toISOString():Ua(t).format();throw new Error("Cannot convert object of type "+ah(t)+" to type ISODate");case"ASPDate":if(th(t))return"/Date("+t+")/";if(t instanceof Date||nh(t))return"/Date("+t.valueOf()+")/";if(eh(t))return"/Date("+((i=Ja.exec(t))?new Date(Number(i[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+ah(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}},getType:ah,copyAndExtendArray:function(t,e){return[].concat(Fa(t),[e])},copyArray:function(t){return t.slice()},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=i.concat(n.filter((function(t){return i.indexOf(t)<0}))),t.className=i.join(" ")},removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=i.filter((function(t){return n.indexOf(t)<0})),t.className=i.join(" ")},forEach:function(t,e){if(Array.isArray(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e(t[r],r,t)},toArray:hh,updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},addEventListener:function(t,e,i,n){t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&navigator.userAgent.indexOf("Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)},removeEventListener:function(t,e,i,n){t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&navigator.userAgent.indexOf("Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)},preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},option:lh,hexToRGB:uh,overrideOpacity:function(t,e){if(-1!==t.indexOf("rgba"))return t;if(-1!==t.indexOf("rgb")){var i=t.substr(t.indexOf("(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=uh(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},RGBToHex:dh,parseColor:function(t,e){if(eh(t)){var i=t;if(yh(i)){var n=i.substr(4).substr(0,i.length-5).split(",").map((function(t){return parseInt(t)}));i=dh(n[0],n[1],n[2])}if(!0===vh(i)){var r=gh(i),o={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},s={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},a=mh(s.h,s.s,s.v),h=mh(o.h,o.s,o.v);return{background:i,border:a,highlight:{background:h,border:a},hover:{background:h,border:a}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:eh(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:eh(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:eh(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:eh(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},RGBToHSV:ch,addCssText:function(t,e){var i=function(t){for(var e=1;e<arguments.length;e++){var i=null!=arguments[e]?arguments[e]:{};e%2?$a(i,!0).forEach((function(e){La(t,e,i[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(i)):$a(i).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(i,e))}))}return t}({},fh.split(t.style.cssText),{},fh.split(e));t.style.cssText=fh.join(i)},removeCssText:function(t,e){var i=fh.split(t.style.cssText),n=fh.split(e);for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&delete i[r];t.style.cssText=fh.join(i)},HSVToRGB:ph,HSVToHex:mh,hexToHSV:gh,isValidHex:vh,isValidRGB:yh,isValidRGBA:function(t){return t=t.replace(" ",""),/rgba\((\d{1,3}),(\d{1,3}),(\d{1,3}),(0?.{1,3})\)/i.test(t)},selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Ga(e)){for(var i=Object.create(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Ga(e[t[n]])&&(i[t[n]]=_h(e[t[n]]));return i}return null},bridgeObject:_h,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],r=void 0;for(r=i;r>0&&e(n,t[r-1])<0;r--)t[r]=t[r-1];t[r]=n}return t},mergeOptions:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=function(t){return null!=t},o=function(t){return null!==t&&"object"===Ga(t)};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!r(i))throw new Error("Parameter option must have a value");if(!o(n))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=o(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[i]:void 0,h=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return o(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!o(t[i])){if(!r(a))return;t[i]=Object.create(a)}if(o(s)){var l=!0;void 0!==s.enabled?l=s.enabled:void 0!==h&&(l=a.enabled),function(t,e,i){o(t[i])||(t[i]={});var n=e[i],r=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(r[s]=n[s])}(t,e,i),t[i].enabled=l}}},binarySearchCustom:function(t,e,i,n){for(var r=0,o=0,s=t.length-1;o<=s&&r<1e4;){var a=Math.floor((o+s)/2),h=t[a],l=e(void 0===n?h[i]:h[i][n]);if(0==l)return a;-1==l?o=a+1:s=a-1,r++}return-1},binarySearchValue:function(t,e,i,n,r){var o,s,a,h,l=0,u=0,d=t.length-1;for(r=null!=r?r:function(t,e){return t==e?0:t<e?-1:1};u<=d&&l<1e4;){if(h=Math.floor(.5*(d+u)),o=t[Math.max(0,h-1)][i],s=t[h][i],a=t[Math.min(t.length-1,h+1)][i],0==r(s,e))return h;if(r(o,e)<0&&r(s,e)>0)return"before"==n?Math.max(0,h-1):h;if(r(s,e)<0&&r(a,e)>0)return"before"==n?h:Math.min(t.length-1,h+1);r(s,e)<0?u=h+1:d=h-1,l++}return-1},easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},topMost:function(t,e){var i;Array.isArray(e)||(e=[e]);var n=!0,r=!1,o=void 0;try{for(var s,a=t[Symbol.iterator]();!(n=(s=a.next()).done);n=!0){var h=s.value;if(h){i=h[e[0]];for(var l=1;l<e.length;l++)i&&(i=i[e[l]]);if(void 0!==i)break}}}catch(t){r=!0,o=t}finally{try{n||null==a.return||a.return()}finally{if(r)throw o}}return i},randomUUID:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},e=arguments.length>1?arguments[1]:void 0,i=arguments.length>2?arguments[2]:void 0,n=e&&i||0;"string"==typeof t&&(e="binary"===t?new Array(16):void 0,t={});var r=t.random||(t.rng||Ba)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e)for(var o=0;o<16;o++)e[n+o]=r[o];return e||function(t,e){var i=e||0,n=za;return n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]}(r)}});function wh(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])}function kh(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function Dh(t){wh(t),kh(t),wh(t)}function Sh(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}function xh(t,e,i,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElement(t),void 0!==n?i.insertBefore(r,n):i.appendChild(r)):(r=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(r,n):i.appendChild(r)),e[t].used.push(r),r}function Mh(t,e,i,n,r,o){var s;if("circle"==i.style?((s=Sh("circle",n,r)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=Sh("rect",n,r)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),o){var a=Sh("text",n,r);o.xOffset&&(t+=o.xOffset),o.yOffset&&(e+=o.yOffset),o.content&&(a.textContent=o.content),o.className&&a.setAttributeNS(null,"class",o.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s}function Th(t,e,i,n,r,o,s,a){if(0!=n){n<0&&(e-=n*=-1);var h=Sh("rect",o,s);h.setAttributeNS(null,"x",t-.5*i),h.setAttributeNS(null,"y",e),h.setAttributeNS(null,"width",i),h.setAttributeNS(null,"height",n),h.setAttributeNS(null,"class",r),a&&h.setAttributeNS(null,"style",a)}}var Oh=Object.freeze({prepareElements:wh,cleanupElements:kh,resetElements:Dh,getSVGElement:Sh,getDOMElement:xh,drawPoint:Mh,drawBar:Th}),Ch=Hs.left;Et({target:"Array",proto:!0,forced:Ke("reduce")},{reduce:function(t){return Ch(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Eh=Math.max,Yh=Math.min;Et({target:"Array",proto:!0,forced:!Be("splice")},{splice:function(t,e){var i,n,r,o,s,a,h=It(this),l=ht(h.length),u=dt(t,l),d=arguments.length;if(0===d?i=n=0:1===d?(i=0,n=l-u):(i=d-2,n=Yh(Eh(st(e),0),l-u)),l+i-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(r=ne(h,n),o=0;o<n;o++)(s=u+o)in h&&ze(r,o,h[s]);if(r.length=n,i<n){for(o=u;o<l-n;o++)a=o+i,(s=o+n)in h?h[a]=h[s]:delete h[a];for(o=l;o>l-n+i;o--)delete h[o-1]}else if(i>n)for(o=l-n;o>u;o--)a=o+i-1,(s=o+n-1)in h?h[a]=h[s]:delete h[a];for(o=0;o<i;o++)h[o+u]=arguments[o+2];return h.length=l-n+i,r}});var Ph=u((function(){Ei(1)}));Et({target:"Object",stat:!0,forced:Ph,sham:!Ti},{getPrototypeOf:function(t){return Ei(It(t))}}),Et({target:"Object",stat:!0},{setPrototypeOf:Ni});var Ih=
/** 
	 * vis-data - data
	 * http://visjs.org/
	 * 
	 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
	 * 
	 * @version 6.1.0
	 * @date    2019-07-16T13:37:00Z
	 * 
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2018-2019 visjs contributors, https://github.com/visjs
	 * 
	 * @license 
	 * vis.js is dual licensed under both
	 * 
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 * 
	 *   and
	 * 
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 * 
	 * vis.js may be distributed under either license.
	 */
function(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t};function Ah(t,e){return t(e={exports:{}},e.exports),e.exports}var Lh=Ah((function(t){function e(t){return(e="function"==typeof Symbol&&"symbol"===xa(Symbol.iterator)?function(t){return xa(t)}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":xa(t)})(t)}function i(n){return"function"==typeof Symbol&&"symbol"===e(Symbol.iterator)?t.exports=i=function(t){return e(t)}:t.exports=i=function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":e(t)},i(n)}t.exports=i}));var Nh=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Rh(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}var jh=function(t,e,i){return e&&Rh(t.prototype,e),i&&Rh(t,i),t};var Fh=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Hh=function(t,e){return!e||"object"!==Lh(e)&&"function"!=typeof e?Fh(t):e},Wh=Ah((function(t){function e(i){return t.exports=e=Object.setPrototypeOf?Object.getPrototypeOf:function(t){return t.__proto__||Object.getPrototypeOf(t)},e(i)}t.exports=e})),Gh=Ah((function(t){function e(i,n){return t.exports=e=Object.setPrototypeOf||function(t,e){return t.__proto__=e,t},e(i,n)}t.exports=e}));for(var Uh=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Gh(t,e)},zh=[],Vh=0;Vh<256;Vh++)zh[Vh]=(Vh+256).toString(16).substr(1);for(var Bh=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var e=new Array(16);return function(){for(var t,i=0;i<16;i++)0==(3&i)&&(t=4294967296*Math.random()),e[i]=t>>>((3&i)<<3)&255;return e}}(),Xh=[],qh=0;qh<256;qh++)Xh[qh]=(qh+256).toString(16).substr(1);var Zh=Bh();Zh[0],Zh[1],Zh[2],Zh[3],Zh[4],Zh[5],Zh[6],Zh[7];function $h(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},e=arguments.length>1?arguments[1]:void 0,i=arguments.length>2?arguments[2]:void 0,n=e&&i||0;"string"==typeof t&&(e="binary"===t?new Array(16):void 0,t={});var r=t.random||(t.rng||Bh)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e)for(var o=0;o<16;o++)e[n+o]=r[o];return e||function(t,e){var i=e||0,n=zh;return n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+"-"+n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]+n[t[i++]]}(r)}function Jh(t){return(Jh="function"==typeof Symbol&&"symbol"===xa(Symbol.iterator)?function(t){return xa(t)}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":xa(t)})(t)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Kh(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}for(var Qh=function(t,e){return t(e={exports:{}},e.exports),e.exports}((function(t,e){t.exports=function(){var e,i;function n(){return e.apply(null,arguments)}function r(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function s(t){return void 0===t}function a(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function h(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function l(t,e){var i,n=[];for(i=0;i<t.length;++i)n.push(e(t[i],i));return n}function u(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function d(t,e){for(var i in e)u(e,i)&&(t[i]=e[i]);return u(e,"toString")&&(t.toString=e.toString),u(e,"valueOf")&&(t.valueOf=e.valueOf),t}function c(t,e,i,n){return Pe(t,e,i,n,!0).utc()}function f(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function p(t){if(null==t._isValid){var e=f(t),n=i.call(e.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function m(t){var e=c(NaN);return null!=t?d(f(e),t):f(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),i=e.length>>>0,n=0;n<i;n++)if(n in e&&t.call(this,e[n],n,e))return!0;return!1};var g=n.momentProperties=[];function v(t,e){var i,n,r;if(s(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),s(e._i)||(t._i=e._i),s(e._f)||(t._f=e._f),s(e._l)||(t._l=e._l),s(e._strict)||(t._strict=e._strict),s(e._tzm)||(t._tzm=e._tzm),s(e._isUTC)||(t._isUTC=e._isUTC),s(e._offset)||(t._offset=e._offset),s(e._pf)||(t._pf=f(e)),s(e._locale)||(t._locale=e._locale),g.length>0)for(i=0;i<g.length;i++)s(r=e[n=g[i]])||(t[n]=r);return t}var y=!1;function _(t){v(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===y&&(y=!0,n.updateOffset(this),y=!1)}function b(t){return t instanceof _||null!=t&&null!=t._isAMomentObject}function w(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function k(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=w(e)),i}function D(t,e,i){var n,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),s=0;for(n=0;n<r;n++)(i&&t[n]!==e[n]||!i&&k(t[n])!==k(e[n]))&&s++;return s+o}function S(t){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function x(t,e){var i=!0;return d((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,t),i){for(var r,o=[],s=0;s<arguments.length;s++){if(r="","object"===xa(arguments[s])){for(var a in r+="\n["+s+"] ",arguments[0])r+=a+": "+arguments[0][a]+", ";r=r.slice(0,-2)}else r=arguments[s];o.push(r)}S(t+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var M,T={};function O(t,e){null!=n.deprecationHandler&&n.deprecationHandler(t,e),T[t]||(S(e),T[t]=!0)}function C(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function E(t,e){var i,n=d({},t);for(i in e)u(e,i)&&(o(t[i])&&o(e[i])?(n[i]={},d(n[i],t[i]),d(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)u(t,i)&&!u(e,i)&&o(t[i])&&(n[i]=d({},n[i]));return n}function Y(t){null!=t&&this.set(t)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,M=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)u(t,e)&&i.push(e);return i};var P={};function I(t,e){var i=t.toLowerCase();P[i]=P[i+"s"]=P[e]=t}function A(t){return"string"==typeof t?P[t]||P[t.toLowerCase()]:void 0}function L(t){var e,i,n={};for(i in t)u(t,i)&&(e=A(i))&&(n[e]=t[i]);return n}var N={};function R(t,e){N[t]=e}function j(t,e,i){var n=""+Math.abs(t),r=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+n}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,H=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,W={},G={};function U(t,e,i,n){var r=n;"string"==typeof n&&(r=function(){return this[n]()}),t&&(G[t]=r),e&&(G[e[0]]=function(){return j(r.apply(this,arguments),e[1],e[2])}),i&&(G[i]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function z(t,e){return t.isValid()?(e=V(e,t.localeData()),W[e]=W[e]||function(t){var e,i,n,r=t.match(F);for(e=0,i=r.length;e<i;e++)G[r[e]]?r[e]=G[r[e]]:r[e]=(n=r[e]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(e){var n,o="";for(n=0;n<i;n++)o+=C(r[n])?r[n].call(e,t):r[n];return o}}(e),W[e](t)):t.localeData().invalidDate()}function V(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(H.lastIndex=0;i>=0&&H.test(t);)t=t.replace(H,n),H.lastIndex=0,i-=1;return t}var B=/\d/,X=/\d\d/,q=/\d{3}/,Z=/\d{4}/,$=/[+-]?\d{6}/,J=/\d\d?/,K=/\d\d\d\d?/,Q=/\d\d\d\d\d\d?/,tt=/\d{1,3}/,et=/\d{1,4}/,it=/[+-]?\d{1,6}/,nt=/\d+/,rt=/[+-]?\d+/,ot=/Z|[+-]\d\d:?\d\d/gi,st=/Z|[+-]\d\d(?::?\d\d)?/gi,at=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,ht={};function lt(t,e,i){ht[t]=C(e)?e:function(t,n){return t&&i?i:e}}function ut(t,e){return u(ht,t)?ht[t](e._strict,e._locale):new RegExp(dt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,r){return e||i||n||r}))))}function dt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ct={};function ft(t,e){var i,n=e;for("string"==typeof t&&(t=[t]),a(e)&&(n=function(t,i){i[e]=k(t)}),i=0;i<t.length;i++)ct[t[i]]=n}function pt(t,e){ft(t,(function(t,i,n,r){n._w=n._w||{},e(t,n._w,n,r)}))}function mt(t,e,i){null!=e&&u(ct,t)&&ct[t](e,i._a,i,t)}var gt=0,vt=1,yt=2,_t=3,bt=4,wt=5,kt=6,Dt=7,St=8;function xt(t){return Mt(t)?366:365}function Mt(t){return t%4==0&&t%100!=0||t%400==0}U("Y",0,0,(function(){var t=this.year();return t<=9999?""+t:"+"+t})),U(0,["YY",2],0,(function(){return this.year()%100})),U(0,["YYYY",4],0,"year"),U(0,["YYYYY",5],0,"year"),U(0,["YYYYYY",6,!0],0,"year"),I("year","y"),R("year",1),lt("Y",rt),lt("YY",J,X),lt("YYYY",et,Z),lt("YYYYY",it,$),lt("YYYYYY",it,$),ft(["YYYYY","YYYYYY"],gt),ft("YYYY",(function(t,e){e[gt]=2===t.length?n.parseTwoDigitYear(t):k(t)})),ft("YY",(function(t,e){e[gt]=n.parseTwoDigitYear(t)})),ft("Y",(function(t,e){e[gt]=parseInt(t,10)})),n.parseTwoDigitYear=function(t){return k(t)+(k(t)>68?1900:2e3)};var Tt,Ot=Ct("FullYear",!0);function Ct(t,e){return function(i){return null!=i?(Yt(this,t,i),n.updateOffset(this,e),this):Et(this,t)}}function Et(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Yt(t,e,i){t.isValid()&&!isNaN(i)&&("FullYear"===e&&Mt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](i,t.month(),Pt(i,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](i))}function Pt(t,e){if(isNaN(t)||isNaN(e))return NaN;var i,n=(e%(i=12)+i)%i;return t+=(e-n)/12,1===n?Mt(t)?29:28:31-n%7%2}Tt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},U("M",["MM",2],"Mo",(function(){return this.month()+1})),U("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),U("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),I("month","M"),R("month",8),lt("M",J),lt("MM",J,X),lt("MMM",(function(t,e){return e.monthsShortRegex(t)})),lt("MMMM",(function(t,e){return e.monthsRegex(t)})),ft(["M","MM"],(function(t,e){e[vt]=k(t)-1})),ft(["MMM","MMMM"],(function(t,e,i,n){var r=i._locale.monthsParse(t,n,i._strict);null!=r?e[vt]=r:f(i).invalidMonth=t}));var It=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,At="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Lt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Nt(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)o=c([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(o,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(r=Tt.call(this._shortMonthsParse,s))?r:null:-1!==(r=Tt.call(this._longMonthsParse,s))?r:null:"MMM"===e?-1!==(r=Tt.call(this._shortMonthsParse,s))?r:-1!==(r=Tt.call(this._longMonthsParse,s))?r:null:-1!==(r=Tt.call(this._longMonthsParse,s))?r:-1!==(r=Tt.call(this._shortMonthsParse,s))?r:null}function Rt(t,e){var i;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=k(e);else if(!a(e=t.localeData().monthsParse(e)))return t;return i=Math.min(t.date(),Pt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,i),t}function jt(t){return null!=t?(Rt(this,t),n.updateOffset(this,!0),this):Et(this,"Month")}var Ft=at,Ht=at;function Wt(){function t(t,e){return e.length-t.length}var e,i,n=[],r=[],o=[];for(e=0;e<12;e++)i=c([2e3,e]),n.push(this.monthsShort(i,"")),r.push(this.months(i,"")),o.push(this.months(i,"")),o.push(this.monthsShort(i,""));for(n.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)n[e]=dt(n[e]),r[e]=dt(r[e]);for(e=0;e<24;e++)o[e]=dt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function Gt(t,e,i,n,r,o,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,r,o,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,r,o,s),a}function Ut(t){var e;if(t<100&&t>=0){var i=Array.prototype.slice.call(arguments);i[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function zt(t,e,i){var n=7+e-i;return-(7+Ut(t,0,n).getUTCDay()-e)%7+n-1}function Vt(t,e,i,n,r){var o,s,a=1+7*(e-1)+(7+i-n)%7+zt(t,n,r);return a<=0?s=xt(o=t-1)+a:a>xt(t)?(o=t+1,s=a-xt(t)):(o=t,s=a),{year:o,dayOfYear:s}}function Bt(t,e,i){var n,r,o=zt(t.year(),e,i),s=Math.floor((t.dayOfYear()-o-1)/7)+1;return s<1?n=s+Xt(r=t.year()-1,e,i):s>Xt(t.year(),e,i)?(n=s-Xt(t.year(),e,i),r=t.year()+1):(r=t.year(),n=s),{week:n,year:r}}function Xt(t,e,i){var n=zt(t,e,i),r=zt(t+1,e,i);return(xt(t)-n+r)/7}function qt(t,e){return t.slice(e,7).concat(t.slice(0,e))}U("w",["ww",2],"wo","week"),U("W",["WW",2],"Wo","isoWeek"),I("week","w"),I("isoWeek","W"),R("week",5),R("isoWeek",5),lt("w",J),lt("ww",J,X),lt("W",J),lt("WW",J,X),pt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=k(t)})),U("d",0,"do","day"),U("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),U("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),U("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),U("e",0,0,"weekday"),U("E",0,0,"isoWeekday"),I("day","d"),I("weekday","e"),I("isoWeekday","E"),R("day",11),R("weekday",11),R("isoWeekday",11),lt("d",J),lt("e",J),lt("E",J),lt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),lt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),lt("dddd",(function(t,e){return e.weekdaysRegex(t)})),pt(["dd","ddd","dddd"],(function(t,e,i,n){var r=i._locale.weekdaysParse(t,n,i._strict);null!=r?e.d=r:f(i).invalidWeekday=t})),pt(["d","e","E"],(function(t,e,i,n){e[n]=k(t)}));var Zt="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),$t="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Jt="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Kt(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)o=c([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(o,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(r=Tt.call(this._weekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:null:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:null:"dddd"===e?-1!==(r=Tt.call(this._weekdaysParse,s))?r:-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:-1!==(r=Tt.call(this._weekdaysParse,s))?r:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:null:-1!==(r=Tt.call(this._minWeekdaysParse,s))?r:-1!==(r=Tt.call(this._weekdaysParse,s))?r:-1!==(r=Tt.call(this._shortWeekdaysParse,s))?r:null}var Qt=at,te=at,ee=at;function ie(){function t(t,e){return e.length-t.length}var e,i,n,r,o,s=[],a=[],h=[],l=[];for(e=0;e<7;e++)i=c([2e3,1]).day(e),n=this.weekdaysMin(i,""),r=this.weekdaysShort(i,""),o=this.weekdays(i,""),s.push(n),a.push(r),h.push(o),l.push(n),l.push(r),l.push(o);for(s.sort(t),a.sort(t),h.sort(t),l.sort(t),e=0;e<7;e++)a[e]=dt(a[e]),h[e]=dt(h[e]),l[e]=dt(l[e]);this._weekdaysRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function ne(){return this.hours()%12||12}function re(t,e){U(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function oe(t,e){return e._meridiemParse}U("H",["HH",2],0,"hour"),U("h",["hh",2],0,ne),U("k",["kk",2],0,(function(){return this.hours()||24})),U("hmm",0,0,(function(){return""+ne.apply(this)+j(this.minutes(),2)})),U("hmmss",0,0,(function(){return""+ne.apply(this)+j(this.minutes(),2)+j(this.seconds(),2)})),U("Hmm",0,0,(function(){return""+this.hours()+j(this.minutes(),2)})),U("Hmmss",0,0,(function(){return""+this.hours()+j(this.minutes(),2)+j(this.seconds(),2)})),re("a",!0),re("A",!1),I("hour","h"),R("hour",13),lt("a",oe),lt("A",oe),lt("H",J),lt("h",J),lt("k",J),lt("HH",J,X),lt("hh",J,X),lt("kk",J,X),lt("hmm",K),lt("hmmss",Q),lt("Hmm",K),lt("Hmmss",Q),ft(["H","HH"],_t),ft(["k","kk"],(function(t,e,i){var n=k(t);e[_t]=24===n?0:n})),ft(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),ft(["h","hh"],(function(t,e,i){e[_t]=k(t),f(i).bigHour=!0})),ft("hmm",(function(t,e,i){var n=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n)),f(i).bigHour=!0})),ft("hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n,2)),e[wt]=k(t.substr(r)),f(i).bigHour=!0})),ft("Hmm",(function(t,e,i){var n=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n))})),ft("Hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[_t]=k(t.substr(0,n)),e[bt]=k(t.substr(n,2)),e[wt]=k(t.substr(r))}));var se,ae=Ct("Hours",!0),he={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:At,monthsShort:Lt,week:{dow:0,doy:6},weekdays:Zt,weekdaysMin:Jt,weekdaysShort:$t,meridiemParse:/[ap]\.?m?\.?/i},le={},ue={};function de(t){return t?t.toLowerCase().replace("_","-"):t}function ce(e){var i=null;if(!le[e]&&t&&t.exports)try{i=se._abbr,Kh(),fe(i)}catch(t){}return le[e]}function fe(t,e){var i;return t&&((i=s(e)?me(t):pe(t,e))?se=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),se._abbr}function pe(t,e){if(null!==e){var i,n=he;if(e.abbr=t,null!=le[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=le[t]._config;else if(null!=e.parentLocale)if(null!=le[e.parentLocale])n=le[e.parentLocale]._config;else{if(null==(i=ce(e.parentLocale)))return ue[e.parentLocale]||(ue[e.parentLocale]=[]),ue[e.parentLocale].push({name:t,config:e}),null;n=i._config}return le[t]=new Y(E(n,e)),ue[t]&&ue[t].forEach((function(t){pe(t.name,t.config)})),fe(t),le[t]}return delete le[t],null}function me(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return se;if(!r(t)){if(e=ce(t))return e;t=[t]}return function(t){for(var e,i,n,r,o=0;o<t.length;){for(e=(r=de(t[o]).split("-")).length,i=(i=de(t[o+1]))?i.split("-"):null;e>0;){if(n=ce(r.slice(0,e).join("-")))return n;if(i&&i.length>=e&&D(r,i,!0)>=e-1)break;e--}o++}return se}(t)}function ge(t){var e,i=t._a;return i&&-2===f(t).overflow&&(e=i[vt]<0||i[vt]>11?vt:i[yt]<1||i[yt]>Pt(i[gt],i[vt])?yt:i[_t]<0||i[_t]>24||24===i[_t]&&(0!==i[bt]||0!==i[wt]||0!==i[kt])?_t:i[bt]<0||i[bt]>59?bt:i[wt]<0||i[wt]>59?wt:i[kt]<0||i[kt]>999?kt:-1,f(t)._overflowDayOfYear&&(e<gt||e>yt)&&(e=yt),f(t)._overflowWeeks&&-1===e&&(e=Dt),f(t)._overflowWeekday&&-1===e&&(e=St),f(t).overflow=e),t}function ve(t,e,i){return null!=t?t:null!=e?e:i}function ye(t){var e,i,r,o,s,a=[];if(!t._d){for(r=function(t){var e=new Date(n.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[yt]&&null==t._a[vt]&&function(t){var e,i,n,r,o,s,a,h;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)o=1,s=4,i=ve(e.GG,t._a[gt],Bt(Ie(),1,4).year),n=ve(e.W,1),((r=ve(e.E,1))<1||r>7)&&(h=!0);else{o=t._locale._week.dow,s=t._locale._week.doy;var l=Bt(Ie(),o,s);i=ve(e.gg,t._a[gt],l.year),n=ve(e.w,l.week),null!=e.d?((r=e.d)<0||r>6)&&(h=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(h=!0)):r=o}n<1||n>Xt(i,o,s)?f(t)._overflowWeeks=!0:null!=h?f(t)._overflowWeekday=!0:(a=Vt(i,n,r,o,s),t._a[gt]=a.year,t._dayOfYear=a.dayOfYear)}(t),null!=t._dayOfYear&&(s=ve(t._a[gt],r[gt]),(t._dayOfYear>xt(s)||0===t._dayOfYear)&&(f(t)._overflowDayOfYear=!0),i=Ut(s,0,t._dayOfYear),t._a[vt]=i.getUTCMonth(),t._a[yt]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=a[e]=r[e];for(;e<7;e++)t._a[e]=a[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[_t]&&0===t._a[bt]&&0===t._a[wt]&&0===t._a[kt]&&(t._nextDay=!0,t._a[_t]=0),t._d=(t._useUTC?Ut:Gt).apply(null,a),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[_t]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(f(t).weekdayMismatch=!0)}}var _e=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,be=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,we=/Z|[+-]\d\d(?::?\d\d)?/,ke=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],De=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Se=/^\/?Date\((\-?\d+)/i;function xe(t){var e,i,n,r,o,s,a=t._i,h=_e.exec(a)||be.exec(a);if(h){for(f(t).iso=!0,e=0,i=ke.length;e<i;e++)if(ke[e][1].exec(h[1])){r=ke[e][0],n=!1!==ke[e][2];break}if(null==r)return void(t._isValid=!1);if(h[3]){for(e=0,i=De.length;e<i;e++)if(De[e][1].exec(h[3])){o=(h[2]||" ")+De[e][0];break}if(null==o)return void(t._isValid=!1)}if(!n&&null!=o)return void(t._isValid=!1);if(h[4]){if(!we.exec(h[4]))return void(t._isValid=!1);s="Z"}t._f=r+(o||"")+(s||""),Ee(t)}else t._isValid=!1}var Me=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Te(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}var Oe={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Ce(t){var e,i,n,r,o,s,a,h=Me.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(h){var l=(e=h[4],i=h[3],n=h[2],r=h[5],o=h[6],s=h[7],a=[Te(e),Lt.indexOf(i),parseInt(n,10),parseInt(r,10),parseInt(o,10)],s&&a.push(parseInt(s,10)),a);if(!function(t,e,i){return!t||$t.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(f(i).weekdayMismatch=!0,i._isValid=!1,!1)}(h[1],l,t))return;t._a=l,t._tzm=function(t,e,i){if(t)return Oe[t];if(e)return 0;var n=parseInt(i,10),r=n%100;return(n-r)/100*60+r}(h[8],h[9],h[10]),t._d=Ut.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),f(t).rfc2822=!0}else t._isValid=!1}function Ee(t){if(t._f!==n.ISO_8601)if(t._f!==n.RFC_2822){t._a=[],f(t).empty=!0;var e,i,r,o,s,a=""+t._i,h=a.length,l=0;for(r=V(t._f,t._locale).match(F)||[],e=0;e<r.length;e++)o=r[e],(i=(a.match(ut(o,t))||[])[0])&&((s=a.substr(0,a.indexOf(i))).length>0&&f(t).unusedInput.push(s),a=a.slice(a.indexOf(i)+i.length),l+=i.length),G[o]?(i?f(t).empty=!1:f(t).unusedTokens.push(o),mt(o,i,t)):t._strict&&!i&&f(t).unusedTokens.push(o);f(t).charsLeftOver=h-l,a.length>0&&f(t).unusedInput.push(a),t._a[_t]<=12&&!0===f(t).bigHour&&t._a[_t]>0&&(f(t).bigHour=void 0),f(t).parsedDateParts=t._a.slice(0),f(t).meridiem=t._meridiem,t._a[_t]=function(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}(t._locale,t._a[_t],t._meridiem),ye(t),ge(t)}else Ce(t);else xe(t)}function Ye(t){var e=t._i,i=t._f;return t._locale=t._locale||me(t._l),null===e||void 0===i&&""===e?m({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),b(e)?new _(ge(e)):(h(e)?t._d=e:r(i)?function(t){var e,i,n,r,o;if(0===t._f.length)return f(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<t._f.length;r++)o=0,e=v({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],Ee(e),p(e)&&(o+=f(e).charsLeftOver,o+=10*f(e).unusedTokens.length,f(e).score=o,(null==n||o<n)&&(n=o,i=e));d(t,i||e)}(t):i?Ee(t):function(t){var e=t._i;s(e)?t._d=new Date(n.now()):h(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=Se.exec(t._i);null===e?(xe(t),!1===t._isValid&&(delete t._isValid,Ce(t),!1===t._isValid&&(delete t._isValid,n.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):r(e)?(t._a=l(e.slice(0),(function(t){return parseInt(t,10)})),ye(t)):o(e)?function(t){if(!t._d){var e=L(t._i);t._a=l([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),ye(t)}}(t):a(e)?t._d=new Date(e):n.createFromInputFallback(t)}(t),p(t)||(t._d=null),t))}function Pe(t,e,i,n,s){var a,h={};return!0!==i&&!1!==i||(n=i,i=void 0),(o(t)&&function(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}(t)||r(t)&&0===t.length)&&(t=void 0),h._isAMomentObject=!0,h._useUTC=h._isUTC=s,h._l=i,h._i=t,h._f=e,h._strict=n,(a=new _(ge(Ye(h))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Ie(t,e,i,n){return Pe(t,e,i,n,!1)}n.createFromInputFallback=x("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Ae=x("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ie.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:m()})),Le=x("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ie.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:m()}));function Ne(t,e){var i,n;if(1===e.length&&r(e[0])&&(e=e[0]),!e.length)return Ie();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}var Re=["year","quarter","month","week","day","hour","minute","second","millisecond"];function je(t){var e=L(t),i=e.year||0,n=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,a=e.hour||0,h=e.minute||0,l=e.second||0,u=e.millisecond||0;this._isValid=function(t){for(var e in t)if(-1===Tt.call(Re,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var i=!1,n=0;n<Re.length;++n)if(t[Re[n]]){if(i)return!1;parseFloat(t[Re[n]])!==k(t[Re[n]])&&(i=!0)}return!0}(e),this._milliseconds=+u+1e3*l+6e4*h+1e3*a*60*60,this._days=+s+7*o,this._months=+r+3*n+12*i,this._data={},this._locale=me(),this._bubble()}function Fe(t){return t instanceof je}function He(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function We(t,e){U(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+j(~~(t/60),2)+e+j(~~t%60,2)}))}We("Z",":"),We("ZZ",""),lt("Z",st),lt("ZZ",st),ft(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=Ue(st,t)}));var Ge=/([\+\-]|\d\d)/gi;function Ue(t,e){var i=(e||"").match(t);if(null===i)return null;var n=((i[i.length-1]||[])+"").match(Ge)||["-",0,0],r=60*n[1]+k(n[2]);return 0===r?0:"+"===n[0]?r:-r}function ze(t,e){var i,r;return e._isUTC?(i=e.clone(),r=(b(t)||h(t)?t.valueOf():Ie(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+r),n.updateOffset(i,!1),i):Ie(t).local()}function Ve(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function Be(){return!!this.isValid()&&this._isUTC&&0===this._offset}n.updateOffset=function(){};var Xe=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,qe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ze(t,e){var i,n,r,o,s,h,l=t,d=null;return Fe(t)?l={ms:t._milliseconds,d:t._days,M:t._months}:a(t)?(l={},e?l[e]=t:l.milliseconds=t):(d=Xe.exec(t))?(i="-"===d[1]?-1:1,l={y:0,d:k(d[yt])*i,h:k(d[_t])*i,m:k(d[bt])*i,s:k(d[wt])*i,ms:k(He(1e3*d[kt]))*i}):(d=qe.exec(t))?(i="-"===d[1]?-1:1,l={y:$e(d[2],i),M:$e(d[3],i),w:$e(d[4],i),d:$e(d[5],i),h:$e(d[6],i),m:$e(d[7],i),s:$e(d[8],i)}):null==l?l={}:"object"===xa(l)&&("from"in l||"to"in l)&&(o=Ie(l.from),s=Ie(l.to),r=o.isValid()&&s.isValid()?(s=ze(s,o),o.isBefore(s)?h=Je(o,s):((h=Je(s,o)).milliseconds=-h.milliseconds,h.months=-h.months),h):{milliseconds:0,months:0},(l={}).ms=r.milliseconds,l.M=r.months),n=new je(l),Fe(t)&&u(t,"_locale")&&(n._locale=t._locale),n}function $e(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Je(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function Ke(t,e){return function(i,n){var r;return null===n||isNaN(+n)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=i,i=n,n=r),Qe(this,Ze(i="string"==typeof i?+i:i,n),t),this}}function Qe(t,e,i,r){var o=e._milliseconds,s=He(e._days),a=He(e._months);t.isValid()&&(r=null==r||r,a&&Rt(t,Et(t,"Month")+a*i),s&&Yt(t,"Date",Et(t,"Date")+s*i),o&&t._d.setTime(t._d.valueOf()+o*i),r&&n.updateOffset(t,s||a))}Ze.fn=je.prototype,Ze.invalid=function(){return Ze(NaN)};var ti=Ke(1,"add"),ei=Ke(-1,"subtract");function ii(t,e){var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function ni(t){var e;return void 0===t?this._locale._abbr:(null!=(e=me(t))&&(this._locale=e),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var ri=x("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function oi(){return this._locale}var si=1e3,ai=60*si,hi=60*ai,li=3506328*hi;function ui(t,e){return(t%e+e)%e}function di(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-li:new Date(t,e,i).valueOf()}function ci(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-li:Date.UTC(t,e,i)}function fi(t,e){U(0,[t,t.length],0,e)}function pi(t,e,i,n,r){var o;return null==t?Bt(this,n,r).year:(e>(o=Xt(t,n,r))&&(e=o),mi.call(this,t,e,i,n,r))}function mi(t,e,i,n,r){var o=Vt(t,e,i,n,r),s=Ut(o.year,0,o.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}U(0,["gg",2],0,(function(){return this.weekYear()%100})),U(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),fi("gggg","weekYear"),fi("ggggg","weekYear"),fi("GGGG","isoWeekYear"),fi("GGGGG","isoWeekYear"),I("weekYear","gg"),I("isoWeekYear","GG"),R("weekYear",1),R("isoWeekYear",1),lt("G",rt),lt("g",rt),lt("GG",J,X),lt("gg",J,X),lt("GGGG",et,Z),lt("gggg",et,Z),lt("GGGGG",it,$),lt("ggggg",it,$),pt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=k(t)})),pt(["gg","GG"],(function(t,e,i,r){e[r]=n.parseTwoDigitYear(t)})),U("Q",0,"Qo","quarter"),I("quarter","Q"),R("quarter",7),lt("Q",B),ft("Q",(function(t,e){e[vt]=3*(k(t)-1)})),U("D",["DD",2],"Do","date"),I("date","D"),R("date",9),lt("D",J),lt("DD",J,X),lt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),ft(["D","DD"],yt),ft("Do",(function(t,e){e[yt]=k(t.match(J)[0])}));var gi=Ct("Date",!0);U("DDD",["DDDD",3],"DDDo","dayOfYear"),I("dayOfYear","DDD"),R("dayOfYear",4),lt("DDD",tt),lt("DDDD",q),ft(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=k(t)})),U("m",["mm",2],0,"minute"),I("minute","m"),R("minute",14),lt("m",J),lt("mm",J,X),ft(["m","mm"],bt);var vi=Ct("Minutes",!1);U("s",["ss",2],0,"second"),I("second","s"),R("second",15),lt("s",J),lt("ss",J,X),ft(["s","ss"],wt);var yi,_i=Ct("Seconds",!1);for(U("S",0,0,(function(){return~~(this.millisecond()/100)})),U(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),U(0,["SSS",3],0,"millisecond"),U(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),U(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),U(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),U(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),U(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),U(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),I("millisecond","ms"),R("millisecond",16),lt("S",tt,B),lt("SS",tt,X),lt("SSS",tt,q),yi="SSSS";yi.length<=9;yi+="S")lt(yi,nt);function bi(t,e){e[kt]=k(1e3*("0."+t))}for(yi="S";yi.length<=9;yi+="S")ft(yi,bi);var wi=Ct("Milliseconds",!1);U("z",0,0,"zoneAbbr"),U("zz",0,0,"zoneName");var ki=_.prototype;function Di(t){return t}ki.add=ti,ki.calendar=function(t,e){var i=t||Ie(),r=ze(i,this).startOf("day"),o=n.calendarFormat(this,r)||"sameElse",s=e&&(C(e[o])?e[o].call(this,i):e[o]);return this.format(s||this.localeData().calendar(o,this,Ie(i)))},ki.clone=function(){return new _(this)},ki.diff=function(t,e,i){var n,r,o;if(!this.isValid())return NaN;if(!(n=ze(t,this)).isValid())return NaN;switch(r=6e4*(n.utcOffset()-this.utcOffset()),e=A(e)){case"year":o=ii(this,n)/12;break;case"month":o=ii(this,n);break;case"quarter":o=ii(this,n)/3;break;case"second":o=(this-n)/1e3;break;case"minute":o=(this-n)/6e4;break;case"hour":o=(this-n)/36e5;break;case"day":o=(this-n-r)/864e5;break;case"week":o=(this-n-r)/6048e5;break;default:o=this-n}return i?o:w(o)},ki.endOf=function(t){var e;if(void 0===(t=A(t))||"millisecond"===t||!this.isValid())return this;var i=this._isUTC?ci:di;switch(t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=hi-ui(e+(this._isUTC?0:this.utcOffset()*ai),hi)-1;break;case"minute":e=this._d.valueOf(),e+=ai-ui(e,ai)-1;break;case"second":e=this._d.valueOf(),e+=si-ui(e,si)-1}return this._d.setTime(e),n.updateOffset(this,!0),this},ki.format=function(t){t||(t=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var e=z(this,t);return this.localeData().postformat(e)},ki.from=function(t,e){return this.isValid()&&(b(t)&&t.isValid()||Ie(t).isValid())?Ze({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},ki.fromNow=function(t){return this.from(Ie(),t)},ki.to=function(t,e){return this.isValid()&&(b(t)&&t.isValid()||Ie(t).isValid())?Ze({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},ki.toNow=function(t){return this.to(Ie(),t)},ki.get=function(t){return C(this[t=A(t)])?this[t]():this},ki.invalidAt=function(){return f(this).overflow},ki.isAfter=function(t,e){var i=b(t)?t:Ie(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=A(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())},ki.isBefore=function(t,e){var i=b(t)?t:Ie(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=A(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())},ki.isBetween=function(t,e,i,n){var r=b(t)?t:Ie(t),o=b(e)?e:Ie(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(n=n||"()")[0]?this.isAfter(r,i):!this.isBefore(r,i))&&(")"===n[1]?this.isBefore(o,i):!this.isAfter(o,i))},ki.isSame=function(t,e){var i,n=b(t)?t:Ie(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=A(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))},ki.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},ki.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},ki.isValid=function(){return p(this)},ki.lang=ri,ki.locale=ni,ki.localeData=oi,ki.max=Le,ki.min=Ae,ki.parsingFlags=function(){return d({},f(this))},ki.set=function(t,e){if("object"===xa(t))for(var i=function(t){var e=[];for(var i in t)e.push({unit:i,priority:N[i]});return e.sort((function(t,e){return t.priority-e.priority})),e}(t=L(t)),n=0;n<i.length;n++)this[i[n].unit](t[i[n].unit]);else if(C(this[t=A(t)]))return this[t](e);return this},ki.startOf=function(t){var e;if(void 0===(t=A(t))||"millisecond"===t||!this.isValid())return this;var i=this._isUTC?ci:di;switch(t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=ui(e+(this._isUTC?0:this.utcOffset()*ai),hi);break;case"minute":e=this._d.valueOf(),e-=ui(e,ai);break;case"second":e=this._d.valueOf(),e-=ui(e,si)}return this._d.setTime(e),n.updateOffset(this,!0),this},ki.subtract=ei,ki.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},ki.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},ki.toDate=function(){return new Date(this.valueOf())},ki.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?z(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):C(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",z(i,"Z")):z(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},ki.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var i="["+t+'("]',n=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",r=e+'[")]';return this.format(i+n+"-MM-DD[T]HH:mm:ss.SSS"+r)},ki.toJSON=function(){return this.isValid()?this.toISOString():null},ki.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},ki.unix=function(){return Math.floor(this.valueOf()/1e3)},ki.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},ki.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},ki.year=Ot,ki.isLeapYear=function(){return Mt(this.year())},ki.weekYear=function(t){return pi.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},ki.isoWeekYear=function(t){return pi.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},ki.quarter=ki.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},ki.month=jt,ki.daysInMonth=function(){return Pt(this.year(),this.month())},ki.week=ki.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},ki.isoWeek=ki.isoWeeks=function(t){var e=Bt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},ki.weeksInYear=function(){var t=this.localeData()._week;return Xt(this.year(),t.dow,t.doy)},ki.isoWeeksInYear=function(){return Xt(this.year(),1,4)},ki.date=gi,ki.day=ki.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},ki.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},ki.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},ki.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},ki.hour=ki.hours=ae,ki.minute=ki.minutes=vi,ki.second=ki.seconds=_i,ki.millisecond=ki.milliseconds=wi,ki.utcOffset=function(t,e,i){var r,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ue(st,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(r=Ve(this)),this._offset=t,this._isUTC=!0,null!=r&&this.add(r,"m"),o!==t&&(!e||this._changeInProgress?Qe(this,Ze(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:Ve(this)},ki.utc=function(t){return this.utcOffset(0,t)},ki.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Ve(this),"m")),this},ki.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ue(ot,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},ki.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ie(t).utcOffset():0,(this.utcOffset()-t)%60==0)},ki.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},ki.isLocal=function(){return!!this.isValid()&&!this._isUTC},ki.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},ki.isUtc=Be,ki.isUTC=Be,ki.zoneAbbr=function(){return this._isUTC?"UTC":""},ki.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},ki.dates=x("dates accessor is deprecated. Use date instead.",gi),ki.months=x("months accessor is deprecated. Use month instead",jt),ki.years=x("years accessor is deprecated. Use year instead",Ot),ki.zone=x("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),ki.isDSTShifted=x("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!s(this._isDSTShifted))return this._isDSTShifted;var t={};if(v(t,this),(t=Ye(t))._a){var e=t._isUTC?c(t._a):Ie(t._a);this._isDSTShifted=this.isValid()&&D(t._a,e.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var Si=Y.prototype;function xi(t,e,i,n){var r=me(),o=c().set(n,e);return r[i](o,t)}function Mi(t,e,i){if(a(t)&&(e=t,t=void 0),t=t||"",null!=e)return xi(t,e,i,"month");var n,r=[];for(n=0;n<12;n++)r[n]=xi(t,n,i,"month");return r}function Ti(t,e,i,n){"boolean"==typeof t?(a(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,a(e)&&(i=e,e=void 0),e=e||"");var r,o=me(),s=t?o._week.dow:0;if(null!=i)return xi(e,(i+s)%7,n,"day");var h=[];for(r=0;r<7;r++)h[r]=xi(e,(r+s)%7,n,"day");return h}Si.calendar=function(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return C(n)?n.call(e,i):n},Si.longDateFormat=function(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.replace(/MMMM|MM|DD|dddd/g,(function(t){return t.slice(1)})),this._longDateFormat[t])},Si.invalidDate=function(){return this._invalidDate},Si.ordinal=function(t){return this._ordinal.replace("%d",t)},Si.preparse=Di,Si.postformat=Di,Si.relativeTime=function(t,e,i,n){var r=this._relativeTime[i];return C(r)?r(t,e,i,n):r.replace(/%d/i,t)},Si.pastFuture=function(t,e){var i=this._relativeTime[t>0?"future":"past"];return C(i)?i(e):i.replace(/%s/i,e)},Si.set=function(t){var e,i;for(i in t)C(e=t[i])?this[i]=e:this["_"+i]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},Si.months=function(t,e){return t?r(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||It).test(e)?"format":"standalone"][t.month()]:r(this._months)?this._months:this._months.standalone},Si.monthsShort=function(t,e){return t?r(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[It.test(e)?"format":"standalone"][t.month()]:r(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},Si.monthsParse=function(t,e,i){var n,r,o;if(this._monthsParseExact)return Nt.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(r=c([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[n]=new RegExp(o.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}},Si.monthsRegex=function(t){return this._monthsParseExact?(u(this,"_monthsRegex")||Wt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(u(this,"_monthsRegex")||(this._monthsRegex=Ht),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},Si.monthsShortRegex=function(t){return this._monthsParseExact?(u(this,"_monthsRegex")||Wt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(u(this,"_monthsShortRegex")||(this._monthsShortRegex=Ft),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},Si.week=function(t){return Bt(t,this._week.dow,this._week.doy).week},Si.firstDayOfYear=function(){return this._week.doy},Si.firstDayOfWeek=function(){return this._week.dow},Si.weekdays=function(t,e){var i=r(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?qt(i,this._week.dow):t?i[t.day()]:i},Si.weekdaysMin=function(t){return!0===t?qt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},Si.weekdaysShort=function(t){return!0===t?qt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},Si.weekdaysParse=function(t,e,i){var n,r,o;if(this._weekdaysParseExact)return Kt.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(r=c([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[n]=new RegExp(o.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}},Si.weekdaysRegex=function(t){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||ie.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(u(this,"_weekdaysRegex")||(this._weekdaysRegex=Qt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},Si.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||ie.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(u(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=te),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},Si.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||ie.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(u(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=ee),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},Si.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},Si.meridiem=function(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"},fe("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===k(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),n.lang=x("moment.lang is deprecated. Use moment.locale instead.",fe),n.langData=x("moment.langData is deprecated. Use moment.localeData instead.",me);var Oi=Math.abs;function Ci(t,e,i,n){var r=Ze(e,i);return t._milliseconds+=n*r._milliseconds,t._days+=n*r._days,t._months+=n*r._months,t._bubble()}function Ei(t){return t<0?Math.floor(t):Math.ceil(t)}function Yi(t){return 4800*t/146097}function Pi(t){return 146097*t/4800}function Ii(t){return function(){return this.as(t)}}var Ai=Ii("ms"),Li=Ii("s"),Ni=Ii("m"),Ri=Ii("h"),ji=Ii("d"),Fi=Ii("w"),Hi=Ii("M"),Wi=Ii("Q"),Gi=Ii("y");function Ui(t){return function(){return this.isValid()?this._data[t]:NaN}}var zi=Ui("milliseconds"),Vi=Ui("seconds"),Bi=Ui("minutes"),Xi=Ui("hours"),qi=Ui("days"),Zi=Ui("months"),$i=Ui("years"),Ji=Math.round,Ki={ss:44,s:45,m:45,h:22,d:26,M:11};function Qi(t,e,i,n,r){return r.relativeTime(e||1,!!i,t,n)}var tn=Math.abs;function en(t){return(t>0)-(t<0)||+t}function nn(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i=tn(this._milliseconds)/1e3,n=tn(this._days),r=tn(this._months);t=w(i/60),e=w(t/60),i%=60,t%=60;var o=w(r/12),s=r%=12,a=n,h=e,l=t,u=i?i.toFixed(3).replace(/\.?0+$/,""):"",d=this.asSeconds();if(!d)return"P0D";var c=d<0?"-":"",f=en(this._months)!==en(d)?"-":"",p=en(this._days)!==en(d)?"-":"",m=en(this._milliseconds)!==en(d)?"-":"";return c+"P"+(o?f+o+"Y":"")+(s?f+s+"M":"")+(a?p+a+"D":"")+(h||l||u?"T":"")+(h?m+h+"H":"")+(l?m+l+"M":"")+(u?m+u+"S":"")}var rn=je.prototype;return rn.isValid=function(){return this._isValid},rn.abs=function(){var t=this._data;return this._milliseconds=Oi(this._milliseconds),this._days=Oi(this._days),this._months=Oi(this._months),t.milliseconds=Oi(t.milliseconds),t.seconds=Oi(t.seconds),t.minutes=Oi(t.minutes),t.hours=Oi(t.hours),t.months=Oi(t.months),t.years=Oi(t.years),this},rn.add=function(t,e){return Ci(this,t,e,1)},rn.subtract=function(t,e){return Ci(this,t,e,-1)},rn.as=function(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=A(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Yi(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Pi(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}},rn.asMilliseconds=Ai,rn.asSeconds=Li,rn.asMinutes=Ni,rn.asHours=Ri,rn.asDays=ji,rn.asWeeks=Fi,rn.asMonths=Hi,rn.asQuarters=Wi,rn.asYears=Gi,rn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*k(this._months/12):NaN},rn._bubble=function(){var t,e,i,n,r,o=this._milliseconds,s=this._days,a=this._months,h=this._data;return o>=0&&s>=0&&a>=0||o<=0&&s<=0&&a<=0||(o+=864e5*Ei(Pi(a)+s),s=0,a=0),h.milliseconds=o%1e3,t=w(o/1e3),h.seconds=t%60,e=w(t/60),h.minutes=e%60,i=w(e/60),h.hours=i%24,s+=w(i/24),r=w(Yi(s)),a+=r,s-=Ei(Pi(r)),n=w(a/12),a%=12,h.days=s,h.months=a,h.years=n,this},rn.clone=function(){return Ze(this)},rn.get=function(t){return t=A(t),this.isValid()?this[t+"s"]():NaN},rn.milliseconds=zi,rn.seconds=Vi,rn.minutes=Bi,rn.hours=Xi,rn.days=qi,rn.weeks=function(){return w(this.days()/7)},rn.months=Zi,rn.years=$i,rn.humanize=function(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),i=function(t,e,i){var n=Ze(t).abs(),r=Ji(n.as("s")),o=Ji(n.as("m")),s=Ji(n.as("h")),a=Ji(n.as("d")),h=Ji(n.as("M")),l=Ji(n.as("y")),u=r<=Ki.ss&&["s",r]||r<Ki.s&&["ss",r]||o<=1&&["m"]||o<Ki.m&&["mm",o]||s<=1&&["h"]||s<Ki.h&&["hh",s]||a<=1&&["d"]||a<Ki.d&&["dd",a]||h<=1&&["M"]||h<Ki.M&&["MM",h]||l<=1&&["y"]||["yy",l];return u[2]=e,u[3]=+t>0,u[4]=i,Qi.apply(null,u)}(this,!t,e);return t&&(i=e.pastFuture(+this,i)),e.postformat(i)},rn.toISOString=nn,rn.toString=nn,rn.toJSON=nn,rn.locale=ni,rn.localeData=oi,rn.toIsoString=x("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",nn),rn.lang=ri,U("X",0,0,"unix"),U("x",0,0,"valueOf"),lt("x",rt),lt("X",/[+-]?\d+(\.\d{1,3})?/),ft("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t,10))})),ft("x",(function(t,e,i){i._d=new Date(k(t))})),n.version="2.24.0",e=Ie,n.fn=ki,n.min=function(){return Ne("isBefore",[].slice.call(arguments,0))},n.max=function(){return Ne("isAfter",[].slice.call(arguments,0))},n.now=function(){return Date.now?Date.now():+new Date},n.utc=c,n.unix=function(t){return Ie(1e3*t)},n.months=function(t,e){return Mi(t,e,"months")},n.isDate=h,n.locale=fe,n.invalid=m,n.duration=Ze,n.isMoment=b,n.weekdays=function(t,e,i){return Ti(t,e,i,"weekdays")},n.parseZone=function(){return Ie.apply(null,arguments).parseZone()},n.localeData=me,n.isDuration=Fe,n.monthsShort=function(t,e){return Mi(t,e,"monthsShort")},n.weekdaysMin=function(t,e,i){return Ti(t,e,i,"weekdaysMin")},n.defineLocale=pe,n.updateLocale=function(t,e){if(null!=e){var i,n,r=he;null!=(n=ce(t))&&(r=n._config),e=E(r,e),(i=new Y(e)).parentLocale=le[t],le[t]=i,fe(t)}else null!=le[t]&&(null!=le[t].parentLocale?le[t]=le[t].parentLocale:null!=le[t]&&delete le[t]);return le[t]},n.locales=function(){return M(le)},n.weekdaysShort=function(t,e,i){return Ti(t,e,i,"weekdaysShort")},n.normalizeUnits=A,n.relativeTimeRounding=function(t){return void 0===t?Ji:"function"==typeof t&&(Ji=t,!0)},n.relativeTimeThreshold=function(t,e){return void 0!==Ki[t]&&(void 0===e?Ki[t]:(Ki[t]=e,"s"===t&&(Ki.ss=e-1),!0))},n.calendarFormat=function(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},n.prototype=ki,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n}()})),tl=[],el=0;el<256;el++)tl[el]=(el+256).toString(16).substr(1);for(var il=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var e=new Array(16);return function(){for(var t,i=0;i<16;i++)0==(3&i)&&(t=4294967296*Math.random()),e[i]=t>>>((3&i)<<3)&255;return e}}(),nl=[],rl=0;rl<256;rl++)nl[rl]=(rl+256).toString(16).substr(1);var ol=il(),sl=(ol[0],ol[1],ol[2],ol[3],ol[4],ol[5],ol[6],ol[7],/^\/?Date\((-?\d+)/i);function al(t){return t instanceof Number||"number"==typeof t}function hl(t){return t instanceof String||"string"==typeof t}function ll(t){return Qh.isMoment(t)}function ul(t,e){var i;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return hl(t)&&!isNaN(Date.parse(t))?Qh(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(al(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(ll(t))return new Date(t.valueOf());if(hl(t))return(i=sl.exec(t))?new Date(Number(i[1])):Qh(new Date(t)).toDate();throw new Error("Cannot convert object of type "+dl(t)+" to type Date");case"Moment":if(al(t))return Qh(t);if(t instanceof Date)return Qh(t.valueOf());if(ll(t))return Qh(t);if(hl(t))return i=sl.exec(t),Qh(i?Number(i[1]):t);throw new Error("Cannot convert object of type "+dl(t)+" to type Date");case"ISODate":if(al(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(ll(t))return t.toDate().toISOString();if(hl(t))return(i=sl.exec(t))?new Date(Number(i[1])).toISOString():Qh(t).format();throw new Error("Cannot convert object of type "+dl(t)+" to type ISODate");case"ASPDate":if(al(t))return"/Date("+t+")/";if(t instanceof Date)return"/Date("+t.valueOf()+")/";if(hl(t))return"/Date("+((i=sl.exec(t))?new Date(Number(i[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+dl(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function dl(t){var e=Jh(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Array.isArray(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function cl(t){return"string"==typeof t||"number"==typeof t}var fl=function(){function t(e){Nh(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return jh(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var n=e[i];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];i.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=setTimeout((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){this._queue.splice(0).forEach((function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var n=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var r=[{name:"flush",original:void 0}];if(i&&i.replace)for(var o=0;o<i.replace.length;o++){var s=i.replace[o];r.push({name:s,original:e[s]}),n.replace(e,s)}return n._extended={object:e,methods:r},n}}]),t}();var pl=function(t){if(Array.isArray(t)){for(var e=0,i=new Array(t.length);e<t.length;e++)i[e]=t[e];return i}};var ml=function(t){if(Symbol.iterator in Object(t)||"[object Arguments]"===Object.prototype.toString.call(t))return Array.from(t)};var gl=function(){throw new TypeError("Invalid attempt to spread non-iterable instance")};var vl=function(t){return pl(t)||ml(t)||gl()},yl=function(){function t(){Nh(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return jh(t,[{key:"_trigger",value:function(t,e,i){if("*"===t)throw new Error("Cannot trigger event *");for(var n=[].concat(vl(this._subscribers[t]),vl(this._subscribers["*"])),r=0,o=n.length;r<o;r++){var s=n[r];s.callback&&s.callback(t,e,null!=i?i:null)}}},{key:"on",value:function(t,e){this._subscribers[t].push({callback:e})}},{key:"off",value:function(t,e){this._subscribers[t]=this._subscribers[t].filter((function(t){return t.callback!==e}))}}]),t}();function _l(t,e){var i=Object.keys(t);return Object.getOwnPropertySymbols&&i.push.apply(i,Object.getOwnPropertySymbols(t)),e&&(i=i.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),i}var bl=function(t){function e(t,i){var n;if(Nh(this,e),n=Hh(this,Wh(e).call(this)),t&&!Array.isArray(t)&&(i=t,t=[]),n._options=i||{},n._data=Object.create({}),n.length=0,n._idProp=n._options.fieldId||"id",n._type={},n._options.type)for(var r=Object.keys(n._options.type),o=0,s=r.length;o<s;o++){var a=r[o],h=n._options.type[a];n._type[a]="Date"==h||"ISODate"==h||"ASPDate"==h?"Date":h}return t&&t.length&&n.add(t),n.setOptions(i),n}return Uh(e,t),jh(e,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=fl.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Lh(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,n=[];if(Array.isArray(t))for(var r=0,o=t.length;r<o;r++)i=this._addItem(t[r]),n.push(i);else{if(!t||"object"!==Lh(t))throw new Error("Unknown dataType");i=this._addItem(t),n.push(i)}return n.length&&this._trigger("add",{items:n},e),n}},{key:"update",value:function(t,e){var i=this,n=[],r=[],o=[],s=[],a=this._idProp,h=function(t){var e=t[a];if(null!=e&&i._data[e]){var h=t,l=Object.assign({},i._data[e]),u=i._updateItem(h);r.push(u),s.push(h),o.push(l)}else{var d=i._addItem(t);n.push(d)}};if(Array.isArray(t))for(var l=0,u=t.length;l<u;l++)t[l]&&"object"===Lh(t[l])?h(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==Lh(t))throw new Error("Unknown dataType");h(t)}if(n.length&&this._trigger("add",{items:n},e),r.length){var d={items:r,oldData:o,data:s};this._trigger("update",d,e)}return n.concat(r)}},{key:"get",value:function(t,e){var i=void 0,n=void 0,r=void 0;cl(t)?(i=t,r=e):Array.isArray(t)?(n=t,r=e):r=t;var o=r&&"Object"===r.returnType?"Object":"Array",s=r&&r.type||this._options.type,a=r&&r.filter,h=[],l=null,u=null,d=null;if(null!=i)(l=this._getItem(i,s))&&a&&!a(l)&&(l=null);else if(null!=n)for(var c=0,f=n.length;c<f;c++)null==(l=this._getItem(n[c],s))||a&&!a(l)||h.push(l);else for(var p=0,m=(u=Object.keys(this._data)).length;p<m;p++)d=u[p],null==(l=this._getItem(d,s))||a&&!a(l)||h.push(l);if(r&&r.order&&null==i&&this._sort(h,r.order),r&&r.fields){var g=r.fields;if(null!=i&&null!=l)l=this._filterFields(l,g);else for(var v=0,y=h.length;v<y;v++)h[v]=this._filterFields(h[v],g)}if("Object"==o){for(var _={},b=0,w=h.length;b<w;b++){var k=h[b];_[k[this._idProp]]=k}return _}return null!=i?l:h}},{key:"getIds",value:function(t){var e,i,n=this._data,r=t&&t.filter,o=t&&t.order,s=t&&t.type||this._options.type,a=Object.keys(n),h=[];if(r)if(o){i=[];for(var l=0,u=a.length;l<u;l++){var d=a[l];r(e=this._getItem(d,s))&&i.push(e)}this._sort(i,o);for(var c=0,f=i.length;c<f;c++)h.push(i[c][this._idProp])}else for(var p=0,m=a.length;p<m;p++){var g=a[p];r(e=this._getItem(g,s))&&h.push(e[this._idProp])}else if(o){i=[];for(var v=0,y=a.length;v<y;v++){var _=a[v];i.push(n[_])}this._sort(i,o);for(var b=0,w=i.length;b<w;b++)h.push(i[b][this._idProp])}else for(var k=0,D=a.length;k<D;k++){e=n[a[k]],h.push(e[this._idProp])}return h}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&e.filter,n=e&&e.type||this._options.type,r=this._data,o=Object.keys(r);if(e&&e.order)for(var s=this.get(e),a=0,h=s.length;a<h;a++){var l=s[a];t(l,l[this._idProp])}else for(var u=0,d=o.length;u<d;u++){var c=o[u],f=this._getItem(c,n);i&&!i(f)||t(f,c)}}},{key:"map",value:function(t,e){for(var i=e&&e.filter,n=e&&e.type||this._options.type,r=[],o=this._data,s=Object.keys(o),a=0,h=s.length;a<h;a++){var l=s[a],u=this._getItem(l,n);i&&!i(u)||r.push(t(u,l))}return e&&e.order&&this._sort(r,e.order),r}},{key:"_filterFields",value:function(t,e){return t?(Array.isArray(e)?e:Object.keys(e)).reduce((function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;t.sort((function(t,e){var n=t[i],r=e[i];return n>r?1:n<r?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");t.sort(e)}}},{key:"remove",value:function(t,e){for(var i=[],n=[],r=Array.isArray(t)?t:[t],o=0,s=r.length;o<s;o++){var a=this._remove(r[o]);if(a){var h=a[this._idProp];null!=h&&(i.push(h),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},e),i}},{key:"_remove",value:function(t){var e;if(cl(t)?e=t:t&&"object"===Lh(t)&&(e=t[this._idProp]),null!=e&&this._data[e]){var i=this._data[e];return delete this._data[e],--this.length,i}return null}},{key:"clear",value:function(t){for(var e=Object.keys(this._data),i=[],n=0,r=e.length;n<r;n++)i.push(this._data[e[n]]);return this._data={},this.length=0,this._trigger("remove",{items:e,oldData:i},t),e}},{key:"max",value:function(t){for(var e=this._data,i=Object.keys(e),n=null,r=null,o=0,s=i.length;o<s;o++){var a=e[i[o]],h=a[t];null!=h&&(null==r||h>r)&&(n=a,r=h)}return n}},{key:"min",value:function(t){for(var e=this._data,i=Object.keys(e),n=null,r=null,o=0,s=i.length;o<s;o++){var a=e[i[o]],h=a[t];null!=h&&(null==r||h<r)&&(n=a,r=h)}return n}},{key:"distinct",value:function(t){for(var e=this._data,i=Object.keys(e),n=[],r=this._options.type&&this._options.type[t]||null,o=0,s=0,a=i.length;s<a;s++){for(var h=e[i[s]][t],l=!1,u=0;u<o;u++)if(n[u]==h){l=!0;break}l||void 0===h||(n[o]=h,o++)}if(r)for(var d=0,c=n.length;d<c;d++)n[d]=ul(n[d],r);return n}},{key:"_addItem",value:function(t){var e=t[this._idProp];if(null!=e){if(this._data[e])throw new Error("Cannot add item: item with id "+e+" already exists")}else e=$h(),t[this._idProp]=e;for(var i={},n=Object.keys(t),r=0,o=n.length;r<o;r++){var s=n[r],a=this._type[s];i[s]=ul(t[s],a)}return this._data[e]=i,this.length++,e}},{key:"_getItem",value:function(t,e){var i,n=this._data[t];if(!n)return null;var r=Object.keys(n);if(e){i={};for(var o=0,s=r.length;o<s;o++){var a=r[o],h=n[a];i[a]=ul(h,e[a])}}else i=function(t){for(var e=1;e<arguments.length;e++){var i=null!=arguments[e]?arguments[e]:{};e%2?_l(i,!0).forEach((function(e){Ih(t,e,i[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(i)):_l(i).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(i,e))}))}return t}({},n);return null==i[this._idProp]&&(i[this._idProp]=n.id),i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+JSON.stringify(t)+")");var i=this._data[e];if(!i)throw new Error("Cannot update item: no item with id "+e+" found");for(var n=Object.keys(t),r=0,o=n.length;r<o;r++){var s=n[r],a=this._type[s];i[s]=ul(t[s],a)}return e}}]),e}(yl),wl=function(t){function e(t,i){var n;return Nh(this,e),(n=Hh(this,Wh(e).call(this))).length=0,n._ids={},n._options=i||{},n.listener=n._onEvent.bind(Fh(n)),n.setData(t),n}return Uh(e,t),jh(e,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this.listener);var e=this._data.getIds({filter:this._options.filter}),i=this._data.get(e);this._ids={},this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:this._options.filter}),r=0,o=n.length;r<o;r++){var s=n[r];this._ids[s]=!0}this.length=n.length,this._trigger("add",{items:n})}else this._data=new bl;this._data.on&&this._data.on("*",this.listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:this._options.filter}),e=Object.keys(this._ids),i={},n=[],r=[],o=[],s=0,a=t.length;s<a;s++){var h=t[s];i[h]=!0,this._ids[h]||(n.push(h),this._ids[h]=!0)}for(var l=0,u=e.length;l<u;l++){var d=e[l],c=this._data.get(d);null==c?console.error("If you see this, report it please."):i[d]||(r.push(d),o.push(c),delete this._ids[d])}this.length+=n.length-r.length,n.length&&this._trigger("add",{items:n}),r.length&&this._trigger("remove",{items:r,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,n=null;cl(t)||Array.isArray(t)?(n=t,i=e):i=t;var r=Object.assign({},this._options,i),o=this._options.filter,s=i&&i.filter;return o&&s&&(r.filter=function(t){return o(t)&&s(t)}),null==n?this._data.get(r):this._data.get(n,r)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=this._options.filter,n=null!=t?t.filter:null;return e=n?i?function(t){return i(t)&&n(t)}:n:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,n=this._options.filter,r=e&&e.filter;i=r?n?function(t){return n(t)&&r(t)}:r:n,this._data.forEach(t,{filter:i,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,n=this._options.filter,r=e&&e.filter;return i=r?n?function(t){return n(t)&&r(t)}:r:n,this._data.map(t,{filter:i,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var n=e.items,r=[],o=[],s=[],a=[],h=[],l=[];switch(t){case"add":for(var u=0,d=n.length;u<d;u++){var c=n[u];this.get(c)&&(this._ids[c]=!0,r.push(c))}break;case"update":for(var f=0,p=n.length;f<p;f++){var m=n[f];this.get(m)?this._ids[m]?(o.push(m),h.push(e.data[f]),a.push(e.oldData[f])):(this._ids[m]=!0,r.push(m)):this._ids[m]&&(delete this._ids[m],s.push(m),l.push(e.oldData[f]))}break;case"remove":for(var g=0,v=n.length;g<v;g++){var y=n[g];this._ids[y]&&(delete this._ids[y],s.push(y),l.push(e.oldData[g]))}}this.length+=r.length-s.length,r.length&&this._trigger("add",{items:r},i),o.length&&this._trigger("update",{items:o,oldData:a,data:h},i),s.length&&this._trigger("remove",{items:s,oldData:l},i)}}}]),e}(yl),kl=n((function(t,e){t.exports=function(){var e,n;function r(){return e.apply(null,arguments)}function o(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function s(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function a(t){return void 0===t}function h(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function l(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function u(t,e){var i,n=[];for(i=0;i<t.length;++i)n.push(e(t[i],i));return n}function d(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function c(t,e){for(var i in e)d(e,i)&&(t[i]=e[i]);return d(e,"toString")&&(t.toString=e.toString),d(e,"valueOf")&&(t.valueOf=e.valueOf),t}function f(t,e,i,n){return Ie(t,e,i,n,!0).utc()}function p(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function m(t){if(null==t._isValid){var e=p(t),i=n.call(e.parsedDateParts,(function(t){return null!=t})),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&i);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function g(t){var e=f(NaN);return null!=t?c(p(e),t):p(e).userInvalidated=!0,e}n=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),i=e.length>>>0,n=0;n<i;n++)if(n in e&&t.call(this,e[n],n,e))return!0;return!1};var v=r.momentProperties=[];function y(t,e){var i,n,r;if(a(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),a(e._i)||(t._i=e._i),a(e._f)||(t._f=e._f),a(e._l)||(t._l=e._l),a(e._strict)||(t._strict=e._strict),a(e._tzm)||(t._tzm=e._tzm),a(e._isUTC)||(t._isUTC=e._isUTC),a(e._offset)||(t._offset=e._offset),a(e._pf)||(t._pf=p(e)),a(e._locale)||(t._locale=e._locale),v.length>0)for(i=0;i<v.length;i++)a(r=e[n=v[i]])||(t[n]=r);return t}var _=!1;function b(t){y(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===_&&(_=!0,r.updateOffset(this),_=!1)}function w(t){return t instanceof b||null!=t&&null!=t._isAMomentObject}function k(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function D(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=k(e)),i}function S(t,e,i){var n,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),s=0;for(n=0;n<r;n++)(i&&t[n]!==e[n]||!i&&D(t[n])!==D(e[n]))&&s++;return s+o}function x(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function M(t,e){var i=!0;return c((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),i){for(var n,o=[],s=0;s<arguments.length;s++){if(n="","object"===xa(arguments[s])){for(var a in n+="\n["+s+"] ",arguments[0])n+=a+": "+arguments[0][a]+", ";n=n.slice(0,-2)}else n=arguments[s];o.push(n)}x(t+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var T,O={};function C(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),O[t]||(x(e),O[t]=!0)}function E(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function Y(t,e){var i,n=c({},t);for(i in e)d(e,i)&&(s(t[i])&&s(e[i])?(n[i]={},c(n[i],t[i]),c(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)d(t,i)&&!d(e,i)&&s(t[i])&&(n[i]=c({},n[i]));return n}function P(t){null!=t&&this.set(t)}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,T=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)d(t,e)&&i.push(e);return i};var I={};function A(t,e){var i=t.toLowerCase();I[i]=I[i+"s"]=I[e]=t}function L(t){return"string"==typeof t?I[t]||I[t.toLowerCase()]:void 0}function N(t){var e,i,n={};for(i in t)d(t,i)&&(e=L(i))&&(n[e]=t[i]);return n}var R={};function j(t,e){R[t]=e}function F(t,e,i){var n=""+Math.abs(t),r=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+n}var H=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,W=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,G={},U={};function z(t,e,i,n){var r=n;"string"==typeof n&&(r=function(){return this[n]()}),t&&(U[t]=r),e&&(U[e[0]]=function(){return F(r.apply(this,arguments),e[1],e[2])}),i&&(U[i]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function V(t,e){return t.isValid()?(e=B(e,t.localeData()),G[e]=G[e]||function(t){var e,i,n,r=t.match(H);for(e=0,i=r.length;e<i;e++)U[r[e]]?r[e]=U[r[e]]:r[e]=(n=r[e]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(e){var n,o="";for(n=0;n<i;n++)o+=E(r[n])?r[n].call(e,t):r[n];return o}}(e),G[e](t)):t.localeData().invalidDate()}function B(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(W.lastIndex=0;i>=0&&W.test(t);)t=t.replace(W,n),W.lastIndex=0,i-=1;return t}var X=/\d/,q=/\d\d/,Z=/\d{3}/,$=/\d{4}/,J=/[+-]?\d{6}/,K=/\d\d?/,Q=/\d\d\d\d?/,tt=/\d\d\d\d\d\d?/,et=/\d{1,3}/,it=/\d{1,4}/,nt=/[+-]?\d{1,6}/,rt=/\d+/,ot=/[+-]?\d+/,st=/Z|[+-]\d\d:?\d\d/gi,at=/Z|[+-]\d\d(?::?\d\d)?/gi,ht=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,lt={};function ut(t,e,i){lt[t]=E(e)?e:function(t,n){return t&&i?i:e}}function dt(t,e){return d(lt,t)?lt[t](e._strict,e._locale):new RegExp(ct(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,r){return e||i||n||r}))))}function ct(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ft={};function pt(t,e){var i,n=e;for("string"==typeof t&&(t=[t]),h(e)&&(n=function(t,i){i[e]=D(t)}),i=0;i<t.length;i++)ft[t[i]]=n}function mt(t,e){pt(t,(function(t,i,n,r){n._w=n._w||{},e(t,n._w,n,r)}))}function gt(t,e,i){null!=e&&d(ft,t)&&ft[t](e,i._a,i,t)}var vt=0,yt=1,_t=2,bt=3,wt=4,kt=5,Dt=6,St=7,xt=8;function Mt(t){return Tt(t)?366:365}function Tt(t){return t%4==0&&t%100!=0||t%400==0}z("Y",0,0,(function(){var t=this.year();return t<=9999?""+t:"+"+t})),z(0,["YY",2],0,(function(){return this.year()%100})),z(0,["YYYY",4],0,"year"),z(0,["YYYYY",5],0,"year"),z(0,["YYYYYY",6,!0],0,"year"),A("year","y"),j("year",1),ut("Y",ot),ut("YY",K,q),ut("YYYY",it,$),ut("YYYYY",nt,J),ut("YYYYYY",nt,J),pt(["YYYYY","YYYYYY"],vt),pt("YYYY",(function(t,e){e[vt]=2===t.length?r.parseTwoDigitYear(t):D(t)})),pt("YY",(function(t,e){e[vt]=r.parseTwoDigitYear(t)})),pt("Y",(function(t,e){e[vt]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return D(t)+(D(t)>68?1900:2e3)};var Ot,Ct=Et("FullYear",!0);function Et(t,e){return function(i){return null!=i?(Pt(this,t,i),r.updateOffset(this,e),this):Yt(this,t)}}function Yt(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Pt(t,e,i){t.isValid()&&!isNaN(i)&&("FullYear"===e&&Tt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](i,t.month(),It(i,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](i))}function It(t,e){if(isNaN(t)||isNaN(e))return NaN;var i,n=(e%(i=12)+i)%i;return t+=(e-n)/12,1===n?Tt(t)?29:28:31-n%7%2}Ot=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},z("M",["MM",2],"Mo",(function(){return this.month()+1})),z("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),z("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),A("month","M"),j("month",8),ut("M",K),ut("MM",K,q),ut("MMM",(function(t,e){return e.monthsShortRegex(t)})),ut("MMMM",(function(t,e){return e.monthsRegex(t)})),pt(["M","MM"],(function(t,e){e[yt]=D(t)-1})),pt(["MMM","MMMM"],(function(t,e,i,n){var r=i._locale.monthsParse(t,n,i._strict);null!=r?e[yt]=r:p(i).invalidMonth=t}));var At=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Lt="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Nt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Rt(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)o=f([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(o,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(r=Ot.call(this._shortMonthsParse,s))?r:null:-1!==(r=Ot.call(this._longMonthsParse,s))?r:null:"MMM"===e?-1!==(r=Ot.call(this._shortMonthsParse,s))?r:-1!==(r=Ot.call(this._longMonthsParse,s))?r:null:-1!==(r=Ot.call(this._longMonthsParse,s))?r:-1!==(r=Ot.call(this._shortMonthsParse,s))?r:null}function jt(t,e){var i;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=D(e);else if(!h(e=t.localeData().monthsParse(e)))return t;return i=Math.min(t.date(),It(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,i),t}function Ft(t){return null!=t?(jt(this,t),r.updateOffset(this,!0),this):Yt(this,"Month")}var Ht=ht,Wt=ht;function Gt(){function t(t,e){return e.length-t.length}var e,i,n=[],r=[],o=[];for(e=0;e<12;e++)i=f([2e3,e]),n.push(this.monthsShort(i,"")),r.push(this.months(i,"")),o.push(this.months(i,"")),o.push(this.monthsShort(i,""));for(n.sort(t),r.sort(t),o.sort(t),e=0;e<12;e++)n[e]=ct(n[e]),r[e]=ct(r[e]);for(e=0;e<24;e++)o[e]=ct(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function Ut(t,e,i,n,r,o,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,r,o,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,r,o,s),a}function zt(t){var e;if(t<100&&t>=0){var i=Array.prototype.slice.call(arguments);i[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function Vt(t,e,i){var n=7+e-i;return-(7+zt(t,0,n).getUTCDay()-e)%7+n-1}function Bt(t,e,i,n,r){var o,s,a=1+7*(e-1)+(7+i-n)%7+Vt(t,n,r);return a<=0?s=Mt(o=t-1)+a:a>Mt(t)?(o=t+1,s=a-Mt(t)):(o=t,s=a),{year:o,dayOfYear:s}}function Xt(t,e,i){var n,r,o=Vt(t.year(),e,i),s=Math.floor((t.dayOfYear()-o-1)/7)+1;return s<1?n=s+qt(r=t.year()-1,e,i):s>qt(t.year(),e,i)?(n=s-qt(t.year(),e,i),r=t.year()+1):(r=t.year(),n=s),{week:n,year:r}}function qt(t,e,i){var n=Vt(t,e,i),r=Vt(t+1,e,i);return(Mt(t)-n+r)/7}function Zt(t,e){return t.slice(e,7).concat(t.slice(0,e))}z("w",["ww",2],"wo","week"),z("W",["WW",2],"Wo","isoWeek"),A("week","w"),A("isoWeek","W"),j("week",5),j("isoWeek",5),ut("w",K),ut("ww",K,q),ut("W",K),ut("WW",K,q),mt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=D(t)})),z("d",0,"do","day"),z("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),z("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),z("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),z("e",0,0,"weekday"),z("E",0,0,"isoWeekday"),A("day","d"),A("weekday","e"),A("isoWeekday","E"),j("day",11),j("weekday",11),j("isoWeekday",11),ut("d",K),ut("e",K),ut("E",K),ut("dd",(function(t,e){return e.weekdaysMinRegex(t)})),ut("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),ut("dddd",(function(t,e){return e.weekdaysRegex(t)})),mt(["dd","ddd","dddd"],(function(t,e,i,n){var r=i._locale.weekdaysParse(t,n,i._strict);null!=r?e.d=r:p(i).invalidWeekday=t})),mt(["d","e","E"],(function(t,e,i,n){e[n]=D(t)}));var $t="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Jt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Kt="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Qt(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)o=f([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(o,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(r=Ot.call(this._weekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Ot.call(this._shortWeekdaysParse,s))?r:null:-1!==(r=Ot.call(this._minWeekdaysParse,s))?r:null:"dddd"===e?-1!==(r=Ot.call(this._weekdaysParse,s))?r:-1!==(r=Ot.call(this._shortWeekdaysParse,s))?r:-1!==(r=Ot.call(this._minWeekdaysParse,s))?r:null:"ddd"===e?-1!==(r=Ot.call(this._shortWeekdaysParse,s))?r:-1!==(r=Ot.call(this._weekdaysParse,s))?r:-1!==(r=Ot.call(this._minWeekdaysParse,s))?r:null:-1!==(r=Ot.call(this._minWeekdaysParse,s))?r:-1!==(r=Ot.call(this._weekdaysParse,s))?r:-1!==(r=Ot.call(this._shortWeekdaysParse,s))?r:null}var te=ht,ee=ht,ie=ht;function ne(){function t(t,e){return e.length-t.length}var e,i,n,r,o,s=[],a=[],h=[],l=[];for(e=0;e<7;e++)i=f([2e3,1]).day(e),n=this.weekdaysMin(i,""),r=this.weekdaysShort(i,""),o=this.weekdays(i,""),s.push(n),a.push(r),h.push(o),l.push(n),l.push(r),l.push(o);for(s.sort(t),a.sort(t),h.sort(t),l.sort(t),e=0;e<7;e++)a[e]=ct(a[e]),h[e]=ct(h[e]),l[e]=ct(l[e]);this._weekdaysRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function re(){return this.hours()%12||12}function oe(t,e){z(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function se(t,e){return e._meridiemParse}z("H",["HH",2],0,"hour"),z("h",["hh",2],0,re),z("k",["kk",2],0,(function(){return this.hours()||24})),z("hmm",0,0,(function(){return""+re.apply(this)+F(this.minutes(),2)})),z("hmmss",0,0,(function(){return""+re.apply(this)+F(this.minutes(),2)+F(this.seconds(),2)})),z("Hmm",0,0,(function(){return""+this.hours()+F(this.minutes(),2)})),z("Hmmss",0,0,(function(){return""+this.hours()+F(this.minutes(),2)+F(this.seconds(),2)})),oe("a",!0),oe("A",!1),A("hour","h"),j("hour",13),ut("a",se),ut("A",se),ut("H",K),ut("h",K),ut("k",K),ut("HH",K,q),ut("hh",K,q),ut("kk",K,q),ut("hmm",Q),ut("hmmss",tt),ut("Hmm",Q),ut("Hmmss",tt),pt(["H","HH"],bt),pt(["k","kk"],(function(t,e,i){var n=D(t);e[bt]=24===n?0:n})),pt(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),pt(["h","hh"],(function(t,e,i){e[bt]=D(t),p(i).bigHour=!0})),pt("hmm",(function(t,e,i){var n=t.length-2;e[bt]=D(t.substr(0,n)),e[wt]=D(t.substr(n)),p(i).bigHour=!0})),pt("hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[bt]=D(t.substr(0,n)),e[wt]=D(t.substr(n,2)),e[kt]=D(t.substr(r)),p(i).bigHour=!0})),pt("Hmm",(function(t,e,i){var n=t.length-2;e[bt]=D(t.substr(0,n)),e[wt]=D(t.substr(n))})),pt("Hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[bt]=D(t.substr(0,n)),e[wt]=D(t.substr(n,2)),e[kt]=D(t.substr(r))}));var ae,he=Et("Hours",!0),le={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Lt,monthsShort:Nt,week:{dow:0,doy:6},weekdays:$t,weekdaysMin:Kt,weekdaysShort:Jt,meridiemParse:/[ap]\.?m?\.?/i},ue={},de={};function ce(t){return t?t.toLowerCase().replace("_","-"):t}function fe(e){var n=null;if(!ue[e]&&t&&t.exports)try{n=ae._abbr,i(),pe(n)}catch(t){}return ue[e]}function pe(t,e){var i;return t&&((i=a(e)?ge(t):me(t,e))?ae=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),ae._abbr}function me(t,e){if(null!==e){var i,n=le;if(e.abbr=t,null!=ue[t])C("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=ue[t]._config;else if(null!=e.parentLocale)if(null!=ue[e.parentLocale])n=ue[e.parentLocale]._config;else{if(null==(i=fe(e.parentLocale)))return de[e.parentLocale]||(de[e.parentLocale]=[]),de[e.parentLocale].push({name:t,config:e}),null;n=i._config}return ue[t]=new P(Y(n,e)),de[t]&&de[t].forEach((function(t){me(t.name,t.config)})),pe(t),ue[t]}return delete ue[t],null}function ge(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return ae;if(!o(t)){if(e=fe(t))return e;t=[t]}return function(t){for(var e,i,n,r,o=0;o<t.length;){for(e=(r=ce(t[o]).split("-")).length,i=(i=ce(t[o+1]))?i.split("-"):null;e>0;){if(n=fe(r.slice(0,e).join("-")))return n;if(i&&i.length>=e&&S(r,i,!0)>=e-1)break;e--}o++}return ae}(t)}function ve(t){var e,i=t._a;return i&&-2===p(t).overflow&&(e=i[yt]<0||i[yt]>11?yt:i[_t]<1||i[_t]>It(i[vt],i[yt])?_t:i[bt]<0||i[bt]>24||24===i[bt]&&(0!==i[wt]||0!==i[kt]||0!==i[Dt])?bt:i[wt]<0||i[wt]>59?wt:i[kt]<0||i[kt]>59?kt:i[Dt]<0||i[Dt]>999?Dt:-1,p(t)._overflowDayOfYear&&(e<vt||e>_t)&&(e=_t),p(t)._overflowWeeks&&-1===e&&(e=St),p(t)._overflowWeekday&&-1===e&&(e=xt),p(t).overflow=e),t}function ye(t,e,i){return null!=t?t:null!=e?e:i}function _e(t){var e,i,n,o,s,a=[];if(!t._d){for(n=function(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[_t]&&null==t._a[yt]&&function(t){var e,i,n,r,o,s,a,h;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)o=1,s=4,i=ye(e.GG,t._a[vt],Xt(Ae(),1,4).year),n=ye(e.W,1),((r=ye(e.E,1))<1||r>7)&&(h=!0);else{o=t._locale._week.dow,s=t._locale._week.doy;var l=Xt(Ae(),o,s);i=ye(e.gg,t._a[vt],l.year),n=ye(e.w,l.week),null!=e.d?((r=e.d)<0||r>6)&&(h=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(h=!0)):r=o}n<1||n>qt(i,o,s)?p(t)._overflowWeeks=!0:null!=h?p(t)._overflowWeekday=!0:(a=Bt(i,n,r,o,s),t._a[vt]=a.year,t._dayOfYear=a.dayOfYear)}(t),null!=t._dayOfYear&&(s=ye(t._a[vt],n[vt]),(t._dayOfYear>Mt(s)||0===t._dayOfYear)&&(p(t)._overflowDayOfYear=!0),i=zt(s,0,t._dayOfYear),t._a[yt]=i.getUTCMonth(),t._a[_t]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=a[e]=n[e];for(;e<7;e++)t._a[e]=a[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[bt]&&0===t._a[wt]&&0===t._a[kt]&&0===t._a[Dt]&&(t._nextDay=!0,t._a[bt]=0),t._d=(t._useUTC?zt:Ut).apply(null,a),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[bt]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(p(t).weekdayMismatch=!0)}}var be=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,we=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ke=/Z|[+-]\d\d(?::?\d\d)?/,De=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],Se=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],xe=/^\/?Date\((\-?\d+)/i;function Me(t){var e,i,n,r,o,s,a=t._i,h=be.exec(a)||we.exec(a);if(h){for(p(t).iso=!0,e=0,i=De.length;e<i;e++)if(De[e][1].exec(h[1])){r=De[e][0],n=!1!==De[e][2];break}if(null==r)return void(t._isValid=!1);if(h[3]){for(e=0,i=Se.length;e<i;e++)if(Se[e][1].exec(h[3])){o=(h[2]||" ")+Se[e][0];break}if(null==o)return void(t._isValid=!1)}if(!n&&null!=o)return void(t._isValid=!1);if(h[4]){if(!ke.exec(h[4]))return void(t._isValid=!1);s="Z"}t._f=r+(o||"")+(s||""),Ye(t)}else t._isValid=!1}var Te=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Oe(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}var Ce={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Ee(t){var e,i,n,r,o,s,a,h=Te.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(h){var l=(e=h[4],i=h[3],n=h[2],r=h[5],o=h[6],s=h[7],a=[Oe(e),Nt.indexOf(i),parseInt(n,10),parseInt(r,10),parseInt(o,10)],s&&a.push(parseInt(s,10)),a);if(!function(t,e,i){return!t||Jt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(p(i).weekdayMismatch=!0,i._isValid=!1,!1)}(h[1],l,t))return;t._a=l,t._tzm=function(t,e,i){if(t)return Ce[t];if(e)return 0;var n=parseInt(i,10),r=n%100;return(n-r)/100*60+r}(h[8],h[9],h[10]),t._d=zt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),p(t).rfc2822=!0}else t._isValid=!1}function Ye(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],p(t).empty=!0;var e,i,n,o,s,a=""+t._i,h=a.length,l=0;for(n=B(t._f,t._locale).match(H)||[],e=0;e<n.length;e++)o=n[e],(i=(a.match(dt(o,t))||[])[0])&&((s=a.substr(0,a.indexOf(i))).length>0&&p(t).unusedInput.push(s),a=a.slice(a.indexOf(i)+i.length),l+=i.length),U[o]?(i?p(t).empty=!1:p(t).unusedTokens.push(o),gt(o,i,t)):t._strict&&!i&&p(t).unusedTokens.push(o);p(t).charsLeftOver=h-l,a.length>0&&p(t).unusedInput.push(a),t._a[bt]<=12&&!0===p(t).bigHour&&t._a[bt]>0&&(p(t).bigHour=void 0),p(t).parsedDateParts=t._a.slice(0),p(t).meridiem=t._meridiem,t._a[bt]=function(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}(t._locale,t._a[bt],t._meridiem),_e(t),ve(t)}else Ee(t);else Me(t)}function Pe(t){var e=t._i,i=t._f;return t._locale=t._locale||ge(t._l),null===e||void 0===i&&""===e?g({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),w(e)?new b(ve(e)):(l(e)?t._d=e:o(i)?function(t){var e,i,n,r,o;if(0===t._f.length)return p(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<t._f.length;r++)o=0,e=y({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],Ye(e),m(e)&&(o+=p(e).charsLeftOver,o+=10*p(e).unusedTokens.length,p(e).score=o,(null==n||o<n)&&(n=o,i=e));c(t,i||e)}(t):i?Ye(t):function(t){var e=t._i;a(e)?t._d=new Date(r.now()):l(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=xe.exec(t._i);null===e?(Me(t),!1===t._isValid&&(delete t._isValid,Ee(t),!1===t._isValid&&(delete t._isValid,r.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):o(e)?(t._a=u(e.slice(0),(function(t){return parseInt(t,10)})),_e(t)):s(e)?function(t){if(!t._d){var e=N(t._i);t._a=u([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),_e(t)}}(t):h(e)?t._d=new Date(e):r.createFromInputFallback(t)}(t),m(t)||(t._d=null),t))}function Ie(t,e,i,n,r){var a,h={};return!0!==i&&!1!==i||(n=i,i=void 0),(s(t)&&function(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}(t)||o(t)&&0===t.length)&&(t=void 0),h._isAMomentObject=!0,h._useUTC=h._isUTC=r,h._l=i,h._i=t,h._f=e,h._strict=n,(a=new b(ve(Pe(h))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Ae(t,e,i,n){return Ie(t,e,i,n,!1)}r.createFromInputFallback=M("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Le=M("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ae.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:g()})),Ne=M("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ae.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:g()}));function Re(t,e){var i,n;if(1===e.length&&o(e[0])&&(e=e[0]),!e.length)return Ae();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}var je=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Fe(t){var e=N(t),i=e.year||0,n=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,a=e.hour||0,h=e.minute||0,l=e.second||0,u=e.millisecond||0;this._isValid=function(t){for(var e in t)if(-1===Ot.call(je,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var i=!1,n=0;n<je.length;++n)if(t[je[n]]){if(i)return!1;parseFloat(t[je[n]])!==D(t[je[n]])&&(i=!0)}return!0}(e),this._milliseconds=+u+1e3*l+6e4*h+1e3*a*60*60,this._days=+s+7*o,this._months=+r+3*n+12*i,this._data={},this._locale=ge(),this._bubble()}function He(t){return t instanceof Fe}function We(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function Ge(t,e){z(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+F(~~(t/60),2)+e+F(~~t%60,2)}))}Ge("Z",":"),Ge("ZZ",""),ut("Z",at),ut("ZZ",at),pt(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=ze(at,t)}));var Ue=/([\+\-]|\d\d)/gi;function ze(t,e){var i=(e||"").match(t);if(null===i)return null;var n=((i[i.length-1]||[])+"").match(Ue)||["-",0,0],r=60*n[1]+D(n[2]);return 0===r?0:"+"===n[0]?r:-r}function Ve(t,e){var i,n;return e._isUTC?(i=e.clone(),n=(w(t)||l(t)?t.valueOf():Ae(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+n),r.updateOffset(i,!1),i):Ae(t).local()}function Be(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function Xe(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var qe=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Ze=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function $e(t,e){var i,n,r,o,s,a,l=t,u=null;return He(t)?l={ms:t._milliseconds,d:t._days,M:t._months}:h(t)?(l={},e?l[e]=t:l.milliseconds=t):(u=qe.exec(t))?(i="-"===u[1]?-1:1,l={y:0,d:D(u[_t])*i,h:D(u[bt])*i,m:D(u[wt])*i,s:D(u[kt])*i,ms:D(We(1e3*u[Dt]))*i}):(u=Ze.exec(t))?(i="-"===u[1]?-1:1,l={y:Je(u[2],i),M:Je(u[3],i),w:Je(u[4],i),d:Je(u[5],i),h:Je(u[6],i),m:Je(u[7],i),s:Je(u[8],i)}):null==l?l={}:"object"===xa(l)&&("from"in l||"to"in l)&&(o=Ae(l.from),s=Ae(l.to),r=o.isValid()&&s.isValid()?(s=Ve(s,o),o.isBefore(s)?a=Ke(o,s):((a=Ke(s,o)).milliseconds=-a.milliseconds,a.months=-a.months),a):{milliseconds:0,months:0},(l={}).ms=r.milliseconds,l.M=r.months),n=new Fe(l),He(t)&&d(t,"_locale")&&(n._locale=t._locale),n}function Je(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Ke(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function Qe(t,e){return function(i,n){var r;return null===n||isNaN(+n)||(C(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=i,i=n,n=r),ti(this,$e(i="string"==typeof i?+i:i,n),t),this}}function ti(t,e,i,n){var o=e._milliseconds,s=We(e._days),a=We(e._months);t.isValid()&&(n=null==n||n,a&&jt(t,Yt(t,"Month")+a*i),s&&Pt(t,"Date",Yt(t,"Date")+s*i),o&&t._d.setTime(t._d.valueOf()+o*i),n&&r.updateOffset(t,s||a))}$e.fn=Fe.prototype,$e.invalid=function(){return $e(NaN)};var ei=Qe(1,"add"),ii=Qe(-1,"subtract");function ni(t,e){var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function ri(t){var e;return void 0===t?this._locale._abbr:(null!=(e=ge(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var oi=M("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function si(){return this._locale}var ai=1e3,hi=60*ai,li=60*hi,ui=3506328*li;function di(t,e){return(t%e+e)%e}function ci(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-ui:new Date(t,e,i).valueOf()}function fi(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-ui:Date.UTC(t,e,i)}function pi(t,e){z(0,[t,t.length],0,e)}function mi(t,e,i,n,r){var o;return null==t?Xt(this,n,r).year:(e>(o=qt(t,n,r))&&(e=o),gi.call(this,t,e,i,n,r))}function gi(t,e,i,n,r){var o=Bt(t,e,i,n,r),s=zt(o.year,0,o.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}z(0,["gg",2],0,(function(){return this.weekYear()%100})),z(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),pi("gggg","weekYear"),pi("ggggg","weekYear"),pi("GGGG","isoWeekYear"),pi("GGGGG","isoWeekYear"),A("weekYear","gg"),A("isoWeekYear","GG"),j("weekYear",1),j("isoWeekYear",1),ut("G",ot),ut("g",ot),ut("GG",K,q),ut("gg",K,q),ut("GGGG",it,$),ut("gggg",it,$),ut("GGGGG",nt,J),ut("ggggg",nt,J),mt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=D(t)})),mt(["gg","GG"],(function(t,e,i,n){e[n]=r.parseTwoDigitYear(t)})),z("Q",0,"Qo","quarter"),A("quarter","Q"),j("quarter",7),ut("Q",X),pt("Q",(function(t,e){e[yt]=3*(D(t)-1)})),z("D",["DD",2],"Do","date"),A("date","D"),j("date",9),ut("D",K),ut("DD",K,q),ut("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),pt(["D","DD"],_t),pt("Do",(function(t,e){e[_t]=D(t.match(K)[0])}));var vi=Et("Date",!0);z("DDD",["DDDD",3],"DDDo","dayOfYear"),A("dayOfYear","DDD"),j("dayOfYear",4),ut("DDD",et),ut("DDDD",Z),pt(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=D(t)})),z("m",["mm",2],0,"minute"),A("minute","m"),j("minute",14),ut("m",K),ut("mm",K,q),pt(["m","mm"],wt);var yi=Et("Minutes",!1);z("s",["ss",2],0,"second"),A("second","s"),j("second",15),ut("s",K),ut("ss",K,q),pt(["s","ss"],kt);var _i,bi=Et("Seconds",!1);for(z("S",0,0,(function(){return~~(this.millisecond()/100)})),z(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),z(0,["SSS",3],0,"millisecond"),z(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),z(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),z(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),z(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),z(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),z(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),A("millisecond","ms"),j("millisecond",16),ut("S",et,X),ut("SS",et,q),ut("SSS",et,Z),_i="SSSS";_i.length<=9;_i+="S")ut(_i,rt);function wi(t,e){e[Dt]=D(1e3*("0."+t))}for(_i="S";_i.length<=9;_i+="S")pt(_i,wi);var ki=Et("Milliseconds",!1);z("z",0,0,"zoneAbbr"),z("zz",0,0,"zoneName");var Di=b.prototype;function Si(t){return t}Di.add=ei,Di.calendar=function(t,e){var i=t||Ae(),n=Ve(i,this).startOf("day"),o=r.calendarFormat(this,n)||"sameElse",s=e&&(E(e[o])?e[o].call(this,i):e[o]);return this.format(s||this.localeData().calendar(o,this,Ae(i)))},Di.clone=function(){return new b(this)},Di.diff=function(t,e,i){var n,r,o;if(!this.isValid())return NaN;if(!(n=Ve(t,this)).isValid())return NaN;switch(r=6e4*(n.utcOffset()-this.utcOffset()),e=L(e)){case"year":o=ni(this,n)/12;break;case"month":o=ni(this,n);break;case"quarter":o=ni(this,n)/3;break;case"second":o=(this-n)/1e3;break;case"minute":o=(this-n)/6e4;break;case"hour":o=(this-n)/36e5;break;case"day":o=(this-n-r)/864e5;break;case"week":o=(this-n-r)/6048e5;break;default:o=this-n}return i?o:k(o)},Di.endOf=function(t){var e;if(void 0===(t=L(t))||"millisecond"===t||!this.isValid())return this;var i=this._isUTC?fi:ci;switch(t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=li-di(e+(this._isUTC?0:this.utcOffset()*hi),li)-1;break;case"minute":e=this._d.valueOf(),e+=hi-di(e,hi)-1;break;case"second":e=this._d.valueOf(),e+=ai-di(e,ai)-1}return this._d.setTime(e),r.updateOffset(this,!0),this},Di.format=function(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=V(this,t);return this.localeData().postformat(e)},Di.from=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ae(t).isValid())?$e({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},Di.fromNow=function(t){return this.from(Ae(),t)},Di.to=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ae(t).isValid())?$e({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},Di.toNow=function(t){return this.to(Ae(),t)},Di.get=function(t){return E(this[t=L(t)])?this[t]():this},Di.invalidAt=function(){return p(this).overflow},Di.isAfter=function(t,e){var i=w(t)?t:Ae(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=L(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())},Di.isBefore=function(t,e){var i=w(t)?t:Ae(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=L(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())},Di.isBetween=function(t,e,i,n){var r=w(t)?t:Ae(t),o=w(e)?e:Ae(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(n=n||"()")[0]?this.isAfter(r,i):!this.isBefore(r,i))&&(")"===n[1]?this.isBefore(o,i):!this.isAfter(o,i))},Di.isSame=function(t,e){var i,n=w(t)?t:Ae(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=L(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))},Di.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},Di.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},Di.isValid=function(){return m(this)},Di.lang=oi,Di.locale=ri,Di.localeData=si,Di.max=Ne,Di.min=Le,Di.parsingFlags=function(){return c({},p(this))},Di.set=function(t,e){if("object"===xa(t))for(var i=function(t){var e=[];for(var i in t)e.push({unit:i,priority:R[i]});return e.sort((function(t,e){return t.priority-e.priority})),e}(t=N(t)),n=0;n<i.length;n++)this[i[n].unit](t[i[n].unit]);else if(E(this[t=L(t)]))return this[t](e);return this},Di.startOf=function(t){var e;if(void 0===(t=L(t))||"millisecond"===t||!this.isValid())return this;var i=this._isUTC?fi:ci;switch(t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=di(e+(this._isUTC?0:this.utcOffset()*hi),li);break;case"minute":e=this._d.valueOf(),e-=di(e,hi);break;case"second":e=this._d.valueOf(),e-=di(e,ai)}return this._d.setTime(e),r.updateOffset(this,!0),this},Di.subtract=ii,Di.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},Di.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},Di.toDate=function(){return new Date(this.valueOf())},Di.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?V(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):E(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",V(i,"Z")):V(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},Di.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var i="["+t+'("]',n=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",r=e+'[")]';return this.format(i+n+"-MM-DD[T]HH:mm:ss.SSS"+r)},Di.toJSON=function(){return this.isValid()?this.toISOString():null},Di.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},Di.unix=function(){return Math.floor(this.valueOf()/1e3)},Di.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},Di.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},Di.year=Ct,Di.isLeapYear=function(){return Tt(this.year())},Di.weekYear=function(t){return mi.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},Di.isoWeekYear=function(t){return mi.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},Di.quarter=Di.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},Di.month=Ft,Di.daysInMonth=function(){return It(this.year(),this.month())},Di.week=Di.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},Di.isoWeek=Di.isoWeeks=function(t){var e=Xt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},Di.weeksInYear=function(){var t=this.localeData()._week;return qt(this.year(),t.dow,t.doy)},Di.isoWeeksInYear=function(){return qt(this.year(),1,4)},Di.date=vi,Di.day=Di.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},Di.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},Di.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},Di.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},Di.hour=Di.hours=he,Di.minute=Di.minutes=yi,Di.second=Di.seconds=bi,Di.millisecond=Di.milliseconds=ki,Di.utcOffset=function(t,e,i){var n,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=ze(at,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(n=Be(this)),this._offset=t,this._isUTC=!0,null!=n&&this.add(n,"m"),o!==t&&(!e||this._changeInProgress?ti(this,$e(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:Be(this)},Di.utc=function(t){return this.utcOffset(0,t)},Di.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Be(this),"m")),this},Di.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=ze(st,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},Di.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ae(t).utcOffset():0,(this.utcOffset()-t)%60==0)},Di.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},Di.isLocal=function(){return!!this.isValid()&&!this._isUTC},Di.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},Di.isUtc=Xe,Di.isUTC=Xe,Di.zoneAbbr=function(){return this._isUTC?"UTC":""},Di.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},Di.dates=M("dates accessor is deprecated. Use date instead.",vi),Di.months=M("months accessor is deprecated. Use month instead",Ft),Di.years=M("years accessor is deprecated. Use year instead",Ct),Di.zone=M("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),Di.isDSTShifted=M("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!a(this._isDSTShifted))return this._isDSTShifted;var t={};if(y(t,this),(t=Pe(t))._a){var e=t._isUTC?f(t._a):Ae(t._a);this._isDSTShifted=this.isValid()&&S(t._a,e.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var xi=P.prototype;function Mi(t,e,i,n){var r=ge(),o=f().set(n,e);return r[i](o,t)}function Ti(t,e,i){if(h(t)&&(e=t,t=void 0),t=t||"",null!=e)return Mi(t,e,i,"month");var n,r=[];for(n=0;n<12;n++)r[n]=Mi(t,n,i,"month");return r}function Oi(t,e,i,n){"boolean"==typeof t?(h(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,h(e)&&(i=e,e=void 0),e=e||"");var r,o=ge(),s=t?o._week.dow:0;if(null!=i)return Mi(e,(i+s)%7,n,"day");var a=[];for(r=0;r<7;r++)a[r]=Mi(e,(r+s)%7,n,"day");return a}xi.calendar=function(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return E(n)?n.call(e,i):n},xi.longDateFormat=function(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.replace(/MMMM|MM|DD|dddd/g,(function(t){return t.slice(1)})),this._longDateFormat[t])},xi.invalidDate=function(){return this._invalidDate},xi.ordinal=function(t){return this._ordinal.replace("%d",t)},xi.preparse=Si,xi.postformat=Si,xi.relativeTime=function(t,e,i,n){var r=this._relativeTime[i];return E(r)?r(t,e,i,n):r.replace(/%d/i,t)},xi.pastFuture=function(t,e){var i=this._relativeTime[t>0?"future":"past"];return E(i)?i(e):i.replace(/%s/i,e)},xi.set=function(t){var e,i;for(i in t)E(e=t[i])?this[i]=e:this["_"+i]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},xi.months=function(t,e){return t?o(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||At).test(e)?"format":"standalone"][t.month()]:o(this._months)?this._months:this._months.standalone},xi.monthsShort=function(t,e){return t?o(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[At.test(e)?"format":"standalone"][t.month()]:o(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},xi.monthsParse=function(t,e,i){var n,r,o;if(this._monthsParseExact)return Rt.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(r=f([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[n]=new RegExp(o.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}},xi.monthsRegex=function(t){return this._monthsParseExact?(d(this,"_monthsRegex")||Gt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(d(this,"_monthsRegex")||(this._monthsRegex=Wt),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},xi.monthsShortRegex=function(t){return this._monthsParseExact?(d(this,"_monthsRegex")||Gt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(d(this,"_monthsShortRegex")||(this._monthsShortRegex=Ht),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},xi.week=function(t){return Xt(t,this._week.dow,this._week.doy).week},xi.firstDayOfYear=function(){return this._week.doy},xi.firstDayOfWeek=function(){return this._week.dow},xi.weekdays=function(t,e){var i=o(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Zt(i,this._week.dow):t?i[t.day()]:i},xi.weekdaysMin=function(t){return!0===t?Zt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},xi.weekdaysShort=function(t){return!0===t?Zt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},xi.weekdaysParse=function(t,e,i){var n,r,o;if(this._weekdaysParseExact)return Qt.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(r=f([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[n]=new RegExp(o.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}},xi.weekdaysRegex=function(t){return this._weekdaysParseExact?(d(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(d(this,"_weekdaysRegex")||(this._weekdaysRegex=te),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},xi.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(d(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(d(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=ee),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},xi.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(d(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(d(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=ie),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},xi.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},xi.meridiem=function(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"},pe("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===D(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=M("moment.lang is deprecated. Use moment.locale instead.",pe),r.langData=M("moment.langData is deprecated. Use moment.localeData instead.",ge);var Ci=Math.abs;function Ei(t,e,i,n){var r=$e(e,i);return t._milliseconds+=n*r._milliseconds,t._days+=n*r._days,t._months+=n*r._months,t._bubble()}function Yi(t){return t<0?Math.floor(t):Math.ceil(t)}function Pi(t){return 4800*t/146097}function Ii(t){return 146097*t/4800}function Ai(t){return function(){return this.as(t)}}var Li=Ai("ms"),Ni=Ai("s"),Ri=Ai("m"),ji=Ai("h"),Fi=Ai("d"),Hi=Ai("w"),Wi=Ai("M"),Gi=Ai("Q"),Ui=Ai("y");function zi(t){return function(){return this.isValid()?this._data[t]:NaN}}var Vi=zi("milliseconds"),Bi=zi("seconds"),Xi=zi("minutes"),qi=zi("hours"),Zi=zi("days"),$i=zi("months"),Ji=zi("years"),Ki=Math.round,Qi={ss:44,s:45,m:45,h:22,d:26,M:11};function tn(t,e,i,n,r){return r.relativeTime(e||1,!!i,t,n)}var en=Math.abs;function nn(t){return(t>0)-(t<0)||+t}function rn(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i=en(this._milliseconds)/1e3,n=en(this._days),r=en(this._months);t=k(i/60),e=k(t/60),i%=60,t%=60;var o=k(r/12),s=r%=12,a=n,h=e,l=t,u=i?i.toFixed(3).replace(/\.?0+$/,""):"",d=this.asSeconds();if(!d)return"P0D";var c=d<0?"-":"",f=nn(this._months)!==nn(d)?"-":"",p=nn(this._days)!==nn(d)?"-":"",m=nn(this._milliseconds)!==nn(d)?"-":"";return c+"P"+(o?f+o+"Y":"")+(s?f+s+"M":"")+(a?p+a+"D":"")+(h||l||u?"T":"")+(h?m+h+"H":"")+(l?m+l+"M":"")+(u?m+u+"S":"")}var on=Fe.prototype;return on.isValid=function(){return this._isValid},on.abs=function(){var t=this._data;return this._milliseconds=Ci(this._milliseconds),this._days=Ci(this._days),this._months=Ci(this._months),t.milliseconds=Ci(t.milliseconds),t.seconds=Ci(t.seconds),t.minutes=Ci(t.minutes),t.hours=Ci(t.hours),t.months=Ci(t.months),t.years=Ci(t.years),this},on.add=function(t,e){return Ei(this,t,e,1)},on.subtract=function(t,e){return Ei(this,t,e,-1)},on.as=function(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=L(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Pi(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Ii(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}},on.asMilliseconds=Li,on.asSeconds=Ni,on.asMinutes=Ri,on.asHours=ji,on.asDays=Fi,on.asWeeks=Hi,on.asMonths=Wi,on.asQuarters=Gi,on.asYears=Ui,on.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*D(this._months/12):NaN},on._bubble=function(){var t,e,i,n,r,o=this._milliseconds,s=this._days,a=this._months,h=this._data;return o>=0&&s>=0&&a>=0||o<=0&&s<=0&&a<=0||(o+=864e5*Yi(Ii(a)+s),s=0,a=0),h.milliseconds=o%1e3,t=k(o/1e3),h.seconds=t%60,e=k(t/60),h.minutes=e%60,i=k(e/60),h.hours=i%24,s+=k(i/24),r=k(Pi(s)),a+=r,s-=Yi(Ii(r)),n=k(a/12),a%=12,h.days=s,h.months=a,h.years=n,this},on.clone=function(){return $e(this)},on.get=function(t){return t=L(t),this.isValid()?this[t+"s"]():NaN},on.milliseconds=Vi,on.seconds=Bi,on.minutes=Xi,on.hours=qi,on.days=Zi,on.weeks=function(){return k(this.days()/7)},on.months=$i,on.years=Ji,on.humanize=function(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),i=function(t,e,i){var n=$e(t).abs(),r=Ki(n.as("s")),o=Ki(n.as("m")),s=Ki(n.as("h")),a=Ki(n.as("d")),h=Ki(n.as("M")),l=Ki(n.as("y")),u=r<=Qi.ss&&["s",r]||r<Qi.s&&["ss",r]||o<=1&&["m"]||o<Qi.m&&["mm",o]||s<=1&&["h"]||s<Qi.h&&["hh",s]||a<=1&&["d"]||a<Qi.d&&["dd",a]||h<=1&&["M"]||h<Qi.M&&["MM",h]||l<=1&&["y"]||["yy",l];return u[2]=e,u[3]=+t>0,u[4]=i,tn.apply(null,u)}(this,!t,e);return t&&(i=e.pastFuture(+this,i)),e.postformat(i)},on.toISOString=rn,on.toString=rn,on.toJSON=rn,on.locale=ri,on.localeData=si,on.toIsoString=M("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",rn),on.lang=oi,z("X",0,0,"unix"),z("x",0,0,"valueOf"),ut("x",ot),ut("X",/[+-]?\d+(\.\d{1,3})?/),pt("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t,10))})),pt("x",(function(t,e,i){i._d=new Date(D(t))})),r.version="2.24.0",e=Ae,r.fn=Di,r.min=function(){return Re("isBefore",[].slice.call(arguments,0))},r.max=function(){return Re("isAfter",[].slice.call(arguments,0))},r.now=function(){return Date.now?Date.now():+new Date},r.utc=f,r.unix=function(t){return Ae(1e3*t)},r.months=function(t,e){return Ti(t,e,"months")},r.isDate=l,r.locale=pe,r.invalid=g,r.duration=$e,r.isMoment=w,r.weekdays=function(t,e,i){return Oi(t,e,i,"weekdays")},r.parseZone=function(){return Ae.apply(null,arguments).parseZone()},r.localeData=ge,r.isDuration=He,r.monthsShort=function(t,e){return Ti(t,e,"monthsShort")},r.weekdaysMin=function(t,e,i){return Oi(t,e,i,"weekdaysMin")},r.defineLocale=me,r.updateLocale=function(t,e){if(null!=e){var i,n,r=le;null!=(n=fe(t))&&(r=n._config),e=Y(r,e),(i=new P(e)).parentLocale=ue[t],ue[t]=i,pe(t)}else null!=ue[t]&&(null!=ue[t].parentLocale?ue[t]=ue[t].parentLocale:null!=ue[t]&&delete ue[t]);return ue[t]},r.locales=function(){return T(ue)},r.weekdaysShort=function(t,e,i){return Oi(t,e,i,"weekdaysShort")},r.normalizeUnits=L,r.relativeTimeRounding=function(t){return void 0===t?Ki:"function"==typeof t&&(Ki=t,!0)},r.relativeTimeThreshold=function(t,e){return void 0!==Qi[t]&&(void 0===e?Qi[t]:(Qi[t]=e,"s"===t&&(Qi.ss=e-1),!0))},r.calendarFormat=function(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},r.prototype=Di,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()})),Dl="undefined"!=typeof window&&window.moment||kl,Sl=function(){function t(e,i){Ma(this,t),this.options=null,this.props=null}return Oa(t,[{key:"setOptions",value:function(t){t&&bh.extend(this.options,t)}},{key:"redraw",value:function(){return!1}},{key:"destroy",value:function(){}},{key:"_isResized",value:function(){var t=this.props._previousWidth!==this.props.width||this.props._previousHeight!==this.props.height;return this.props._previousWidth=this.props.width,this.props._previousHeight=this.props.height,t}}]),t}();function xl(t,e,i){if(i&&!Array.isArray(i))return xl(t,e,[i]);if(e.hiddenDates=[],i&&1==Array.isArray(i)){for(var n=0;n<i.length;n++)if(void 0===i[n].repeat){var r={};r.start=t(i[n].start).toDate().valueOf(),r.end=t(i[n].end).toDate().valueOf(),e.hiddenDates.push(r)}e.hiddenDates.sort((function(t,e){return t.start-e.start}))}}function Ml(t,e,i){if(i&&!Array.isArray(i))return Ml(t,e,[i]);if(i&&void 0!==e.domProps.centerContainer.width){xl(t,e,i);for(var n=t(e.range.start),r=t(e.range.end),o=(e.range.end-e.range.start)/e.domProps.centerContainer.width,s=0;s<i.length;s++)if(void 0!==i[s].repeat){var a=t(i[s].start),h=t(i[s].end);if("Invalid Date"==a._d)throw new Error("Supplied start date is not valid: ".concat(i[s].start));if("Invalid Date"==h._d)throw new Error("Supplied end date is not valid: ".concat(i[s].end));if(h-a>=4*o){var l=0,u=r.clone();switch(i[s].repeat){case"daily":a.day()!=h.day()&&(l=1),a.dayOfYear(n.dayOfYear()),a.year(n.year()),a.subtract(7,"days"),h.dayOfYear(n.dayOfYear()),h.year(n.year()),h.subtract(7-l,"days"),u.add(1,"weeks");break;case"weekly":var d=h.diff(a,"days"),c=a.day();a.date(n.date()),a.month(n.month()),a.year(n.year()),h=a.clone(),a.day(c),h.day(c),h.add(d,"days"),a.subtract(1,"weeks"),h.subtract(1,"weeks"),u.add(1,"weeks");break;case"monthly":a.month()!=h.month()&&(l=1),a.month(n.month()),a.year(n.year()),a.subtract(1,"months"),h.month(n.month()),h.year(n.year()),h.subtract(1,"months"),h.add(l,"months"),u.add(1,"months");break;case"yearly":a.year()!=h.year()&&(l=1),a.year(n.year()),a.subtract(1,"years"),h.year(n.year()),h.subtract(1,"years"),h.add(l,"years"),u.add(1,"years");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",i[s].repeat)}for(;a<u;)switch(e.hiddenDates.push({start:a.valueOf(),end:h.valueOf()}),i[s].repeat){case"daily":a.add(1,"days"),h.add(1,"days");break;case"weekly":a.add(1,"weeks"),h.add(1,"weeks");break;case"monthly":a.add(1,"months"),h.add(1,"months");break;case"yearly":a.add(1,"y"),h.add(1,"y");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",i[s].repeat)}e.hiddenDates.push({start:a.valueOf(),end:h.valueOf()})}}Tl(e);var f=Rl(e.range.start,e.hiddenDates),p=Rl(e.range.end,e.hiddenDates),m=e.range.start,g=e.range.end;1==f.hidden&&(m=1==e.range.startToFront?f.startDate-1:f.endDate+1),1==p.hidden&&(g=1==e.range.endToFront?p.startDate-1:p.endDate+1),1!=f.hidden&&1!=p.hidden||e.range._applyRange(m,g)}}function Tl(t){for(var e=t.hiddenDates,i=[],n=0;n<e.length;n++)for(var r=0;r<e.length;r++)n!=r&&1!=e[r].remove&&1!=e[n].remove&&(e[r].start>=e[n].start&&e[r].end<=e[n].end?e[r].remove=!0:e[r].start>=e[n].start&&e[r].start<=e[n].end?(e[n].end=e[r].end,e[r].remove=!0):e[r].end>=e[n].start&&e[r].end<=e[n].end&&(e[n].start=e[r].start,e[r].remove=!0));for(n=0;n<e.length;n++)!0!==e[n].remove&&i.push(e[n]);t.hiddenDates=i,t.hiddenDates.sort((function(t,e){return t.start-e.start}))}function Ol(t,e,i){for(var n=!1,r=e.current.valueOf(),o=0;o<e.hiddenDates.length;o++){var s=e.hiddenDates[o].start,a=e.hiddenDates[o].end;if(r>=s&&r<a){n=!0;break}}if(1==n&&r<e._end.valueOf()&&r!=i){var h=t(i),l=t(a);h.year()!=l.year()?e.switchedYear=!0:h.month()!=l.month()?e.switchedMonth=!0:h.dayOfYear()!=l.dayOfYear()&&(e.switchedDay=!0),e.current=l}}function Cl(t,e,i){var n;if(0==t.body.hiddenDates.length)return n=t.range.conversion(i),(e.valueOf()-n.offset)*n.scale;var r=Rl(e,t.body.hiddenDates);1==r.hidden&&(e=r.startDate);var o=Yl(t.body.hiddenDates,t.range.start,t.range.end);if(e<t.range.start){n=t.range.conversion(i,o);var s=Pl(t.body.hiddenDates,e,n.offset);return e=t.options.moment(e).toDate().valueOf(),e+=s,-(n.offset-e.valueOf())*n.scale}if(e>t.range.end){var a={start:t.range.start,end:e};return e=Il(t.options.moment,t.body.hiddenDates,a,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}return e=Il(t.options.moment,t.body.hiddenDates,t.range,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}function El(t,e,i){if(0==t.body.hiddenDates.length){var n=t.range.conversion(i);return new Date(e/n.scale+n.offset)}var r=Yl(t.body.hiddenDates,t.range.start,t.range.end),o=(t.range.end-t.range.start-r)*e/i,s=Ll(t.body.hiddenDates,t.range,o);return new Date(s+o+t.range.start)}function Yl(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<i&&(n+=s-o)}return n}function Pl(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<=i&&(n+=s-o)}return n}function Il(t,e,i,n){return n=t(n).toDate().valueOf(),n-=Al(t,e,i,n)}function Al(t,e,i,n){var r=0;n=t(n).toDate().valueOf();for(var o=0;o<e.length;o++){var s=e[o].start,a=e[o].end;s>=i.start&&a<i.end&&n>=a&&(r+=a-s)}return r}function Ll(t,e,i){for(var n=0,r=0,o=e.start,s=0;s<t.length;s++){var a=t[s].start,h=t[s].end;if(a>=e.start&&h<e.end){if(r+=a-o,o=h,r>=i)break;n+=h-a}}return n}function Nl(t,e,i,n){var r=Rl(e,t);return 1==r.hidden?i<0?1==n?r.startDate-(r.endDate-e)-1:r.startDate-1:1==n?r.endDate+(e-r.startDate)+1:r.endDate+1:e}function Rl(t,e){for(var i=0;i<e.length;i++){var n=e[i].start,r=e[i].end;if(t>=n&&t<r)return{hidden:!0,startDate:n,endDate:r}}return{hidden:!1,startDate:n,endDate:r}}Et({target:"String",proto:!0},{repeat:Nn});var jl=Object.freeze({convertHiddenOptions:xl,updateHiddenDates:Ml,removeDuplicates:Tl,printDates:function(t){for(var e=0;e<t.length;e++)console.log(e,new Date(t[e].start),new Date(t[e].end),t[e].start,t[e].end,t[e].remove)},stepOverHiddenDates:Ol,toScreen:Cl,toTime:El,getHiddenDurationBetween:Yl,getHiddenDurationBeforeStart:Pl,correctTimeForHidden:Il,getHiddenDurationBefore:Al,getAccumulatedHiddenDuration:Ll,snapAwayFromHidden:Nl,getIsHidden:Rl}),Fl=function(t){function e(t,i){var n;Ma(this,e),n=Ia(this,Ea(e).call(this));var r=Dl().hours(0).minutes(0).seconds(0).milliseconds(0),o=r.clone().add(-3,"days").valueOf(),s=r.clone().add(3,"days").valueOf();return n.millisecondsPerPixelCache=void 0,void 0===i?(n.start=o,n.end=s):(n.start=i.start||o,n.end=i.end||s),n.rolling=!1,n.body=t,n.deltaDifference=0,n.scaleOffset=0,n.startToFront=!1,n.endToFront=!0,n.defaultOptions={rtl:!1,start:null,end:null,moment:Dl,direction:"horizontal",moveable:!0,zoomable:!0,min:null,max:null,zoomMin:10,zoomMax:31536e10,rollingMode:{follow:!1,offset:.5}},n.options=bh.extend({},n.defaultOptions),n.props={touch:{}},n.animationTimer=null,n.body.emitter.on("panstart",n._onDragStart.bind(Pa(n))),n.body.emitter.on("panmove",n._onDrag.bind(Pa(n))),n.body.emitter.on("panend",n._onDragEnd.bind(Pa(n))),n.body.emitter.on("mousewheel",n._onMouseWheel.bind(Pa(n))),n.body.emitter.on("touch",n._onTouch.bind(Pa(n))),n.body.emitter.on("pinch",n._onPinch.bind(Pa(n))),n.body.dom.rollingModeBtn.addEventListener("click",n.startRolling.bind(Pa(n))),n.setOptions(i),n}return Ca(e,t),Oa(e,[{key:"setOptions",value:function(t){if(t){bh.selectiveExtend(["animation","direction","min","max","zoomMin","zoomMax","moveable","zoomable","moment","activate","hiddenDates","zoomKey","zoomFriction","rtl","showCurrentTime","rollingMode","horizontalScroll"],this.options,t),t.rollingMode&&t.rollingMode.follow&&this.startRolling(),("start"in t||"end"in t)&&this.setRange(t.start,t.end)}}},{key:"startRolling",value:function(){var t=this;!function e(){t.stopRolling(),t.rolling=!0;var i=t.end-t.start,n=bh.convert(new Date,"Date").valueOf(),r=t.options.rollingMode&&t.options.rollingMode.offset||.5,o=n-i*r,s=n+i*(1-r);t.setRange(o,s,{animation:!1}),(i=1/t.conversion(t.body.domProps.center.width).scale/10)<30&&(i=30),i>1e3&&(i=1e3),t.body.dom.rollingModeBtn.style.visibility="hidden",t.currentTimeTimer=setTimeout(e,i)}()}},{key:"stopRolling",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),this.rolling=!1,this.body.dom.rollingModeBtn.style.visibility="visible")}},{key:"setRange",value:function(t,e,i,n,r){i||(i={}),!0!==i.byUser&&(i.byUser=!1);var o=this,s=null!=t?bh.convert(t,"Date").valueOf():null,a=null!=e?bh.convert(e,"Date").valueOf():null;if(this._cancelAnimation(),this.millisecondsPerPixelCache=void 0,i.animation){var h=this.start,l=this.end,u="object"===xa(i.animation)&&"duration"in i.animation?i.animation.duration:500,d="object"===xa(i.animation)&&"easingFunction"in i.animation?i.animation.easingFunction:"easeInOutQuad",c=bh.easingFunctions[d];if(!c)throw new Error("Unknown easing function ".concat(JSON.stringify(d),". Choose from: ").concat(Object.keys(bh.easingFunctions).join(", ")));var f=Date.now(),p=!1;return function t(){if(!o.props.touch.dragging){var e=Date.now()-f,d=c(e/u),g=e>u,v=g||null===s?s:h+(s-h)*d,y=g||null===a?a:l+(a-l)*d;m=o._applyRange(v,y),Ml(o.options.moment,o.body,o.options.hiddenDates),p=p||m;var _={start:new Date(o.start),end:new Date(o.end),byUser:i.byUser,event:i.event};if(r&&r(d,m,g),m&&o.body.emitter.emit("rangechange",_),g){if(p&&(o.body.emitter.emit("rangechanged",_),n))return n()}else o.animationTimer=setTimeout(t,20)}}()}var m=this._applyRange(s,a);if(Ml(this.options.moment,this.body,this.options.hiddenDates),m){var g={start:new Date(this.start),end:new Date(this.end),byUser:i.byUser,event:i.event};if(this.body.emitter.emit("rangechange",g),clearTimeout(o.timeoutID),o.timeoutID=setTimeout((function(){o.body.emitter.emit("rangechanged",g)}),200),n)return n()}}},{key:"getMillisecondsPerPixel",value:function(){return void 0===this.millisecondsPerPixelCache&&(this.millisecondsPerPixelCache=(this.end-this.start)/this.body.dom.center.clientWidth),this.millisecondsPerPixelCache}},{key:"_cancelAnimation",value:function(){this.animationTimer&&(clearTimeout(this.animationTimer),this.animationTimer=null)}},{key:"_applyRange",value:function(t,e){var i,n=null!=t?bh.convert(t,"Date").valueOf():this.start,r=null!=e?bh.convert(e,"Date").valueOf():this.end,o=null!=this.options.max?bh.convert(this.options.max,"Date").valueOf():null,s=null!=this.options.min?bh.convert(this.options.min,"Date").valueOf():null;if(isNaN(n)||null===n)throw new Error('Invalid start "'.concat(t,'"'));if(isNaN(r)||null===r)throw new Error('Invalid end "'.concat(e,'"'));if(r<n&&(r=n),null!==s&&n<s&&(n+=i=s-n,r+=i,null!=o&&r>o&&(r=o)),null!==o&&r>o&&(n-=i=r-o,r-=i,null!=s&&n<s&&(n=s)),null!==this.options.zoomMin){var a=parseFloat(this.options.zoomMin);if(a<0&&(a=0),r-n<a){this.end-this.start===a&&n>=this.start-.5&&r<=this.end?(n=this.start,r=this.end):(n-=(i=a-(r-n))/2,r+=i/2)}}if(null!==this.options.zoomMax){var h=parseFloat(this.options.zoomMax);h<0&&(h=0),r-n>h&&(this.end-this.start===h&&n<this.start&&r>this.end?(n=this.start,r=this.end):(n+=(i=r-n-h)/2,r-=i/2))}var l=this.start!=n||this.end!=r;return n>=this.start&&n<=this.end||r>=this.start&&r<=this.end||this.start>=n&&this.start<=r||this.end>=n&&this.end<=r||this.body.emitter.emit("checkRangedItems"),this.start=n,this.end=r,l}},{key:"getRange",value:function(){return{start:this.start,end:this.end}}},{key:"conversion",value:function(t,i){return e.conversion(this.start,this.end,t,i)}},{key:"_onDragStart",value:function(t){this.deltaDifference=0,this.previousDelta=0,this.options.moveable&&this._isInsideRange(t)&&this.props.touch.allowDragging&&(this.stopRolling(),this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.dragging=!0,this.body.dom.root&&(this.body.dom.root.style.cursor="move"))}},{key:"_onDrag",value:function(t){if(t&&this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging){var e=this.options.direction;Hl(e);var i="horizontal"==e?t.deltaX:t.deltaY;i-=this.deltaDifference;var n=this.props.touch.end-this.props.touch.start;n-=Yl(this.body.hiddenDates,this.start,this.end);var r,o="horizontal"==e?this.body.domProps.center.width:this.body.domProps.center.height;r=this.options.rtl?i/o*n:-i/o*n;var s=this.props.touch.start+r,a=this.props.touch.end+r,h=Nl(this.body.hiddenDates,s,this.previousDelta-i,!0),l=Nl(this.body.hiddenDates,a,this.previousDelta-i,!0);if(h!=s||l!=a)return this.deltaDifference+=i,this.props.touch.start=h,this.props.touch.end=l,void this._onDrag(t);this.previousDelta=i,this._applyRange(s,a);var u=new Date(this.start),d=new Date(this.end);this.body.emitter.emit("rangechange",{start:u,end:d,byUser:!0,event:t}),this.body.emitter.emit("panmove")}}},{key:"_onDragEnd",value:function(t){this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging&&(this.props.touch.dragging=!1,this.body.dom.root&&(this.body.dom.root.style.cursor="auto"),this.body.emitter.emit("rangechanged",{start:new Date(this.start),end:new Date(this.end),byUser:!0,event:t}))}},{key:"_onMouseWheel",value:function(t){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail?e=-t.detail/3:t.deltaY&&(e=-t.deltaY/3),!(this.options.zoomKey&&!t[this.options.zoomKey]&&this.options.zoomable||!this.options.zoomable&&this.options.moveable)&&this.options.zoomable&&this.options.moveable&&this._isInsideRange(t)&&e){var i,n,r=this.options.zoomFriction||5;if(i=e<0?1-e/r:1/(1+e/r),this.rolling){var o=this.options.rollingMode&&this.options.rollingMode.offset||.5;n=this.start+(this.end-this.start)*o}else{var s=this.getPointer({x:t.clientX,y:t.clientY},this.body.dom.center);n=this._pointerToDate(s)}this.zoom(i,n,e,t),t.preventDefault()}}},{key:"_onTouch",value:function(t){this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.allowDragging=!0,this.props.touch.center=null,this.scaleOffset=0,this.deltaDifference=0,bh.preventDefault(t)}},{key:"_onPinch",value:function(t){if(this.options.zoomable&&this.options.moveable){bh.preventDefault(t),this.props.touch.allowDragging=!1,this.props.touch.center||(this.props.touch.center=this.getPointer(t.center,this.body.dom.center)),this.stopRolling();var e=1/(t.scale+this.scaleOffset),i=this._pointerToDate(this.props.touch.center),n=Yl(this.body.hiddenDates,this.start,this.end),r=Al(this.options.moment,this.body.hiddenDates,this,i),o=n-r,s=i-r+(this.props.touch.start-(i-r))*e,a=i+o+(this.props.touch.end-(i+o))*e;this.startToFront=1-e<=0,this.endToFront=e-1<=0;var h=Nl(this.body.hiddenDates,s,1-e,!0),l=Nl(this.body.hiddenDates,a,e-1,!0);h==s&&l==a||(this.props.touch.start=h,this.props.touch.end=l,this.scaleOffset=1-t.scale,s=h,a=l);var u={animation:!1,byUser:!0,event:t};this.setRange(s,a,u),this.startToFront=!1,this.endToFront=!0}}},{key:"_isInsideRange",value:function(t){var e;e=t.touches&&t.touches[0]?t.touches[0].clientX:t.center?t.center.x:t.clientX;var i=this.body.dom.centerContainer.getBoundingClientRect(),n=this.options.rtl?e-i.left:i.right-e,r=this.body.util.toTime(n);return r>=this.start&&r<=this.end}},{key:"_pointerToDate",value:function(t){var e,i=this.options.direction;if(Hl(i),"horizontal"==i)return this.body.util.toTime(t.x).valueOf();var n=this.body.domProps.center.height;return e=this.conversion(n),t.y/e.scale+e.offset}},{key:"getPointer",value:function(t,e){var i=e.getBoundingClientRect();return this.options.rtl?{x:i.right-t.x,y:t.y-i.top}:{x:t.x-i.left,y:t.y-i.top}}},{key:"zoom",value:function(t,e,i,n){null==e&&(e=(this.start+this.end)/2);var r=Yl(this.body.hiddenDates,this.start,this.end),o=Al(this.options.moment,this.body.hiddenDates,this,e),s=r-o,a=e-o+(this.start-(e-o))*t,h=e+s+(this.end-(e+s))*t;this.startToFront=!(i>0),this.endToFront=!(-i>0);var l=Nl(this.body.hiddenDates,a,i,!0),u=Nl(this.body.hiddenDates,h,-i,!0);l==a&&u==h||(a=l,h=u);var d={animation:!1,byUser:!0,event:n};this.setRange(a,h,d),this.startToFront=!1,this.endToFront=!0}},{key:"move",value:function(t){var e=this.end-this.start,i=this.start+e*t,n=this.end+e*t;this.start=i,this.end=n}},{key:"moveTo",value:function(t){var e=(this.start+this.end)/2-t,i=this.start-e,n=this.end-e;this.setRange(i,n,{animation:!1,byUser:!0,event:null})}}],[{key:"conversion",value:function(t,e,i,n){return void 0===n&&(n=0),0!=i&&e-t!=0?{offset:t,scale:i/(e-t-n)}:{offset:0,scale:1}}}]),e}(Sl);function Hl(t){if("horizontal"!=t&&"vertical"!=t)throw new TypeError('Unknown direction "'.concat(t,'". Choose "horizontal" or "vertical".'))}var Wl=Gl;function Gl(t){if(t)return function(t){for(var e in Gl.prototype)t[e]=Gl.prototype[e];return t}(t)}Gl.prototype.on=Gl.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks[t]=this._callbacks[t]||[]).push(e),this},Gl.prototype.once=function(t,e){var i=this;function n(){i.off(t,n),e.apply(this,arguments)}return this._callbacks=this._callbacks||{},n.fn=e,this.on(t,n),this},Gl.prototype.off=Gl.prototype.removeListener=Gl.prototype.removeAllListeners=Gl.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks[t];if(!n)return this;if(1==arguments.length)return delete this._callbacks[t],this;for(var r=0;r<n.length;r++)if((i=n[r])===e||i.fn===e){n.splice(r,1);break}return this},Gl.prototype.emit=function(t){this._callbacks=this._callbacks||{};var e=[].slice.call(arguments,1),i=this._callbacks[t];if(i)for(var n=0,r=(i=i.slice(0)).length;n<r;++n)i[n].apply(this,e);return this},Gl.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks[t]||[]},Gl.prototype.hasListeners=function(t){return!!this.listeners(t).length};var Ul=n((function(t,e){var i;t.exports=(i=null,function t(e,n){var r=n||{preventDefault:!1};if(e.Manager){var o=e,s=function(e,i){var n=Object.create(r);return i&&o.assign(n,i),t(new o(e,n),n)};return o.assign(s,o),s.Manager=function(e,i){var n=Object.create(r);return i&&o.assign(n,i),t(new o.Manager(e,n),n)},s}var a=Object.create(e),h=e.element;function l(t){return t.match(/[^ ]+/g)}function u(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var n=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof n&&(t.srcEvent.stopPropagation=function(){n(),t.stopPropagation()}),t.firstTarget=i;for(var r=i;r&&!e;){var o=r.hammer;if(o)for(var s,a=0;a<o.length;a++)if(s=o[a]._handlers[t.type])for(var h=0;h<s.length&&!e;h++)s[h](t);r=r.parentNode}}return h.hammer||(h.hammer=[]),h.hammer.push(a),e.on("hammer.input",(function(t){!0!==r.preventDefault&&r.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(i=t.target)})),a._handlers={},a.on=function(t,i){return l(t).forEach((function(t){var n=a._handlers[t];n||(a._handlers[t]=n=[],e.on(t,u)),n.push(i)})),a},a.off=function(t,i){return l(t).forEach((function(t){var n=a._handlers[t];n&&((n=i?n.filter((function(t){return t!==i})):[]).length>0?a._handlers[t]=n:(e.off(t,u),delete a._handlers[t]))})),a},a.emit=function(t,n){i=n.target,e.emit(t,n)},a.destroy=function(){var t=e.element.hammer,i=t.indexOf(a);-1!==i&&t.splice(i,1),t.length||delete e.element.hammer,a._handlers={},e.destroy()},a})}));function zl(){return(zl=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t}).apply(this,arguments)}function Vl(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Bl(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Xl,ql="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var r in n)n.hasOwnProperty(r)&&(e[r]=n[r])}return e}:Object.assign,Zl=["","webkit","Moz","MS","ms","o"],$l="undefined"==typeof document?{style:{}}:document.createElement("div"),Jl="function",Kl=Math.round,Ql=Math.abs,tu=Date.now;function eu(t,e){for(var i,n,r=e[0].toUpperCase()+e.slice(1),o=0;o<Zl.length;){if((n=(i=Zl[o])?i+r:e)in t)return n;o++}}Xl="undefined"==typeof window?{}:window;var iu=eu($l.style,"touchAction"),nu=void 0!==iu;var ru="auto",ou="manipulation",su="none",au="pan-x",hu="pan-y",lu=function(){if(!nu)return!1;var t={},e=Xl.CSS&&Xl.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||Xl.CSS.supports("touch-action",i)})),t}(),uu="ontouchstart"in Xl,du=void 0!==eu(Xl,"PointerEvent"),cu=uu&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),fu="touch",pu="mouse",mu=25,gu=1,vu=2,yu=4,_u=8,bu=1,wu=2,ku=4,Du=8,Su=16,xu=wu|ku,Mu=Du|Su,Tu=xu|Mu,Ou=["x","y"],Cu=["clientX","clientY"];function Eu(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function Yu(t,e){return xa(t)===Jl?t.apply(e&&e[0]||void 0,e):t}function Pu(t,e){return t.indexOf(e)>-1}var Iu=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){"compute"===t&&(t=this.compute()),nu&&this.manager.element.style&&lu[t]&&(this.manager.element.style[iu]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Eu(this.manager.recognizers,(function(e){Yu(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Pu(t,su))return su;var e=Pu(t,au),i=Pu(t,hu);return e&&i?su:e||i?e?au:hu:Pu(t,ou)?ou:ru}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,r=Pu(n,su)&&!lu[su],o=Pu(n,hu)&&!lu[hu],s=Pu(n,au)&&!lu[au];if(r){var a=1===t.pointers.length,h=t.distance<2,l=t.deltaTime<250;if(a&&h&&l)return}if(!s||!o)return r||o&&i&xu||s&&i&Mu?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Au(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Lu(t){var e=t.length;if(1===e)return{x:Kl(t[0].clientX),y:Kl(t[0].clientY)};for(var i=0,n=0,r=0;r<e;)i+=t[r].clientX,n+=t[r].clientY,r++;return{x:Kl(i/e),y:Kl(n/e)}}function Nu(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:Kl(t.pointers[i].clientX),clientY:Kl(t.pointers[i].clientY)},i++;return{timeStamp:tu(),pointers:e,center:Lu(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Ru(t,e,i){i||(i=Ou);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return Math.sqrt(n*n+r*r)}function ju(t,e,i){i||(i=Ou);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return 180*Math.atan2(r,n)/Math.PI}function Fu(t,e){return t===e?bu:Ql(t)>=Ql(e)?t<0?wu:ku:e<0?Du:Su}function Hu(t,e,i){return{x:e/t||0,y:i/t||0}}function Wu(t,e){var i=t.session,n=e.pointers,r=n.length;i.firstInput||(i.firstInput=Nu(e)),r>1&&!i.firstMultiple?i.firstMultiple=Nu(e):1===r&&(i.firstMultiple=!1);var o=i.firstInput,s=i.firstMultiple,a=s?s.center:o.center,h=e.center=Lu(n);e.timeStamp=tu(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=ju(a,h),e.distance=Ru(a,h),function(t,e){var i=e.center,n=t.offsetDelta||{},r=t.prevDelta||{},o=t.prevInput||{};e.eventType!==gu&&o.eventType!==yu||(r=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=r.x+(i.x-n.x),e.deltaY=r.y+(i.y-n.y)}(i,e),e.offsetDirection=Fu(e.deltaX,e.deltaY);var l,u,d=Hu(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=d.x,e.overallVelocityY=d.y,e.overallVelocity=Ql(d.x)>Ql(d.y)?d.x:d.y,e.scale=s?(l=s.pointers,Ru((u=n)[0],u[1],Cu)/Ru(l[0],l[1],Cu)):1,e.rotation=s?function(t,e){return ju(e[1],e[0],Cu)+ju(t[1],t[0],Cu)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,r,o,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==_u&&(a>mu||void 0===s.velocity)){var h=e.deltaX-s.deltaX,l=e.deltaY-s.deltaY,u=Hu(a,h,l);n=u.x,r=u.y,i=Ql(u.x)>Ql(u.y)?u.x:u.y,o=Fu(h,l),t.lastInterval=e}else i=s.velocity,n=s.velocityX,r=s.velocityY,o=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=r,e.direction=o}(i,e);var c=t.element;Au(e.srcEvent.target,c)&&(c=e.srcEvent.target),e.target=c}function Gu(t,e,i){var n=i.pointers.length,r=i.changedPointers.length,o=e&gu&&n-r==0,s=e&(yu|_u)&&n-r==0;i.isFirst=!!o,i.isFinal=!!s,o&&(t.session={}),i.eventType=e,Wu(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function Uu(t){return t.trim().split(/\s+/g)}function zu(t,e,i){Eu(Uu(e),(function(e){t.addEventListener(e,i,!1)}))}function Vu(t,e,i){Eu(Uu(e),(function(e){t.removeEventListener(e,i,!1)}))}function Bu(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Xu=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Yu(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&zu(this.element,this.evEl,this.domHandler),this.evTarget&&zu(this.target,this.evTarget,this.domHandler),this.evWin&&zu(Bu(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Vu(this.element,this.evEl,this.domHandler),this.evTarget&&Vu(this.target,this.evTarget,this.domHandler),this.evWin&&Vu(Bu(this.element),this.evWin,this.domHandler)},t}();function qu(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var Zu={pointerdown:gu,pointermove:vu,pointerup:yu,pointercancel:_u,pointerout:_u},$u={2:fu,3:"pen",4:pu,5:"kinect"},Ju="pointerdown",Ku="pointermove pointerup pointercancel";Xl.MSPointerEvent&&!Xl.PointerEvent&&(Ju="MSPointerDown",Ku="MSPointerMove MSPointerUp MSPointerCancel");var Qu=function(t){function e(){var i,n=e.prototype;return n.evEl=Ju,n.evWin=Ku,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return Vl(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),r=Zu[n],o=$u[t.pointerType]||t.pointerType,s=o===fu,a=qu(e,t.pointerId,"pointerId");r&gu&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):r&(yu|_u)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,r,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),i&&e.splice(a,1))},e}(Xu);function td(t){return Array.prototype.slice.call(t,0)}function ed(t,e,i){for(var n=[],r=[],o=0;o<t.length;){var s=e?t[o][e]:t[o];qu(r,s)<0&&n.push(t[o]),r[o]=s,o++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var id={touchstart:gu,touchmove:vu,touchend:yu,touchcancel:_u},nd="touchstart touchmove touchend touchcancel",rd=function(t){function e(){var i;return e.prototype.evTarget=nd,(i=t.apply(this,arguments)||this).targetIds={},i}return Vl(e,t),e.prototype.handler=function(t){var e=id[t.type],i=od.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:fu,srcEvent:t})},e}(Xu);function od(t,e){var i,n,r=td(t.touches),o=this.targetIds;if(e&(gu|vu)&&1===r.length)return o[r[0].identifier]=!0,[r,r];var s=td(t.changedTouches),a=[],h=this.target;if(n=r.filter((function(t){return Au(t.target,h)})),e===gu)for(i=0;i<n.length;)o[n[i].identifier]=!0,i++;for(i=0;i<s.length;)o[s[i].identifier]&&a.push(s[i]),e&(yu|_u)&&delete o[s[i].identifier],i++;return a.length?[ed(n.concat(a),"identifier",!0),a]:void 0}var sd={mousedown:gu,mousemove:vu,mouseup:yu},ad="mousedown",hd="mousemove mouseup",ld=function(t){function e(){var i,n=e.prototype;return n.evEl=ad,n.evWin=hd,(i=t.apply(this,arguments)||this).pressed=!1,i}return Vl(e,t),e.prototype.handler=function(t){var e=sd[t.type];e&gu&&0===t.button&&(this.pressed=!0),e&vu&&1!==t.which&&(e=yu),this.pressed&&(e&yu&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:pu,srcEvent:t}))},e}(Xu),ud=2500,dd=25;function cd(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),ud)}}function fd(t,e){t&gu?(this.primaryTouch=e.changedPointers[0].identifier,cd.call(this,e)):t&(yu|_u)&&cd.call(this,e)}function pd(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var r=this.lastTouches[n],o=Math.abs(e-r.x),s=Math.abs(i-r.y);if(o<=dd&&s<=dd)return!0}return!1}var md=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var r=i.pointerType===fu,o=i.pointerType===pu;if(!(o&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(r)fd.call(Bl(Bl(n)),e,i);else if(o&&pd.call(Bl(Bl(n)),i))return;n.callback(t,e,i)}},n.touch=new rd(n.manager,n.handler),n.mouse=new ld(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Vl(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Xu)}();function gd(t,e,i){return!!Array.isArray(t)&&(Eu(t,i[e],i),!0)}var vd=1,yd=2,_d=4,bd=8,wd=bd,kd=16,Dd=1;function Sd(t,e){var i=e.manager;return i?i.get(t):t}function xd(t){return t&kd?"cancel":t&bd?"end":t&_d?"move":t&yd?"start":""}var Md=function(){function t(t){void 0===t&&(t={}),this.options=zl({enable:!0},t),this.id=Dd++,this.manager=null,this.state=vd,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return ql(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(gd(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Sd(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return gd(t,"dropRecognizeWith",this)?this:(t=Sd(t,this),delete this.simultaneous[t.id],this)},e.requireFailure=function(t){if(gd(t,"requireFailure",this))return this;var e=this.requireFail;return-1===qu(e,t=Sd(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(gd(t,"dropRequireFailure",this))return this;t=Sd(t,this);var e=qu(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<bd&&n(e.options.event+xd(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=bd&&n(e.options.event+xd(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=32},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(32|vd)))return!1;t++}return!0},e.recognize=function(t){var e=ql({},t);if(!Yu(this.options.enable,[this,e]))return this.reset(),void(this.state=32);this.state&(wd|kd|32)&&(this.state=vd),this.state=this.process(e),this.state&(yd|_d|bd|kd)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Td={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,preset:[],cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}};function Od(t,e){var i,n=t.element;n.style&&(Eu(t.options.cssProps,(function(r,o){i=eu(n.style,o),e?(t.oldCssProps[i]=n.style[i],n.style[i]=r):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var Cd=function(){function t(t,e){var i,n=this;this.options=ql({},Td,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(du?Qu:cu?rd:uu?md:ld))(i,Gu),this.touchAction=new Iu(this,this.options.touchAction),Od(this,!0),Eu(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return ql(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,r=e.curRecognizer;(!r||r&&r.state&wd)&&(e.curRecognizer=null,r=null);for(var o=0;o<n.length;)i=n[o],2===e.stopped||r&&i!==r&&!i.canRecognizeWith(r)?i.reset():i.recognize(t),!r&&i.state&(yd|_d|bd)&&(e.curRecognizer=i,r=i),o++}},e.get=function(t){if(t instanceof Md)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(gd(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(gd(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=qu(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return Eu(Uu(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return Eu(Uu(t),(function(t){e?i[t]&&i[t].splice(qu(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&Od(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Ed={touchstart:gu,touchmove:vu,touchend:yu,touchcancel:_u},Yd="touchstart",Pd="touchstart touchmove touchend touchcancel",Id=function(t){function e(){var i,n=e.prototype;return n.evTarget=Yd,n.evWin=Pd,(i=t.apply(this,arguments)||this).started=!1,i}return Vl(e,t),e.prototype.handler=function(t){var e=Ed[t.type];if(e===gu&&(this.started=!0),this.started){var i=Ad.call(this,t,e);e&(yu|_u)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:fu,srcEvent:t})}},e}(Xu);function Ad(t,e){var i=td(t.touches),n=td(t.changedTouches);return e&(yu|_u)&&(i=ed(i.concat(n),"identifier",!0)),[i,n]}var Ld=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zl({pointers:1},e))||this}Vl(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=e&(yd|_d),r=this.attrTest(t);return n&&(i&_u||!r)?e|kd:n||r?i&yu?e|bd:e&yd?e|_d:yd:32},e}(Md),Nd=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,zl({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}Vl(e,t);var i=e.prototype;return i.getTouchAction=function(){return[ou]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime<i.time;if(this.reset(),t.eventType&gu&&0===this.count)return this.failTimeout();if(r&&o&&n){if(t.eventType!==yu)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||Ru(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=wd,e.tryEmit()}),i.interval),yd):wd}return 32},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=32}),this.options.interval),32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===wd&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Md);function Rd(t){return t===Su?"down":t===Du?"up":t===wu?"left":t===ku?"right":""}var jd=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,zl({event:"pan",threshold:10,pointers:1,direction:Tu},e))||this).pX=null,i.pY=null,i}Vl(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&xu&&e.push(hu),t&Mu&&e.push(au),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,r=t.direction,o=t.deltaX,s=t.deltaY;return r&e.direction||(e.direction&xu?(r=0===o?bu:o<0?wu:ku,i=o!==this.pX,n=Math.abs(t.deltaX)):(r=0===s?bu:s<0?Du:Su,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=r,i&&n>e.threshold&&r&e.direction},i.attrTest=function(t){return Ld.prototype.attrTest.call(this,t)&&(this.state&yd||!(this.state&yd)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=Rd(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Ld),Fd=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zl({event:"swipe",threshold:10,velocity:.3,direction:xu|Mu,pointers:1},e))||this}Vl(e,t);var i=e.prototype;return i.getTouchAction=function(){return jd.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return n&(xu|Mu)?i=e.overallVelocity:n&xu?i=e.overallVelocityX:n&Mu&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Ql(i)>this.options.velocity&&e.eventType&yu},i.emit=function(t){var e=Rd(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Ld),Hd=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zl({event:"pinch",threshold:0,pointers:2},e))||this}Vl(e,t);var i=e.prototype;return i.getTouchAction=function(){return[su]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&yd)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Ld),Wd=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zl({event:"rotate",threshold:0,pointers:2},e))||this}Vl(e,t);var i=e.prototype;return i.getTouchAction=function(){return[su]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&yd)},e}(Ld),Gd=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,zl({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}Vl(e,t);var i=e.prototype;return i.getTouchAction=function(){return[ru]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime>i.time;if(this._input=t,!r||!n||t.eventType&(yu|_u)&&!o)this.reset();else if(t.eventType&gu)this.reset(),this._timer=setTimeout((function(){e.state=wd,e.tryEmit()}),i.time);else if(t.eventType&yu)return wd;return 32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===wd&&(t&&t.eventType&yu?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=tu(),this.manager.emit(this.options.event,this._input)))},e}(Md);function Ud(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",r=window.console&&(window.console.warn||window.console.log);return r&&r.call(window.console,n,i),t.apply(this,arguments)}}var zd=Ud((function(t,e,i){for(var n=Object.keys(e),r=0;r<n.length;)(!i||i&&void 0===t[n[r]])&&(t[n[r]]=e[n[r]]),r++;return t}),"extend","Use `assign`."),Vd=Ud((function(t,e){return zd(t,e,!0)}),"merge","Use `assign`.");function Bd(t,e,i){var n,r=e.prototype;(n=t.prototype=Object.create(r)).constructor=t,n._super=r,i&&ql(n,i)}function Xd(t,e){return function(){return t.apply(e,arguments)}}var qd,Zd=function(){var t=function(t,e){return void 0===e&&(e={}),new Cd(t,zl({recognizers:[[Wd,{enable:!1}],[Hd,{enable:!1},["rotate"]],[Fd,{direction:xu}],[jd,{direction:xu},["swipe"]],[Nd],[Nd,{event:"doubletap",taps:2},["tap"]],[Gd]]},e))};return t.VERSION="2.0.15",t.DIRECTION_ALL=Tu,t.DIRECTION_DOWN=Su,t.DIRECTION_LEFT=wu,t.DIRECTION_RIGHT=ku,t.DIRECTION_UP=Du,t.DIRECTION_HORIZONTAL=xu,t.DIRECTION_VERTICAL=Mu,t.DIRECTION_NONE=bu,t.DIRECTION_DOWN=Su,t.INPUT_START=gu,t.INPUT_MOVE=vu,t.INPUT_END=yu,t.INPUT_CANCEL=_u,t.STATE_POSSIBLE=vd,t.STATE_BEGAN=yd,t.STATE_CHANGED=_d,t.STATE_ENDED=bd,t.STATE_RECOGNIZED=wd,t.STATE_CANCELLED=kd,t.STATE_FAILED=32,t.Manager=Cd,t.Input=Xu,t.TouchAction=Iu,t.TouchInput=rd,t.MouseInput=ld,t.PointerEventInput=Qu,t.TouchMouseInput=md,t.SingleTouchInput=Id,t.Recognizer=Md,t.AttrRecognizer=Ld,t.Tap=Nd,t.Pan=jd,t.Swipe=Fd,t.Pinch=Hd,t.Rotate=Wd,t.Press=Gd,t.on=zu,t.off=Vu,t.each=Eu,t.merge=Vd,t.extend=zd,t.bindFn=Xd,t.assign=ql,t.inherit=Bd,t.bindFn=Xd,t.prefixed=eu,t.toArray=td,t.inArray=qu,t.uniqueArray=ed,t.splitStr=Uu,t.boolOrFn=Yu,t.hasParent=Au,t.addEventListeners=zu,t.removeEventListeners=Vu,t.defaults=Td,t}();"undefined"!=typeof window?qd=Ul(window.Hammer||Zd,{preventDefault:"mouse"}):qd=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t};var $d=qd;function Jd(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}var Kd=function(){function t(e,i,n,r,o){Ma(this,t),this.moment=Dl,this.current=this.moment(),this._start=this.moment(),this._end=this.moment(),this.autoScale=!0,this.scale="day",this.step=1,this.setRange(e,i,n),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,Array.isArray(r)?this.hiddenDates=r:this.hiddenDates=null!=r?[r]:[],this.format=t.FORMAT,this.options=o||{}}return Oa(t,[{key:"setMoment",value:function(t){this.moment=t,this.current=this.moment(this.current.valueOf()),this._start=this.moment(this._start.valueOf()),this._end=this.moment(this._end.valueOf())}},{key:"setFormat",value:function(e){var i=bh.deepExtend({},t.FORMAT);this.format=bh.deepExtend(i,e)}},{key:"setRange",value:function(t,e,i){if(!(t instanceof Date&&e instanceof Date))throw"No legal start or end date in method setRange";this._start=null!=t?this.moment(t.valueOf()):Date.now(),this._end=null!=e?this.moment(e.valueOf()):Date.now(),this.autoScale&&this.setMinimumStep(i)}},{key:"start",value:function(){this.current=this._start.clone(),this.roundToMinor()}},{key:"roundToMinor",value:function(){switch("week"==this.scale&&this.current.weekday(0),this.scale){case"year":this.current.year(this.step*Math.floor(this.current.year()/this.step)),this.current.month(0);case"month":this.current.date(1);case"week":case"day":case"weekday":this.current.hours(0);case"hour":this.current.minutes(0);case"minute":this.current.seconds(0);case"second":this.current.milliseconds(0)}if(1!=this.step){var t=this.current.clone();switch(this.scale){case"millisecond":this.current.subtract(this.current.milliseconds()%this.step,"milliseconds");break;case"second":this.current.subtract(this.current.seconds()%this.step,"seconds");break;case"minute":this.current.subtract(this.current.minutes()%this.step,"minutes");break;case"hour":this.current.subtract(this.current.hours()%this.step,"hours");break;case"weekday":case"day":this.current.subtract((this.current.date()-1)%this.step,"day");break;case"week":this.current.subtract(this.current.week()%this.step,"week");break;case"month":this.current.subtract(this.current.month()%this.step,"month");break;case"year":this.current.subtract(this.current.year()%this.step,"year")}t.isSame(this.current)||(this.current=Dl(Nl(this.hiddenDates,this.current.valueOf(),-1,!0)))}}},{key:"hasNext",value:function(){return this.current.valueOf()<=this._end.valueOf()}},{key:"next",value:function(){var t=this.current.valueOf();switch(this.scale){case"millisecond":this.current.add(this.step,"millisecond");break;case"second":this.current.add(this.step,"second");break;case"minute":this.current.add(this.step,"minute");break;case"hour":this.current.add(this.step,"hour"),this.current.month()<6?this.current.subtract(this.current.hours()%this.step,"hour"):this.current.hours()%this.step!=0&&this.current.add(this.step-this.current.hours()%this.step,"hour");break;case"weekday":case"day":this.current.add(this.step,"day");break;case"week":if(0!==this.current.weekday())this.current.weekday(0),this.current.add(this.step,"week");else if(!1===this.options.showMajorLabels)this.current.add(this.step,"week");else{var e=this.current.clone();e.add(1,"week"),e.isSame(this.current,"month")?this.current.add(this.step,"week"):(this.current.add(this.step,"week"),this.current.date(1))}break;case"month":this.current.add(this.step,"month");break;case"year":this.current.add(this.step,"year")}if(1!=this.step)switch(this.scale){case"millisecond":this.current.milliseconds()>0&&this.current.milliseconds()<this.step&&this.current.milliseconds(0);break;case"second":this.current.seconds()>0&&this.current.seconds()<this.step&&this.current.seconds(0);break;case"minute":this.current.minutes()>0&&this.current.minutes()<this.step&&this.current.minutes(0);break;case"hour":this.current.hours()>0&&this.current.hours()<this.step&&this.current.hours(0);break;case"weekday":case"day":this.current.date()<this.step+1&&this.current.date(1);break;case"week":this.current.week()<this.step&&this.current.week(1);break;case"month":this.current.month()<this.step&&this.current.month(0)}this.current.valueOf()==t&&(this.current=this._end.clone()),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,Ol(this.moment,this,t)}},{key:"getCurrent",value:function(){return this.current.clone()}},{key:"setScale",value:function(t){t&&"string"==typeof t.scale&&(this.scale=t.scale,this.step=t.step>0?t.step:1,this.autoScale=!1)}},{key:"setAutoScale",value:function(t){this.autoScale=t}},{key:"setMinimumStep",value:function(t){if(null!=t){31104e9>t&&(this.scale="year",this.step=1e3),15552e9>t&&(this.scale="year",this.step=500),31104e8>t&&(this.scale="year",this.step=100),15552e8>t&&(this.scale="year",this.step=50),31104e7>t&&(this.scale="year",this.step=10),15552e7>t&&(this.scale="year",this.step=5),31104e6>t&&(this.scale="year",this.step=1),7776e6>t&&(this.scale="month",this.step=3),2592e6>t&&(this.scale="month",this.step=1),6048e5>t&&(this.scale="week",this.step=1),1728e5>t&&(this.scale="day",this.step=2),864e5>t&&(this.scale="day",this.step=1),432e5>t&&(this.scale="weekday",this.step=1),144e5>t&&(this.scale="hour",this.step=4),36e5>t&&(this.scale="hour",this.step=1),9e5>t&&(this.scale="minute",this.step=15),6e5>t&&(this.scale="minute",this.step=10),3e5>t&&(this.scale="minute",this.step=5),6e4>t&&(this.scale="minute",this.step=1),15e3>t&&(this.scale="second",this.step=15),1e4>t&&(this.scale="second",this.step=10),5e3>t&&(this.scale="second",this.step=5),1e3>t&&(this.scale="second",this.step=1),200>t&&(this.scale="millisecond",this.step=200),100>t&&(this.scale="millisecond",this.step=100),50>t&&(this.scale="millisecond",this.step=50),10>t&&(this.scale="millisecond",this.step=10),5>t&&(this.scale="millisecond",this.step=5),1>t&&(this.scale="millisecond",this.step=1)}}},{key:"isMajor",value:function(){if(1==this.switchedYear)switch(this.scale){case"year":case"month":case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedMonth)switch(this.scale){case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedDay)switch(this.scale){case"millisecond":case"second":case"minute":case"hour":return!0;default:return!1}var t=this.moment(this.current);switch(this.scale){case"millisecond":return 0==t.milliseconds();case"second":return 0==t.seconds();case"minute":return 0==t.hours()&&0==t.minutes();case"hour":return 0==t.hours();case"weekday":case"day":case"week":return 1==t.date();case"month":return 0==t.month();case"year":default:return!1}}},{key:"getLabelMinor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.minorLabels)return this.format.minorLabels(t,this.scale,this.step);var e=this.format.minorLabels[this.scale];switch(this.scale){case"week":if(1===t.date()&&0!==t.weekday())return"";default:return e&&e.length>0?this.moment(t).format(e):""}}},{key:"getLabelMajor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.majorLabels)return this.format.majorLabels(t,this.scale,this.step);var e=this.format.majorLabels[this.scale];return e&&e.length>0?this.moment(t).format(e):""}},{key:"getClassName",value:function(){var t=this.moment,e=this.moment(this.current),i=e.locale?e.locale("en"):e.lang("en"),n=this.step,r=[];function o(t){return t/n%2==0?" vis-even":" vis-odd"}function s(e){return e.isSame(Date.now(),"day")?" vis-today":e.isSame(t().add(1,"day"),"day")?" vis-tomorrow":e.isSame(t().add(-1,"day"),"day")?" vis-yesterday":""}function a(t){return t.isSame(Date.now(),"week")?" vis-current-week":""}function h(t){return t.isSame(Date.now(),"month")?" vis-current-month":""}switch(this.scale){case"millisecond":r.push(s(i)),r.push(o(i.milliseconds()));break;case"second":r.push(s(i)),r.push(o(i.seconds()));break;case"minute":r.push(s(i)),r.push(o(i.minutes()));break;case"hour":r.push("vis-h".concat(i.hours()).concat(4==this.step?"-h"+(i.hours()+4):"")),r.push(s(i)),r.push(o(i.hours()));break;case"weekday":r.push("vis-".concat(i.format("dddd").toLowerCase())),r.push(s(i)),r.push(a(i)),r.push(o(i.date()));break;case"day":r.push("vis-day".concat(i.date())),r.push("vis-".concat(i.format("MMMM").toLowerCase())),r.push(s(i)),r.push(h(i)),r.push(this.step<=2?s(i):""),r.push(this.step<=2?"vis-".concat(i.format("dddd").toLowerCase()):""),r.push(o(i.date()-1));break;case"week":r.push("vis-week".concat(i.format("w"))),r.push(a(i)),r.push(o(i.week()));break;case"month":r.push("vis-".concat(i.format("MMMM").toLowerCase())),r.push(h(i)),r.push(o(i.month()));break;case"year":r.push("vis-year".concat(i.year())),r.push(function(t){return t.isSame(Date.now(),"year")?" vis-current-year":""}(i)),r.push(o(i.year()))}return r.filter(String).join(" ")}}],[{key:"snap",value:function(t,e,i){var n=Dl(t);if("year"==e){var r=n.year()+Math.round(n.month()/12);n.year(Math.round(r/i)*i),n.month(0),n.date(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("month"==e)n.date()>15?(n.date(1),n.add(1,"month")):n.date(1),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("week"==e)n.weekday()>2?(n.weekday(0),n.add(1,"week")):n.weekday(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("day"==e){switch(i){case 5:case 2:n.hours(24*Math.round(n.hours()/24));break;default:n.hours(12*Math.round(n.hours()/12))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("weekday"==e){switch(i){case 5:case 2:n.hours(12*Math.round(n.hours()/12));break;default:n.hours(6*Math.round(n.hours()/6))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("hour"==e){switch(i){case 4:n.minutes(60*Math.round(n.minutes()/60));break;default:n.minutes(30*Math.round(n.minutes()/30))}n.seconds(0),n.milliseconds(0)}else if("minute"==e){switch(i){case 15:case 10:n.minutes(5*Math.round(n.minutes()/5)),n.seconds(0);break;case 5:n.seconds(60*Math.round(n.seconds()/60));break;default:n.seconds(30*Math.round(n.seconds()/30))}n.milliseconds(0)}else if("second"==e)switch(i){case 15:case 10:n.seconds(5*Math.round(n.seconds()/5)),n.milliseconds(0);break;case 5:n.milliseconds(1e3*Math.round(n.milliseconds()/1e3));break;default:n.milliseconds(500*Math.round(n.milliseconds()/500))}else if("millisecond"==e){var o=i>5?i/2:1;n.milliseconds(Math.round(n.milliseconds()/o)*o)}return n}}]),t}();Kd.FORMAT={minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}};var Qd=function(t){function e(t,i){var n;return Ma(this,e),(n=Ia(this,Ea(e).call(this))).dom={foreground:null,lines:[],majorTexts:[],minorTexts:[],redundant:{lines:[],majorTexts:[],minorTexts:[]}},n.props={range:{start:0,end:0,minimumStep:0},lineTop:0},n.defaultOptions={orientation:{axis:"bottom"},showMinorLabels:!0,showMajorLabels:!0,maxMinorChars:7,format:Kd.FORMAT,moment:Dl,timeAxis:null},n.options=bh.extend({},n.defaultOptions),n.body=t,n._create(),n.setOptions(i),n}return Ca(e,t),Oa(e,[{key:"setOptions",value:function(t){t&&(bh.selectiveExtend(["showMinorLabels","showMajorLabels","maxMinorChars","hiddenDates","timeAxis","moment","rtl"],this.options,t),bh.selectiveDeepExtend(["format"],this.options,t),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.axis=t.orientation:"object"===xa(t.orientation)&&"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis)),"locale"in t&&("function"==typeof Dl.locale?Dl.locale(t.locale):Dl.lang(t.locale)))}},{key:"_create",value:function(){this.dom.foreground=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.foreground.className="vis-time-axis vis-foreground",this.dom.background.className="vis-time-axis vis-background"}},{key:"destroy",value:function(){this.dom.foreground.parentNode&&this.dom.foreground.parentNode.removeChild(this.dom.foreground),this.dom.background.parentNode&&this.dom.background.parentNode.removeChild(this.dom.background),this.body=null}},{key:"redraw",value:function(){var t=this.props,e=this.dom.foreground,i=this.dom.background,n="top"==this.options.orientation.axis?this.body.dom.top:this.body.dom.bottom,r=e.parentNode!==n;this._calculateCharSize();var o=this.options.showMinorLabels&&"none"!==this.options.orientation.axis,s=this.options.showMajorLabels&&"none"!==this.options.orientation.axis;t.minorLabelHeight=o?t.minorCharHeight:0,t.majorLabelHeight=s?t.majorCharHeight:0,t.height=t.minorLabelHeight+t.majorLabelHeight,t.width=e.offsetWidth,t.minorLineHeight=this.body.domProps.root.height-t.majorLabelHeight-("top"==this.options.orientation.axis?this.body.domProps.bottom.height:this.body.domProps.top.height),t.minorLineWidth=1,t.majorLineHeight=t.minorLineHeight+t.majorLabelHeight,t.majorLineWidth=1;var a=e.nextSibling,h=i.nextSibling;return e.parentNode&&e.parentNode.removeChild(e),i.parentNode&&i.parentNode.removeChild(i),e.style.height="".concat(this.props.height,"px"),this._repaintLabels(),a?n.insertBefore(e,a):n.appendChild(e),h?this.body.dom.backgroundVertical.insertBefore(i,h):this.body.dom.backgroundVertical.appendChild(i),this._isResized()||r}},{key:"_repaintLabels",value:function(){var t=this.options.orientation.axis,e=bh.convert(this.body.range.start,"Number"),i=bh.convert(this.body.range.end,"Number"),n=this.body.util.toTime((this.props.minorCharWidth||10)*this.options.maxMinorChars).valueOf(),r=n-Al(this.options.moment,this.body.hiddenDates,this.body.range,n);r-=this.body.util.toTime(0).valueOf();var o=new Kd(new Date(e),new Date(i),r,this.body.hiddenDates,this.options);o.setMoment(this.options.moment),this.options.format&&o.setFormat(this.options.format),this.options.timeAxis&&o.setScale(this.options.timeAxis),this.step=o;var s,a,h,l,u,d,c=this.dom;c.redundant.lines=c.lines,c.redundant.majorTexts=c.majorTexts,c.redundant.minorTexts=c.minorTexts,c.lines=[],c.majorTexts=[],c.minorTexts=[];var f,p,m,g=0,v=void 0,y=0;for(o.start(),a=o.getCurrent(),l=this.body.util.toScreen(a);o.hasNext()&&y<1e3;){switch(y++,u=o.isMajor(),m=o.getClassName(),s=a,h=l,o.next(),a=o.getCurrent(),f=g,g=(l=this.body.util.toScreen(a))-h,o.scale){case"week":d=!0;break;default:d=g>=.4*f}if(this.options.showMinorLabels&&d){var _=this._repaintMinorText(h,o.getLabelMinor(s),t,m);_.style.width="".concat(g,"px")}u&&this.options.showMajorLabels?(h>0&&(null==v&&(v=h),_=this._repaintMajorText(h,o.getLabelMajor(s),t,m)),p=this._repaintMajorLine(h,g,t,m)):d?p=this._repaintMinorLine(h,g,t,m):p&&(p.style.width="".concat(parseInt(p.style.width)+g,"px"))}if(1e3!==y||tc||(console.warn("Something is wrong with the Timeline scale. Limited drawing of grid lines to ".concat(1e3," lines.")),tc=!0),this.options.showMajorLabels){var b=this.body.util.toTime(0),w=o.getLabelMajor(b),k=w.length*(this.props.majorCharWidth||10)+10;(null==v||k<v)&&this._repaintMajorText(0,w,t,m)}bh.forEach(this.dom.redundant,(function(t){for(;t.length;){var e=t.pop();e&&e.parentNode&&e.parentNode.removeChild(e)}}))}},{key:"_repaintMinorText",value:function(t,e,i,n){var r=this.dom.redundant.minorTexts.shift();if(!r){var o=document.createTextNode("");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}this.dom.minorTexts.push(r),r.innerHTML=e;var s="top"==i?this.props.majorLabelHeight:0;return this._setXY(r,t,s),r.className="vis-text vis-minor ".concat(n),r}},{key:"_repaintMajorText",value:function(t,e,i,n){var r=this.dom.redundant.majorTexts.shift();if(!r){var o=document.createElement("div");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}r.childNodes[0].innerHTML=e,r.className="vis-text vis-major ".concat(n);var s="top"==i?0:this.props.minorLabelHeight;return this._setXY(r,t,s),this.dom.majorTexts.push(r),r}},{key:"_setXY",value:function(t,e,i){var n=this.options.rtl?-1*e:e;t.style.transform="translate(".concat(n,"px, ").concat(i,"px)")}},{key:"_repaintMinorLine",value:function(t,e,i,n){var r=this.dom.redundant.lines.shift();r||(r=document.createElement("div"),this.dom.background.appendChild(r)),this.dom.lines.push(r);var o=this.props;r.style.width="".concat(e,"px"),r.style.height="".concat(o.minorLineHeight,"px");var s="top"==i?o.majorLabelHeight:this.body.domProps.top.height,a=t-o.minorLineWidth/2;return this._setXY(r,a,s),r.className="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-minor ").concat(n),r}},{key:"_repaintMajorLine",value:function(t,e,i,n){var r=this.dom.redundant.lines.shift();r||(r=document.createElement("div"),this.dom.background.appendChild(r)),this.dom.lines.push(r);var o=this.props;r.style.width="".concat(e,"px"),r.style.height="".concat(o.majorLineHeight,"px");var s="top"==i?0:this.body.domProps.top.height,a=t-o.majorLineWidth/2;return this._setXY(r,a,s),r.className="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-major ").concat(n),r}},{key:"_calculateCharSize",value:function(){this.dom.measureCharMinor||(this.dom.measureCharMinor=document.createElement("DIV"),this.dom.measureCharMinor.className="vis-text vis-minor vis-measure",this.dom.measureCharMinor.style.position="absolute",this.dom.measureCharMinor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMinor)),this.props.minorCharHeight=this.dom.measureCharMinor.clientHeight,this.props.minorCharWidth=this.dom.measureCharMinor.clientWidth,this.dom.measureCharMajor||(this.dom.measureCharMajor=document.createElement("DIV"),this.dom.measureCharMajor.className="vis-text vis-major vis-measure",this.dom.measureCharMajor.style.position="absolute",this.dom.measureCharMajor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMajor)),this.props.majorCharHeight=this.dom.measureCharMajor.clientHeight,this.props.majorCharWidth=this.dom.measureCharMajor.clientWidth}}]),e}(Sl),tc=!1,ec=n((function(t,e){t.exports=function(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,r={},o={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){l(t,"keydown")},h=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==o[e][t.keyCode]){for(var n=o[e][t.keyCode],r=0;r<n.length;r++)void 0===n[r].shift?n[r].fn(t):1==n[r].shift&&1==t.shiftKey?n[r].fn(t):0==n[r].shift&&0==t.shiftKey&&n[r].fn(t);1==i&&t.preventDefault()}};return r.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===o[i][s[t].code]&&(o[i][s[t].code]=[]),o[i][s[t].code].push({fn:e,shift:s[t].shift})},r.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&r.bind(i,t,e)},r.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},r.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],r=o[i][s[t].code];if(void 0!==r)for(var a=0;a<r.length;a++)r[a].fn==e&&r[a].shift==s[t].shift||n.push(o[i][s[t].code][a]);o[i][s[t].code]=n}else o[i][s[t].code]=[]},r.reset=function(){o={keydown:{},keyup:{}}},r.destroy=function(){o={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",h,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",h,!0),r}}));function ic(t){this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=$d(this.dom.overlay),this.hammer.on("tap",this._onTapOverlay.bind(this));var e=this;["tap","doubletap","press","pinch","pan","panstart","panmove","panend"].forEach((function(t){e.hammer.on(t,(function(t){t.stopPropagation()}))})),document&&document.body&&(this.onClick=function(i){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(i.target,t)||e.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=ec(),this.escListener=this.deactivate.bind(this)}Wl(ic.prototype),ic.current=null,ic.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},ic.prototype.activate=function(){ic.current&&ic.current.deactivate(),ic.current=this,this.active=!0,this.dom.overlay.style.display="none",bh.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),this.keycharm.bind("esc",this.escListener)},ic.prototype.deactivate=function(){this.active=!1,this.dom.overlay.style.display="",bh.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},ic.prototype._onTapOverlay=function(t){this.activate(),t.stopPropagation()};n((function(t,e){(function(t){t.defineLocale("it",{months:"gennaio_febbraio_marzo_aprile_maggio_giugno_luglio_agosto_settembre_ottobre_novembre_dicembre".split("_"),monthsShort:"gen_feb_mar_apr_mag_giu_lug_ago_set_ott_nov_dic".split("_"),weekdays:"domenica_lunedì_martedì_mercoledì_giovedì_venerdì_sabato".split("_"),weekdaysShort:"dom_lun_mar_mer_gio_ven_sab".split("_"),weekdaysMin:"do_lu_ma_me_gi_ve_sa".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[Oggi alle] LT",nextDay:"[Domani alle] LT",nextWeek:"dddd [alle] LT",lastDay:"[Ieri alle] LT",lastWeek:function(){switch(this.day()){case 0:return"[la scorsa] dddd [alle] LT";default:return"[lo scorso] dddd [alle] LT"}},sameElse:"L"},relativeTime:{future:function(t){return(/^[0-9].+$/.test(t)?"tra":"in")+" "+t},past:"%s fa",s:"alcuni secondi",ss:"%d secondi",m:"un minuto",mm:"%d minuti",h:"un'ora",hh:"%d ore",d:"un giorno",dd:"%d giorni",M:"un mese",MM:"%d mesi",y:"un anno",yy:"%d anni"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4}})})(kl)})),n((function(t,e){(function(t){var e="jan._feb._mrt._apr._mei_jun._jul._aug._sep._okt._nov._dec.".split("_"),i="jan_feb_mrt_apr_mei_jun_jul_aug_sep_okt_nov_dec".split("_"),n=[/^jan/i,/^feb/i,/^maart|mrt.?$/i,/^apr/i,/^mei$/i,/^jun[i.]?$/i,/^jul[i.]?$/i,/^aug/i,/^sep/i,/^okt/i,/^nov/i,/^dec/i],r=/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december|jan\.?|feb\.?|mrt\.?|apr\.?|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i;t.defineLocale("nl",{months:"januari_februari_maart_april_mei_juni_juli_augustus_september_oktober_november_december".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december)/i,monthsShortStrictRegex:/^(jan\.?|feb\.?|mrt\.?|apr\.?|mei|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"zondag_maandag_dinsdag_woensdag_donderdag_vrijdag_zaterdag".split("_"),weekdaysShort:"zo._ma._di._wo._do._vr._za.".split("_"),weekdaysMin:"zo_ma_di_wo_do_vr_za".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD-MM-YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[vandaag om] LT",nextDay:"[morgen om] LT",nextWeek:"dddd [om] LT",lastDay:"[gisteren om] LT",lastWeek:"[afgelopen] dddd [om] LT",sameElse:"L"},relativeTime:{future:"over %s",past:"%s geleden",s:"een paar seconden",ss:"%d seconden",m:"één minuut",mm:"%d minuten",h:"één uur",hh:"%d uur",d:"één dag",dd:"%d dagen",M:"één maand",MM:"%d maanden",y:"één jaar",yy:"%d jaar"},dayOfMonthOrdinalParse:/\d{1,2}(ste|de)/,ordinal:function(t){return t+(1===t||8===t||t>=20?"ste":"de")},week:{dow:1,doy:4}})})(kl)})),n((function(t,e){(function(t){function e(t,e,i,n){var r={m:["eine Minute","einer Minute"],h:["eine Stunde","einer Stunde"],d:["ein Tag","einem Tag"],dd:[t+" Tage",t+" Tagen"],M:["ein Monat","einem Monat"],MM:[t+" Monate",t+" Monaten"],y:["ein Jahr","einem Jahr"],yy:[t+" Jahre",t+" Jahren"]};return e?r[i][0]:r[i][1]}t.defineLocale("de",{months:"Januar_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember".split("_"),monthsShort:"Jan._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.".split("_"),monthsParseExact:!0,weekdays:"Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag".split("_"),weekdaysShort:"So._Mo._Di._Mi._Do._Fr._Sa.".split("_"),weekdaysMin:"So_Mo_Di_Mi_Do_Fr_Sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D. MMMM YYYY",LLL:"D. MMMM YYYY HH:mm",LLLL:"dddd, D. MMMM YYYY HH:mm"},calendar:{sameDay:"[heute um] LT [Uhr]",sameElse:"L",nextDay:"[morgen um] LT [Uhr]",nextWeek:"dddd [um] LT [Uhr]",lastDay:"[gestern um] LT [Uhr]",lastWeek:"[letzten] dddd [um] LT [Uhr]"},relativeTime:{future:"in %s",past:"vor %s",s:"ein paar Sekunden",ss:"%d Sekunden",m:e,mm:"%d Minuten",h:e,hh:"%d Stunden",d:e,dd:e,M:e,MM:e,y:e,yy:e},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})})(kl)})),n((function(t,e){(function(t){t.defineLocale("fr",{months:"janvier_février_mars_avril_mai_juin_juillet_août_septembre_octobre_novembre_décembre".split("_"),monthsShort:"janv._févr._mars_avr._mai_juin_juil._août_sept._oct._nov._déc.".split("_"),monthsParseExact:!0,weekdays:"dimanche_lundi_mardi_mercredi_jeudi_vendredi_samedi".split("_"),weekdaysShort:"dim._lun._mar._mer._jeu._ven._sam.".split("_"),weekdaysMin:"di_lu_ma_me_je_ve_sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[Aujourd’hui à] LT",nextDay:"[Demain à] LT",nextWeek:"dddd [à] LT",lastDay:"[Hier à] LT",lastWeek:"dddd [dernier à] LT",sameElse:"L"},relativeTime:{future:"dans %s",past:"il y a %s",s:"quelques secondes",ss:"%d secondes",m:"une minute",mm:"%d minutes",h:"une heure",hh:"%d heures",d:"un jour",dd:"%d jours",M:"un mois",MM:"%d mois",y:"un an",yy:"%d ans"},dayOfMonthOrdinalParse:/\d{1,2}(er|)/,ordinal:function(t,e){switch(e){case"D":return t+(1===t?"er":"");default:case"M":case"Q":case"DDD":case"d":return t+(1===t?"er":"e");case"w":case"W":return t+(1===t?"re":"e")}},week:{dow:1,doy:4}})})(kl)})),n((function(t,e){(function(t){var e="ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.".split("_"),i="ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic".split("_"),n=[/^ene/i,/^feb/i,/^mar/i,/^abr/i,/^may/i,/^jun/i,/^jul/i,/^ago/i,/^sep/i,/^oct/i,/^nov/i,/^dic/i],r=/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;t.defineLocale("es",{months:"enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,monthsShortStrictRegex:/^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"domingo_lunes_martes_miércoles_jueves_viernes_sábado".split("_"),weekdaysShort:"dom._lun._mar._mié._jue._vie._sáb.".split("_"),weekdaysMin:"do_lu_ma_mi_ju_vi_sá".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD/MM/YYYY",LL:"D [de] MMMM [de] YYYY",LLL:"D [de] MMMM [de] YYYY H:mm",LLLL:"dddd, D [de] MMMM [de] YYYY H:mm"},calendar:{sameDay:function(){return"[hoy a la"+(1!==this.hours()?"s":"")+"] LT"},nextDay:function(){return"[mañana a la"+(1!==this.hours()?"s":"")+"] LT"},nextWeek:function(){return"dddd [a la"+(1!==this.hours()?"s":"")+"] LT"},lastDay:function(){return"[ayer a la"+(1!==this.hours()?"s":"")+"] LT"},lastWeek:function(){return"[el] dddd [pasado a la"+(1!==this.hours()?"s":"")+"] LT"},sameElse:"L"},relativeTime:{future:"en %s",past:"hace %s",s:"unos segundos",ss:"%d segundos",m:"un minuto",mm:"%d minutos",h:"una hora",hh:"%d horas",d:"un día",dd:"%d días",M:"un mes",MM:"%d meses",y:"un año",yy:"%d años"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4}})})(kl)})),n((function(t,e){(function(t){function e(t,e,i){var n,r;return"m"===i?e?"хвилина":"хвилину":"h"===i?e?"година":"годину":t+" "+(n=+t,r={ss:e?"секунда_секунди_секунд":"секунду_секунди_секунд",mm:e?"хвилина_хвилини_хвилин":"хвилину_хвилини_хвилин",hh:e?"година_години_годин":"годину_години_годин",dd:"день_дні_днів",MM:"місяць_місяці_місяців",yy:"рік_роки_років"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}function i(t){return function(){return t+"о"+(11===this.hours()?"б":"")+"] LT"}}t.defineLocale("uk",{months:{format:"січня_лютого_березня_квітня_травня_червня_липня_серпня_вересня_жовтня_листопада_грудня".split("_"),standalone:"січень_лютий_березень_квітень_травень_червень_липень_серпень_вересень_жовтень_листопад_грудень".split("_")},monthsShort:"січ_лют_бер_квіт_трав_черв_лип_серп_вер_жовт_лист_груд".split("_"),weekdays:function(t,e){var i={nominative:"неділя_понеділок_вівторок_середа_четвер_п’ятниця_субота".split("_"),accusative:"неділю_понеділок_вівторок_середу_четвер_п’ятницю_суботу".split("_"),genitive:"неділі_понеділка_вівторка_середи_четверга_п’ятниці_суботи".split("_")};return!0===t?i.nominative.slice(1,7).concat(i.nominative.slice(0,1)):t?i[/(\[[ВвУу]\]) ?dddd/.test(e)?"accusative":/\[?(?:минулої|наступної)? ?\] ?dddd/.test(e)?"genitive":"nominative"][t.day()]:i.nominative},weekdaysShort:"нд_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"нд_пн_вт_ср_чт_пт_сб".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY р.",LLL:"D MMMM YYYY р., HH:mm",LLLL:"dddd, D MMMM YYYY р., HH:mm"},calendar:{sameDay:i("[Сьогодні "),nextDay:i("[Завтра "),lastDay:i("[Вчора "),nextWeek:i("[У] dddd ["),lastWeek:function(){switch(this.day()){case 0:case 3:case 5:case 6:return i("[Минулої] dddd [").call(this);case 1:case 2:case 4:return i("[Минулого] dddd [").call(this)}},sameElse:"L"},relativeTime:{future:"за %s",past:"%s тому",s:"декілька секунд",ss:e,m:e,mm:e,h:"годину",hh:e,d:"день",dd:e,M:"місяць",MM:e,y:"рік",yy:e},meridiemParse:/ночі|ранку|дня|вечора/,isPM:function(t){return/^(дня|вечора)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночі":t<12?"ранку":t<17?"дня":"вечора"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":case"w":case"W":return t+"-й";case"D":return t+"-го";default:return t}},week:{dow:1,doy:7}})})(kl)})),n((function(t,e){(function(t){function e(t,e,i){var n,r;return"m"===i?e?"минута":"минуту":t+" "+(n=+t,r={ss:e?"секунда_секунды_секунд":"секунду_секунды_секунд",mm:e?"минута_минуты_минут":"минуту_минуты_минут",hh:"час_часа_часов",dd:"день_дня_дней",MM:"месяц_месяца_месяцев",yy:"год_года_лет"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}var i=[/^янв/i,/^фев/i,/^мар/i,/^апр/i,/^ма[йя]/i,/^июн/i,/^июл/i,/^авг/i,/^сен/i,/^окт/i,/^ноя/i,/^дек/i];t.defineLocale("ru",{months:{format:"января_февраля_марта_апреля_мая_июня_июля_августа_сентября_октября_ноября_декабря".split("_"),standalone:"январь_февраль_март_апрель_май_июнь_июль_август_сентябрь_октябрь_ноябрь_декабрь".split("_")},monthsShort:{format:"янв._февр._мар._апр._мая_июня_июля_авг._сент._окт._нояб._дек.".split("_"),standalone:"янв._февр._март_апр._май_июнь_июль_авг._сент._окт._нояб._дек.".split("_")},weekdays:{standalone:"воскресенье_понедельник_вторник_среда_четверг_пятница_суббота".split("_"),format:"воскресенье_понедельник_вторник_среду_четверг_пятницу_субботу".split("_"),isFormat:/\[ ?[Вв] ?(?:прошлую|следующую|эту)? ?\] ?dddd/},weekdaysShort:"вс_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"вс_пн_вт_ср_чт_пт_сб".split("_"),monthsParse:i,longMonthsParse:i,shortMonthsParse:i,monthsRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsShortRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsStrictRegex:/^(январ[яь]|феврал[яь]|марта?|апрел[яь]|ма[яй]|июн[яь]|июл[яь]|августа?|сентябр[яь]|октябр[яь]|ноябр[яь]|декабр[яь])/i,monthsShortStrictRegex:/^(янв\.|февр?\.|мар[т.]|апр\.|ма[яй]|июн[ья.]|июл[ья.]|авг\.|сент?\.|окт\.|нояб?\.|дек\.)/i,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY г.",LLL:"D MMMM YYYY г., H:mm",LLLL:"dddd, D MMMM YYYY г., H:mm"},calendar:{sameDay:"[Сегодня, в] LT",nextDay:"[Завтра, в] LT",lastDay:"[Вчера, в] LT",nextWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В следующее] dddd, [в] LT";case 1:case 2:case 4:return"[В следующий] dddd, [в] LT";case 3:case 5:case 6:return"[В следующую] dddd, [в] LT"}},lastWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В прошлое] dddd, [в] LT";case 1:case 2:case 4:return"[В прошлый] dddd, [в] LT";case 3:case 5:case 6:return"[В прошлую] dddd, [в] LT"}},sameElse:"L"},relativeTime:{future:"через %s",past:"%s назад",s:"несколько секунд",ss:e,m:e,mm:e,h:"час",hh:e,d:"день",dd:e,M:"месяц",MM:e,y:"год",yy:e},meridiemParse:/ночи|утра|дня|вечера/i,isPM:function(t){return/^(дня|вечера)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночи":t<12?"утра":t<17?"дня":"вечера"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го|я)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":return t+"-й";case"D":return t+"-го";case"w":case"W":return t+"-я";default:return t}},week:{dow:1,doy:4}})})(kl)})),n((function(t,e){(function(t){t.defineLocale("ja",{months:"一月_二月_三月_四月_五月_六月_七月_八月_九月_十月_十一月_十二月".split("_"),monthsShort:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),weekdays:"日曜日_月曜日_火曜日_水曜日_木曜日_金曜日_土曜日".split("_"),weekdaysShort:"日_月_火_水_木_金_土".split("_"),weekdaysMin:"日_月_火_水_木_金_土".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"YYYY/MM/DD",LL:"YYYY年M月D日",LLL:"YYYY年M月D日 HH:mm",LLLL:"YYYY年M月D日 dddd HH:mm",l:"YYYY/MM/DD",ll:"YYYY年M月D日",lll:"YYYY年M月D日 HH:mm",llll:"YYYY年M月D日(ddd) HH:mm"},meridiemParse:/午前|午後/i,isPM:function(t){return"午後"===t},meridiem:function(t,e,i){return t<12?"午前":"午後"},calendar:{sameDay:"[今日] LT",nextDay:"[明日] LT",nextWeek:function(t){return t.week()<this.week()?"[来週]dddd LT":"dddd LT"},lastDay:"[昨日] LT",lastWeek:function(t){return this.week()<t.week()?"[先週]dddd LT":"dddd LT"},sameElse:"L"},dayOfMonthOrdinalParse:/\d{1,2}日/,ordinal:function(t,e){switch(e){case"d":case"D":case"DDD":return t+"日";default:return t}},relativeTime:{future:"%s後",past:"%s前",s:"数秒",ss:"%d秒",m:"1分",mm:"%d分",h:"1時間",hh:"%d時間",d:"1日",dd:"%d日",M:"1ヶ月",MM:"%dヶ月",y:"1年",yy:"%d年"}})})(kl)}));var nc=n((function(t,e){e.en={current:"current",time:"time",deleteSelected:"Delete selected"},e.en_EN=e.en,e.en_US=e.en,e.it={current:"attuale",time:"tempo",deleteSelected:"Cancella la selezione"},e.it_IT=e.it,e.it_CH=e.it,e.nl={current:"huidige",time:"tijd",deleteSelected:"Selectie verwijderen"},e.nl_NL=e.nl,e.nl_BE=e.nl,e.de={current:"Aktuelle",time:"Zeit",deleteSelected:"Lösche Auswahl"},e.de_DE=e.de,e.fr={current:"actuel",time:"heure",deleteSelected:"Effacer la selection"},e.fr_FR=e.fr,e.fr_CA=e.fr,e.fr_BE=e.fr,e.es={current:"corriente",time:"hora",deleteSelected:"Eliminar selección"},e.es_ES=e.es,e.uk={current:"поточний",time:"час",deleteSelected:"Видалити обране"},e.uk_UA=e.uk,e.ru={current:"текущее",time:"время",deleteSelected:"Удалить выбранное"},e.ru_RU=e.ru,e.ja={current:"現在",time:"時刻",deleteSelected:"選択されたものを削除"},e.ja_JP=e.ja})),rc=function(t){function e(t,i){var n;Ma(this,e),(n=Ia(this,Ea(e).call(this))).body=t,n.defaultOptions={moment:Dl,locales:nc,locale:"en",id:void 0,title:void 0},n.options=bh.extend({},n.defaultOptions),n.setOptions(i),bh.extend(n.options.locales,nc,n.options.locales);var r=n.defaultOptions.locales[n.defaultOptions.locale];return Object.keys(n.options.locales).forEach((function(t){n.options.locales[t]=bh.extend({},r,n.options.locales[t])})),i&&i.time?n.customTime=i.time:n.customTime=new Date,n.eventParams={},n._create(),n}return Ca(e,t),Oa(e,[{key:"setOptions",value:function(t){t&&bh.selectiveExtend(["moment","locale","locales","id","title","rtl"],this.options,t)}},{key:"_create",value:function(){var t=document.createElement("div");t["custom-time"]=this,t.className="vis-custom-time ".concat(this.options.id||""),t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t;var e=document.createElement("div");function i(t){this.body.range._onMouseWheel(t)}e.style.position="relative",e.style.top="0px",this.options.rtl?e.style.right="-10px":e.style.left="-10px",e.style.height="100%",e.style.width="20px",e.addEventListener?(e.addEventListener("mousewheel",i.bind(this),!1),e.addEventListener("DOMMouseScroll",i.bind(this),!1)):e.attachEvent("onmousewheel",i.bind(this)),t.appendChild(e),this.hammer=new $d(e),this.hammer.on("panstart",this._onDragStart.bind(this)),this.hammer.on("panmove",this._onDrag.bind(this)),this.hammer.on("panend",this._onDragEnd.bind(this)),this.hammer.get("pan").set({threshold:5,direction:$d.DIRECTION_ALL})}},{key:"destroy",value:function(){this.hide(),this.hammer.destroy(),this.hammer=null,this.body=null}},{key:"redraw",value:function(){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar));var e=this.body.util.toScreen(this.customTime),i=this.options.locales[this.options.locale];i||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),i=this.options.locales.en);var n=this.options.title;return void 0===n?n=(n="".concat(i.time,": ").concat(this.options.moment(this.customTime).format("dddd, MMMM Do YYYY, H:mm:ss"))).charAt(0).toUpperCase()+n.substring(1):"function"==typeof n&&(n=n.call(this.customTime)),this.options.rtl?this.bar.style.right="".concat(e,"px"):this.bar.style.left="".concat(e,"px"),this.bar.title=n,!1}},{key:"hide",value:function(){this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar)}},{key:"setCustomTime",value:function(t){this.customTime=bh.convert(t,"Date"),this.redraw()}},{key:"getCustomTime",value:function(){return new Date(this.customTime.valueOf())}},{key:"setCustomMarker",value:function(t,e){var i=document.createElement("div");i.className="vis-custom-time-marker",i.innerHTML=t,i.style.position="absolute",e&&(i.setAttribute("contenteditable","true"),i.addEventListener("pointerdown",(function(){i.focus()})),i.addEventListener("input",this._onMarkerChange.bind(this)),i.title=t,i.addEventListener("blur",function(t){this.title!=t.target.innerHTML&&(this._onMarkerChanged(t),this.title=t.target.innerHTML)}.bind(this))),this.bar.appendChild(i)}},{key:"setCustomTitle",value:function(t){this.options.title=t}},{key:"_onDragStart",value:function(t){this.eventParams.dragging=!0,this.eventParams.customTime=this.customTime,t.stopPropagation()}},{key:"_onDrag",value:function(t){if(this.eventParams.dragging){var e=this.options.rtl?-1*t.deltaX:t.deltaX,i=this.body.util.toScreen(this.eventParams.customTime)+e,n=this.body.util.toTime(i);this.setCustomTime(n),this.body.emitter.emit("timechange",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation()}}},{key:"_onDragEnd",value:function(t){this.eventParams.dragging&&(this.body.emitter.emit("timechanged",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation())}},{key:"_onMarkerChange",value:function(t){this.body.emitter.emit("markerchange",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}},{key:"_onMarkerChanged",value:function(t){this.body.emitter.emit("markerchanged",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}}],[{key:"customTimeFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("custom-time"))return e["custom-time"];e=e.parentNode}return null}}]),e}(Sl),oc=function(){function t(){Ma(this,t)}return Oa(t,[{key:"_create",value:function(t){var e=this;this.dom={},this.dom.container=t,this.dom.container.style.position="relative",this.dom.root=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.backgroundVertical=document.createElement("div"),this.dom.backgroundHorizontal=document.createElement("div"),this.dom.centerContainer=document.createElement("div"),this.dom.leftContainer=document.createElement("div"),this.dom.rightContainer=document.createElement("div"),this.dom.center=document.createElement("div"),this.dom.left=document.createElement("div"),this.dom.right=document.createElement("div"),this.dom.top=document.createElement("div"),this.dom.bottom=document.createElement("div"),this.dom.shadowTop=document.createElement("div"),this.dom.shadowBottom=document.createElement("div"),this.dom.shadowTopLeft=document.createElement("div"),this.dom.shadowBottomLeft=document.createElement("div"),this.dom.shadowTopRight=document.createElement("div"),this.dom.shadowBottomRight=document.createElement("div"),this.dom.rollingModeBtn=document.createElement("div"),this.dom.loadingScreen=document.createElement("div"),this.dom.root.className="vis-timeline",this.dom.background.className="vis-panel vis-background",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical",this.dom.backgroundHorizontal.className="vis-panel vis-background vis-horizontal",this.dom.centerContainer.className="vis-panel vis-center",this.dom.leftContainer.className="vis-panel vis-left",this.dom.rightContainer.className="vis-panel vis-right",this.dom.top.className="vis-panel vis-top",this.dom.bottom.className="vis-panel vis-bottom",this.dom.left.className="vis-content",this.dom.center.className="vis-content",this.dom.right.className="vis-content",this.dom.shadowTop.className="vis-shadow vis-top",this.dom.shadowBottom.className="vis-shadow vis-bottom",this.dom.shadowTopLeft.className="vis-shadow vis-top",this.dom.shadowBottomLeft.className="vis-shadow vis-bottom",this.dom.shadowTopRight.className="vis-shadow vis-top",this.dom.shadowBottomRight.className="vis-shadow vis-bottom",this.dom.rollingModeBtn.className="vis-rolling-mode-btn",this.dom.loadingScreen.className="vis-loading-screen",this.dom.root.appendChild(this.dom.background),this.dom.root.appendChild(this.dom.backgroundVertical),this.dom.root.appendChild(this.dom.backgroundHorizontal),this.dom.root.appendChild(this.dom.centerContainer),this.dom.root.appendChild(this.dom.leftContainer),this.dom.root.appendChild(this.dom.rightContainer),this.dom.root.appendChild(this.dom.top),this.dom.root.appendChild(this.dom.bottom),this.dom.root.appendChild(this.dom.rollingModeBtn),this.dom.centerContainer.appendChild(this.dom.center),this.dom.leftContainer.appendChild(this.dom.left),this.dom.rightContainer.appendChild(this.dom.right),this.dom.centerContainer.appendChild(this.dom.shadowTop),this.dom.centerContainer.appendChild(this.dom.shadowBottom),this.dom.leftContainer.appendChild(this.dom.shadowTopLeft),this.dom.leftContainer.appendChild(this.dom.shadowBottomLeft),this.dom.rightContainer.appendChild(this.dom.shadowTopRight),this.dom.rightContainer.appendChild(this.dom.shadowBottomRight),this.props={root:{},background:{},centerContainer:{},leftContainer:{},rightContainer:{},center:{},left:{},right:{},top:{},bottom:{},border:{},scrollTop:0,scrollTopMin:0},this.on("rangechange",(function(){!0===e.initialDrawDone&&e._redraw()})),this.on("rangechanged",(function(){e.initialRangeChangeDone||(e.initialRangeChangeDone=!0)})),this.on("touch",this._onTouch.bind(this)),this.on("panmove",this._onDrag.bind(this));var i=this;this._origRedraw=this._redraw.bind(this),this._redraw=bh.throttle(this._origRedraw),this.on("_change",(function(t){i.itemSet&&i.itemSet.initialItemSetDrawn&&t&&1==t.queue?i._redraw():i._origRedraw()})),this.hammer=new $d(this.dom.root);var n=this.hammer.get("pinch").set({enable:!0});n&&function(t){t.getTouchAction=function(){return["pan-y"]}}(n),this.hammer.get("pan").set({threshold:5,direction:$d.DIRECTION_ALL}),this.listeners={};var r,o;["tap","doubletap","press","pinch","pan","panstart","panmove","panend"].forEach((function(t){var e=function(e){i.isActive()&&i.emit(t,e)};i.hammer.on(t,e),i.listeners[t]=e})),Jd(this.hammer,(function(t){i.emit("touch",t)})),r=this.hammer,(o=function(t){i.emit("release",t)}).inputHandler=function(t){t.isFinal&&o(t)},r.on("hammer.input",o.inputHandler);var s="onwheel"in document.createElement("div")?"wheel":void 0!==document.onmousewheel?"mousewheel":this.dom.centerContainer.addEventListener?"DOMMouseScroll":"onmousewheel";function a(t){if(i.options.verticalScroll&&(t.preventDefault(),i.isActive())){var e=-t.target.scrollTop;i._setScrollTop(e),i._redraw(),i.emit("scrollSide",t)}}this.dom.centerContainer.addEventListener(s,function(t){this.isActive()&&this.emit("mousewheel",t);var e=0,i=0;if("detail"in t&&(i=-1*t.detail),"wheelDelta"in t&&(i=t.wheelDelta),"wheelDeltaY"in t&&(i=t.wheelDeltaY),"wheelDeltaX"in t&&(e=-1*t.wheelDeltaX),"axis"in t&&t.axis===t.HORIZONTAL_AXIS&&(e=-1*i,i=0),"deltaY"in t&&(i=-1*t.deltaY),"deltaX"in t&&(e=t.deltaX),t.deltaMode&&(1===t.deltaMode?(e*=40,i*=40):(e*=40,i*=800)),this.options.preferZoom){if(!this.options.zoomKey||t[this.options.zoomKey])return}else if(this.options.zoomKey&&t[this.options.zoomKey])return;if(this.options.verticalScroll||this.options.horizontalScroll)if(this.options.verticalScroll&&Math.abs(i)>=Math.abs(e)){var n=this.props.scrollTop,r=n+i;if(this.isActive())this._setScrollTop(r)!==n&&(this._redraw(),this.emit("scroll",t),t.preventDefault())}else if(this.options.horizontalScroll){var o=(Math.abs(e)>=Math.abs(i)?e:i)/120*(this.range.end-this.range.start)/20,s=this.range.start+o,a=this.range.end+o,h={animation:!1,byUser:!0,event:t};this.range.setRange(s,a,h),t.preventDefault()}}.bind(this),!1),this.dom.left.parentNode.addEventListener("scroll",a.bind(this)),this.dom.right.parentNode.addEventListener("scroll",a.bind(this));var h=!1;if(this.dom.center.addEventListener("dragover",function(t){if(t.preventDefault&&(i.emit("dragover",i.getEventProperties(t)),t.preventDefault()),t.target.className.indexOf("timeline")>-1&&!h)return t.dataTransfer.dropEffect="move",h=!0,!1}.bind(this),!1),this.dom.center.addEventListener("drop",function(t){t.preventDefault&&t.preventDefault(),t.stopPropagation&&t.stopPropagation();try{var e=JSON.parse(t.dataTransfer.getData("text"));if(!e||!e.content)return}catch(t){return!1}return h=!1,t.center={x:t.clientX,y:t.clientY},"item"!==e.target?i.itemSet._onAddItem(t):i.itemSet._onDropObjectOnItem(t),i.emit("drop",i.getEventProperties(t)),!1}.bind(this),!1),this.customTimes=[],this.touch={},this.redrawCount=0,this.initialDrawDone=!1,this.initialRangeChangeDone=!1,!t)throw new Error("No container provided");t.appendChild(this.dom.root),t.appendChild(this.dom.loadingScreen)}},{key:"setOptions",value:function(t){if(t){if(bh.selectiveExtend(["width","height","minHeight","maxHeight","autoResize","start","end","clickToUse","dataAttributes","hiddenDates","locale","locales","moment","preferZoom","rtl","zoomKey","horizontalScroll","verticalScroll"],this.options,t),this.dom.rollingModeBtn.style.visibility="hidden",this.options.rtl&&(this.dom.container.style.direction="rtl",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical-rtl"),this.options.verticalScroll&&(this.options.rtl?this.dom.rightContainer.className="vis-panel vis-right vis-vertical-scroll":this.dom.leftContainer.className="vis-panel vis-left vis-vertical-scroll"),"object"!==xa(this.options.orientation)&&(this.options.orientation={item:void 0,axis:void 0}),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation={item:t.orientation,axis:t.orientation}:"object"===xa(t.orientation)&&("item"in t.orientation&&(this.options.orientation.item=t.orientation.item),"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis))),"both"===this.options.orientation.axis){if(!this.timeAxis2){var e=this.timeAxis2=new Qd(this.body);e.setOptions=function(t){var i=t?bh.extend({},t):{};i.orientation="top",Qd.prototype.setOptions.call(e,i)},this.components.push(e)}}else if(this.timeAxis2){var i=this.components.indexOf(this.timeAxis2);-1!==i&&this.components.splice(i,1),this.timeAxis2.destroy(),this.timeAxis2=null}"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),"hiddenDates"in this.options&&xl(this.options.moment,this.body,this.options.hiddenDates),"clickToUse"in t&&(t.clickToUse?this.activator||(this.activator=new ic(this.dom.root)):this.activator&&(this.activator.destroy(),delete this.activator)),this._initAutoResize()}if(this.components.forEach((function(e){return e.setOptions(t)})),"configure"in t){this.configurator||(this.configurator=this._createConfigurator()),this.configurator.setOptions(t.configure);var n=bh.deepExtend({},this.options);this.components.forEach((function(t){bh.deepExtend(n,t.options)})),this.configurator.setModuleOptions({global:n})}this._redraw()}},{key:"isActive",value:function(){return!this.activator||this.activator.active}},{key:"destroy",value:function(){for(var t in this.setItems(null),this.setGroups(null),this.off(),this._stopAutoResize(),this.dom.root.parentNode&&this.dom.root.parentNode.removeChild(this.dom.root),this.dom=null,this.activator&&(this.activator.destroy(),delete this.activator),this.listeners)this.listeners.hasOwnProperty(t)&&delete this.listeners[t];this.listeners=null,this.hammer&&this.hammer.destroy(),this.hammer=null,this.components.forEach((function(t){return t.destroy()})),this.body=null}},{key:"setCustomTime",value:function(t,e){var i=this.customTimes.filter((function(t){return e===t.options.id}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(JSON.stringify(e)));i.length>0&&i[0].setCustomTime(t)}},{key:"getCustomTime",value:function(t){var e=this.customTimes.filter((function(e){return e.options.id===t}));if(0===e.length)throw new Error("No custom time bar found with id ".concat(JSON.stringify(t)));return e[0].getCustomTime()}},{key:"setCustomTimeMarker",value:function(t,e,i){var n=this.customTimes.filter((function(t){return t.options.id===e}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(JSON.stringify(e)));n.length>0&&n[0].setCustomMarker(t,i)}},{key:"setCustomTimeTitle",value:function(t,e){var i=this.customTimes.filter((function(t){return t.options.id===e}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(JSON.stringify(e)));if(i.length>0)return i[0].setCustomTitle(t)}},{key:"getEventProperties",value:function(t){return{event:t}}},{key:"addCustomTime",value:function(t,e){var i=void 0!==t?bh.convert(t,"Date").valueOf():new Date;if(this.customTimes.some((function(t){return t.options.id===e})))throw new Error("A custom time with id ".concat(JSON.stringify(e)," already exists"));var n=new rc(this.body,bh.extend({},this.options,{time:i,id:e}));return this.customTimes.push(n),this.components.push(n),this._redraw(),e}},{key:"removeCustomTime",value:function(t){var e=this,i=this.customTimes.filter((function(e){return e.options.id===t}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(JSON.stringify(t)));i.forEach((function(t){e.customTimes.splice(e.customTimes.indexOf(t),1),e.components.splice(e.components.indexOf(t),1),t.destroy()}))}},{key:"getVisibleItems",value:function(){return this.itemSet&&this.itemSet.getVisibleItems()||[]}},{key:"getVisibleGroups",value:function(){return this.itemSet&&this.itemSet.getVisibleGroups()||[]}},{key:"fit",value:function(t,e){var i=this.getDataRange();if(null!==i.min||null!==i.max){var n=i.max-i.min,r=new Date(i.min.valueOf()-.01*n),o=new Date(i.max.valueOf()+.01*n),s=!t||void 0===t.animation||t.animation;this.range.setRange(r,o,{animation:s},e)}}},{key:"getDataRange",value:function(){throw new Error("Cannot invoke abstract method getDataRange")}},{key:"setWindow",value:function(t,e,i,n){var r,o;"function"==typeof arguments[2]&&(n=arguments[2],i={}),1==arguments.length?(r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r})):2==arguments.length&&"function"==typeof arguments[1]?(o=arguments[0],n=arguments[1],r=void 0===o.animation||o.animation,this.range.setRange(o.start,o.end,{animation:r},n)):(r=!i||void 0===i.animation||i.animation,this.range.setRange(t,e,{animation:r},n))}},{key:"moveTo",value:function(t,e,i){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.range.end-this.range.start,r=bh.convert(t,"Date").valueOf(),o=r-n/2,s=r+n/2,a=!e||void 0===e.animation||e.animation;this.range.setRange(o,s,{animation:a},i)}},{key:"getWindow",value:function(){var t=this.range.getRange();return{start:new Date(t.start),end:new Date(t.end)}}},{key:"zoomIn",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=s/(1+t),h=(s-a)/2,l=r+h,u=o-h;this.setWindow(l,u,e,i)}}},{key:"zoomOut",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=r-s*t/2,h=o+s*t/2;this.setWindow(a,h,e,i)}}},{key:"redraw",value:function(){this._redraw()}},{key:"_redraw",value:function(){this.redrawCount++;var t=this.dom;if(t&&t.container&&0!=t.root.offsetWidth){var e=!1,i=this.options,n=this.props;Ml(this.options.moment,this.body,this.options.hiddenDates),"top"==i.orientation?(bh.addClassName(t.root,"vis-top"),bh.removeClassName(t.root,"vis-bottom")):(bh.removeClassName(t.root,"vis-top"),bh.addClassName(t.root,"vis-bottom")),i.rtl?(bh.addClassName(t.root,"vis-rtl"),bh.removeClassName(t.root,"vis-ltr")):(bh.addClassName(t.root,"vis-ltr"),bh.removeClassName(t.root,"vis-rtl")),t.root.style.maxHeight=bh.option.asSize(i.maxHeight,""),t.root.style.minHeight=bh.option.asSize(i.minHeight,""),t.root.style.width=bh.option.asSize(i.width,"");var r=t.root.clientHeight,o=t.root.offsetHeight,s=t.root.offsetWidth,a=t.centerContainer.clientHeight;n.border.left=(t.centerContainer.offsetWidth-t.centerContainer.clientWidth)/2,n.border.right=n.border.left,n.border.top=(t.centerContainer.offsetHeight-a)/2,n.border.bottom=n.border.top,n.borderRootHeight=o-r,n.borderRootWidth=s-t.root.clientWidth,0===a&&(n.border.left=n.border.top,n.border.right=n.border.left),0===r&&(n.borderRootWidth=n.borderRootHeight),n.center.height=t.center.offsetHeight,n.left.height=t.left.offsetHeight,n.right.height=t.right.offsetHeight,n.top.height=t.top.clientHeight||-n.border.top,n.bottom.height=t.bottom.clientHeight||-n.border.bottom;var h=Math.max(n.left.height,n.center.height,n.right.height),l=n.top.height+h+n.bottom.height+n.borderRootHeight+n.border.top+n.border.bottom;t.root.style.height=bh.option.asSize(i.height,"".concat(l,"px")),n.root.height=t.root.offsetHeight,n.background.height=n.root.height-n.borderRootHeight;var u=n.root.height-n.top.height-n.bottom.height-n.borderRootHeight;n.centerContainer.height=u,n.leftContainer.height=u,n.rightContainer.height=n.leftContainer.height,n.root.width=s,n.background.width=n.root.width-n.borderRootWidth,this.initialDrawDone||(n.scrollbarWidth=bh.getScrollBarWidth());var d=t.leftContainer.clientWidth,c=t.rightContainer.clientWidth;i.verticalScroll?i.rtl?(n.left.width=d||-n.border.left,n.right.width=c+n.scrollbarWidth||-n.border.right):(n.left.width=d+n.scrollbarWidth||-n.border.left,n.right.width=c||-n.border.right):(n.left.width=d||-n.border.left,n.right.width=c||-n.border.right),this._setDOM();var f=this._updateScrollTop();"top"!=i.orientation.item&&(f+=Math.max(n.centerContainer.height-n.center.height-n.border.top-n.border.bottom,0)),t.center.style.transform="translateY(".concat(f,"px)");var p=0==n.scrollTop?"hidden":"",m=n.scrollTop==n.scrollTopMin?"hidden":"";t.shadowTop.style.visibility=p,t.shadowBottom.style.visibility=m,t.shadowTopLeft.style.visibility=p,t.shadowBottomLeft.style.visibility=m,t.shadowTopRight.style.visibility=p,t.shadowBottomRight.style.visibility=m,i.verticalScroll&&(t.rightContainer.className="vis-panel vis-right vis-vertical-scroll",t.leftContainer.className="vis-panel vis-left vis-vertical-scroll",t.shadowTopRight.style.visibility="hidden",t.shadowBottomRight.style.visibility="hidden",t.shadowTopLeft.style.visibility="hidden",t.shadowBottomLeft.style.visibility="hidden",t.left.style.top="0px",t.right.style.top="0px"),(!i.verticalScroll||n.center.height<n.centerContainer.height)&&(t.left.style.top="".concat(f,"px"),t.right.style.top="".concat(f,"px"),t.rightContainer.className=t.rightContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),t.leftContainer.className=t.leftContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),n.left.width=d||-n.border.left,n.right.width=c||-n.border.right,this._setDOM());var g=n.center.height>n.centerContainer.height;this.hammer.get("pan").set({direction:g?$d.DIRECTION_ALL:$d.DIRECTION_HORIZONTAL}),this.components.forEach((function(t){e=t.redraw()||e}));if(e){if(this.redrawCount<5)return void this.body.emitter.emit("_change");console.log("WARNING: infinite loop in redraw?")}else this.redrawCount=0;this.body.emitter.emit("changed")}}},{key:"_setDOM",value:function(){var t=this.props,e=this.dom;t.leftContainer.width=t.left.width,t.rightContainer.width=t.right.width;var i=t.root.width-t.left.width-t.right.width-t.borderRootWidth;t.center.width=i,t.centerContainer.width=i,t.top.width=i,t.bottom.width=i,e.background.style.height="".concat(t.background.height,"px"),e.backgroundVertical.style.height="".concat(t.background.height,"px"),e.backgroundHorizontal.style.height="".concat(t.centerContainer.height,"px"),e.centerContainer.style.height="".concat(t.centerContainer.height,"px"),e.leftContainer.style.height="".concat(t.leftContainer.height,"px"),e.rightContainer.style.height="".concat(t.rightContainer.height,"px"),e.background.style.width="".concat(t.background.width,"px"),e.backgroundVertical.style.width="".concat(t.centerContainer.width,"px"),e.backgroundHorizontal.style.width="".concat(t.background.width,"px"),e.centerContainer.style.width="".concat(t.center.width,"px"),e.top.style.width="".concat(t.top.width,"px"),e.bottom.style.width="".concat(t.bottom.width,"px"),e.background.style.left="0",e.background.style.top="0",e.backgroundVertical.style.left="".concat(t.left.width+t.border.left,"px"),e.backgroundVertical.style.top="0",e.backgroundHorizontal.style.left="0",e.backgroundHorizontal.style.top="".concat(t.top.height,"px"),e.centerContainer.style.left="".concat(t.left.width,"px"),e.centerContainer.style.top="".concat(t.top.height,"px"),e.leftContainer.style.left="0",e.leftContainer.style.top="".concat(t.top.height,"px"),e.rightContainer.style.left="".concat(t.left.width+t.center.width,"px"),e.rightContainer.style.top="".concat(t.top.height,"px"),e.top.style.left="".concat(t.left.width,"px"),e.top.style.top="0",e.bottom.style.left="".concat(t.left.width,"px"),e.bottom.style.top="".concat(t.top.height+t.centerContainer.height,"px"),e.center.style.left="0",e.left.style.left="0",e.right.style.left="0"}},{key:"setCurrentTime",value:function(t){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");this.currentTime.setCurrentTime(t)}},{key:"getCurrentTime",value:function(){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");return this.currentTime.getCurrentTime()}},{key:"_toTime",value:function(t){return El(this,t,this.props.center.width)}},{key:"_toGlobalTime",value:function(t){return El(this,t,this.props.root.width)}},{key:"_toScreen",value:function(t){return Cl(this,t,this.props.center.width)}},{key:"_toGlobalScreen",value:function(t){return Cl(this,t,this.props.root.width)}},{key:"_initAutoResize",value:function(){1==this.options.autoResize?this._startAutoResize():this._stopAutoResize()}},{key:"_startAutoResize",value:function(){var t=this;this._stopAutoResize(),this._onResize=function(){if(1==t.options.autoResize){if(t.dom.root){var e=t.dom.root.offsetHeight,i=t.dom.root.offsetWidth;i==t.props.lastWidth&&e==t.props.lastHeight||(t.props.lastWidth=i,t.props.lastHeight=e,t.props.scrollbarWidth=bh.getScrollBarWidth(),t.body.emitter.emit("_change"))}}else t._stopAutoResize()},bh.addEventListener(window,"resize",this._onResize),t.dom.root&&(t.props.lastWidth=t.dom.root.offsetWidth,t.props.lastHeight=t.dom.root.offsetHeight),this.watchTimer=setInterval(this._onResize,1e3)}},{key:"_stopAutoResize",value:function(){this.watchTimer&&(clearInterval(this.watchTimer),this.watchTimer=void 0),this._onResize&&(bh.removeEventListener(window,"resize",this._onResize),this._onResize=null)}},{key:"_onTouch",value:function(t){this.touch.allowDragging=!0,this.touch.initialScrollTop=this.props.scrollTop}},{key:"_onPinch",value:function(t){this.touch.allowDragging=!1}},{key:"_onDrag",value:function(t){if(t&&this.touch.allowDragging){var e=t.deltaY,i=this._getScrollTop(),n=this._setScrollTop(this.touch.initialScrollTop+e);this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),n!=i&&this.emit("verticalDrag")}}},{key:"_setScrollTop",value:function(t){return this.props.scrollTop=t,this._updateScrollTop(),this.props.scrollTop}},{key:"_updateScrollTop",value:function(){var t=Math.min(this.props.centerContainer.height-this.props.center.height,0);return t!=this.props.scrollTopMin&&("top"!=this.options.orientation.item&&(this.props.scrollTop+=t-this.props.scrollTopMin),this.props.scrollTopMin=t),this.props.scrollTop>0&&(this.props.scrollTop=0),this.props.scrollTop<t&&(this.props.scrollTop=t),this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),this.props.scrollTop}},{key:"_getScrollTop",value:function(){return this.props.scrollTop}},{key:"_createConfigurator",value:function(){throw new Error("Cannot invoke abstract method _createConfigurator")}}]),t}();Wl(oc.prototype);var sc=function(t){function e(t,i){var n;Ma(this,e),(n=Ia(this,Ea(e).call(this))).body=t,n.defaultOptions={rtl:!1,showCurrentTime:!0,alignCurrentTime:void 0,moment:Dl,locales:nc,locale:"en"},n.options=bh.extend({},n.defaultOptions),n.setOptions(i),bh.extend(n.options.locales,nc,n.options.locales);var r=n.defaultOptions.locales[n.defaultOptions.locale];return Object.keys(n.options.locales).forEach((function(t){n.options.locales[t]=bh.extend({},r,n.options.locales[t])})),n.offset=0,n._create(),n}return Ca(e,t),Oa(e,[{key:"_create",value:function(){var t=document.createElement("div");t.className="vis-current-time",t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t}},{key:"destroy",value:function(){this.options.showCurrentTime=!1,this.redraw(),this.body=null}},{key:"setOptions",value:function(t){t&&bh.selectiveExtend(["rtl","showCurrentTime","alignCurrentTime","moment","locale","locales"],this.options,t)}},{key:"redraw",value:function(){if(this.options.showCurrentTime){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar),this.start());var e=this.options.moment(Date.now()+this.offset);this.options.alignCurrentTime&&(e=e.startOf(this.options.alignCurrentTime));var i=this.body.util.toScreen(e),n=this.options.locales[this.options.locale];n||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),n=this.options.locales.en);var r="".concat(n.current," ").concat(n.time,": ").concat(e.format("dddd, MMMM Do YYYY, H:mm:ss"));r=r.charAt(0).toUpperCase()+r.substring(1),this.options.rtl?this.bar.style.transform="translateX(".concat(-1*i,"px)"):this.bar.style.transform="translateX(".concat(i,"px)"),this.bar.title=r}else this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),this.stop();return!1}},{key:"start",value:function(){var t=this;!function e(){t.stop();var i=1/t.body.range.conversion(t.body.domProps.center.width).scale/10;i<30&&(i=30),i>1e3&&(i=1e3),t.redraw(),t.body.emitter.emit("currentTimeTick"),t.currentTimeTimer=setTimeout(e,i)}()}},{key:"stop",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),delete this.currentTimeTimer)}},{key:"setCurrentTime",value:function(t){var e=bh.convert(t,"Date").valueOf(),i=Date.now();this.offset=e-i,this.redraw()}},{key:"getCurrentTime",value:function(){return new Date(Date.now()+this.offset)}}]),e}(Sl),ac=se.find,hc=!0;"find"in[]&&Array(1).find((function(){hc=!1})),Et({target:"Array",proto:!0,forced:hc},{find:function(t){return ac(this,t,arguments.length>1?arguments[1]:void 0)}}),Mi("find");var lc=n((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,i,n,r,o){var s,a,h,l,u,d,c=ee(i,n,r?2:1);if(o)s=t;else{if("function"!=typeof(a=ui(t)))throw TypeError("Target is not iterable");if(oi(a)){for(h=0,l=ht(t.length);l>h;h++)if((u=r?c(P(d=t[h])[0],d[1]):c(t[h]))&&u instanceof e)return u;return new e(!1)}s=a.call(t)}for(;!(d=s.next()).done;)if((u=ei(s,c,d.value,r))&&u instanceof e)return u;return new e(!1)}).stop=function(t){return new e(!0,t)}})),uc=A.f,dc=Mr.fastKey,cc=Q.set,fc=Q.getterFor,pc=(function(t,e,i,n,r){var o=l[t],s=o&&o.prototype,a=o,h=n?"set":"add",d={},c=function(t){var e=s[t];tt(s,t,"add"==t?function(t){return e.call(this,0===t?0:t),this}:"delete"==t?function(t){return!(r&&!k(t))&&e.call(this,0===t?0:t)}:"get"==t?function(t){return r&&!k(t)?void 0:e.call(this,0===t?0:t)}:"has"==t?function(t){return!(r&&!k(t))&&e.call(this,0===t?0:t)}:function(t,i){return e.call(this,0===t?0:t,i),this})};if(Ot(t,"function"!=typeof o||!(r||s.forEach&&!u((function(){(new o).entries().next()})))))a=i.getConstructor(e,t,n,h),Mr.REQUIRED=!0;else if(Ot(t,!0)){var f=new a,p=f[h](r?{}:-0,1)!=f,m=u((function(){f.has(1)})),g=mi((function(t){new o(t)})),v=!r&&u((function(){for(var t=new o,e=5;e--;)t[h](e,e);return!t.has(-0)}));g||((a=e((function(e,i){Mn(e,a,t);var r=Qn(new o,e,a);return null!=i&&lc(i,r[h],r,n),r}))).prototype=s,s.constructor=a),(m||v)&&(c("delete"),c("has"),n&&c("get")),(v||p)&&c(h),r&&s.clear&&delete s.clear}d[t]=a,Et({global:!0,forced:a!=o},d),Qt(a,t),r||i.setStrong(a,t,n)}("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),{getConstructor:function(t,e,i,n){var r=t((function(t,o){Mn(t,r,e),cc(t,{type:e,index:Ht(null),first:void 0,last:void 0,size:0}),d||(t.size=0),null!=o&&lc(o,t[n],t,i)})),o=fc(e),s=function(t,e,i){var n,r,s=o(t),h=a(t,e);return h?h.value=i:(s.last=h={index:r=dc(e,!0),key:e,value:i,previous:n=s.last,next:void 0,removed:!1},s.first||(s.first=h),n&&(n.next=h),d?s.size++:t.size++,"F"!==r&&(s.index[r]=h)),t},a=function(t,e){var i,n=o(t),r=dc(e);if("F"!==r)return n.index[r];for(i=n.first;i;i=i.next)if(i.key==e)return i};return xn(r.prototype,{clear:function(){for(var t=o(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,d?t.size=0:this.size=0},delete:function(t){var e=o(this),i=a(this,t);if(i){var n=i.next,r=i.previous;delete e.index[i.index],i.removed=!0,r&&(r.next=n),n&&(n.previous=r),e.first==i&&(e.first=n),e.last==i&&(e.last=r),d?e.size--:this.size--}return!!i},forEach:function(t){for(var e,i=o(this),n=ee(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!a(this,t)}}),xn(r.prototype,i?{get:function(t){var e=a(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),d&&uc(r.prototype,"size",{get:function(){return o(this).size}}),r},setStrong:function(t,e,i){var n=e+" Iterator",r=fc(e),o=fc(n);Wi(t,e,(function(t,e){cc(this,{type:n,target:t,state:r(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?"keys"==e?{value:i.key,done:!1}:"values"==e?{value:i.value,done:!1}:{value:[i.key,i.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),i?"entries":"values",!i,!0),to(e)}}),ft.includes);Et({target:"Array",proto:!0},{includes:function(t){return pc(this,t,arguments.length>1?arguments[1]:void 0)}}),Mi("includes");var mc=function(t){if(Jr(t))throw TypeError("The method doesn't accept regular expressions");return t},gc=Xt("match");Et({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[gc]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~String(b(this)).indexOf(mc(t),arguments.length>1?arguments[1]:void 0)}});var vc=.001;function yc(t){t.sort((function(t,e){return t.data.start-e.data.start}))}function _c(t){t.sort((function(t,e){return("end"in t.data?t.data.end:t.data.start)-("end"in e.data?e.data.end:e.data.start)}))}function bc(t,e,i,n){if(i)for(var r=0;r<t.length;r++)t[r].top=null;for(r=0;r<t.length;r++){var o=t[r];if(o.stack&&null===o.top){o.top=e.axis;var s=!1;do{for(var a=null,h=0,l=t.length;h<l;h++){var u=t[h];if(s=n()||!1)return!0;if(null!==u.top&&u!==o&&u.stack&&xc(o,u,e.item,u.options.rtl)){a=u;break}}null!=a&&(o.top=a.top+a.height+e.item.vertical)}while(a)}}return s}function wc(t,e,i){for(var n=0;n<t.length;n++)t[n].top=null;var r=i.height;for(n=0;n<t.length;n++){var o=t[n];if(o.stack&&null===o.top){o.top=o.baseTop;do{for(var s=null,a=0,h=t.length;a<h;a++){var l=t[a];if(null!==l.top&&l!==o&&xc(o,l,e.item,l.options.rtl)){s=l;break}}null!=s&&(o.top=s.top+s.height+e.item.vertical),o.top+o.height>r&&(r=o.top+o.height)}while(s)}}i.height=r-i.top+.5*e.item.vertical}function kc(t,e,i,n){for(var r=0;r<t.length;r++)if(null==t[r].data.subgroup)t[r].top=e.item.vertical;else if(void 0!==t[r].data.subgroup&&n){var o=0;for(var s in i)i.hasOwnProperty(s)&&1==i[s].visible&&i[s].index<i[t[r].data.subgroup].index&&(o+=i[s].height,i[t[r].data.subgroup].top=o);t[r].top=o+.5*e.item.vertical}n||Dc(t,e,i)}function Dc(t,e,i){for(var n in i)if(i.hasOwnProperty(n)){i[n].top=0;do{var r=null;for(var o in i)if(null!==i[o].top&&o!==n&&i[n].index>i[o].index&&Mc(i[n],i[o])){r=i[o];break}null!=r&&(i[n].top=r.top+r.height)}while(r)}for(var s=0;s<t.length;s++)void 0!==t[s].data.subgroup&&(t[s].top=i[t[s].data.subgroup].top+.5*e.item.vertical)}function Sc(t,e,i){var n=!1,r=[];for(var o in i)i[o].hasOwnProperty("index")?r[i[o].index]=o:r.push(o);for(var s=0;s<r.length;s++)if(o=r[s],i.hasOwnProperty(o)){for(var a in n=n||i[o].stack,i[o].top=0,i)i[a].visible&&i[o].index>i[a].index&&(i[o].top+=i[a].height);for(var h=t[o],l=0;l<h.length;l++)void 0!==h[l].data.subgroup&&(h[l].top=i[h[l].data.subgroup].top+.5*e.item.vertical,i[o].stack&&(h[l].baseTop=h[l].top));n&&i[o].stack&&wc(t[o],e,i[o])}}function xc(t,e,i,n){return n?t.right-i.horizontal+vc<e.right+e.width&&t.right+t.width+i.horizontal-vc>e.right&&t.top-i.vertical+vc<e.top+e.height&&t.top+t.height+i.vertical-vc>e.top:t.left-i.horizontal+vc<e.left+e.width&&t.left+t.width+i.horizontal-vc>e.left&&t.top-i.vertical+vc<e.top+e.height&&t.top+t.height+i.vertical-vc>e.top}function Mc(t,e){return t.start<=e.start&&t.end>=e.start&&t.top<e.top+e.height&&t.top+t.height>e.top||e.start<=t.start&&e.end>=t.start&&e.top<t.top+t.height&&e.top+e.height>t.top}var Tc=Object.freeze({orderByStart:yc,orderByEnd:_c,stack:bc,substack:wc,nostack:kc,stackSubgroups:Dc,stackSubgroupsWithInnerStack:Sc,collision:xc,collisionByTimes:Mc}),Oc="__background__",Cc=function(){function t(e,i,n){if(Ma(this,t),this.groupId=e,this.subgroups={},this.subgroupStack={},this.subgroupStackAll=!1,this.subgroupVisibility={},this.doInnerStack=!1,this.shouldBailStackItems=!1,this.subgroupIndex=0,this.subgroupOrderer=i&&i.subgroupOrder,this.itemSet=n,this.isVisible=null,this.stackDirty=!0,i&&i.nestedGroups&&(this.nestedGroups=i.nestedGroups,0==i.showNested?this.showNested=!1:this.showNested=!0),i&&i.subgroupStack)if("boolean"==typeof i.subgroupStack)this.doInnerStack=i.subgroupStack,this.subgroupStackAll=i.subgroupStack;else for(var r in i.subgroupStack)this.subgroupStack[r]=i.subgroupStack[r],this.doInnerStack=this.doInnerStack||i.subgroupStack[r];i&&i.heightMode?this.heightMode=i.heightMode:this.heightMode=n.options.groupHeightMode,this.nestedInGroup=null,this.dom={},this.props={label:{width:0,height:0}},this.className=null,this.items={},this.visibleItems=[],this.itemsInRange=[],this.orderedItems={byStart:[],byEnd:[]},this.checkRangedItems=!1;var o=this;this.itemSet.body.emitter.on("checkRangedItems",(function(){o.checkRangedItems=!0})),this._create(),this.setData(i)}return Oa(t,[{key:"_create",value:function(){var t=document.createElement("div");this.itemSet.options.groupEditable.order?t.className="vis-label draggable":t.className="vis-label",this.dom.label=t;var e=document.createElement("div");e.className="vis-inner",t.appendChild(e),this.dom.inner=e;var i=document.createElement("div");i.className="vis-group",i["vis-group"]=this,this.dom.foreground=i,this.dom.background=document.createElement("div"),this.dom.background.className="vis-group",this.dom.axis=document.createElement("div"),this.dom.axis.className="vis-group",this.dom.marker=document.createElement("div"),this.dom.marker.style.visibility="hidden",this.dom.marker.style.position="absolute",this.dom.marker.innerHTML="",this.dom.background.appendChild(this.dom.marker)}},{key:"setData",value:function(t){if(!this.itemSet.groupTouchParams.isDragging){var e,i;if(t&&t.subgroupVisibility)for(var n in t.subgroupVisibility)this.subgroupVisibility[n]=t.subgroupVisibility[n];if((e=this.itemSet.options&&this.itemSet.options.groupTemplate?(i=this.itemSet.options.groupTemplate.bind(this))(t,this.dom.inner):t&&t.content)instanceof Element){for(;this.dom.inner.firstChild;)this.dom.inner.removeChild(this.dom.inner.firstChild);this.dom.inner.appendChild(e)}else e instanceof Object&&e.isReactComponent||(e instanceof Object?i(t,this.dom.inner):this.dom.inner.innerHTML=null!=e?e:this.groupId||"");this.dom.label.title=t&&t.title||"",this.dom.inner.firstChild?bh.removeClassName(this.dom.inner,"vis-hidden"):bh.addClassName(this.dom.inner,"vis-hidden"),t&&t.nestedGroups?(this.nestedGroups&&this.nestedGroups==t.nestedGroups||(this.nestedGroups=t.nestedGroups),void 0===t.showNested&&void 0!==this.showNested||(0==t.showNested?this.showNested=!1:this.showNested=!0),bh.addClassName(this.dom.label,"vis-nesting-group"),this.showNested?(bh.removeClassName(this.dom.label,"collapsed"),bh.addClassName(this.dom.label,"expanded")):(bh.removeClassName(this.dom.label,"expanded"),bh.addClassName(this.dom.label,"collapsed"))):this.nestedGroups&&(this.nestedGroups=null,bh.removeClassName(this.dom.label,"collapsed"),bh.removeClassName(this.dom.label,"expanded"),bh.removeClassName(this.dom.label,"vis-nesting-group")),t&&(t.treeLevel||t.nestedInGroup)?(bh.addClassName(this.dom.label,"vis-nested-group"),t.treeLevel?bh.addClassName(this.dom.label,"vis-group-level-"+t.treeLevel):bh.addClassName(this.dom.label,"vis-group-level-unknown-but-gte1")):bh.addClassName(this.dom.label,"vis-group-level-0");var r=t&&t.className||null;r!=this.className&&(this.className&&(bh.removeClassName(this.dom.label,this.className),bh.removeClassName(this.dom.foreground,this.className),bh.removeClassName(this.dom.background,this.className),bh.removeClassName(this.dom.axis,this.className)),bh.addClassName(this.dom.label,r),bh.addClassName(this.dom.foreground,r),bh.addClassName(this.dom.background,r),bh.addClassName(this.dom.axis,r),this.className=r),this.style&&(bh.removeCssText(this.dom.label,this.style),this.style=null),t&&t.style&&(bh.addCssText(this.dom.label,t.style),this.style=t.style)}}},{key:"getLabelWidth",value:function(){return this.props.label.width}},{key:"_didMarkerHeightChange",value:function(){var t=this.dom.marker.clientHeight;if(t!=this.lastMarkerHeight){this.lastMarkerHeight=t;var e={},i=0;if(bh.forEach(this.items,(function(t,n){if(t.dirty=!0,t.displayed){e[n]=t.redraw(!0),i=e[n].length}})),i>0)for(var n=function(t){bh.forEach(e,(function(e){e[t]()}))},r=0;r<i;r++)n(r);return!0}return!1}},{key:"_calculateGroupSizeAndPosition",value:function(){var t=this.dom.foreground,e=t.offsetTop,i=t.offsetLeft,n=t.offsetWidth;this.top=e,this.right=i,this.width=n}},{key:"_shouldBailItemsRedraw",value:function(){var t=this,e=this.itemSet.options.onTimeout,i={relativeBailingTime:this.itemSet.itemsSettingTime,bailTimeMs:e&&e.timeoutMs,userBailFunction:e&&e.callback,shouldBailStackItems:this.shouldBailStackItems},n=null;if(!this.itemSet.initialDrawDone){if(i.shouldBailStackItems)return!0;Math.abs(Date.now()-new Date(i.relativeBailingTime))>i.bailTimeMs&&(i.userBailFunction&&null==this.itemSet.userContinueNotBail?i.userBailFunction((function(e){t.itemSet.userContinueNotBail=e,n=!e})):n=0==t.itemSet.userContinueNotBail)}return n}},{key:"_redrawItems",value:function(t,e,i,n){var r=this;if(t||this.stackDirty||this.isVisible&&!e){var o={},s={byEnd:this.orderedItems.byEnd.filter((function(t){return!t.isCluster})),byStart:this.orderedItems.byStart.filter((function(t){return!t.isCluster}))},a={byEnd:Aa(new Set(this.orderedItems.byEnd.map((function(t){return t.cluster})).filter((function(t){return!!t})))),byStart:Aa(new Set(this.orderedItems.byStart.map((function(t){return t.cluster})).filter((function(t){return!!t}))))},h=function(){var t=r._updateItemsInRange(s,r.visibleItems.filter((function(t){return!t.isCluster})),n),e=r._updateClustersInRange(a,r.visibleItems.filter((function(t){return t.isCluster})),n);return[].concat(Aa(t),Aa(e))};if("function"==typeof this.itemSet.options.order)!function(){var t=r;if(r.doInnerStack&&r.itemSet.options.stackSubgroups){for(var e in r.subgroups)o[e]=r.subgroups[e].items.slice().sort((function(e,i){return t.itemSet.options.order(e.data,i.data)}));Sc(o,i,r.subgroups),r.visibleItems=h()}else{r.visibleItems=h();var n=r.visibleItems.slice().filter((function(t){return t.isCluster||!t.isCluster&&!t.cluster})).sort((function(e,i){return t.itemSet.options.order(e.data,i.data)}));r.shouldBailStackItems=bc(n,i,!0,r._shouldBailItemsRedraw.bind(r))}}();else{var l=this._updateItemsInRange(s,this.visibleItems.filter((function(t){return!t.isCluster})),n),u=this._updateClustersInRange(a,this.visibleItems.filter((function(t){return t.isCluster})),n);if(this.visibleItems=[].concat(Aa(l),Aa(u)),this.itemSet.options.stack)if(this.doInnerStack&&this.itemSet.options.stackSubgroups){for(var d in this.subgroups)o[d]=this.subgroups[d].items;Sc(o,i,this.subgroups)}else this.shouldBailStackItems=bc(this.visibleItems,i,!0,this._shouldBailItemsRedraw.bind(this));else kc(this.visibleItems,i,this.subgroups,this.itemSet.options.stackSubgroups)}for(var c=0;c<this.visibleItems.length;c++)this.visibleItems[c].repositionX(),void 0!==this.subgroupVisibility[this.visibleItems[c].data.subgroup]&&(this.subgroupVisibility[this.visibleItems[c].data.subgroup]||this.visibleItems[c].hide());this.itemSet.options.cluster&&bh.forEach(this.items,(function(t){t.cluster&&t.displayed&&t.hide()})),this.shouldBailStackItems&&this.itemSet.body.emitter.emit("destroyTimeline"),this.stackDirty=!1}}},{key:"_didResize",value:function(t,e){t=bh.updateProperty(this,"height",e)||t;var i=this.dom.inner.clientWidth,n=this.dom.inner.clientHeight;return t=bh.updateProperty(this.props.label,"width",i)||t,t=bh.updateProperty(this.props.label,"height",n)||t}},{key:"_applyGroupHeight",value:function(t){this.dom.background.style.height="".concat(t,"px"),this.dom.foreground.style.height="".concat(t,"px"),this.dom.label.style.height="".concat(t,"px")}},{key:"_updateItemsVerticalPosition",value:function(t){for(var e=0,i=this.visibleItems.length;e<i;e++){var n=this.visibleItems[e];n.repositionY(t),this.isVisible||this.groupId==Oc||n.displayed&&n.hide()}}},{key:"redraw",value:function(t,e,i,n){var r,o,s=this,a=!1,h=this.isVisible,l=[function(){i=s._didMarkerHeightChange.call(s)||i},this._updateSubGroupHeights.bind(this,e),this._calculateGroupSizeAndPosition.bind(this),function(){s.isVisible=s._isGroupVisible.bind(s)(t,e)},function(){s._redrawItems.bind(s)(i,h,e,t)},this._updateSubgroupsSizes.bind(this),function(){r=s._calculateHeight.bind(s)(e)},this._calculateGroupSizeAndPosition.bind(this),function(){a=s._didResize.bind(s)(a,r)},function(){s._applyGroupHeight.bind(s)(r)},function(){s._updateItemsVerticalPosition.bind(s)(e)},function(){return!s.isVisible&&s.height&&(a=!1),a}.bind(this)];return n?l:(l.forEach((function(t){o=t()})),o)}},{key:"_updateSubGroupHeights",value:function(t){var e=this;if(Object.keys(this.subgroups).length>0){var i=this;this._resetSubgroups(),bh.forEach(this.visibleItems,(function(n){void 0!==n.data.subgroup&&(i.subgroups[n.data.subgroup].height=Math.max(i.subgroups[n.data.subgroup].height,n.height+t.item.vertical),i.subgroups[n.data.subgroup].visible=void 0===e.subgroupVisibility[n.data.subgroup]||Boolean(e.subgroupVisibility[n.data.subgroup]))}))}}},{key:"_isGroupVisible",value:function(t,e){return this.top<=t.body.domProps.centerContainer.height-t.body.domProps.scrollTop+e.axis&&this.top+this.height+e.axis>=-t.body.domProps.scrollTop}},{key:"_calculateHeight",value:function(t){var e,i;if((i="fixed"===this.heightMode?bh.toArray(this.items):this.visibleItems).length>0){var n=i[0].top,r=i[0].top+i[0].height;if(bh.forEach(i,(function(t){n=Math.min(n,t.top),r=Math.max(r,t.top+t.height)})),n>t.axis){var o=n-t.axis;r-=o,bh.forEach(i,(function(t){t.top-=o}))}e=r+t.item.vertical/2,"fitItems"!==this.heightMode&&(e=Math.max(e,this.props.label.height))}else e=this.props.label.height;return e}},{key:"show",value:function(){this.dom.label.parentNode||this.itemSet.dom.labelSet.appendChild(this.dom.label),this.dom.foreground.parentNode||this.itemSet.dom.foreground.appendChild(this.dom.foreground),this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background),this.dom.axis.parentNode||this.itemSet.dom.axis.appendChild(this.dom.axis)}},{key:"hide",value:function(){var t=this.dom.label;t.parentNode&&t.parentNode.removeChild(t);var e=this.dom.foreground;e.parentNode&&e.parentNode.removeChild(e);var i=this.dom.background;i.parentNode&&i.parentNode.removeChild(i);var n=this.dom.axis;n.parentNode&&n.parentNode.removeChild(n)}},{key:"add",value:function(t){if(this.items[t.id]=t,t.setParent(this),this.stackDirty=!0,void 0!==t.data.subgroup&&(this._addToSubgroup(t),this.orderSubgroups()),!this.visibleItems.includes(t)){var e=this.itemSet.body.range;this._checkIfVisible(t,this.visibleItems,e)}}},{key:"_addToSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;null!=e&&void 0===this.subgroups[e]&&(this.subgroups[e]={height:0,top:0,start:t.data.start,end:t.data.end||t.data.start,visible:!1,index:this.subgroupIndex,items:[],stack:this.subgroupStackAll||this.subgroupStack[e]||!1},this.subgroupIndex++),new Date(t.data.start)<new Date(this.subgroups[e].start)&&(this.subgroups[e].start=t.data.start);var i=t.data.end||t.data.start;new Date(i)>new Date(this.subgroups[e].end)&&(this.subgroups[e].end=i),this.subgroups[e].items.push(t)}},{key:"_updateSubgroupsSizes",value:function(){var t=this;if(t.subgroups){var e=function(e){var i=t.subgroups[e].items[0].data.end||t.subgroups[e].items[0].data.start,n=t.subgroups[e].items[0].data.start,r=i-1;t.subgroups[e].items.forEach((function(t){new Date(t.data.start)<new Date(n)&&(n=t.data.start);var e=t.data.end||t.data.start;new Date(e)>new Date(r)&&(r=e)})),t.subgroups[e].start=n,t.subgroups[e].end=new Date(r-1)};for(var i in t.subgroups)e(i)}}},{key:"orderSubgroups",value:function(){if(void 0!==this.subgroupOrderer){var t=[];if("string"==typeof this.subgroupOrderer){for(var e in this.subgroups)t.push({subgroup:e,sortField:this.subgroups[e].items[0].data[this.subgroupOrderer]});t.sort((function(t,e){return t.sortField-e.sortField}))}else if("function"==typeof this.subgroupOrderer){for(var i in this.subgroups)t.push(this.subgroups[i].items[0].data);t.sort(this.subgroupOrderer)}if(t.length>0)for(var n=0;n<t.length;n++)this.subgroups[t[n].subgroup].index=n}}},{key:"_resetSubgroups",value:function(){for(var t in this.subgroups)this.subgroups.hasOwnProperty(t)&&(this.subgroups[t].visible=!1,this.subgroups[t].height=0)}},{key:"remove",value:function(t){delete this.items[t.id],t.setParent(null),this.stackDirty=!0;var e=this.visibleItems.indexOf(t);-1!=e&&this.visibleItems.splice(e,1),void 0!==t.data.subgroup&&(this._removeFromSubgroup(t),this.orderSubgroups())}},{key:"_removeFromSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;if(null!=e){var i=this.subgroups[e];if(i){var n=i.items.indexOf(t);n>=0&&(i.items.splice(n,1),i.items.length?this._updateSubgroupsSizes():delete this.subgroups[e])}}}},{key:"removeFromDataSet",value:function(t){this.itemSet.removeItem(t.id)}},{key:"order",value:function(){for(var t=bh.toArray(this.items),e=[],i=[],n=0;n<t.length;n++)void 0!==t[n].data.end&&i.push(t[n]),e.push(t[n]);this.orderedItems={byStart:e,byEnd:i},yc(this.orderedItems.byStart),_c(this.orderedItems.byEnd)}},{key:"_updateItemsInRange",value:function(t,e,i){var n=[],r={};if(!this.isVisible&&this.groupId!=Oc){for(var o=0;o<e.length;o++){var s=e[o];s.displayed&&s.hide()}return n}var a=(i.end-i.start)/4,h=i.start-a,l=i.end+a;if(e.length>0)for(var u=0;u<e.length;u++)this._checkIfVisibleWithReference(e[u],n,r,i);var d=bh.binarySearchCustom(t.byStart,(function(t){return t<h?-1:t<=l?0:1}),"data","start");if(this._traceVisible(d,t.byStart,n,r,(function(t){return t.data.start<h||t.data.start>l})),1==this.checkRangedItems){this.checkRangedItems=!1;for(var c=0;c<t.byEnd.length;c++)this._checkIfVisibleWithReference(t.byEnd[c],n,r,i)}else{var f=bh.binarySearchCustom(t.byEnd,(function(t){return t<h?-1:0}),"data","end");this._traceVisible(f,t.byEnd,n,r,(function(t){return t.data.end<h||t.data.start>l}))}for(var p={},m=0,g=0;g<n.length;g++){var v=n[g];if(!v.displayed){p[g]=v.redraw(!0),m=p[g].length}}if(m>0)for(var y=function(t){bh.forEach(p,(function(e){e[t]()}))},_=0;_<m;_++)y(_);for(var b=0;b<n.length;b++)n[b].repositionX();return n}},{key:"_traceVisible",value:function(t,e,i,n,r){if(-1!=t){for(var o=t;o>=0;o--){var s=e[o];if(r(s))break;s.isCluster&&!s.hasItems()||s.cluster||void 0===n[s.id]&&(n[s.id]=!0,i.push(s))}for(var a=t+1;a<e.length;a++){var h=e[a];if(r(h))break;h.isCluster&&!h.hasItems()||h.cluster||void 0===n[h.id]&&(n[h.id]=!0,i.push(h))}}}},{key:"_checkIfVisible",value:function(t,e,i){t.isVisible(i)?(t.displayed||t.show(),t.repositionX(),e.push(t)):t.displayed&&t.hide()}},{key:"_checkIfVisibleWithReference",value:function(t,e,i,n){t.isVisible(n)?void 0===i[t.id]&&(i[t.id]=!0,e.push(t)):t.displayed&&t.hide()}},{key:"_updateClustersInRange",value:function(t,e,i){var n=[],r={};if(e.length>0)for(var o=0;o<e.length;o++)this._checkIfVisibleWithReference(e[o],n,r,i);for(var s=0;s<t.byStart.length;s++)this._checkIfVisibleWithReference(t.byStart[s],n,r,i);for(var a=0;a<t.byEnd.length;a++)this._checkIfVisibleWithReference(t.byEnd[a],n,r,i);for(var h={},l=0,u=0;u<n.length;u++){var d=n[u];if(!d.displayed){h[u]=d.redraw(!0),l=h[u].length}}if(l>0)for(var c=0;c<l;c++)bh.forEach(h,(function(t){t[c]()}));for(var f=0;f<n.length;f++)n[f].repositionX();return n}},{key:"changeSubgroup",value:function(t,e,i){this._removeFromSubgroup(t,e),this._addToSubgroup(t,i),this.orderSubgroups()}}]),t}(),Ec=function(t){function e(t,i,n){var r;return Ma(this,e),(r=Ia(this,Ea(e).call(this,t,i,n))).width=0,r.height=0,r.top=0,r.left=0,r}return Ca(e,t),Oa(e,[{key:"redraw",value:function(t,e,i){this.visibleItems=this._updateItemsInRange(this.orderedItems,this.visibleItems,t),this.width=this.dom.background.offsetWidth,this.dom.background.style.height="0";for(var n=0,r=this.visibleItems.length;n<r;n++){this.visibleItems[n].repositionY(e)}return!1}},{key:"show",value:function(){this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background)}}]),e}(Cc),Yc=function(){function t(e,i,n){var r=this;Ma(this,t),this.id=null,this.parent=null,this.data=e,this.dom=null,this.conversion=i||{},this.defaultOptions={locales:nc,locale:"en"},this.options=bh.extend({},this.defaultOptions,n),bh.extend(this.options.locales,nc,this.options.locales);var o=this.defaultOptions.locales[this.defaultOptions.locale];Object.keys(this.options.locales).forEach((function(t){r.options.locales[t]=bh.extend({},o,r.options.locales[t])})),this.selected=!1,this.displayed=!1,this.groupShowing=!0,this.selectable=n&&n.selectable||!1,this.dirty=!0,this.top=null,this.right=null,this.left=null,this.width=null,this.height=null,this.setSelectability(e),this.editable=null,this._updateEditStatus()}return Oa(t,[{key:"select",value:function(){this.selectable&&(this.selected=!0,this.dirty=!0,this.displayed&&this.redraw())}},{key:"unselect",value:function(){this.selected=!1,this.dirty=!0,this.displayed&&this.redraw()}},{key:"setData",value:function(t){null!=t.group&&this.data.group!=t.group&&null!=this.parent&&this.parent.itemSet._moveToGroup(this,t.group),this.setSelectability(t),this.parent&&(this.parent.stackDirty=!0),null!=t.subgroup&&this.data.subgroup!=t.subgroup&&null!=this.parent&&this.parent.changeSubgroup(this,this.data.subgroup,t.subgroup),this.data=t,this._updateEditStatus(),this.dirty=!0,this.displayed&&this.redraw()}},{key:"setSelectability",value:function(t){t&&(this.selectable=void 0===t.selectable||Boolean(t.selectable))}},{key:"setParent",value:function(t){this.displayed?(this.hide(),this.parent=t,this.parent&&this.show()):this.parent=t}},{key:"isVisible",value:function(t){return!1}},{key:"show",value:function(){return!1}},{key:"hide",value:function(){return!1}},{key:"redraw",value:function(){}},{key:"repositionX",value:function(){}},{key:"repositionY",value:function(){}},{key:"_repaintDragCenter",value:function(){if(this.selected&&this.options.editable.updateTime&&!this.dom.dragCenter){var t=this,e=document.createElement("div");e.className="vis-drag-center",e.dragCenterItem=this,this.hammerDragCenter=new $d(e),this.hammerDragCenter.on("tap",(function(e){t.parent.itemSet.body.emitter.emit("click",{event:e,item:t.id})})),this.hammerDragCenter.on("doubletap",(function(e){e.stopPropagation(),t.parent.itemSet._onUpdateItem(t),t.parent.itemSet.body.emitter.emit("doubleClick",{event:e,item:t.id})})),this.hammerDragCenter.on("panstart",t.parent.itemSet._onDragStart.bind(t.parent.itemSet)),this.hammerDragCenter.on("panmove",t.parent.itemSet._onDrag.bind(t.parent.itemSet)),this.hammerDragCenter.on("panend",t.parent.itemSet._onDragEnd.bind(t.parent.itemSet)),this.dom.box?this.dom.dragLeft?this.dom.box.insertBefore(e,this.dom.dragLeft):this.dom.box.appendChild(e):this.dom.point&&this.dom.point.appendChild(e),this.dom.dragCenter=e}else!this.selected&&this.dom.dragCenter&&(this.dom.dragCenter.parentNode&&this.dom.dragCenter.parentNode.removeChild(this.dom.dragCenter),this.dom.dragCenter=null,this.hammerDragCenter&&(this.hammerDragCenter.destroy(),this.hammerDragCenter=null))}},{key:"_repaintDeleteButton",value:function(t){var e=(this.options.editable.overrideItems||null==this.editable)&&this.options.editable.remove||!this.options.editable.overrideItems&&null!=this.editable&&this.editable.remove;if(this.selected&&e&&!this.dom.deleteButton){var i=this,n=document.createElement("div");this.options.rtl?n.className="vis-delete-rtl":n.className="vis-delete";var r=this.options.locales[this.options.locale];r||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),r=this.options.locales.en),n.title=r.deleteSelected,this.hammerDeleteButton=new $d(n).on("tap",(function(t){t.stopPropagation(),i.parent.removeFromDataSet(i)})),t.appendChild(n),this.dom.deleteButton=n}else!this.selected&&this.dom.deleteButton&&(this.dom.deleteButton.parentNode&&this.dom.deleteButton.parentNode.removeChild(this.dom.deleteButton),this.dom.deleteButton=null,this.hammerDeleteButton&&(this.hammerDeleteButton.destroy(),this.hammerDeleteButton=null))}},{key:"_repaintOnItemUpdateTimeTooltip",value:function(t){if(this.options.tooltipOnItemUpdateTime){var e=(this.options.editable.updateTime||!0===this.data.editable)&&!1!==this.data.editable;if(this.selected&&e&&!this.dom.onItemUpdateTimeTooltip){var i=document.createElement("div");i.className="vis-onUpdateTime-tooltip",t.appendChild(i),this.dom.onItemUpdateTimeTooltip=i}else!this.selected&&this.dom.onItemUpdateTimeTooltip&&(this.dom.onItemUpdateTimeTooltip.parentNode&&this.dom.onItemUpdateTimeTooltip.parentNode.removeChild(this.dom.onItemUpdateTimeTooltip),this.dom.onItemUpdateTimeTooltip=null);if(this.dom.onItemUpdateTimeTooltip){this.dom.onItemUpdateTimeTooltip.style.visibility=this.parent.itemSet.touchParams.itemIsDragging?"visible":"hidden",this.dom.onItemUpdateTimeTooltip.style.transform="translateX(-50%)",this.dom.onItemUpdateTimeTooltip.style.left="50%";var n,r=this.parent.itemSet.body.domProps.scrollTop;("top"==this.options.orientation.item?this.top:this.parent.height-this.top-this.height)+this.parent.top-50<-r?(this.dom.onItemUpdateTimeTooltip.style.bottom="",this.dom.onItemUpdateTimeTooltip.style.top="".concat(this.height+2,"px")):(this.dom.onItemUpdateTimeTooltip.style.top="",this.dom.onItemUpdateTimeTooltip.style.bottom="".concat(this.height+2,"px")),this.options.tooltipOnItemUpdateTime&&this.options.tooltipOnItemUpdateTime.template?n=this.options.tooltipOnItemUpdateTime.template.bind(this)(this.data):(n="start: ".concat(Dl(this.data.start).format("MM/DD/YYYY hh:mm")),this.data.end&&(n+="<br> end: ".concat(Dl(this.data.end).format("MM/DD/YYYY hh:mm")))),this.dom.onItemUpdateTimeTooltip.innerHTML=n}}}},{key:"_getItemData",value:function(){return this.parent.itemSet.itemsData.get(this.id)}},{key:"_updateContents",value:function(t){var e,i,n,r,o=this._getItemData(),s=(this.dom.box||this.dom.point).getElementsByClassName("vis-item-visible-frame")[0];if(n=this.options.visibleFrameTemplate?(r=this.options.visibleFrameTemplate.bind(this))(o,s):"",s)if(n instanceof Object&&!(n instanceof Element))r(o,s);else if(this._contentToString(this.itemVisibleFrameContent)!==this._contentToString(n)){if(n instanceof Element)s.innerHTML="",s.appendChild(n);else if(null!=n)s.innerHTML=n;else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.itemVisibleFrameContent=n}if((e=this.options.template?(i=this.options.template.bind(this))(o,t,this.data):this.data.content)instanceof Object&&!(e instanceof Element))i(o,t);else if(this._contentToString(this.content)!==this._contentToString(e)){if(e instanceof Element)t.innerHTML="",t.appendChild(e);else if(null!=e)t.innerHTML=e;else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.content=e}}},{key:"_updateDataAttributes",value:function(t){if(this.options.dataAttributes&&this.options.dataAttributes.length>0){var e=[];if(Array.isArray(this.options.dataAttributes))e=this.options.dataAttributes;else{if("all"!=this.options.dataAttributes)return;e=Object.keys(this.data)}var i=!0,n=!1,r=void 0;try{for(var o,s=e[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value,h=this.data[a];null!=h?t.setAttribute("data-".concat(a),h):t.removeAttribute("data-".concat(a))}}catch(t){n=!0,r=t}finally{try{i||null==s.return||s.return()}finally{if(n)throw r}}}}},{key:"_updateStyle",value:function(t){this.style&&(bh.removeCssText(t,this.style),this.style=null),this.data.style&&(bh.addCssText(t,this.data.style),this.style=this.data.style)}},{key:"_contentToString",value:function(t){return"string"==typeof t?t:t&&"outerHTML"in t?t.outerHTML:t}},{key:"_updateEditStatus",value:function(){this.options&&("boolean"==typeof this.options.editable?this.editable={updateTime:this.options.editable,updateGroup:this.options.editable,remove:this.options.editable}:"object"===xa(this.options.editable)&&(this.editable={},bh.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.options.editable))),this.options&&this.options.editable&&!0===this.options.editable.overrideItems||this.data&&("boolean"==typeof this.data.editable?this.editable={updateTime:this.data.editable,updateGroup:this.data.editable,remove:this.data.editable}:"object"===xa(this.data.editable)&&(this.editable={},bh.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.data.editable)))}},{key:"getWidthLeft",value:function(){return 0}},{key:"getWidthRight",value:function(){return 0}},{key:"getTitle",value:function(){return this.options.tooltip&&this.options.tooltip.template?this.options.tooltip.template.bind(this)(this._getItemData(),this.data):this.data.title}}]),t}();Yc.prototype.stack=!0;var Pc=function(t){function e(t,i,n){var r;if(Ma(this,e),(r=Ia(this,Ea(e).call(this))).props={dot:{width:0,height:0},line:{width:0,height:0}},r.options=n,t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return Yc.call(Pa(r),t,i,n),r}return Ca(e,t),Oa(e,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e,i=this.data.align||this.options.align,n=this.width*t.getMillisecondsPerPixel();return e="right"==i?this.data.start.getTime()>t.start&&this.data.start.getTime()-n<t.end:"left"==i?this.data.start.getTime()+n>t.start&&this.data.start.getTime()<t.end:this.data.start.getTime()+n/2>t.start&&this.data.start.getTime()-n/2<t.end,e}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-line",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-dot",this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}if(!this.dom.line.parentNode){var e=this.parent.dom.background;if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className="vis-item vis-box".concat(e),this.dom.line.className="vis-item vis-line".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},dot:{height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},line:{width:this.dom.line.offsetWidth},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.props.dot.height=t.dot.height,this.props.dot.width=t.dot.width,this.props.line.width=t.line.width,this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.box)}},{key:"redraw",value:function(t){var e,i,n=this,r=[this._createDomElement.bind(this),this._appendDomElement.bind(this),this._updateDirtyDomComponents.bind(this),function(){n.dirty&&(e=n._getDomComponentsSizes())},function(){n.dirty&&n._updateDomComponentsSizes.bind(n)(e)},this._repaintDomAdditionals.bind(this)];return t?r:(r.forEach((function(t){i=t()})),i)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.remove(),t.line.parentNode&&t.line.remove(),t.dot.parentNode&&t.dot.remove(),this.displayed=!1}}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(void 0!==e||void 0!==i){var r=n?-1*e:e;t.style.transform=void 0!==i?void 0!==e?"translate(".concat(r,"px, ").concat(i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.box,this.boxX,this.boxY,t),e(this.dom.dot,this.dotX,this.dotY,t),e(this.dom.line,this.lineX,this.lineY,t)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.options.align,i=this.props.line.width,n=this.props.dot.width;"right"==e?(this.boxX=t-this.width,this.lineX=t-i,this.dotX=t-i/2-n/2):"left"==e?(this.boxX=t,this.lineX=t,this.dotX=t+i/2-n/2):(this.boxX=t-this.width/2,this.lineX=this.options.rtl?t-i:t-i/2,this.dotX=t-n/2),this.options.rtl?this.right=this.boxX:this.left=this.boxX,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.line.style;if("top"==t){var i=this.parent.top+this.top+1;this.boxY=this.top||0,e.height="".concat(i,"px"),e.bottom="",e.top="0"}else{var n=this.parent.itemSet.props.height-this.parent.top-this.parent.height+this.top;this.boxY=this.parent.height-this.top-(this.height||0),e.height="".concat(n,"px"),e.top="",e.bottom="0"}this.dotY=-this.props.dot.height/2,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}}]),e}(Yc),Ic=function(t){function e(t,i,n){var r;if(Ma(this,e),(r=Ia(this,Ea(e).call(this))).props={dot:{top:0,width:0,height:0},content:{height:0,marginLeft:0,marginRight:0}},r.options=n,t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return Yc.call(Pa(r),t,i,n),r}return Ca(e,t),Oa(e,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e=this.width*t.getMillisecondsPerPixel();return this.data.start.getTime()+e>t.start&&this.data.start<t.end}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.point=document.createElement("div"),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.point.appendChild(this.dom.content),this.dom.dot=document.createElement("div"),this.dom.point.appendChild(this.dom.dot),this.dom.point["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.point.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.point)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.point),this._updateStyle(this.dom.point);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.point.className="vis-item vis-point".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{dot:{width:this.dom.dot.offsetWidth,height:this.dom.dot.offsetHeight},content:{width:this.dom.content.offsetWidth,height:this.dom.content.offsetHeight},point:{width:this.dom.point.offsetWidth,height:this.dom.point.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.dot.width=t.dot.width,this.props.dot.height=t.dot.height,this.props.content.height=t.content.height,this.options.rtl?this.dom.content.style.marginRight="".concat(2*this.props.dot.width,"px"):this.dom.content.style.marginLeft="".concat(2*this.props.dot.width,"px"),this.width=t.point.width,this.height=t.point.height,this.dom.dot.style.top="".concat((this.height-this.props.dot.height)/2,"px");var e=this.props.dot.width,i=this.options.rtl?e/2*-1:e/2;this.dom.dot.style.transform="translateX(".concat(i,"px"),this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.point),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.point)}},{key:"redraw",value:function(t){var e,i,n=this,r=[this._createDomElement.bind(this),this._appendDomElement.bind(this),this._updateDirtyDomComponents.bind(this),function(){n.dirty&&(e=n._getDomComponentsSizes())},function(){n.dirty&&n._updateDomComponentsSizes.bind(n)(e)},this._repaintDomAdditionals.bind(this)];return t?r:(r.forEach((function(t){i=t()})),i)}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(void 0!==e||void 0!==i){var r=n?-1*e:e;t.style.transform=void 0!==i?void 0!==e?"translate(".concat(r,"px, ").concat(i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.point,this.pointX,this.pointY,t)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){this.displayed&&(this.dom.point.parentNode&&this.dom.point.parentNode.removeChild(this.dom.point),this.displayed=!1)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start);this.options.rtl?(this.pointX=t-this.width,this.right=-1*(t-this.props.dot.width)):(this.pointX=t,this.left=t-this.props.dot.width),this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item;this.pointY="top"==t?this.top:this.parent.height-this.top-this.height,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.props.dot.width}},{key:"getWidthRight",value:function(){return this.props.dot.width}}]),e}(Yc),Ac=function(t){function e(t,i,n){var r;if(Ma(this,e),(r=Ia(this,Ea(e).call(this))).props={content:{width:0}},r.overflow=!1,r.options=n,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return Yc.call(Pa(r),t,i,n),r}return Ca(e,t),Oa(e,[{key:"isVisible",value:function(t){return!this.cluster&&(this.data.start<t.end&&this.data.end>t.start)}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.visibleFrame=document.createElement("div"),this.dom.visibleFrame.className="vis-item-visible-frame",this.dom.box.appendChild(this.dom.visibleFrame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className=this.baseClassName+e,this.dom.content.style.maxWidth="none"}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.frame).overflow,this.whiteSpace="nowrap"!==window.getComputedStyle(this.dom.content).whiteSpace,{content:{width:this.dom.content.offsetWidth},box:{height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=t.box.height,this.dom.content.style.maxWidth="",this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDeleteButton(this.dom.box),this._repaintDragCenter(),this._repaintDragLeft(),this._repaintDragRight()}},{key:"redraw",value:function(t){var e,i,n=this,r=[this._createDomElement.bind(this),this._appendDomElement.bind(this),this._updateDirtyDomComponents.bind(this),function(){n.dirty&&(e=n._getDomComponentsSizes.bind(n)())},function(){n.dirty&&n._updateDomComponentsSizes.bind(n)(e)},this._repaintDomAdditionals.bind(this)];return t?r:(r.forEach((function(t){i=t()})),i)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom.box;t.parentNode&&t.parentNode.removeChild(t),this.displayed=!1}}},{key:"repositionX",value:function(t){var e,i,n=this.parent.width,r=this.conversion.toScreen(this.data.start),o=this.conversion.toScreen(this.data.end),s=void 0===this.data.align?this.options.align:this.data.align;!1===this.data.limitSize||void 0!==t&&!0!==t||(r<-n&&(r=-n),o>2*n&&(o=2*n));var a=Math.max(Math.round(1e3*(o-r))/1e3,1);switch(this.overflow?(this.options.rtl?this.right=r:this.left=r,this.width=a+this.props.content.width,i=this.props.content.width):(this.options.rtl?this.right=r:this.left=r,this.width=a,i=Math.min(o-r,this.props.content.width)),this.options.rtl?this.dom.box.style.transform="translateX(".concat(-1*this.right,"px)"):this.dom.box.style.transform="translateX(".concat(this.left,"px)"),this.dom.box.style.width="".concat(a,"px"),this.whiteSpace&&(this.height=this.dom.box.offsetHeight),s){case"left":this.dom.content.style.transform="translateX(0)";break;case"right":if(this.options.rtl){var h=-1*Math.max(a-i,0);this.dom.content.style.transform="translateX(".concat(h,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max(a-i,0),"px)");break;case"center":if(this.options.rtl){var l=-1*Math.max((a-i)/2,0);this.dom.content.style.transform="translateX(".concat(l,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max((a-i)/2,0),"px)");break;default:if(e=this.overflow?o>0?Math.max(-r,0):-i:r<0?-r:0,this.options.rtl){var u=-1*e;this.dom.content.style.transform="translateX(".concat(u,"px)")}else this.dom.content.style.transform="translateX(".concat(e,"px)")}}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;e.style.top="".concat("top"==t?this.top:this.parent.height-this.top-this.height,"px")}},{key:"_repaintDragLeft",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.options.editable.updateTime&&!this.dom.dragLeft){var t=document.createElement("div");t.className="vis-drag-left",t.dragLeftItem=this,this.dom.box.appendChild(t),this.dom.dragLeft=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragLeft||(this.dom.dragLeft.parentNode&&this.dom.dragLeft.parentNode.removeChild(this.dom.dragLeft),this.dom.dragLeft=null)}},{key:"_repaintDragRight",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.options.editable.updateTime&&!this.dom.dragRight){var t=document.createElement("div");t.className="vis-drag-right",t.dragRightItem=this,this.dom.box.appendChild(t),this.dom.dragRight=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragRight||(this.dom.dragRight.parentNode&&this.dom.dragRight.parentNode.removeChild(this.dom.dragRight),this.dom.dragRight=null)}}]),e}(Yc);Ac.prototype.baseClassName="vis-item vis-range";var Lc=function(t){function e(t,i,n){var r;if(Ma(this,e),(r=Ia(this,Ea(e).call(this))).props={content:{width:0}},r.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return Yc.call(Pa(r),t,i,n),r}return Ca(e,t),Oa(e,[{key:"isVisible",value:function(t){return this.data.start<t.end&&this.data.end>t.start}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.background;if(!t)throw new Error("Cannot redraw item: parent has no background container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.content),this._updateStyle(this.dom.box);var t=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"");this.dom.box.className=this.baseClassName+t}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.content).overflow,{content:{width:this.dom.content.offsetWidth}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=0,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){}},{key:"redraw",value:function(t){var e,i,n=this,r=[this._createDomElement.bind(this),this._appendDomElement.bind(this),this._updateDirtyDomComponents.bind(this),function(){n.dirty&&(e=n._getDomComponentsSizes.bind(n)())},function(){n.dirty&&n._updateDomComponentsSizes.bind(n)(e)},this._repaintDomAdditionals.bind(this)];return t?r:(r.forEach((function(t){i=t()})),i)}},{key:"repositionY",value:function(t){var e,i=this.options.orientation.item;if(void 0!==this.data.subgroup){var n=this.data.subgroup;this.dom.box.style.height="".concat(this.parent.subgroups[n].height,"px"),this.dom.box.style.top="".concat("top"==i?this.parent.top+this.parent.subgroups[n].top:this.parent.top+this.parent.height-this.parent.subgroups[n].top-this.parent.subgroups[n].height,"px"),this.dom.box.style.bottom=""}else this.parent instanceof Ec?(e=Math.max(this.parent.height,this.parent.itemSet.body.domProps.center.height,this.parent.itemSet.body.domProps.centerContainer.height),this.dom.box.style.bottom="bottom"==i?"0":"",this.dom.box.style.top="top"==i?"0":""):(e=this.parent.height,this.dom.box.style.top="".concat(this.parent.top,"px"),this.dom.box.style.bottom="");this.dom.box.style.height="".concat(e,"px")}}]),e}(Yc);Lc.prototype.baseClassName="vis-item vis-background",Lc.prototype.stack=!1,Lc.prototype.show=Ac.prototype.show,Lc.prototype.hide=Ac.prototype.hide,Lc.prototype.repositionX=Ac.prototype.repositionX;var Nc=function(){function t(e,i){Ma(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Oa(t,[{key:"setPosition",value:function(t,e){this.x=parseInt(t),this.y=parseInt(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod||"none"==this.overflowMethod){var a=!1,h=!0;"flip"==this.overflowMethod&&(this.y-e<this.padding&&(h=!1),this.x+i>r-this.padding&&(a=!0)),o=a?this.x-i:this.x,s=h?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),Rc=se.every;Et({target:"Array",proto:!0,forced:Ke("every")},{every:function(t){return Rc(this,t,arguments.length>1?arguments[1]:void 0)}});var jc=function(t){function e(t,i,n){var r;if(Ma(this,e),(r=Ia(this,Ea(e).call(this))).props={content:{width:0,height:0}},r.options=Object.assign({},{fitOnDoubleClick:!0},n,{editable:!1}),!t||null==t.uiItems)throw new Error('Property "uiItems" missing in item '+t.id);return Yc.call(Pa(r),t,i,r.options),r.id=bh.randomUUID(),r.group=t.group,r._setupRange(),r.emitter=r.data.eventEmitter,r.range=r.data.range,r.attached=!1,r.isCluster=!0,r.data.isCluster=!0,r}return Ca(e,t),Oa(e,[{key:"hasItems",value:function(){return this.data.uiItems&&this.data.uiItems.length&&this.attached}},{key:"setUiItems",value:function(t){this.detach(),this.data.uiItems=t,this._setupRange(),this.attach()}},{key:"isVisible",value:function(t){var e=this.data.end?this.data.end-this.data.start:0,i=this.width*t.getMillisecondsPerPixel(),n=Math.max(e,this.data.start.getTime()+i);return this.data.start<t.end&&n>t.start&&this.hasItems()}},{key:"getData",value:function(){return{isCluster:!0,id:this.id,items:this.data.items||[],data:this.data}}},{key:"redraw",value:function(t){var e,i,n=[this._createDomElement.bind(this),this._appendDomElement.bind(this),this._updateDirtyDomComponents.bind(this),function(){this.dirty&&(e=this._getDomComponentsSizes())}.bind(this),function(){this.dirty&&this._updateDomComponentsSizes.bind(this)(e)}.bind(this),this._repaintDomAdditionals.bind(this)];return t?n:(n.forEach((function(t){i=t()})),i)}},{key:"show",value:function(){this.displayed||this.redraw()}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.parentNode.removeChild(t.box),this.options.showStipes&&(t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot)),this.displayed=!1}}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.data.end?this.conversion.toScreen(this.data.end):0;if(e)this.repositionXWithRanges(t,e);else{var i=void 0===this.data.align?this.options.align:this.data.align;this.repositionXWithoutRanges(t,i)}this.options.showStipes&&(this.dom.line.style.display=this._isStipeVisible()?"block":"none",this.dom.dot.style.display=this._isStipeVisible()?"block":"none",this._isStipeVisible()&&this.repositionStype(t,e))}},{key:"repositionStype",value:function(t,e){this.dom.line.style.display="block",this.dom.dot.style.display="block";var i=this.dom.line.offsetWidth,n=this.dom.dot.offsetWidth;if(e){var r=i+t+(e-t)/2,o=r-n/2,s=this.options.rtl?-1*r:r,a=this.options.rtl?-1*o:o;this.dom.line.style.transform="translateX(".concat(s,")px"),this.dom.dot.style.transform="translateX(".concat(a,"px)")}else{var h=this.options.rtl?-1*t:t,l=this.options.rtl?-1*(t-n/2):t-n/2;this.dom.line.style.transform="".concat(h,"px"),this.dom.dot.style.transform="".concat(l,"px")}}},{key:"repositionXWithoutRanges",value:function(t,e){"right"==e?this.options.rtl?(this.right=t-this.width,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width,this.dom.box.style.left=this.left+"px"):"left"==e?this.options.rtl?(this.right=t,this.dom.box.style.right=this.right+"px"):(this.left=t,this.dom.box.style.left=this.left+"px"):this.options.rtl?(this.right=t-this.width/2,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width/2,this.dom.box.style.left=this.left+"px")}},{key:"repositionXWithRanges",value:function(t,e){var i=Math.round(Math.max(e-t+.5,1));this.options.rtl?this.right=t:this.left=t,this.width=Math.max(i,this.minWidth||0),this.options.rtl?this.dom.box.style.right=this.right+"px":this.dom.box.style.left=this.left+"px",this.dom.box.style.width=i+"px"}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;if(e.style.top="top"==t?(this.top||0)+"px":(this.parent.height-this.top-this.height||0)+"px",this.options.showStipes){if("top"==t)this.dom.line.style.top="0",this.dom.line.style.height=this.parent.top+this.top+1+"px",this.dom.line.style.bottom="";else{var i=this.parent.itemSet.props.height,n=i-this.parent.top-this.parent.height+this.top;this.dom.line.style.top=i-n+"px",this.dom.line.style.bottom="0"}this.dom.dot.style.top=-this.dom.dot.offsetHeight/2+"px"}}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}},{key:"move",value:function(){this.repositionX(),this.repositionY()}},{key:"attach",value:function(){var t=!0,e=!1,i=void 0;try{for(var n,r=this.data.uiItems[Symbol.iterator]();!(t=(n=r.next()).done);t=!0){n.value.cluster=this}}catch(t){e=!0,i=t}finally{try{t||null==r.return||r.return()}finally{if(e)throw i}}this.data.items=this.data.uiItems.map((function(t){return t.data})),this.attached=!0,this.dirty=!0}},{key:"detach",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.hasItems()){var e=!0,i=!1,n=void 0;try{for(var r,o=this.data.uiItems[Symbol.iterator]();!(e=(r=o.next()).done);e=!0){var s=r.value;delete s.cluster}}catch(t){i=!0,n=t}finally{try{e||null==o.return||o.return()}finally{if(i)throw n}}this.attached=!1,t&&this.group&&(this.group.remove(this),this.group=null),this.data.items=[],this.dirty=!0}}},{key:"_onDoubleClick",value:function(){this._fit()}},{key:"_setupRange",value:function(){var t=this.data.uiItems.map((function(t){return{start:t.data.start.valueOf(),end:t.data.end?t.data.end.valueOf():t.data.start.valueOf()}}));this.data.min=Math.min.apply(Math,Aa(t.map((function(t){return Math.min(t.start,t.end||t.start)})))),this.data.max=Math.max.apply(Math,Aa(t.map((function(t){return Math.max(t.start,t.end||t.start)}))));var e=this.data.uiItems.map((function(t){return t.center})).reduce((function(t,e){return t+e}),0)/this.data.uiItems.length;this.data.uiItems.some((function(t){return t.data.end}))?(this.data.start=new Date(this.data.min),this.data.end=new Date(this.data.max)):(this.data.start=new Date(e),this.data.end=null)}},{key:"_getUiItems",value:function(){var t=this;return this.data.uiItems&&this.data.uiItems.length?this.data.uiItems.filter((function(e){return e.cluster===t})):[]}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.options.showStipes&&(this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-cluster-line",this.dom.line.style.display="none",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-cluster-dot",this.dom.dot.style.display="none"),this.options.fitOnDoubleClick&&(this.dom.box.ondblclick=e.prototype._onDoubleClick.bind(this)),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}var e=this.parent.dom.background;if(this.options.showStipes){if(!this.dom.line.parentNode){if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.baseClassName+" "+(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+" vis-readonly";this.dom.box.className="vis-item "+t,this.options.showStipes&&(this.dom.line.className="vis-item vis-cluster-line "+(this.selected?" vis-selected":""),this.dom.dot.className="vis-item vis-cluster-dot "+(this.selected?" vis-selected":"")),this.data.end&&(this.dom.content.style.maxWidth="none")}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.data.end?this.minWidth=t.box.width:this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box)}},{key:"_isStipeVisible",value:function(){return this.minWidth>=this.width||!this.data.end}},{key:"_getFitRange",value:function(){var t=.05*(this.data.max-this.data.min)/2;return{fitStart:this.data.min-t,fitEnd:this.data.max+t}}},{key:"_fit",value:function(){if(this.emitter){var t=this._getFitRange(),e=t.fitStart,i=t.fitEnd,n={start:new Date(e),end:new Date(i),animation:!0};this.emitter.emit("fit",n)}}},{key:"_getItemData",value:function(){return this.data}}]),e}(Yc);jc.prototype.baseClassName="vis-item vis-range vis-cluster";var Fc="__ungrouped__",Hc=function(){function t(e){Ma(this,t),this.itemSet=e,this.groups={},this.cache={},this.cache[-1]=[]}return Oa(t,[{key:"createClusterItem",value:function(t,e,i){return new jc(t,e,i)}},{key:"setItems",value:function(t,e){this.items=t||[],this.dataChanged=!0,this.applyOnChangedLevel=!1,e&&e.applyOnChangedLevel&&(this.applyOnChangedLevel=e.applyOnChangedLevel)}},{key:"updateData",value:function(){this.dataChanged=!0,this.applyOnChangedLevel=!1}},{key:"getClusters",value:function(t,e,i){var n="boolean"==typeof i?{}:i,r=n.maxItems,o=n.clusterCriteria;o||(o=function(){return!0}),r=r||1;var s=-1,a=0;if(e>0){if(e>=1)return[];s=Math.abs(Math.round(Math.log(100/e)/Math.log(2))),a=Math.abs(Math.pow(2,s))}if(this.dataChanged){var h=s!=this.cacheLevel;(!this.applyOnChangedLevel||h)&&(this._dropLevelsCache(),this._filterData())}this.cacheLevel=s;var l=this.cache[s];if(!l){for(var u in l=[],this.groups)if(this.groups.hasOwnProperty(u))for(var d=this.groups[u],c=d.length,f=0;f<c;){for(var p=d[f],m=1,g=f-1;g>=0&&p.center-d[g].center<a/2;)!d[g].cluster&&o(p.data,d[g].data)&&m++,g--;for(var v=f+1;v<d.length&&d[v].center-p.center<a/2;)o(p.data,d[v].data)&&m++,v++;for(var y=l.length-1;y>=0&&p.center-l[y].center<a;)p.group==l[y].group&&o(p.data,l[y].data)&&m++,y--;if(m>r){for(var _=m-r+1,b=[],w=f;b.length<_&&w<d.length;)o(d[w].data,d[w].data)&&b.push(d[w]),w++;var k=this.itemSet.getGroupId(p.data),D=this.itemSet.groups[k]||this.itemSet.groups[Fc],S=this._getClusterForItems(b,D,t,i);l.push(S),f+=_}else delete p.cluster,f+=1}this.cache[s]=l}return l}},{key:"_filterData",value:function(){var t={};this.groups=t;for(var e=0,i=Object.values(this.items);e<i.length;e++){var n=i[e],r=n.parent?n.parent.groupId:"",o=t[r];o||(o=[],t[r]=o),o.push(n),n.data.start&&(n.data.end?n.center=(n.data.start.valueOf()+n.data.end.valueOf())/2:n.center=n.data.start.valueOf())}for(var s in t)t.hasOwnProperty(s)&&t[s].sort((function(t,e){return t.center-e.center}));this.dataChanged=!1}},{key:"_getClusterForItems",value:function(t,e,i,n){var r,o=(i||[]).map((function(t){return{cluster:t,itemsIds:new Set(t.data.uiItems.map((function(t){return t.id})))}}));if(o.length){var s=!0,a=!1,h=void 0;try{for(var l,u=function(){var e=l.value;if(e.itemsIds.size===t.length&&t.every((function(t){return e.itemsIds.has(t.id)})))return r=e.cluster,"break"},d=o[Symbol.iterator]();!(s=(l=d.next()).done);s=!0){if("break"===u())break}}catch(t){a=!0,h=t}finally{try{s||null==d.return||d.return()}finally{if(a)throw h}}}if(r)return r.setUiItems(t),r.group!==e&&(r.group&&r.group.remove(r),e&&(e.add(r),r.group=e)),r;var c=n.titleTemplate||"",f={toScreen:this.itemSet.body.util.toScreen,toTime:this.itemSet.body.util.toTime},p='<div title="'+m+'">'+t.length+"</div>",m=c.replace(/{count}/,t.length),g=Object.assign({},n,this.itemSet.options),v={content:p,title:m,group:e,uiItems:t,eventEmitter:this.itemSet.body.emitter,range:this.itemSet.body.range};return r=this.createClusterItem(v,f,g),e&&(e.add(r),r.group=e),r.attach(),r}},{key:"_dropLevelsCache",value:function(){this.cache={},this.cacheLevel=-1,this.cache[this.cacheLevel]=[]}}]),t}(),Wc="__background__",Gc=function(t){function e(t,i){var n;Ma(this,e),(n=Ia(this,Ea(e).call(this))).body=t,n.defaultOptions={type:null,orientation:{item:"bottom"},align:"auto",stack:!0,stackSubgroups:!0,groupOrderSwap:function(t,e,i){var n=e.order;e.order=t.order,t.order=n},groupOrder:"order",selectable:!0,multiselect:!1,itemsAlwaysDraggable:{item:!1,range:!1},editable:{updateTime:!1,updateGroup:!1,add:!1,remove:!1,overrideItems:!1},groupEditable:{order:!1,add:!1,remove:!1},snap:Kd.snap,onDropObjectOnItem:function(t,e,i){i(e)},onAdd:function(t,e){e(t)},onUpdate:function(t,e){e(t)},onMove:function(t,e){e(t)},onRemove:function(t,e){e(t)},onMoving:function(t,e){e(t)},onAddGroup:function(t,e){e(t)},onMoveGroup:function(t,e){e(t)},onRemoveGroup:function(t,e){e(t)},margin:{item:{horizontal:10,vertical:10},axis:20},showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:500},tooltipOnItemUpdateTime:!1},n.options=bh.extend({},n.defaultOptions),n.options.rtl=i.rtl,n.options.onTimeout=i.onTimeout,n.itemOptions={type:{start:"Date",end:"Date"}},n.conversion={toScreen:t.util.toScreen,toTime:t.util.toTime},n.dom={},n.props={},n.hammer=null;var r=Pa(n);return n.itemsData=null,n.groupsData=null,n.itemsSettingTime=null,n.initialItemSetDrawn=!1,n.userContinueNotBail=null,n.sequentialSelection=!1,n.itemListeners={add:function(t,e,i){r._onAdd(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()},update:function(t,e,i){r._onUpdate(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()},remove:function(t,e,i){r._onRemove(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()}},n.groupListeners={add:function(t,e,i){if(r._onAddGroups(e.items),r.groupsData&&r.groupsData.length>0){var n=r.groupsData.getDataSet();n.get().forEach((function(t){if(t.nestedGroups){0!=t.showNested&&(t.showNested=!0);var e=[];t.nestedGroups.forEach((function(i){var r=n.get(i);r&&(r.nestedInGroup=t.id,0==t.showNested&&(r.visible=!1),e=e.concat(r))})),n.update(e,i)}}))}},update:function(t,e,i){r._onUpdateGroups(e.items)},remove:function(t,e,i){r._onRemoveGroups(e.items)}},n.items={},n.groups={},n.groupIds=[],n.selection=[],n.popup=null,n.popupTimer=null,n.touchParams={},n.groupTouchParams={group:null,isDragging:!1},n._create(),n.setOptions(i),n.clusters=[],n}return Ca(e,t),Oa(e,[{key:"_create",value:function(){var t=this,e=document.createElement("div");e.className="vis-itemset",e["vis-itemset"]=this,this.dom.frame=e;var i=document.createElement("div");i.className="vis-background",e.appendChild(i),this.dom.background=i;var n=document.createElement("div");n.className="vis-foreground",e.appendChild(n),this.dom.foreground=n;var r=document.createElement("div");r.className="vis-axis",this.dom.axis=r;var o=document.createElement("div");o.className="vis-labelset",this.dom.labelSet=o,this._updateUngrouped();var s=new Ec(Wc,null,this);s.show(),this.groups[Wc]=s,this.hammer=new $d(this.body.dom.centerContainer),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._onTouch(e)})),this.hammer.on("panstart",this._onDragStart.bind(this)),this.hammer.on("panmove",this._onDrag.bind(this)),this.hammer.on("panend",this._onDragEnd.bind(this)),this.hammer.get("pan").set({threshold:5,direction:$d.ALL}),this.hammer.on("tap",this._onSelectItem.bind(this)),this.hammer.on("press",this._onMultiSelectItem.bind(this)),this.hammer.on("doubletap",this._onAddItem.bind(this)),this.options.rtl?this.groupHammer=new $d(this.body.dom.rightContainer):this.groupHammer=new $d(this.body.dom.leftContainer),this.groupHammer.on("tap",this._onGroupClick.bind(this)),this.groupHammer.on("panstart",this._onGroupDragStart.bind(this)),this.groupHammer.on("panmove",this._onGroupDrag.bind(this)),this.groupHammer.on("panend",this._onGroupDragEnd.bind(this)),this.groupHammer.get("pan").set({threshold:5,direction:$d.DIRECTION_VERTICAL}),this.body.dom.centerContainer.addEventListener("mouseover",this._onMouseOver.bind(this)),this.body.dom.centerContainer.addEventListener("mouseout",this._onMouseOut.bind(this)),this.body.dom.centerContainer.addEventListener("mousemove",this._onMouseMove.bind(this)),this.body.dom.centerContainer.addEventListener("contextmenu",this._onDragEnd.bind(this)),this.body.dom.centerContainer.addEventListener("mousewheel",this._onMouseWheel.bind(this)),this.show()}},{key:"setOptions",value:function(t){var e=this;if(t){bh.selectiveExtend(["type","rtl","align","order","stack","stackSubgroups","selectable","multiselect","sequentialSelection","multiselectPerGroup","groupOrder","dataAttributes","template","groupTemplate","visibleFrameTemplate","hide","snap","groupOrderSwap","showTooltips","tooltip","tooltipOnItemUpdateTime","groupHeightMode","onTimeout"],this.options,t),"itemsAlwaysDraggable"in t&&("boolean"==typeof t.itemsAlwaysDraggable?(this.options.itemsAlwaysDraggable.item=t.itemsAlwaysDraggable,this.options.itemsAlwaysDraggable.range=!1):"object"===xa(t.itemsAlwaysDraggable)&&(bh.selectiveExtend(["item","range"],this.options.itemsAlwaysDraggable,t.itemsAlwaysDraggable),this.options.itemsAlwaysDraggable.item||(this.options.itemsAlwaysDraggable.range=!1))),"sequentialSelection"in t&&"boolean"==typeof t.sequentialSelection&&(this.options.sequentialSelection=t.sequentialSelection),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.item="top"===t.orientation?"top":"bottom":"object"===xa(t.orientation)&&"item"in t.orientation&&(this.options.orientation.item=t.orientation.item)),"margin"in t&&("number"==typeof t.margin?(this.options.margin.axis=t.margin,this.options.margin.item.horizontal=t.margin,this.options.margin.item.vertical=t.margin):"object"===xa(t.margin)&&(bh.selectiveExtend(["axis"],this.options.margin,t.margin),"item"in t.margin&&("number"==typeof t.margin.item?(this.options.margin.item.horizontal=t.margin.item,this.options.margin.item.vertical=t.margin.item):"object"===xa(t.margin.item)&&bh.selectiveExtend(["horizontal","vertical"],this.options.margin.item,t.margin.item)))),["locale","locales"].forEach((function(i){i in t&&(e.options[i]=t[i])})),"editable"in t&&("boolean"==typeof t.editable?(this.options.editable.updateTime=t.editable,this.options.editable.updateGroup=t.editable,this.options.editable.add=t.editable,this.options.editable.remove=t.editable,this.options.editable.overrideItems=!1):"object"===xa(t.editable)&&bh.selectiveExtend(["updateTime","updateGroup","add","remove","overrideItems"],this.options.editable,t.editable)),"groupEditable"in t&&("boolean"==typeof t.groupEditable?(this.options.groupEditable.order=t.groupEditable,this.options.groupEditable.add=t.groupEditable,this.options.groupEditable.remove=t.groupEditable):"object"===xa(t.groupEditable)&&bh.selectiveExtend(["order","add","remove"],this.options.groupEditable,t.groupEditable));["onDropObjectOnItem","onAdd","onUpdate","onRemove","onMove","onMoving","onAddGroup","onMoveGroup","onRemoveGroup"].forEach((function(i){var n=t[i];if(n){if("function"!=typeof n)throw new Error("option ".concat(i," must be a function ").concat(i,"(item, callback)"));e.options[i]=n}})),t.cluster?(Object.assign(this.options,{cluster:t.cluster}),this.clusterGenerator||(this.clusterGenerator=new Hc(this)),this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.clusterGenerator?(this._detachAllClusters(),this.clusters=[],this.clusterGenerator=null,this.options.cluster=void 0,this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.markDirty()}}},{key:"markDirty",value:function(t){this.groupIds=[],t&&(t.refreshItems&&bh.forEach(this.items,(function(t){t.dirty=!0,t.displayed&&t.redraw()})),t.restackGroups&&bh.forEach(this.groups,(function(t,e){e!==Wc&&(t.stackDirty=!0)})))}},{key:"destroy",value:function(){this.clearPopupTimer(),this.hide(),this.setItems(null),this.setGroups(null),this.hammer&&this.hammer.destroy(),this.groupHammer&&this.groupHammer.destroy(),this.hammer=null,this.body=null,this.conversion=null}},{key:"hide",value:function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.axis.parentNode&&this.dom.axis.parentNode.removeChild(this.dom.axis),this.dom.labelSet.parentNode&&this.dom.labelSet.parentNode.removeChild(this.dom.labelSet)}},{key:"show",value:function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame),this.dom.axis.parentNode||this.body.dom.backgroundVertical.appendChild(this.dom.axis),this.dom.labelSet.parentNode||(this.options.rtl?this.body.dom.right.appendChild(this.dom.labelSet):this.body.dom.left.appendChild(this.dom.labelSet))}},{key:"setPopupTimer",value:function(t){if(this.clearPopupTimer(),t){var e=this.options.tooltip.delay||"number"==typeof this.options.tooltip.delay?this.options.tooltip.delay:500;this.popupTimer=setTimeout((function(){t.show()}),e)}}},{key:"clearPopupTimer",value:function(){null!=this.popupTimer&&(clearTimeout(this.popupTimer),this.popupTimer=null)}},{key:"setSelection",value:function(t){null==t&&(t=[]),Array.isArray(t)||(t=[t]);var e=this.selection.filter((function(e){return-1===t.indexOf(e)})),i=!0,n=!1,r=void 0;try{for(var o,s=e[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var a=o.value,h=this.getItemById(a);h&&h.unselect()}}catch(t){n=!0,r=t}finally{try{i||null==s.return||s.return()}finally{if(n)throw r}}this.selection=Aa(t);var l=!0,u=!1,d=void 0;try{for(var c,f=t[Symbol.iterator]();!(l=(c=f.next()).done);l=!0){var p=c.value,m=this.getItemById(p);m&&m.select()}}catch(t){u=!0,d=t}finally{try{l||null==f.return||f.return()}finally{if(u)throw d}}}},{key:"getSelection",value:function(){return this.selection.concat([])}},{key:"getVisibleItems",value:function(){var t,e,i=this.body.range.getRange();this.options.rtl?(t=this.body.util.toScreen(i.start),e=this.body.util.toScreen(i.end)):(e=this.body.util.toScreen(i.start),t=this.body.util.toScreen(i.end));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o=this.groups[r],s=o.isVisible?o.visibleItems:[],a=!0,h=!1,l=void 0;try{for(var u,d=s[Symbol.iterator]();!(a=(u=d.next()).done);a=!0){var c=u.value;this.options.rtl?c.right<e&&c.right+c.width>t&&n.push(c.id):c.left<t&&c.left+c.width>e&&n.push(c.id)}}catch(t){h=!0,l=t}finally{try{a||null==d.return||d.return()}finally{if(h)throw l}}}return n}},{key:"getVisibleGroups",value:function(){var t=[];for(var e in this.groups){if(this.groups.hasOwnProperty(e))this.groups[e].isVisible&&t.push(e)}return t}},{key:"getItemById",value:function(t){return this.items[t]||this.clusters.find((function(e){return e.id===t}))}},{key:"_deselect",value:function(t){for(var e=this.selection,i=0,n=e.length;i<n;i++)if(e[i]==t){e.splice(i,1);break}}},{key:"redraw",value:function(){var t=this,e=this.options.margin,i=this.body.range,n=bh.option.asSize,r=this.options,o=r.orientation.item,s=!1,a=this.dom.frame;this.props.top=this.body.domProps.top.height+this.body.domProps.border.top,this.options.rtl?this.props.right=this.body.domProps.right.width+this.body.domProps.border.right:this.props.left=this.body.domProps.left.width+this.body.domProps.border.left,a.className="vis-itemset",this.options.cluster&&this._clusterItems(),s=this._orderGroups()||s;var h=i.end-i.start,l=h!=this.lastVisibleInterval||this.props.width!=this.props.lastWidth,u=i.start!=this.lastRangeStart,d=r.stack!=this.lastStack,c=r.stackSubgroups!=this.lastStackSubgroups,f=l||u||d||c;this.lastVisibleInterval=h,this.lastRangeStart=i.start,this.lastStack=r.stack,this.lastStackSubgroups=r.stackSubgroups,this.props.lastWidth=this.props.width;var p=this._firstGroup(),m={item:e.item,axis:e.axis},g={item:e.item,axis:e.item.vertical/2},v=0,y=e.axis+e.item.vertical;this.groups[Wc].redraw(i,g,f);var _={},b=0;return bh.forEach(this.groups,(function(t,e){if(e!==Wc){var n=t==p?m:g;_[e]=t.redraw(i,n,f,!0),b=_[e].length}})),b>0&&function(){for(var e={},i=function(t){bh.forEach(_,(function(i,n){e[n]=i[t]()}))},n=0;n<b;n++)i(n);bh.forEach(t.groups,(function(t,i){if(i!==Wc){var n=e[i];s=n||s,v+=t.height}})),v=Math.max(v,y)}(),v=Math.max(v,y),a.style.height=n(v),this.props.width=a.offsetWidth,this.props.height=v,this.dom.axis.style.top=n("top"==o?this.body.domProps.top.height+this.body.domProps.border.top:this.body.domProps.top.height+this.body.domProps.centerContainer.height),this.options.rtl?this.dom.axis.style.right="0":this.dom.axis.style.left="0",this.initialItemSetDrawn=!0,s=this._isResized()||s}},{key:"_firstGroup",value:function(){var t="top"==this.options.orientation.item?0:this.groupIds.length-1,e=this.groupIds[t];return this.groups[e]||this.groups.__ungrouped__||null}},{key:"_updateUngrouped",value:function(){var t,e,i=this.groups.__ungrouped__;if(this.groupsData){if(i)for(e in i.hide(),delete this.groups.__ungrouped__,this.items)if(this.items.hasOwnProperty(e)){(t=this.items[e]).parent&&t.parent.remove(t);var n=this.getGroupId(t.data),r=this.groups[n];r&&r.add(t)||t.hide()}}else if(!i){for(e in i=new Cc(null,null,this),this.groups.__ungrouped__=i,this.items)this.items.hasOwnProperty(e)&&(t=this.items[e],i.add(t));i.show()}}},{key:"getLabelSet",value:function(){return this.dom.labelSet}},{key:"setItems",value:function(t){this.itemsSettingTime=new Date;var e,i=this,n=this.itemsData;if(t){if(!(t instanceof bl||t instanceof wl))throw new TypeError("Data must be an instance of DataSet or DataView");this.itemsData=t}else this.itemsData=null;if(n&&(bh.forEach(this.itemListeners,(function(t,e){n.off(e,t)})),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;bh.forEach(this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e),this._updateUngrouped()}this.body.emitter.emit("_change",{queue:!0})}},{key:"getItems",value:function(){return this.itemsData}},{key:"setGroups",value:function(t){var e,i=this;if(this.groupsData&&(bh.forEach(this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null,this._onRemoveGroups(e)),t){if(!(t instanceof bl||t instanceof wl))throw new TypeError("Data must be an instance of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var n=this.groupsData;this.groupsData instanceof wl&&(n=this.groupsData.getDataSet()),n.get().forEach((function(t){t.nestedGroups&&t.nestedGroups.forEach((function(e){var i=n.get(e);i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),n.update(i)}))}));var r=this.id;bh.forEach(this.groupListeners,(function(t,e){i.groupsData.on(e,t,r)})),e=this.groupsData.getIds(),this._onAddGroups(e)}this._updateUngrouped(),this._order(),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems(),this.markDirty({refreshItems:!0,restackGroups:!0})),this.body.emitter.emit("_change",{queue:!0})}},{key:"getGroups",value:function(){return this.groupsData}},{key:"removeItem",value:function(t){var e=this.itemsData.get(t),i=this.itemsData.getDataSet();e&&this.options.onRemove(e,(function(e){e&&i.remove(t)}))}},{key:"_getType",value:function(t){return t.type||this.options.type||(t.end?"range":"box")}},{key:"getGroupId",value:function(t){return"background"==this._getType(t)&&null==t.group?Wc:this.groupsData?t.group:"__ungrouped__"}},{key:"_onUpdate",value:function(t){var i=this,n=this;t.forEach((function(t){var r,o=n.itemsData.get(t,n.itemOptions),s=n.items[t],a=o?n._getType(o):null,h=e.types[a];if(s&&(h&&s instanceof h?n._updateItem(s,o):(r=s.selected,n._removeItem(s),s=null)),!s&&o){if(!h)throw new TypeError('Unknown item type "'.concat(a,'"'));(s=new h(o,n.conversion,n.options)).id=t,n._addItem(s),r&&(i.selection.push(t),s.select())}})),this._order(),this.options.cluster&&(this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this._clusterItems()),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemove",value:function(t){var e=0,i=this;t.forEach((function(t){var n=i.items[t];n&&(e++,i._removeItem(n))})),e&&(this._order(),this.body.emitter.emit("_change",{queue:!0}))}},{key:"_order",value:function(){bh.forEach(this.groups,(function(t){t.order()}))}},{key:"_onUpdateGroups",value:function(t){this._onAddGroups(t)}},{key:"_onAddGroups",value:function(t){var e=this;t.forEach((function(t){var i=e.groupsData.get(t),n=e.groups[t];if(n)n.setData(i);else{if("__ungrouped__"==t||t==Wc)throw new Error("Illegal group id. ".concat(t," is a reserved id."));var r=Object.create(e.options);for(var o in bh.extend(r,{height:null}),n=new Cc(t,i,e),e.groups[t]=n,e.items)if(e.items.hasOwnProperty(o)){var s=e.items[o];s.data.group==t&&n.add(s)}n.order(),n.show()}})),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemoveGroups",value:function(t){var e=this.groups;t.forEach((function(t){var i=e[t];i&&(i.hide(),delete e[t])})),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems()),this.markDirty({restackGroups:!!this.options.cluster}),this.body.emitter.emit("_change",{queue:!0})}},{key:"_orderGroups",value:function(){if(this.groupsData){var t=this.groupsData.getIds({order:this.options.groupOrder});t=this._orderNestedGroups(t);var e=!bh.equalArray(t,this.groupIds);if(e){var i=this.groups;t.forEach((function(t){i[t].hide()})),t.forEach((function(t){i[t].show()})),this.groupIds=t}return e}return!1}},{key:"_orderNestedGroups",value:function(t){var e=this;return function t(e,i){var n=[];return i.forEach((function(i){if(n.push(i),e.groupsData.get(i).nestedGroups){var r=e.groupsData.get({filter:function(t){return t.nestedInGroup==i},order:e.options.groupOrder}).map((function(t){return t.id}));n=n.concat(t(e,r))}})),n}(this,t.filter((function(t){return!e.groupsData.get(t).nestedInGroup})))}},{key:"_addItem",value:function(t){this.items[t.id]=t;var e=this.getGroupId(t.data),i=this.groups[e];i?i&&i.data&&i.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1,i&&i.add(t)}},{key:"_updateItem",value:function(t,e){t.setData(e);var i=this.getGroupId(t.data),n=this.groups[i];n?n&&n.data&&n.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1}},{key:"_removeItem",value:function(t){t.hide(),delete this.items[t.id];var e=this.selection.indexOf(t.id);-1!=e&&this.selection.splice(e,1),t.parent&&t.parent.remove(t),null!=this.popup&&this.popup.hide()}},{key:"_constructByEndArray",value:function(t){for(var e=[],i=0;i<t.length;i++)t[i]instanceof Ac&&e.push(t[i]);return e}},{key:"_onTouch",value:function(t){this.touchParams.item=this.itemFromTarget(t),this.touchParams.dragLeftItem=t.target.dragLeftItem||!1,this.touchParams.dragRightItem=t.target.dragRightItem||!1,this.touchParams.itemProps=null}},{key:"_getGroupIndex",value:function(t){for(var e=0;e<this.groupIds.length;e++)if(t==this.groupIds[e])return e}},{key:"_onDragStart",value:function(t){var e=this;if(!this.touchParams.itemIsDragging){var i,n=this.touchParams.item||null,r=this;if(n&&(n.selected||this.options.itemsAlwaysDraggable.item)){if(this.options.editable.overrideItems&&!this.options.editable.updateTime&&!this.options.editable.updateGroup)return;if(null!=n.editable&&!n.editable.updateTime&&!n.editable.updateGroup&&!this.options.editable.overrideItems)return;var o=this.touchParams.dragLeftItem,s=this.touchParams.dragRightItem;if(this.touchParams.itemIsDragging=!0,this.touchParams.selectedItem=n,o)i={item:o,initialX:t.center.x,dragLeft:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(s)i={item:s,initialX:t.center.x,dragRight:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey))this._onDragStartAddItem(t);else{this.groupIds.length<1&&this.redraw();var a=this._getGroupIndex(n.data.group),h=this.options.itemsAlwaysDraggable.item&&!n.selected?[n.id]:this.getSelection();this.touchParams.itemProps=h.map((function(i){var n=r.items[i],o=r._getGroupIndex(n.data.group);return{item:n,initialX:t.center.x,groupOffset:a-o,data:e._cloneItemData(n.data)}}))}t.stopPropagation()}else this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey)&&this._onDragStartAddItem(t)}}},{key:"_onDragStartAddItem",value:function(t){var e=this.options.snap||null,i=this.dom.frame.getBoundingClientRect(),n=this.options.rtl?i.right-t.center.x+10:t.center.x-i.left-10,r=this.body.util.toTime(n),o=this.body.util.getScale(),s=this.body.util.getStep(),a=e?e(r,o,s):r,h={type:"range",start:a,end:a,content:"new item"},l=bh.randomUUID();h[this.itemsData._idProp]=l;var u=this.groupFromTarget(t);u&&(h.group=u.groupId);var d=new Ac(h,this.conversion,this.options);d.id=l,d.data=this._cloneItemData(h),this._addItem(d),this.touchParams.selectedItem=d;var c={item:d,initialX:t.center.x,data:d.data};this.options.rtl?c.dragLeft=!0:c.dragRight=!0,this.touchParams.itemProps=[c],t.stopPropagation()}},{key:"_onDrag",value:function(t){var e=this;if(null!=this.popup&&this.options.showTooltips&&!this.popup.hidden){var i=this.body.dom.centerContainer,n=i.getBoundingClientRect();this.popup.setPosition(t.center.x-n.left+i.offsetLeft,t.center.y-n.top+i.offsetTop),this.popup.show()}if(this.touchParams.itemProps){t.stopPropagation();var r=this,o=this.options.snap||null,s=this.body.dom.root.offsetLeft,a=this.options.rtl?s+this.body.domProps.right.width:s+this.body.domProps.left.width,h=this.body.util.getScale(),l=this.body.util.getStep(),u=this.touchParams.selectedItem,d=(this.options.editable.overrideItems||null==u.editable)&&this.options.editable.updateGroup||!this.options.editable.overrideItems&&null!=u.editable&&u.editable.updateGroup,c=null;if(d&&u&&null!=u.data.group){var f=r.groupFromTarget(t);f&&(c=this._getGroupIndex(f.groupId))}this.touchParams.itemProps.forEach((function(i){var n,s,f,p,m,g=r.body.util.toTime(t.center.x-a),v=r.body.util.toTime(i.initialX-a);n=e.options.rtl?-(g-v):g-v;var y=e._cloneItemData(i.item.data);if(null==i.item.editable||i.item.editable.updateTime||i.item.editable.updateGroup||r.options.editable.overrideItems){if((e.options.editable.overrideItems||null==u.editable)&&e.options.editable.updateTime||!e.options.editable.overrideItems&&null!=u.editable&&u.editable.updateTime)if(i.dragLeft)e.options.rtl?null!=y.end&&(f=bh.convert(i.data.end,"Date"),m=new Date(f.valueOf()+n),y.end=o?o(m,h,l):m):null!=y.start&&(s=bh.convert(i.data.start,"Date"),p=new Date(s.valueOf()+n),y.start=o?o(p,h,l):p);else if(i.dragRight)e.options.rtl?null!=y.start&&(s=bh.convert(i.data.start,"Date"),p=new Date(s.valueOf()+n),y.start=o?o(p,h,l):p):null!=y.end&&(f=bh.convert(i.data.end,"Date"),m=new Date(f.valueOf()+n),y.end=o?o(m,h,l):m);else if(null!=y.start)if(s=bh.convert(i.data.start,"Date").valueOf(),p=new Date(s+n),null!=y.end){var _=(f=bh.convert(i.data.end,"Date")).valueOf()-s.valueOf();y.start=o?o(p,h,l):p,y.end=new Date(y.start.valueOf()+_)}else y.start=o?o(p,h,l):p;if(d&&!i.dragLeft&&!i.dragRight&&null!=c&&null!=y.group){var b=c-i.groupOffset;b=Math.max(0,b),b=Math.min(r.groupIds.length-1,b),y.group=r.groupIds[b]}y=e._cloneItemData(y),r.options.onMoving(y,(function(t){t&&i.item.setData(e._cloneItemData(t,"Date"))}))}})),this.body.emitter.emit("_change")}}},{key:"_moveToGroup",value:function(t,e){var i=this.groups[e];if(i&&i.groupId!=t.data.group){var n=t.parent;n.remove(t),n.order(),t.data.group=i.groupId,i.add(t),i.order()}}},{key:"_onDragEnd",value:function(t){var e=this;if(this.touchParams.itemIsDragging=!1,this.touchParams.itemProps){t.stopPropagation();var i=this,n=this.itemsData.getDataSet(),r=this.touchParams.itemProps;this.touchParams.itemProps=null,r.forEach((function(t){var r=t.item.id;if(null!=i.itemsData.get(r,i.itemOptions)){var o=e._cloneItemData(t.item.data);i.options.onMove(o,(function(e){e?(e[n._idProp]=r,n.update(e)):(t.item.setData(t.data),i.body.emitter.emit("_change"))}))}else i.options.onAdd(t.item.data,(function(e){i._removeItem(t.item),e&&i.itemsData.getDataSet().add(e),i.body.emitter.emit("_change")}))}))}}},{key:"_onGroupClick",value:function(t){var e=this,i=this.groupFromTarget(t);setTimeout((function(){e.toggleGroupShowNested(i)}),1)}},{key:"toggleGroupShowNested",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(t&&t.nestedGroups){var i=this.groupsData.getDataSet();t.showNested=null!=e?!!e:!t.showNested;var n=i.get(t.groupId);n.showNested=t.showNested;for(var r=t.nestedGroups,o=r;o.length>0;){var s=o;o=[];for(var a=0;a<s.length;a++){var h=i.get(s[a]);h.nestedGroups&&(o=o.concat(h.nestedGroups))}o.length>0&&(r=r.concat(o))}var l=i.get(r).map((function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}));i.update(l.concat(n)),n.showNested?(bh.removeClassName(t.dom.label,"collapsed"),bh.addClassName(t.dom.label,"expanded")):(bh.removeClassName(t.dom.label,"expanded"),bh.addClassName(t.dom.label,"collapsed"))}}},{key:"toggleGroupDragClassName",value:function(t){t.dom.label.classList.toggle("vis-group-is-dragging"),t.dom.foreground.classList.toggle("vis-group-is-dragging")}},{key:"_onGroupDragStart",value:function(t){this.groupTouchParams.isDragging||this.options.groupEditable.order&&(this.groupTouchParams.group=this.groupFromTarget(t),this.groupTouchParams.group&&(t.stopPropagation(),this.groupTouchParams.isDragging=!0,this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.originalOrder=this.groupsData.getIds({order:this.options.groupOrder})))}},{key:"_onGroupDrag",value:function(t){if(this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this.groupsData;this.groupsData instanceof wl&&(e=this.groupsData.getDataSet());var i=this.groupFromTarget(t);if(i&&i.height!=this.groupTouchParams.group.height){var n,r=i.top<this.groupTouchParams.group.top;n=t.touches&&t.touches[0]?t.touches[0].clientY:t.center?t.center.y:t.clientY;var o=i.dom.foreground.getBoundingClientRect(),s=this.groupTouchParams.group.height;if(r){if(o.top+s<n)return}else{var a=i.height;if(o.top+a-s>n)return}}if(i&&i!=this.groupTouchParams.group){var h=e.get(i.groupId),l=e.get(this.groupTouchParams.group.groupId);l&&h&&(this.options.groupOrderSwap(l,h,e),e.update(l),e.update(h));var u=e.getIds({order:this.options.groupOrder});if(!bh.equalArray(u,this.groupTouchParams.originalOrder))for(var d=this.groupTouchParams.originalOrder,c=this.groupTouchParams.group.groupId,f=Math.min(d.length,u.length),p=0,m=0,g=0;p<f;){for(;p+m<f&&p+g<f&&u[p+m]==d[p+g];)p++;if(p+m>=f)break;if(u[p+m]==c)m=1;else if(d[p+g]==c)g=1;else{var v=u.indexOf(d[p+g]),y=e.get(u[p+m]),_=e.get(d[p+g]);this.options.groupOrderSwap(y,_,e),e.update(y),e.update(_);var b=u[p+m];u[p+m]=d[p+g],u[v]=b,p++}}}}}},{key:"_onGroupDragEnd",value:function(t){if(this.groupTouchParams.isDragging=!1,this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this,i=e.groupTouchParams.group.groupId,n=e.groupsData.getDataSet(),r=bh.extend({},n.get(i));e.options.onMoveGroup(r,(function(t){if(t)t[n._idProp]=i,n.update(t);else{var r=n.getIds({order:e.options.groupOrder});if(!bh.equalArray(r,e.groupTouchParams.originalOrder))for(var o=e.groupTouchParams.originalOrder,s=Math.min(o.length,r.length),a=0;a<s;){for(;a<s&&r[a]==o[a];)a++;if(a>=s)break;var h=r.indexOf(o[a]),l=n.get(r[a]),u=n.get(o[a]);e.options.groupOrderSwap(l,u,n),n.update(l),n.update(u);var d=r[a];r[a]=o[a],r[h]=d,a++}}})),e.body.emitter.emit("groupDragged",{groupId:i}),this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.group=null}}},{key:"_onSelectItem",value:function(t){if(this.options.selectable){var e=t.srcEvent&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey),i=t.srcEvent&&t.srcEvent.shiftKey;if(e||i)this._onMultiSelectItem(t);else{var n=this.getSelection(),r=this.itemFromTarget(t),o=r&&r.selectable?[r.id]:[];this.setSelection(o);var s=this.getSelection();(s.length>0||n.length>0)&&this.body.emitter.emit("select",{items:s,event:t})}}}},{key:"_onMouseOver",value:function(t){var e=this.itemFromTarget(t);if(e&&e!==this.itemFromRelatedTarget(t)){var i=e.getTitle();if(this.options.showTooltips&&i){null==this.popup&&(this.popup=new Nc(this.body.dom.root,this.options.tooltip.overflowMethod||"flip")),this.popup.setText(i);var n=this.body.dom.centerContainer,r=n.getBoundingClientRect();this.popup.setPosition(t.clientX-r.left+n.offsetLeft,t.clientY-r.top+n.offsetTop),this.setPopupTimer(this.popup)}else this.clearPopupTimer(),null!=this.popup&&this.popup.hide();this.body.emitter.emit("itemover",{item:e.id,event:t})}}},{key:"_onMouseOut",value:function(t){var e=this.itemFromTarget(t);e&&(e!==this.itemFromRelatedTarget(t)&&(this.clearPopupTimer(),null!=this.popup&&this.popup.hide(),this.body.emitter.emit("itemout",{item:e.id,event:t})))}},{key:"_onMouseMove",value:function(t){if(this.itemFromTarget(t)&&(null!=this.popupTimer&&this.setPopupTimer(this.popup),this.options.showTooltips&&this.options.tooltip.followMouse&&this.popup&&!this.popup.hidden)){var e=this.body.dom.centerContainer,i=e.getBoundingClientRect();this.popup.setPosition(t.clientX-i.left+e.offsetLeft,t.clientY-i.top+e.offsetTop),this.popup.show()}}},{key:"_onMouseWheel",value:function(t){this.touchParams.itemIsDragging&&this._onDragEnd(t)}},{key:"_onUpdateItem",value:function(t){if(this.options.selectable&&this.options.editable.updateTime&&this.options.editable.updateGroup){var e=this;if(t){var i=e.itemsData.get(t.id);this.options.onUpdate(i,(function(t){t&&e.itemsData.getDataSet().update(t)}))}}}},{key:"_onDropObjectOnItem",value:function(t){var e=this.itemFromTarget(t),i=JSON.parse(t.dataTransfer.getData("text"));this.options.onDropObjectOnItem(i,e)}},{key:"_onAddItem",value:function(t){if(this.options.selectable&&this.options.editable.add){var e,i,n=this,r=this.options.snap||null,o=this.dom.frame.getBoundingClientRect(),s=this.options.rtl?o.right-t.center.x:t.center.x-o.left,a=this.body.util.toTime(s),h=this.body.util.getScale(),l=this.body.util.getStep();"drop"==t.type?((i=JSON.parse(t.dataTransfer.getData("text"))).content=i.content?i.content:"new item",i.start=i.start?i.start:r?r(a,h,l):a,i.type=i.type||"box",i[this.itemsData._idProp]=i.id||bh.randomUUID(),"range"!=i.type||i.end||(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,h,l):e)):((i={start:r?r(a,h,l):a,content:"new item"})[this.itemsData._idProp]=bh.randomUUID(),"range"===this.options.type&&(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,h,l):e));var u=this.groupFromTarget(t);u&&(i.group=u.groupId),i=this._cloneItemData(i),this.options.onAdd(i,(function(e){e&&(n.itemsData.getDataSet().add(e),"drop"==t.type&&n.setSelection([e.id]))}))}}},{key:"_onMultiSelectItem",value:function(t){var i=this;if(this.options.selectable){var n=this.itemFromTarget(t);if(n){var r=this.options.multiselect?this.getSelection():[];if((t.srcEvent&&t.srcEvent.shiftKey||!1||this.options.sequentialSelection)&&this.options.multiselect){var o=this.itemsData.get(n.id).group,s=void 0;this.options.multiselectPerGroup&&r.length>0&&(s=this.itemsData.get(r[0]).group),this.options.multiselectPerGroup&&null!=s&&s!=o||r.push(n.id);var a=e._getItemRange(this.itemsData.get(r,this.itemOptions));if(!this.options.multiselectPerGroup||s==o)for(var h in r=[],this.items)if(this.items.hasOwnProperty(h)){var l=this.items[h],u=l.data.start,d=void 0!==l.data.end?l.data.end:u;!(u>=a.min&&d<=a.max)||this.options.multiselectPerGroup&&s!=this.itemsData.get(l.id).group||l instanceof Lc||r.push(l.id)}}else{var c=r.indexOf(n.id);-1==c?r.push(n.id):r.splice(c,1)}var f=r.filter((function(t){return i.getItemById(t).selectable}));this.setSelection(f),this.body.emitter.emit("select",{items:this.getSelection(),event:t})}}}},{key:"itemFromElement",value:function(t){for(var e=t;e;){if(e.hasOwnProperty("vis-item"))return e["vis-item"];e=e.parentNode}return null}},{key:"itemFromTarget",value:function(t){return this.itemFromElement(t.target)}},{key:"itemFromRelatedTarget",value:function(t){return this.itemFromElement(t.relatedTarget)}},{key:"groupFromTarget",value:function(t){var e;e=t.touches&&t.touches[0]?t.touches[0].clientY:t.center?t.center.y:t.clientY;var i=this.groupIds;i.length<=0&&this.groupsData&&(i=this.groupsData.getIds({order:this.options.groupOrder}));for(var n=0;n<i.length;n++){var r=i[n],o=this.groups[r],s=o.dom.foreground,a=s.getBoundingClientRect();if(e>=a.top&&e<a.top+s.offsetHeight)return o;if("top"===this.options.orientation.item){if(n===this.groupIds.length-1&&e>a.top)return o}else if(0===n&&e<a.top+s.offset)return o}return null}},{key:"_cloneItemData",value:function(t,e){var i=bh.extend({},t);return e||(e=this.itemsData.getDataSet()._options.type),null!=i.start&&(i.start=bh.convert(i.start,e&&e.start||"Date")),null!=i.end&&(i.end=bh.convert(i.end,e&&e.end||"Date")),i}},{key:"_clusterItems",value:function(){if(this.options.cluster){var t=this.body.range.conversion(this.body.domProps.center.width).scale,e=this.clusterGenerator.getClusters(this.clusters,t,this.options.cluster);if(this.clusters!=e){if(this._detachAllClusters(),e){var i=!0,n=!1,r=void 0;try{for(var o,s=e[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){o.value.attach()}}catch(t){n=!0,r=t}finally{try{i||null==s.return||s.return()}finally{if(n)throw r}}this.clusters=e}this._updateClusters(e)}}}},{key:"_detachAllClusters",value:function(){if(this.options.cluster&&this.clusters&&this.clusters.length){var t=!0,e=!1,i=void 0;try{for(var n,r=this.clusters[Symbol.iterator]();!(t=(n=r.next()).done);t=!0){n.value.detach()}}catch(t){e=!0,i=t}finally{try{t||null==r.return||r.return()}finally{if(e)throw i}}}}},{key:"_updateClusters",value:function(t){if(this.clusters&&this.clusters.length){var e=new Set(t.map((function(t){return t.id}))),i=this.clusters.filter((function(t){return!e.has(t.id)})),n=!1,r=!0,o=!1,s=void 0;try{for(var a,h=i[Symbol.iterator]();!(r=(a=h.next()).done);r=!0){var l=a.value,u=this.selection.indexOf(l.id);-1!==u&&(l.unselect(),this.selection.splice(u,1),n=!0)}}catch(t){o=!0,s=t}finally{try{r||null==h.return||h.return()}finally{if(o)throw s}}if(n){var d=this.getSelection();this.body.emitter.emit("select",{items:d,event:event})}}this.clusters=t||[]}}],[{key:"_getItemRange",value:function(t){var e=null,i=null;return t.forEach((function(t){(null==i||t.start<i)&&(i=t.start),null!=t.end?(null==e||t.end>e)&&(e=t.end):(null==e||t.start>e)&&(e=t.start)})),{min:i,max:e}}},{key:"itemSetFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("vis-itemset"))return e["vis-itemset"];e=e.parentNode}return null}}]),e}(Sl);Gc.types={background:Lc,box:Pc,range:Ac,point:Ic},Gc.prototype._onAdd=Gc.prototype._onUpdate;var Uc,zc=!1,Vc="background: #FFeeee; color: #dd0000",Bc=function(){function t(){Ma(this,t)}return Oa(t,null,[{key:"validate",value:function(e,i,n){zc=!1,Uc=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),zc}},{key:"parse",value:function(e,i,n){for(var r in e)e.hasOwnProperty(r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),Vc)},h=t.getType(i[e]),l=o[h];void 0!==l?"array"===t.getType(l)&&-1===l.indexOf(i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+i[e]+'". '),zc=!0):"object"===h&&"__any__"!==r&&(s=bh.copyAndExtendArray(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(Object.keys(o))+". Received ["+h+'] "'+i[e]+'"'),zc=!0)}},{key:"getType",value:function(t){var e=xa(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Array.isArray(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,Uc,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Object.keys(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+r,Vc),zc=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],h=e.toLowerCase(),l=void 0;for(var u in i){var d=void 0;if(void 0!==i[u].__type__&&!0===r){var c=t.findInOptions(e,i[u],bh.copyAndExtendArray(n,u));o>c.distance&&(s=c.closestMatch,a=c.path,o=c.distance,l=c.indexMatch)}else-1!==u.toLowerCase().indexOf(h)&&(l=u),o>(d=t.levenshteinDistance(e,u))&&(s=u,a=bh.copyArray(n),o=d)}return{closestMatch:s,path:a,distance:o,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",n="\n\n"+i+"options = {\n",r=0;r<t.length;r++){for(var o=0;o<r+1;o++)n+="  ";n+=t[r]+": {\n"}for(var s=0;s<t.length+1;s++)n+="  ";n+=e+"\n";for(var a=0;a<t.length+1;a++){for(var h=0;h<t.length-a;h++)n+="  ";n+="}\n"}return n+"\n\n"}},{key:"print",value:function(t){return JSON.stringify(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),Xc="string",qc="boolean",Zc="number",$c="object",Jc={configure:{enabled:{boolean:qc},filter:{boolean:qc,function:"function"},container:{dom:"dom"},__type__:{object:$c,boolean:qc,function:"function"}},align:{string:Xc},alignCurrentTime:{string:Xc,undefined:"undefined"},rtl:{boolean:qc,undefined:"undefined"},rollingMode:{follow:{boolean:qc},offset:{number:Zc,undefined:"undefined"},__type__:{object:$c}},onTimeout:{timeoutMs:{number:Zc},callback:{function:"function"},__type__:{object:$c}},verticalScroll:{boolean:qc,undefined:"undefined"},horizontalScroll:{boolean:qc,undefined:"undefined"},autoResize:{boolean:qc},throttleRedraw:{number:Zc},clickToUse:{boolean:qc},dataAttributes:{string:Xc,array:"array"},editable:{add:{boolean:qc,undefined:"undefined"},remove:{boolean:qc,undefined:"undefined"},updateGroup:{boolean:qc,undefined:"undefined"},updateTime:{boolean:qc,undefined:"undefined"},overrideItems:{boolean:qc,undefined:"undefined"},__type__:{boolean:qc,object:$c}},end:{number:Zc,date:"date",string:Xc,moment:"moment"},format:{minorLabels:{millisecond:{string:Xc,undefined:"undefined"},second:{string:Xc,undefined:"undefined"},minute:{string:Xc,undefined:"undefined"},hour:{string:Xc,undefined:"undefined"},weekday:{string:Xc,undefined:"undefined"},day:{string:Xc,undefined:"undefined"},week:{string:Xc,undefined:"undefined"},month:{string:Xc,undefined:"undefined"},year:{string:Xc,undefined:"undefined"},__type__:{object:$c,function:"function"}},majorLabels:{millisecond:{string:Xc,undefined:"undefined"},second:{string:Xc,undefined:"undefined"},minute:{string:Xc,undefined:"undefined"},hour:{string:Xc,undefined:"undefined"},weekday:{string:Xc,undefined:"undefined"},day:{string:Xc,undefined:"undefined"},week:{string:Xc,undefined:"undefined"},month:{string:Xc,undefined:"undefined"},year:{string:Xc,undefined:"undefined"},__type__:{object:$c,function:"function"}},__type__:{object:$c}},moment:{function:"function"},groupHeightMode:{string:Xc},groupOrder:{string:Xc,function:"function"},groupEditable:{add:{boolean:qc,undefined:"undefined"},remove:{boolean:qc,undefined:"undefined"},order:{boolean:qc,undefined:"undefined"},__type__:{boolean:qc,object:$c}},groupOrderSwap:{function:"function"},height:{string:Xc,number:Zc},hiddenDates:{start:{date:"date",number:Zc,string:Xc,moment:"moment"},end:{date:"date",number:Zc,string:Xc,moment:"moment"},repeat:{string:Xc},__type__:{object:$c,array:"array"}},itemsAlwaysDraggable:{item:{boolean:qc,undefined:"undefined"},range:{boolean:qc,undefined:"undefined"},__type__:{boolean:qc,object:$c}},limitSize:{boolean:qc},locale:{string:Xc},locales:{__any__:{any:"any"},__type__:{object:$c}},margin:{axis:{number:Zc},item:{horizontal:{number:Zc,undefined:"undefined"},vertical:{number:Zc,undefined:"undefined"},__type__:{object:$c,number:Zc}},__type__:{object:$c,number:Zc}},max:{date:"date",number:Zc,string:Xc,moment:"moment"},maxHeight:{number:Zc,string:Xc},maxMinorChars:{number:Zc},min:{date:"date",number:Zc,string:Xc,moment:"moment"},minHeight:{number:Zc,string:Xc},moveable:{boolean:qc},multiselect:{boolean:qc},multiselectPerGroup:{boolean:qc},onAdd:{function:"function"},onDropObjectOnItem:{function:"function"},onUpdate:{function:"function"},onMove:{function:"function"},onMoving:{function:"function"},onRemove:{function:"function"},onAddGroup:{function:"function"},onMoveGroup:{function:"function"},onRemoveGroup:{function:"function"},onInitialDrawComplete:{function:"function"},order:{function:"function"},orientation:{axis:{string:Xc,undefined:"undefined"},item:{string:Xc,undefined:"undefined"},__type__:{string:Xc,object:$c}},selectable:{boolean:qc},sequentialSelection:{boolean:qc},showCurrentTime:{boolean:qc},showMajorLabels:{boolean:qc},showMinorLabels:{boolean:qc},stack:{boolean:qc},stackSubgroups:{boolean:qc},cluster:{maxItems:{number:Zc,undefined:"undefined"},titleTemplate:{string:Xc,undefined:"undefined"},clusterCriteria:{function:"function",undefined:"undefined"},showStipes:{boolean:qc,undefined:"undefined"},fitOnDoubleClick:{boolean:qc,undefined:"undefined"},__type__:{boolean:qc,object:$c}},snap:{function:"function",null:"null"},start:{date:"date",number:Zc,string:Xc,moment:"moment"},template:{function:"function"},loadingScreenTemplate:{function:"function"},groupTemplate:{function:"function"},visibleFrameTemplate:{string:Xc,function:"function"},showTooltips:{boolean:qc},tooltip:{followMouse:{boolean:qc},overflowMethod:{string:["cap","flip","none"]},delay:{number:Zc},template:{function:"function"},__type__:{object:$c}},tooltipOnItemUpdateTime:{template:{function:"function"},__type__:{boolean:qc,object:$c}},timeAxis:{scale:{string:Xc,undefined:"undefined"},step:{number:Zc,undefined:"undefined"},__type__:{object:$c}},type:{string:Xc},width:{string:Xc,number:Zc},preferZoom:{boolean:qc},zoomable:{boolean:qc},zoomKey:{string:["ctrlKey","altKey","shiftKey","metaKey",""]},zoomFriction:{number:Zc},zoomMax:{number:Zc},zoomMin:{number:Zc},__type__:{object:$c}},Kc={global:{align:["center","left","right"],alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],direction:!1,autoResize:!0,clickToUse:!1,editable:{add:!1,remove:!1,updateGroup:!1,updateTime:!1},end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}},groupHeightMode:["auto","fixed","fitItems"],groupsDraggable:!1,height:"",locale:"",margin:{axis:[20,0,100,1],item:{horizontal:[10,0,100,1],vertical:[10,0,100,1]}},max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!1,multiselect:!1,multiselectPerGroup:!1,orientation:{axis:["both","bottom","top"],item:["bottom","top"]},preferZoom:!1,selectable:!0,showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,stack:!0,stackSubgroups:!0,cluster:!1,start:"",showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:[500,0,99999,100]},tooltipOnItemUpdateTime:!1,type:["box","point","range","background"],width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","shiftKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1]}};Et({target:"Array",proto:!0},{fill:On}),Mi("fill");var Qc={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},tf=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Ma(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Oa(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return Qc[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===bh.isString(t)){if(!0===bh.isValidRGB(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===bh.isValidRGBA(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===bh.isValidHex(t)){var s=bh.hexToRGB(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+JSON.stringify(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this,e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];!0===e&&(this.previousColor=bh.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",setTimeout((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];!0===e&&(this.initialColor=bh.extend({},t)),this.color=t;var i=bh.RGBToHSV(t.r,t.g,t.b),n=2*Math.PI,r=this.r*i.s,o=this.centerCoordinates.x+r*Math.sin(n*i.h),s=this.centerCoordinates.y+r*Math.cos(n*i.h);this.colorPickerSelector.style.left=o-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=s-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=bh.RGBToHSV(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=bh.HSVToRGB(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=bh.RGBToHSV(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),i.fill(),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var t=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var e=document.createElement("DIV");e.style.color="red",e.style.fontWeight="bold",e.style.padding="10px",e.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(e)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var i=this;this.opacityRange.onchange=function(){i._setOpacity(this.value)},this.opacityRange.oninput=function(){i._setOpacity(this.value)},this.brightnessRange.onchange=function(){i._setBrightness(this.value)},this.brightnessRange.oninput=function(){i._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=this._hide.bind(this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=this._apply.bind(this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=this._save.bind(this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=this._loadLast.bind(this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new $d(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),Jd(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,h=2*Math.PI/360,l=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(h*n),i=this.centerCoordinates.y+r*Math.cos(h*n),a=bh.HSVToRGB(n*(1/360),r*l,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,h=Math.atan2(s,a),l=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(h)*l+r,d=Math.sin(h)*l+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=d-.5*this.colorPickerSelector.clientWidth+"px";var c=h/(2*Math.PI);c=c<0?c+1:c;var f=l/this.r,p=bh.RGBToHSV(this.color.r,this.color.g,this.color.b);p.h=c,p.s=f;var m=bh.HSVToRGB(p.h,p.s,p.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}(),ef=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Ma(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},bh.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new tf(r),this.wrapper=void 0}return Oa(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(t instanceof Array)this.options.filter=t.join();else if("object"===xa(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==t.filter&&(this.options.filter=t.filter),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===this.options.filter&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=this.options.filter,e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===t.indexOf(n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return n.forEach((function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?"<i><b>"+t+":</b></i>":t+":",n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==t.indexOf(e)&&(r=t.indexOf(e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerHTML=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var h="",l=0;if(void 0!==e){e<0&&1.2*e<r?(a.min=Math.ceil(1.2*e),l=a.min,h="range increased"):e/1.2<r&&(a.min=Math.ceil(e/1.2),l=a.min,h="range increased"),1.2*e>o&&1!==o&&(a.max=Math.ceil(1.2*e),l=a.max,h="range increased"),a.value=e}else a.value=n;var u=document.createElement("input");u.className="vis-configuration vis-config-rangeinput",u.value=a.value;var d=this;a.onchange=function(){u.value=this.value,d._update(Number(this.value),i)},a.oninput=function(){u.value=this.value};var c=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,c,a,u);""!==h&&this.popupHistory[f]!==l&&(this.popupHistory[f]=l,this._setupPopup(h,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=setTimeout((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=setTimeout((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===xa(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=this.options.filter,o=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],h=bh.copyAndExtendArray(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!(a instanceof Array)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,h,!0),this.allowCreation=!1===i),!1!==n){o=!0;var l=this._getValue(h);if(a instanceof Array)this._handleArray(a,l,h);else if("string"==typeof a)this._makeTextInput(a,l,h);else if("boolean"==typeof a)this._makeCheckbox(a,l,h);else if(a instanceof Object){var u=!0;if(-1!==e.indexOf("physics")&&this.moduleOptions.physics.solver!==s&&(u=!1),!0===u)if(void 0!==a.enabled){var d=bh.copyAndExtendArray(h,"enabled"),c=this._getValue(d);if(!0===c){var f=this._makeLabel(s,h,!0);this._makeItem(h,f),o=this._handleObject(a,h)||o}else this._makeCheckbox(a,c,h)}else{var p=this._makeLabel(s,h,!0);this._makeItem(h,p),o=this._handleObject(a,h)||o}}else console.error("dont know how to handle",a,s,h)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+JSON.stringify(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),nf=function(t){function e(t,i,n,r){var o;if(Ma(this,e),(o=Ia(this,Ea(e).call(this))).initTime=new Date,o.itemsDone=!1,!(Pa(o)instanceof e))throw new SyntaxError("Constructor must be called with the new operator");if(!(Array.isArray(n)||n instanceof bl||n instanceof wl)&&n instanceof Object){var s=r;r=n,n=s}r&&r.throttleRedraw&&console.warn('Timeline option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var a=Pa(o);if(o.defaultOptions={autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:Dl},o.options=bh.deepExtend({},o.defaultOptions),o._create(t),!r||r&&void 0===r.rtl){var h;o.dom.root.style.visibility="hidden";for(var l=o.dom.root;!h&&l;)h=window.getComputedStyle(l,null).direction,l=l.parentElement;o.options.rtl=h&&"rtl"==h.toLowerCase()}else o.options.rtl=r.rtl;r&&(r.rollingMode&&(o.options.rollingMode=r.rollingMode),r.onInitialDrawComplete&&(o.options.onInitialDrawComplete=r.onInitialDrawComplete),r.onTimeout&&(o.options.onTimeout=r.onTimeout),r.loadingScreenTemplate&&(o.options.loadingScreenTemplate=r.loadingScreenTemplate));var u=document.createElement("div");if(o.options.loadingScreenTemplate){var d=o.options.loadingScreenTemplate.bind(Pa(o)),c=d(o.dom.loadingScreen);c instanceof Object&&!(c instanceof Element)?d(u):c instanceof Element?(u.innerHTML="",u.appendChild(c)):null!=c&&(u.innerHTML=c)}return o.dom.loadingScreen.appendChild(u),o.components=[],o.body={dom:o.dom,domProps:o.props,emitter:{on:o.on.bind(Pa(o)),off:o.off.bind(Pa(o)),emit:o.emit.bind(Pa(o))},hiddenDates:[],util:{getScale:function(){return a.timeAxis.step.scale},getStep:function(){return a.timeAxis.step.step},toScreen:a._toScreen.bind(a),toGlobalScreen:a._toGlobalScreen.bind(a),toTime:a._toTime.bind(a),toGlobalTime:a._toGlobalTime.bind(a)}},o.range=new Fl(o.body,o.options),o.components.push(o.range),o.body.range=o.range,o.timeAxis=new Qd(o.body,o.options),o.timeAxis2=null,o.components.push(o.timeAxis),o.currentTime=new sc(o.body,o.options),o.components.push(o.currentTime),o.itemSet=new Gc(o.body,o.options),o.components.push(o.itemSet),o.itemsData=null,o.groupsData=null,o.dom.root.ontouchstart=function(t){a.emit("touchstart",a.getEventProperties(t))},o.dom.root.ontouchend=function(t){a.emit("touchend",a.getEventProperties(t))},o.dom.root.onclick=function(t){a.emit("click",a.getEventProperties(t))},o.dom.root.ondblclick=function(t){a.emit("doubleClick",a.getEventProperties(t))},o.dom.root.oncontextmenu=function(t){a.emit("contextmenu",a.getEventProperties(t))},o.dom.root.onmouseover=function(t){a.emit("mouseOver",a.getEventProperties(t))},window.PointerEvent?(o.dom.root.onpointerdown=function(t){a.emit("mouseDown",a.getEventProperties(t))},o.dom.root.onpointermove=function(t){a.emit("mouseMove",a.getEventProperties(t))},o.dom.root.onpointerup=function(t){a.emit("mouseUp",a.getEventProperties(t))}):(o.dom.root.onmousemove=function(t){a.emit("mouseMove",a.getEventProperties(t))},o.dom.root.onmousedown=function(t){a.emit("mouseDown",a.getEventProperties(t))},o.dom.root.onmouseup=function(t){a.emit("mouseUp",a.getEventProperties(t))}),o.initialFitDone=!1,o.on("changed",(function(){if(null!=a.itemsData){if(!a.initialFitDone&&!a.options.rollingMode)if(a.initialFitDone=!0,null!=a.options.start||null!=a.options.end){if(null==a.options.start||null==a.options.end)var t=a.getItemRange();var e=null!=a.options.start?a.options.start:t.min,i=null!=a.options.end?a.options.end:t.max;a.setWindow(e,i,{animation:!1})}else a.fit({animation:!1});a.initialDrawDone||!a.initialRangeChangeDone&&(a.options.start||a.options.end)&&!a.options.rollingMode||(a.initialDrawDone=!0,a.itemSet.initialDrawDone=!0,a.dom.root.style.visibility="visible",a.dom.loadingScreen.parentNode.removeChild(a.dom.loadingScreen),a.options.onInitialDrawComplete&&setTimeout((function(){return a.options.onInitialDrawComplete()}),0))}})),o.on("destroyTimeline",(function(){a.destroy()})),r&&o.setOptions(r),o.body.emitter.on("fit",(function(t){o._onFit(t),o.redraw()})),n&&o.setGroups(n),i&&o.setItems(i),o._redraw(),o}return Ca(e,t),Oa(e,[{key:"_createConfigurator",value:function(){return new ef(this,this.dom.container,Kc)}},{key:"redraw",value:function(){this.itemSet&&this.itemSet.markDirty({refreshItems:!0}),this._redraw()}},{key:"setOptions",value:function(t){if(!0===Bc.validate(t,Jc)&&console.log("%cErrors have been found in the supplied options object.",Vc),oc.prototype.setOptions.call(this,t),"type"in t&&t.type!==this.options.type){this.options.type=t.type;var e=this.itemsData;if(e){var i=this.getSelection();this.setItems(null),this.setItems(e),this.setSelection(i)}}}},{key:"setItems",value:function(t){var e;this.itemsDone=!1,e=t?t instanceof bl||t instanceof wl?t:new bl(t,{type:{start:"Date",end:"Date"}}):null,this.itemsData=e,this.itemSet&&this.itemSet.setItems(e)}},{key:"setGroups",value:function(t){var e;if(t){var i=function(t){return!1!==t.visible};e=t instanceof bl||t instanceof wl?new wl(t,{filter:i}):new bl(t.filter(i))}else e=null;this.groupsData=e,this.itemSet.setGroups(e)}},{key:"setData",value:function(t){t&&t.groups&&this.setGroups(t.groups),t&&t.items&&this.setItems(t.items)}},{key:"setSelection",value:function(t,e){this.itemSet&&this.itemSet.setSelection(t),e&&e.focus&&this.focus(t,e)}},{key:"getSelection",value:function(){return this.itemSet&&this.itemSet.getSelection()||[]}},{key:"focus",value:function(t,e){if(this.itemsData&&null!=t){var i=Array.isArray(t)?t:[t],n=this.itemsData.getDataSet().get(i,{type:{start:"Date",end:"Date"}}),r=null,o=null;if(n.forEach((function(t){var e=t.start.valueOf(),i="end"in t?t.end.valueOf():t.start.valueOf();(null===r||e<r)&&(r=e),(null===o||i>o)&&(o=i)})),null!==r&&null!==o){var s=this,a=this.itemSet.items[i[0]],h=-1*this._getScrollTop(),l=null,u=function(){var t=sf(s,a);t.shouldScroll&&t.itemTop!=l.itemTop&&(s._setScrollTop(-t.scrollOffset),s._redraw())},d=(r+o)/2,c=1.1*(o-r),f=!e||void 0===e.animation||e.animation;f||(l={shouldScroll:!1,scrollOffset:-1,itemTop:-1}),this.range.setRange(d-c/2,d+c/2,{animation:f},(function(){u(),setTimeout(u,100)}),(function(t,e,i){var n=sf(s,a);if(!1!==n&&(l||(l=n),l.itemTop!=n.itemTop||l.shouldScroll)){l.itemTop!=n.itemTop&&n.shouldScroll&&(l=n,h=-1*s._getScrollTop());var r=h,o=l.scrollOffset,u=i?o:r+(o-r)*t;s._setScrollTop(-u),e||s._redraw()}}))}}}},{key:"fit",value:function(t,e){var i,n=!t||void 0===t.animation||t.animation,r=this.itemsData&&this.itemsData.getDataSet();1===r.length&&void 0===r.get()[0].end?(i=this.getDataRange(),this.moveTo(i.min.valueOf(),{animation:n},e)):(i=this.getItemRange(),this.range.setRange(i.min,i.max,{animation:n},e))}},{key:"getItemRange",value:function(){var t=this,e=this.getDataRange(),i=null!==e.min?e.min.valueOf():null,n=null!==e.max?e.max.valueOf():null,r=null,o=null;if(null!=i&&null!=n){var s=n-i;s<=0&&(s=10);var a=s/this.props.center.width,h={},l=0;if(bh.forEach(this.itemSet.items,(function(t,e){if(t.groupShowing){h[e]=t.redraw(!0),l=h[e].length}})),l>0)for(var u=function(t){bh.forEach(h,(function(e){e[t]()}))},d=0;d<l;d++)u(d);if(bh.forEach(this.itemSet.items,(function(e){var s,h,l=rf(e),u=of(e);t.options.rtl?(s=l-(e.getWidthRight()+10)*a,h=u+(e.getWidthLeft()+10)*a):(s=l-(e.getWidthLeft()+10)*a,h=u+(e.getWidthRight()+10)*a),s<i&&(i=s,r=e),h>n&&(n=h,o=e)})),r&&o){var c=r.getWidthLeft()+10,f=o.getWidthRight()+10,p=this.props.center.width-c-f;p>0&&(this.options.rtl?(i=rf(r)-f*s/p,n=of(o)+c*s/p):(i=rf(r)-c*s/p,n=of(o)+f*s/p))}}return{min:null!=i?new Date(i):null,max:null!=n?new Date(n):null}}},{key:"getDataRange",value:function(){var t=null,e=null,i=this.itemsData&&this.itemsData.getDataSet();return i&&i.forEach((function(i){var n=bh.convert(i.start,"Date").valueOf(),r=bh.convert(null!=i.end?i.end:i.start,"Date").valueOf();(null===t||n<t)&&(t=n),(null===e||r>e)&&(e=r)})),{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}}},{key:"getEventProperties",value:function(t){var e,i,n,r,o;if(t.touches){if(!t.touches[0])return;e=t.touches[0].clientX,i=t.touches[0].clientY,n=t.targetTouches[0].target,r=t.changedTouches[0].pageX,o=t.changedTouches[0].pageY}else e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=bh.getTarget(t),r=t.srcEvent?t.srcEvent.pageX:t.pageX,o=t.srcEvent?t.srcEvent.pageY:t.pageY;var s=this.dom.centerContainer.getBoundingClientRect(),a=this.options.rtl?s.right-e:e-s.left,h=i-s.top,l=this.itemSet.itemFromTarget(t),u=this.itemSet.groupFromTarget(t),d=rc.customTimeFromTarget(t),c=this.itemSet.options.snap||null,f=this.body.util.getScale(),p=this.body.util.getStep(),m=this._toTime(a),g=c?c(m,f,p):m,v=null;return null!=l?v="item":null!=d?v="custom-time":bh.hasParent(n,this.timeAxis.dom.foreground)?v="axis":this.timeAxis2&&bh.hasParent(n,this.timeAxis2.dom.foreground)?v="axis":bh.hasParent(n,this.itemSet.dom.labelSet)?v="group-label":bh.hasParent(n,this.currentTime.bar)?v="current-time":bh.hasParent(n,this.dom.center)&&(v="background"),{event:t,item:l?l.id:null,isCluster:!!l&&!!l.isCluster,items:l?l.items||[]:null,group:u?u.groupId:null,customTime:d?d.options.id:null,what:v,pageX:r,pageY:o,x:a,y:h,time:m,snappedTime:g}}},{key:"toggleRollingMode",value:function(){this.range.rolling?this.range.stopRolling():(null==this.options.rollingMode&&this.setOptions(this.options),this.range.startRolling())}},{key:"_redraw",value:function(){oc.prototype._redraw.call(this)}},{key:"_onFit",value:function(t){var e=t.start,i=t.end,n=t.animation;i?this.range.setRange(e,i,{animation:n}):this.moveTo(e.valueOf(),{animation:n})}}]),e}(oc);function rf(t){return bh.convert(t.data.start,"Date").valueOf()}function of(t){var e=null!=t.data.end?t.data.end:t.data.start;return bh.convert(e,"Date").valueOf()}function sf(t,e){if(!e.parent)return!1;var i=t.options.rtl?t.props.rightContainer.height:t.props.leftContainer.height,n=t.props.center.height,r=e.parent,o=r.top,s=!0,a=t.timeAxis.options.orientation.axis,h=function(){return"bottom"==a?r.height-e.top-e.height:e.top},l=-1*t._getScrollTop(),u=o+h(),d=e.height;return u<l?o+i<=o+h()+d&&(o+=h()-t.itemSet.options.margin.item.vertical):u+d>l+i?o+=h()+d-i+t.itemSet.options.margin.item.vertical:s=!1,{shouldScroll:s,scrollOffset:o=Math.min(o,n-i),itemTop:u}}var af=1..toPrecision,hf=u((function(){return"1"!==af.call(1,void 0)}))||!u((function(){af.call({})}));Et({target:"Number",proto:!0,forced:hf},{toPrecision:function(t){return void 0===t?af.call(yr(this)):af.call(yr(this),t)}});var lf=function(){function t(e,i,n,r,o,s){var a=arguments.length>6&&void 0!==arguments[6]&&arguments[6],h=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(Ma(this,t),this.majorSteps=[1,2,5,10],this.minorSteps=[.25,.5,1,2],this.customLines=null,this.containerHeight=o,this.majorCharHeight=s,this._start=e,this._end=i,this.scale=1,this.minorStepIdx=-1,this.magnitudefactor=1,this.determineScale(),this.zeroAlign=a,this.autoScaleStart=n,this.autoScaleEnd=r,this.formattingFunction=h,n||r){var l=this,u=function(t){var e=t-t%(l.magnitudefactor*l.minorSteps[l.minorStepIdx]);return t%(l.magnitudefactor*l.minorSteps[l.minorStepIdx])>l.magnitudefactor*l.minorSteps[l.minorStepIdx]*.5?e+l.magnitudefactor*l.minorSteps[l.minorStepIdx]:e};n&&(this._start-=2*this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._start=u(this._start)),r&&(this._end+=this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._end=u(this._end)),this.determineScale()}}return Oa(t,[{key:"setCharHeight",value:function(t){this.majorCharHeight=t}},{key:"setHeight",value:function(t){this.containerHeight=t}},{key:"determineScale",value:function(){var t=this._end-this._start;this.scale=this.containerHeight/t;var e=this.majorCharHeight/this.scale,i=t>0?Math.round(Math.log(t)/Math.LN10):0;this.minorStepIdx=-1,this.magnitudefactor=Math.pow(10,i);var n=0;i<0&&(n=i);for(var r=!1,o=n;Math.abs(o)<=Math.abs(i);o++){this.magnitudefactor=Math.pow(10,o);for(var s=0;s<this.minorSteps.length;s++){if(this.magnitudefactor*this.minorSteps[s]>=e){r=!0,this.minorStepIdx=s;break}}if(!0===r)break}}},{key:"is_major",value:function(t){return t%(this.magnitudefactor*this.majorSteps[this.minorStepIdx])==0}},{key:"getStep",value:function(){return this.magnitudefactor*this.minorSteps[this.minorStepIdx]}},{key:"getFirstMajor",value:function(){var t=this.magnitudefactor*this.majorSteps[this.minorStepIdx];return this.convertValue(this._start+(t-this._start%t)%t)}},{key:"formatValue",value:function(t){var e=t.toPrecision(5);return"function"==typeof this.formattingFunction&&(e=this.formattingFunction(t)),"number"==typeof e?"".concat(e):"string"==typeof e?e:t.toPrecision(5)}},{key:"getLines",value:function(){for(var t=[],e=this.getStep(),i=(e-this._start%e)%e,n=this._start+i;this._end-n>1e-5;n+=e)n!=this._start&&t.push({major:this.is_major(n),y:this.convertValue(n),val:this.formatValue(n)});return t}},{key:"followScale",value:function(t){var e=this.minorStepIdx,i=this._start,n=this._end,r=this,o=function(){r.magnitudefactor*=2},s=function(){r.magnitudefactor/=2};t.minorStepIdx<=1&&this.minorStepIdx<=1||t.minorStepIdx>1&&this.minorStepIdx>1||(t.minorStepIdx<this.minorStepIdx?(this.minorStepIdx=1,2==e?o():(o(),o())):(this.minorStepIdx=2,1==e?s():(s(),s())));for(var a=t.convertValue(0),h=t.getStep()*t.scale,l=!1,u=0;!l&&u++<5;){this.scale=h/(this.minorSteps[this.minorStepIdx]*this.magnitudefactor);var d=this.containerHeight/this.scale;this._start=i,this._end=this._start+d;var c=this._end*this.scale,f=this.magnitudefactor*this.majorSteps[this.minorStepIdx],p=this.getFirstMajor()-t.getFirstMajor();if(this.zeroAlign){var m=a-c;this._end+=m/this.scale,this._start=this._end-d}else this.autoScaleStart?(this._start-=p/this.scale,this._end=this._start+d):(this._start+=f-p/this.scale,this._end=this._start+d);if(!this.autoScaleEnd&&this._end>n+1e-5)s(),l=!1;else{if(!this.autoScaleStart&&this._start<i-1e-5){if(!(this.zeroAlign&&i>=0)){s(),l=!1;continue}console.warn("Can't adhere to given 'min' range, due to zeroalign")}this.autoScaleStart&&this.autoScaleEnd&&d<n-i?(o(),l=!1):l=!0}}}},{key:"convertValue",value:function(t){return this.containerHeight-(t-this._start)*this.scale}},{key:"screenToValue",value:function(t){return(this.containerHeight-t)/this.scale+this._start}}]),t}(),uf=function(t){function e(t,i,n,r){var o;Ma(this,e),(o=Ia(this,Ea(e).call(this))).id=bh.randomUUID(),o.body=t,o.defaultOptions={orientation:"left",showMinorLabels:!0,showMajorLabels:!0,icons:!1,majorLinesOffset:7,minorLinesOffset:4,labelOffsetX:10,labelOffsetY:2,iconWidth:20,width:"40px",visible:!0,alignZeros:!0,left:{range:{min:void 0,max:void 0},format:function(t){return"".concat(parseFloat(t.toPrecision(3)))},title:{text:void 0,style:void 0}},right:{range:{min:void 0,max:void 0},format:function(t){return"".concat(parseFloat(t.toPrecision(3)))},title:{text:void 0,style:void 0}}},o.linegraphOptions=r,o.linegraphSVG=n,o.props={},o.DOMelements={lines:{},labels:{},title:{}},o.dom={},o.scale=void 0,o.range={start:0,end:0},o.options=bh.extend({},o.defaultOptions),o.conversionFactor=1,o.setOptions(i),o.width=Number("".concat(o.options.width).replace("px","")),o.minWidth=o.width,o.height=o.linegraphSVG.getBoundingClientRect().height,o.hidden=!1,o.stepPixels=25,o.zeroCrossing=-1,o.amountOfSteps=-1,o.lineOffset=0,o.master=!0,o.masterAxis=null,o.svgElements={},o.iconsRemoved=!1,o.groups={},o.amountOfGroups=0,o._create(),null==o.scale&&o._redrawLabels(),o.framework={svg:o.svg,svgElements:o.svgElements,options:o.options,groups:o.groups};var s=Pa(o);return o.body.emitter.on("verticalDrag",(function(){s.dom.lineContainer.style.top="".concat(s.body.domProps.scrollTop,"px")})),o}return Ca(e,t),Oa(e,[{key:"addGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1}},{key:"updateGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.amountOfGroups+=1),this.groups[t]=e}},{key:"removeGroup",value:function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)}},{key:"setOptions",value:function(t){if(t){var e=!1;this.options.orientation!=t.orientation&&void 0!==t.orientation&&(e=!0);bh.selectiveDeepExtend(["orientation","showMinorLabels","showMajorLabels","icons","majorLinesOffset","minorLinesOffset","labelOffsetX","labelOffsetY","iconWidth","width","visible","left","right","alignZeros"],this.options,t),this.minWidth=Number("".concat(this.options.width).replace("px","")),!0===e&&this.dom.frame&&(this.hide(),this.show())}}},{key:"_create",value:function(){this.dom.frame=document.createElement("div"),this.dom.frame.style.width=this.options.width,this.dom.frame.style.height=this.height,this.dom.lineContainer=document.createElement("div"),this.dom.lineContainer.style.width="100%",this.dom.lineContainer.style.height=this.height,this.dom.lineContainer.style.position="relative",this.dom.lineContainer.style.visibility="visible",this.dom.lineContainer.style.display="block",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.height="100%",this.svg.style.width="100%",this.svg.style.display="block",this.dom.frame.appendChild(this.svg)}},{key:"_redrawGroupIcons",value:function(){var t;wh(this.svgElements);var e=this.options.iconWidth,i=11.5;t="left"===this.options.orientation?4:this.width-e-4;var n=Object.keys(this.groups);n.sort((function(t,e){return t<e?-1:1}));for(var r=0,o=n;r<o.length;r++){var s=o[r];!0!==this.groups[s].visible||void 0!==this.linegraphOptions.visibility[s]&&!0!==this.linegraphOptions.visibility[s]||(this.groups[s].getLegend(e,15,this.framework,t,i),i+=19)}kh(this.svgElements),this.iconsRemoved=!1}},{key:"_cleanupIcons",value:function(){!1===this.iconsRemoved&&(wh(this.svgElements),kh(this.svgElements),this.iconsRemoved=!0)}},{key:"show",value:function(){this.hidden=!1,this.dom.frame.parentNode||("left"===this.options.orientation?this.body.dom.left.appendChild(this.dom.frame):this.body.dom.right.appendChild(this.dom.frame)),this.dom.lineContainer.parentNode||this.body.dom.backgroundHorizontal.appendChild(this.dom.lineContainer),this.dom.lineContainer.style.display="block"}},{key:"hide",value:function(){this.hidden=!0,this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.lineContainer.style.display="none"}},{key:"setRange",value:function(t,e){this.range.start=t,this.range.end=e}},{key:"redraw",value:function(){var t=!1,e=0;for(var i in this.dom.lineContainer.style.top="".concat(this.body.domProps.scrollTop,"px"),this.groups)this.groups.hasOwnProperty(i)&&(!0!==this.groups[i].visible||void 0!==this.linegraphOptions.visibility[i]&&!0!==this.linegraphOptions.visibility[i]||e++);if(0===this.amountOfGroups||0===e)this.hide();else{this.show(),this.height=Number(this.linegraphSVG.style.height.replace("px","")),this.dom.lineContainer.style.height="".concat(this.height,"px"),this.width=!0===this.options.visible?Number("".concat(this.options.width).replace("px","")):0;var n=this.props,r=this.dom.frame;r.className="vis-data-axis",this._calculateCharSize();var o=this.options.orientation,s=this.options.showMinorLabels,a=this.options.showMajorLabels,h=this.body.dom.backgroundHorizontal.offsetWidth;n.minorLabelHeight=s?n.minorCharHeight:0,n.majorLabelHeight=a?n.majorCharHeight:0,n.minorLineWidth=h-this.lineOffset-this.width+2*this.options.minorLinesOffset,n.minorLineHeight=1,n.majorLineWidth=h-this.lineOffset-this.width+2*this.options.majorLinesOffset,n.majorLineHeight=1,"left"===o?(r.style.top="0",r.style.left="0",r.style.bottom="",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.left.width,this.props.height=this.body.domProps.left.height):(r.style.top="",r.style.bottom="0",r.style.left="0",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.right.width,this.props.height=this.body.domProps.right.height),t=this._redrawLabels(),t=this._isResized()||t,!0===this.options.icons?this._redrawGroupIcons():this._cleanupIcons(),this._redrawTitle(o)}return t}},{key:"_redrawLabels",value:function(){var t=this,e=!1;wh(this.DOMelements.lines),wh(this.DOMelements.labels);var i=this.options.orientation,n=null!=this.options[i].range?this.options[i].range:{},r=!0;null!=n.max&&(this.range.end=n.max,r=!1);var o=!0;null!=n.min&&(this.range.start=n.min,o=!1),this.scale=new lf(this.range.start,this.range.end,o,r,this.dom.frame.offsetHeight,this.props.majorCharHeight,this.options.alignZeros,this.options[i].format),!1===this.master&&null!=this.masterAxis?(this.scale.followScale(this.masterAxis.scale),this.dom.lineContainer.style.display="none"):this.dom.lineContainer.style.display="block",this.maxLabelSize=0,this.scale.getLines().forEach((function(e){var n=e.y,r=e.major;t.options.showMinorLabels&&!1===r&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-minor",t.props.minorCharHeight),r&&n>=0&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-major",t.props.majorCharHeight),!0===t.master&&(r?t._redrawLine(n,i,"vis-grid vis-horizontal vis-major",t.options.majorLinesOffset,t.props.majorLineWidth):t._redrawLine(n,i,"vis-grid vis-horizontal vis-minor",t.options.minorLinesOffset,t.props.minorLineWidth))}));var s=0;void 0!==this.options[i].title&&void 0!==this.options[i].title.text&&(s=this.props.titleCharHeight);var a=!0===this.options.icons?Math.max(this.options.iconWidth,s)+this.options.labelOffsetX+15:s+this.options.labelOffsetX+15;return this.maxLabelSize>this.width-a&&!0===this.options.visible?(this.width=this.maxLabelSize+a,this.options.width="".concat(this.width,"px"),kh(this.DOMelements.lines),kh(this.DOMelements.labels),this.redraw(),e=!0):this.maxLabelSize<this.width-a&&!0===this.options.visible&&this.width>this.minWidth?(this.width=Math.max(this.minWidth,this.maxLabelSize+a),this.options.width="".concat(this.width,"px"),kh(this.DOMelements.lines),kh(this.DOMelements.labels),this.redraw(),e=!0):(kh(this.DOMelements.lines),kh(this.DOMelements.labels),e=!1),e}},{key:"convertValue",value:function(t){return this.scale.convertValue(t)}},{key:"screenToValue",value:function(t){return this.scale.screenToValue(t)}},{key:"_redrawLabel",value:function(t,e,i,n,r){var o=xh("div",this.DOMelements.labels,this.dom.frame);o.className=n,o.innerHTML=e,"left"===i?(o.style.left="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="right"):(o.style.right="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="left"),o.style.top="".concat(t-.5*r+this.options.labelOffsetY,"px"),e+="";var s=Math.max(this.props.majorCharWidth,this.props.minorCharWidth);this.maxLabelSize<e.length*s&&(this.maxLabelSize=e.length*s)}},{key:"_redrawLine",value:function(t,e,i,n,r){if(!0===this.master){var o=xh("div",this.DOMelements.lines,this.dom.lineContainer);o.className=i,o.innerHTML="","left"===e?o.style.left="".concat(this.width-n,"px"):o.style.right="".concat(this.width-n,"px"),o.style.width="".concat(r,"px"),o.style.top="".concat(t,"px")}}},{key:"_redrawTitle",value:function(t){if(wh(this.DOMelements.title),void 0!==this.options[t].title&&void 0!==this.options[t].title.text){var e=xh("div",this.DOMelements.title,this.dom.frame);e.className="vis-y-axis vis-title vis-".concat(t),e.innerHTML=this.options[t].title.text,void 0!==this.options[t].title.style&&bh.addCssText(e,this.options[t].title.style),"left"===t?e.style.left="".concat(this.props.titleCharHeight,"px"):e.style.right="".concat(this.props.titleCharHeight,"px"),e.style.width="".concat(this.height,"px")}kh(this.DOMelements.title)}},{key:"_calculateCharSize",value:function(){if(!("minorCharHeight"in this.props)){var t=document.createTextNode("0"),e=document.createElement("div");e.className="vis-y-axis vis-minor vis-measure",e.appendChild(t),this.dom.frame.appendChild(e),this.props.minorCharHeight=e.clientHeight,this.props.minorCharWidth=e.clientWidth,this.dom.frame.removeChild(e)}if(!("majorCharHeight"in this.props)){var i=document.createTextNode("0"),n=document.createElement("div");n.className="vis-y-axis vis-major vis-measure",n.appendChild(i),this.dom.frame.appendChild(n),this.props.majorCharHeight=n.clientHeight,this.props.majorCharWidth=n.clientWidth,this.dom.frame.removeChild(n)}if(!("titleCharHeight"in this.props)){var r=document.createTextNode("0"),o=document.createElement("div");o.className="vis-y-axis vis-title vis-measure",o.appendChild(r),this.dom.frame.appendChild(o),this.props.titleCharHeight=o.clientHeight,this.props.titleCharWidth=o.clientWidth,this.dom.frame.removeChild(o)}}}]),e}(Sl);function df(t,e){}function cf(t,e){return{style:(e=void 0===e?{}:e).style||t.options.drawPoints.style,styles:e.styles||t.options.drawPoints.styles,size:e.size||t.options.drawPoints.size,className:e.className||t.className}}function ff(t,e){}function pf(t,e){}function mf(t,e,i,n){this.id=e;this.options=bh.selectiveBridgeObject(["sampling","style","sort","yAxisOrientation","barChart","drawPoints","shaded","interpolation","zIndex","excludeFromStacking","excludeFromLegend"],i),this.usingDefaultStyle=void 0===t.className,this.groupsUsingDefaultStyles=n,this.zeroPosition=0,this.update(t),1==this.usingDefaultStyle&&(this.groupsUsingDefaultStyles[0]+=1),this.itemsData=[],this.visible=void 0===t.visible||t.visible}function gf(t,e,i,n){this.body=t,this.defaultOptions={enabled:!1,icons:!0,iconSize:20,iconSpacing:6,left:{visible:!0,position:"top-left"},right:{visible:!0,position:"top-right"}},this.side=i,this.options=bh.extend({},this.defaultOptions),this.linegraphOptions=n,this.svgElements={},this.dom={},this.groups={},this.amountOfGroups=0,this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups},this.setOptions(e)}df.draw=function(t,e,i,n){n=n||0;for(var r=function(t,e){var i=void 0;t.options&&t.options.drawPoints&&t.options.drawPoints.onRender&&"function"==typeof t.options.drawPoints.onRender&&(i=t.options.drawPoints.onRender);e.group.options&&e.group.options.drawPoints&&e.group.options.drawPoints.onRender&&"function"==typeof e.group.options.drawPoints.onRender&&(i=e.group.options.drawPoints.onRender);return i}(i,e),o=0;o<t.length;o++)if(r){var s=r(t[o],e);!0!==s&&"object"!==xa(s)||Mh(t[o].screen_x+n,t[o].screen_y,cf(e,s),i.svgElements,i.svg,t[o].label)}else Mh(t[o].screen_x+n,t[o].screen_y,cf(e),i.svgElements,i.svg,t[o].label)},df.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=Sh("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline"),Mh(e+.5*n,i,cf(t),o.svgElements,o.svg)},ff.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=Sh("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline");var h=Math.round(.3*n),l=t.options.barChart.width/h,u=Math.round(.4*r),d=Math.round(.75*r),c=Math.round((n-2*h)/3);if(Th(e+.5*h+c,i+s-u-1,h,u,t.className+" vis-bar",o.svgElements,o.svg,t.style),Th(e+1.5*h+c+2,i+s-d-1,h,d,t.className+" vis-bar",o.svgElements,o.svg,t.style),1==t.options.drawPoints.enabled){var f={style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size/l,className:t.className};Mh(e+.5*h+c,i+s-u-1,f,o.svgElements,o.svg),Mh(e+1.5*h+c+2,i+s-d-1,f,o.svgElements,o.svg)}},ff.draw=function(t,e,i){var n,r,o,s,a,h,l=[],u={},d=0;for(a=0;a<t.length;a++)if("bar"===(s=i.groups[t[a]]).options.style&&!0===s.visible&&(void 0===i.options.groups.visibility[t[a]]||!0===i.options.groups.visibility[t[a]]))for(h=0;h<e[t[a]].length;h++)l.push({screen_x:e[t[a]][h].screen_x,screen_end:e[t[a]][h].screen_end,screen_y:e[t[a]][h].screen_y,x:e[t[a]][h].x,end:e[t[a]][h].end,y:e[t[a]][h].y,groupId:t[a],label:e[t[a]][h].label}),d+=1;if(0!==d)for(l.sort((function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x})),ff._getDataIntersections(u,l),a=0;a<l.length;a++){var c=null!=(s=i.groups[l[a].groupId]).options.barChart.minWidth?s.options.barChart.minWidth:.1*s.options.barChart.width,f=0;if(void 0===u[r=l[a].screen_x])a+1<l.length&&(n=Math.abs(l[a+1].screen_x-r)),o=ff._getSafeDrawData(n,s,c);else{var p=a+(u[r].amount-u[r].resolved);p<l.length&&(n=Math.abs(l[p].screen_x-r)),o=ff._getSafeDrawData(n,s,c),u[r].resolved+=1,!0===s.options.stack&&!0!==s.options.excludeFromStacking?l[a].screen_y<s.zeroPosition?(f=u[r].accumulatedNegative,u[r].accumulatedNegative+=s.zeroPosition-l[a].screen_y):(f=u[r].accumulatedPositive,u[r].accumulatedPositive+=s.zeroPosition-l[a].screen_y):!0===s.options.barChart.sideBySide&&(o.width=o.width/u[r].amount,o.offset+=u[r].resolved*o.width-.5*o.width*(u[r].amount+1))}var m=o.width,g=l[a].screen_x;if(null!=l[a].screen_end?g+=.5*(m=l[a].screen_end-l[a].screen_x):g+=o.offset,Th(g,l[a].screen_y-f,m,s.zeroPosition-l[a].screen_y,s.className+" vis-bar",i.svgElements,i.svg,s.style),!0===s.options.drawPoints.enabled){var v={screen_x:l[a].screen_x,screen_y:l[a].screen_y-f,x:l[a].x,y:l[a].y,groupId:l[a].groupId,label:l[a].label};df.draw([v],s,i,o.offset)}}},ff._getDataIntersections=function(t,e){for(var i,n=0;n<e.length;n++)n+1<e.length&&(i=Math.abs(e[n+1].screen_x-e[n].screen_x)),n>0&&(i=Math.min(i,Math.abs(e[n-1].screen_x-e[n].screen_x))),0===i&&(void 0===t[e[n].screen_x]&&(t[e[n].screen_x]={amount:0,resolved:0,accumulatedPositive:0,accumulatedNegative:0}),t[e[n].screen_x].amount+=1)},ff._getSafeDrawData=function(t,e,i){var n,r;return t<e.options.barChart.width&&t>0?(n=t<i?i:t,r=0,"left"===e.options.barChart.align?r-=.5*t:"right"===e.options.barChart.align&&(r+=.5*t)):(n=e.options.barChart.width,r=0,"left"===e.options.barChart.align?r-=.5*e.options.barChart.width:"right"===e.options.barChart.align&&(r+=.5*e.options.barChart.width)),{width:n,offset:r}},ff.getStackedYRange=function(t,e,i,n,r){if(t.length>0){t.sort((function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x}));var o={};ff._getDataIntersections(o,t),e[n]=ff._getStackedYRange(o,t),e[n].yAxisOrientation=r,i.push(n)}},ff._getStackedYRange=function(t,e){for(var i,n=e[0].screen_y,r=e[0].screen_y,o=0;o<e.length;o++)void 0===t[i=e[o].screen_x]?(n=n>e[o].screen_y?e[o].screen_y:n,r=r<e[o].screen_y?e[o].screen_y:r):e[o].screen_y<0?t[i].accumulatedNegative+=e[o].screen_y:t[i].accumulatedPositive+=e[o].screen_y;for(var s in t)t.hasOwnProperty(s)&&(n=(n=n>t[s].accumulatedNegative?t[s].accumulatedNegative:n)>t[s].accumulatedPositive?t[s].accumulatedPositive:n,r=(r=r<t[s].accumulatedNegative?t[s].accumulatedNegative:r)<t[s].accumulatedPositive?t[s].accumulatedPositive:r);return{min:n,max:r}},pf.calcPath=function(t,e){if(null!=t&&t.length>0){return 1==e.options.interpolation.enabled?pf._catmullRom(t,e):pf._linear(t)}},pf.drawIcon=function(t,e,i,n,r,o){var s,a,h=.5*r,l=Sh("rect",o.svgElements,o.svg);(l.setAttributeNS(null,"x",e),l.setAttributeNS(null,"y",i-h),l.setAttributeNS(null,"width",n),l.setAttributeNS(null,"height",2*h),l.setAttributeNS(null,"class","vis-outline"),(s=Sh("path",o.svgElements,o.svg)).setAttributeNS(null,"class",t.className),void 0!==t.style&&s.setAttributeNS(null,"style",t.style),s.setAttributeNS(null,"d","M"+e+","+i+" L"+(e+n)+","+i),1==t.options.shaded.enabled&&(a=Sh("path",o.svgElements,o.svg),"top"==t.options.shaded.orientation?a.setAttributeNS(null,"d","M"+e+", "+(i-h)+"L"+e+","+i+" L"+(e+n)+","+i+" L"+(e+n)+","+(i-h)):a.setAttributeNS(null,"d","M"+e+","+i+" L"+e+","+(i+h)+" L"+(e+n)+","+(i+h)+"L"+(e+n)+","+i),a.setAttributeNS(null,"class",t.className+" vis-icon-fill"),void 0!==t.options.shaded.style&&""!==t.options.shaded.style&&a.setAttributeNS(null,"style",t.options.shaded.style)),1==t.options.drawPoints.enabled)&&Mh(e+.5*n,i,{style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size,className:t.className},o.svgElements,o.svg)},pf.drawShading=function(t,e,i,n){if(1==e.options.shaded.enabled){var r,o=Number(n.svg.style.height.replace("px","")),s=Sh("path",n.svgElements,n.svg),a="L";1==e.options.interpolation.enabled&&(a="C");var h=0;h="top"==e.options.shaded.orientation?0:"bottom"==e.options.shaded.orientation?o:Math.min(Math.max(0,e.zeroPosition),o),r="group"==e.options.shaded.orientation&&null!=i&&null!=i?"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" L"+i[i.length-1][0]+","+i[i.length-1][1]+" "+this.serializePath(i,a,!0)+i[0][0]+","+i[0][1]+" Z":"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" V"+h+" H"+t[0][0]+" Z",s.setAttributeNS(null,"class",e.className+" vis-fill"),void 0!==e.options.shaded.style&&s.setAttributeNS(null,"style",e.options.shaded.style),s.setAttributeNS(null,"d",r)}},pf.draw=function(t,e,i){if(null!=t&&null!=t){var n=Sh("path",i.svgElements,i.svg);n.setAttributeNS(null,"class",e.className),void 0!==e.style&&n.setAttributeNS(null,"style",e.style);var r="L";1==e.options.interpolation.enabled&&(r="C"),n.setAttributeNS(null,"d","M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,r,!1))}},pf.serializePath=function(t,e,i){if(t.length<2)return"";var n,r=e;if(i)for(n=t.length-2;n>0;n--)r+=t[n][0]+","+t[n][1]+" ";else for(n=1;n<t.length;n++)r+=t[n][0]+","+t[n][1]+" ";return r},pf._catmullRomUniform=function(t){var e,i,n,r,o,s,a=[];a.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var h=t.length,l=0;l<h-1;l++)e=0==l?t[0]:t[l-1],i=t[l],n=t[l+1],r=l+2<h?t[l+2]:n,o={screen_x:(-e.screen_x+6*i.screen_x+n.screen_x)*(1/6),screen_y:(-e.screen_y+6*i.screen_y+n.screen_y)*(1/6)},s={screen_x:(i.screen_x+6*n.screen_x-r.screen_x)*(1/6),screen_y:(i.screen_y+6*n.screen_y-r.screen_y)*(1/6)},a.push([o.screen_x,o.screen_y]),a.push([s.screen_x,s.screen_y]),a.push([n.screen_x,n.screen_y]);return a},pf._catmullRom=function(t,e){var i=e.options.interpolation.alpha;if(0==i||void 0===i)return this._catmullRomUniform(t);var n,r,o,s,a,h,l,u,d,c,f,p,m,g,v,y,_,b,w,k=[];k.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var D=t.length,S=0;S<D-1;S++)n=0==S?t[0]:t[S-1],r=t[S],o=t[S+1],s=S+2<D?t[S+2]:o,l=Math.sqrt(Math.pow(n.screen_x-r.screen_x,2)+Math.pow(n.screen_y-r.screen_y,2)),u=Math.sqrt(Math.pow(r.screen_x-o.screen_x,2)+Math.pow(r.screen_y-o.screen_y,2)),d=Math.sqrt(Math.pow(o.screen_x-s.screen_x,2)+Math.pow(o.screen_y-s.screen_y,2)),g=Math.pow(d,i),y=Math.pow(d,2*i),v=Math.pow(u,i),_=Math.pow(u,2*i),w=Math.pow(l,i),c=2*(b=Math.pow(l,2*i))+3*w*v+_,f=2*y+3*g*v+_,(p=3*w*(w+v))>0&&(p=1/p),(m=3*g*(g+v))>0&&(m=1/m),a={screen_x:(-_*n.screen_x+c*r.screen_x+b*o.screen_x)*p,screen_y:(-_*n.screen_y+c*r.screen_y+b*o.screen_y)*p},h={screen_x:(y*r.screen_x+f*o.screen_x-_*s.screen_x)*m,screen_y:(y*r.screen_y+f*o.screen_y-_*s.screen_y)*m},0==a.screen_x&&0==a.screen_y&&(a=r),0==h.screen_x&&0==h.screen_y&&(h=o),k.push([a.screen_x,a.screen_y]),k.push([h.screen_x,h.screen_y]),k.push([o.screen_x,o.screen_y]);return k},pf._linear=function(t){for(var e=[],i=0;i<t.length;i++)e.push([t[i].screen_x,t[i].screen_y]);return e},mf.prototype.setItems=function(t){null!=t?(this.itemsData=t,1==this.options.sort&&bh.insertSort(this.itemsData,(function(t,e){return t.x>e.x?1:-1}))):this.itemsData=[]},mf.prototype.getItems=function(){return this.itemsData},mf.prototype.setZeroPosition=function(t){this.zeroPosition=t},mf.prototype.setOptions=function(t){if(void 0!==t){bh.selectiveDeepExtend(["sampling","style","sort","yAxisOrientation","barChart","zIndex","excludeFromStacking","excludeFromLegend"],this.options,t),"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),bh.mergeOptions(this.options,t,"interpolation"),bh.mergeOptions(this.options,t,"drawPoints"),bh.mergeOptions(this.options,t,"shaded"),t.interpolation&&"object"==xa(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5))}},mf.prototype.update=function(t){this.group=t,this.content=t.content||"graph",this.className=t.className||this.className||"vis-graph-group"+this.groupsUsingDefaultStyles[0]%10,this.visible=void 0===t.visible||t.visible,this.style=t.style,this.setOptions(t.options)},mf.prototype.getLegend=function(t,e,i,n,r){null!=i&&null!=i||(i={svg:document.createElementNS("http://www.w3.org/2000/svg","svg"),svgElements:{},options:this.options,groups:[this]});switch(null!=n&&null!=n||(n=0),null!=r&&null!=r||(r=.5*e),this.options.style){case"line":pf.drawIcon(this,n,r,t,e,i);break;case"points":case"point":df.drawIcon(this,n,r,t,e,i);break;case"bar":ff.drawIcon(this,n,r,t,e,i)}return{icon:i.svg,label:this.content,orientation:this.options.yAxisOrientation}},mf.prototype.getYRange=function(t){for(var e=t[0].y,i=t[0].y,n=0;n<t.length;n++)e=e>t[n].y?t[n].y:e,i=i<t[n].y?t[n].y:i;return{min:e,max:i,yAxisOrientation:this.options.yAxisOrientation}},gf.prototype=new Sl,gf.prototype.clear=function(){this.groups={},this.amountOfGroups=0},gf.prototype.addGroup=function(t,e){1!=e.options.excludeFromLegend&&(this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1)},gf.prototype.updateGroup=function(t,e){this.groups[t]=e},gf.prototype.removeGroup=function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)},gf.prototype._create=function(){this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-legend",this.dom.frame.style.position="absolute",this.dom.frame.style.top="10px",this.dom.frame.style.display="block",this.dom.textArea=document.createElement("div"),this.dom.textArea.className="vis-legend-text",this.dom.textArea.style.position="relative",this.dom.textArea.style.top="0px",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.width=this.options.iconSize+5+"px",this.svg.style.height="100%",this.dom.frame.appendChild(this.svg),this.dom.frame.appendChild(this.dom.textArea)},gf.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},gf.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},gf.prototype.setOptions=function(t){bh.selectiveDeepExtend(["enabled","orientation","icons","left","right"],this.options,t)},gf.prototype.redraw=function(){var t=0,e=Object.keys(this.groups);e.sort((function(t,e){return t<e?-1:1}));for(var i=0;i<e.length;i++){var n=e[i];1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||t++}if(0==this.options[this.side].visible||0==this.amountOfGroups||0==this.options.enabled||0==t)this.hide();else{if(this.show(),"top-left"==this.options[this.side].position||"bottom-left"==this.options[this.side].position?(this.dom.frame.style.left="4px",this.dom.frame.style.textAlign="left",this.dom.textArea.style.textAlign="left",this.dom.textArea.style.left=this.options.iconSize+15+"px",this.dom.textArea.style.right="",this.svg.style.left="0px",this.svg.style.right=""):(this.dom.frame.style.right="4px",this.dom.frame.style.textAlign="right",this.dom.textArea.style.textAlign="right",this.dom.textArea.style.right=this.options.iconSize+15+"px",this.dom.textArea.style.left="",this.svg.style.right="0px",this.svg.style.left=""),"top-left"==this.options[this.side].position||"top-right"==this.options[this.side].position)this.dom.frame.style.top=4-Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.bottom="";else{var r=this.body.domProps.center.height-this.body.domProps.centerContainer.height;this.dom.frame.style.bottom=4+r+Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.top=""}0==this.options.icons?(this.dom.frame.style.width=this.dom.textArea.offsetWidth+10+"px",this.dom.textArea.style.right="",this.dom.textArea.style.left="",this.svg.style.width="0px"):(this.dom.frame.style.width=this.options.iconSize+15+this.dom.textArea.offsetWidth+10+"px",this.drawLegendIcons());var o="";for(i=0;i<e.length;i++)n=e[i],1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||(o+=this.groups[n].content+"<br />");this.dom.textArea.innerHTML=o,this.dom.textArea.style.lineHeight=.75*this.options.iconSize+this.options.iconSpacing+"px"}},gf.prototype.drawLegendIcons=function(){if(this.dom.frame.parentNode){var t=Object.keys(this.groups);t.sort((function(t,e){return t<e?-1:1})),Dh(this.svgElements);var e=window.getComputedStyle(this.dom.frame).paddingTop,i=Number(e.replace("px","")),n=i,r=this.options.iconSize,o=.75*this.options.iconSize,s=i+.5*o+3;this.svg.style.width=r+5+i+"px";for(var a=0;a<t.length;a++){var h=t[a];1!=this.groups[h].visible||void 0!==this.linegraphOptions.visibility[h]&&1!=this.linegraphOptions.visibility[h]||(this.groups[h].getLegend(r,o,this.framework,n,s),s+=o+this.options.iconSpacing)}}};function vf(t,e){this.id=bh.randomUUID(),this.body=t,this.defaultOptions={yAxisOrientation:"left",defaultGroup:"default",sort:!0,sampling:!0,stack:!1,graphHeight:"400px",shaded:{enabled:!1,orientation:"bottom"},style:"line",barChart:{width:50,sideBySide:!1,align:"center"},interpolation:{enabled:!0,parametrization:"centripetal",alpha:.5},drawPoints:{enabled:!0,size:6,style:"square"},dataAxis:{},legend:{},groups:{visibility:{}}},this.options=bh.extend({},this.defaultOptions),this.dom={},this.props={},this.hammer=null,this.groups={},this.abortedGraphUpdate=!1,this.updateSVGheight=!1,this.updateSVGheightOnResize=!1,this.forceGraphUpdate=!0;var i=this;this.itemsData=null,this.groupsData=null,this.itemListeners={add:function(t,e,n){i._onAdd(e.items)},update:function(t,e,n){i._onUpdate(e.items)},remove:function(t,e,n){i._onRemove(e.items)}},this.groupListeners={add:function(t,e,n){i._onAddGroups(e.items)},update:function(t,e,n){i._onUpdateGroups(e.items)},remove:function(t,e,n){i._onRemoveGroups(e.items)}},this.items={},this.selection=[],this.lastStart=this.body.range.start,this.touchParams={},this.svgElements={},this.setOptions(e),this.groupsUsingDefaultStyles=[0],this.body.emitter.on("rangechanged",(function(){i.lastStart=i.body.range.start,i.svg.style.left=bh.option.asSize(-i.props.width),i.forceGraphUpdate=!0,i.redraw.call(i)})),this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups}}vf.prototype=new Sl,vf.prototype._create=function(){var t=document.createElement("div");t.className="vis-line-graph",this.dom.frame=t,this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="relative",this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",this.svg.style.display="block",t.appendChild(this.svg),this.options.dataAxis.orientation="left",this.yAxisLeft=new uf(this.body,this.options.dataAxis,this.svg,this.options.groups),this.options.dataAxis.orientation="right",this.yAxisRight=new uf(this.body,this.options.dataAxis,this.svg,this.options.groups),delete this.options.dataAxis.orientation,this.legendLeft=new gf(this.body,this.options.legend,"left",this.options.groups),this.legendRight=new gf(this.body,this.options.legend,"right",this.options.groups),this.show()},vf.prototype.setOptions=function(t){if(t){void 0===t.graphHeight&&void 0!==t.height?(this.updateSVGheight=!0,this.updateSVGheightOnResize=!0):void 0!==this.body.domProps.centerContainer.height&&void 0!==t.graphHeight&&parseInt((t.graphHeight+"").replace("px",""))<this.body.domProps.centerContainer.height&&(this.updateSVGheight=!0),bh.selectiveDeepExtend(["sampling","defaultGroup","stack","height","graphHeight","yAxisOrientation","style","barChart","dataAxis","sort","groups"],this.options,t),bh.mergeOptions(this.options,t,"interpolation"),bh.mergeOptions(this.options,t,"drawPoints"),bh.mergeOptions(this.options,t,"shaded"),bh.mergeOptions(this.options,t,"legend"),t.interpolation&&"object"==xa(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5)),this.yAxisLeft&&void 0!==t.dataAxis&&(this.yAxisLeft.setOptions(this.options.dataAxis),this.yAxisRight.setOptions(this.options.dataAxis)),this.legendLeft&&void 0!==t.legend&&(this.legendLeft.setOptions(this.options.legend),this.legendRight.setOptions(this.options.legend)),this.groups.hasOwnProperty("__ungrouped__")&&this.groups.__ungrouped__.setOptions(t)}this.dom.frame&&(this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0}))},vf.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},vf.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},vf.prototype.setItems=function(t){var e,i=this,n=this.itemsData;if(t){if(!(t instanceof bl||t instanceof wl))throw new TypeError("Data must be an instance of DataSet or DataView");this.itemsData=t}else this.itemsData=null;if(n&&(bh.forEach(this.itemListeners,(function(t,e){n.off(e,t)})),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;bh.forEach(this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e)}},vf.prototype.setGroups=function(t){var e,i=this;if(this.groupsData){bh.forEach(this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null;for(var n=0;n<e.length;n++)this._removeGroup(e[n])}if(t){if(!(t instanceof bl||t instanceof wl))throw new TypeError("Data must be an instance of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var r=this.id;bh.forEach(this.groupListeners,(function(t,e){i.groupsData.on(e,t,r)})),e=this.groupsData.getIds(),this._onAddGroups(e)}},vf.prototype._onUpdate=function(t){this._updateAllGroupData(t)},vf.prototype._onAdd=function(t){this._onUpdate(t)},vf.prototype._onRemove=function(t){this._onUpdate(t)},vf.prototype._onUpdateGroups=function(t){this._updateAllGroupData(null,t)},vf.prototype._onAddGroups=function(t){this._onUpdateGroups(t)},vf.prototype._onRemoveGroups=function(t){for(var e=0;e<t.length;e++)this._removeGroup(t[e]);this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})},vf.prototype._removeGroup=function(t){this.groups.hasOwnProperty(t)&&("right"==this.groups[t].options.yAxisOrientation?(this.yAxisRight.removeGroup(t),this.legendRight.removeGroup(t),this.legendRight.redraw()):(this.yAxisLeft.removeGroup(t),this.legendLeft.removeGroup(t),this.legendLeft.redraw()),delete this.groups[t])},vf.prototype._updateGroup=function(t,e){this.groups.hasOwnProperty(e)?(this.groups[e].update(t),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.updateGroup(e,this.groups[e]),this.legendRight.updateGroup(e,this.groups[e]),this.yAxisLeft.removeGroup(e),this.legendLeft.removeGroup(e)):(this.yAxisLeft.updateGroup(e,this.groups[e]),this.legendLeft.updateGroup(e,this.groups[e]),this.yAxisRight.removeGroup(e),this.legendRight.removeGroup(e))):(this.groups[e]=new mf(t,e,this.options,this.groupsUsingDefaultStyles),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.addGroup(e,this.groups[e]),this.legendRight.addGroup(e,this.groups[e])):(this.yAxisLeft.addGroup(e,this.groups[e]),this.legendLeft.addGroup(e,this.groups[e]))),this.legendLeft.redraw(),this.legendRight.redraw()},vf.prototype._updateAllGroupData=function(t,e){if(null!=this.itemsData){var i={},n=this.itemsData.get(),r=this.itemsData._idProp,o={};t&&t.map((function(t){o[t]=t}));for(var s={},a=0;a<n.length;a++){var h=n[a],l=h.group;null==l&&(l="__ungrouped__"),s.hasOwnProperty(l)?s[l]++:s[l]=1}var u={};if(!e&&t)for(l in this.groups)if(this.groups.hasOwnProperty(l)){var d=(m=this.groups[l]).getItems();i[l]=d.filter((function(t){return u[t[r]]=t[r],t[r]!==o[t[r]]}));var c=s[l];s[l]-=i[l].length,i[l].length<c&&(i[l][c-1]={})}for(a=0;a<n.length;a++)if(null==(l=(h=n[a]).group)&&(l="__ungrouped__"),e||!t||h[r]===o[h[r]]||!u.hasOwnProperty(h[r])){i.hasOwnProperty(l)||(i[l]=new Array(s[l]));var f=bh.bridgeObject(h);f.x=bh.convert(h.x,"Date"),f.end=bh.convert(h.end,"Date"),f.orginalY=h.y,f.y=Number(h.y),f[r]=h[r];var p=i[l].length-s[l]--;i[l][p]=f}for(l in this.groups)this.groups.hasOwnProperty(l)&&(i.hasOwnProperty(l)||(i[l]=new Array(0)));for(l in i)if(i.hasOwnProperty(l))if(0==i[l].length)this.groups.hasOwnProperty(l)&&this._removeGroup(l);else{var m=void 0;null!=this.groupsData&&(m=this.groupsData.get(l)),null==m&&(m={id:l,content:this.options.defaultGroup+l}),this._updateGroup(m,l),this.groups[l].setItems(i[l])}this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})}},vf.prototype.redraw=function(){var t=!1;this.props.width=this.dom.frame.offsetWidth,this.props.height=this.body.domProps.centerContainer.height-this.body.domProps.border.top-this.body.domProps.border.bottom,t=this._isResized()||t;var e=this.body.range.end-this.body.range.start,i=e!=this.lastVisibleInterval;if(this.lastVisibleInterval=e,1==t&&(this.svg.style.width=bh.option.asSize(3*this.props.width),this.svg.style.left=bh.option.asSize(-this.props.width),-1==(this.options.height+"").indexOf("%")&&1!=this.updateSVGheightOnResize||(this.updateSVGheight=!0)),1==this.updateSVGheight?(this.options.graphHeight!=this.props.height+"px"&&(this.options.graphHeight=this.props.height+"px",this.svg.style.height=this.props.height+"px"),this.updateSVGheight=!1):this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",1==t||1==i||1==this.abortedGraphUpdate||1==this.forceGraphUpdate)t=this._updateGraph()||t,this.forceGraphUpdate=!1;else if(0!=this.lastStart){var n=this.body.range.start-this.lastStart,r=this.body.range.end-this.body.range.start;if(0!=this.props.width){var o=n*(this.props.width/r);this.svg.style.left=-this.props.width-o+"px"}}return this.legendLeft.redraw(),this.legendRight.redraw(),t},vf.prototype._getSortedGroupIds=function(){var t=[];for(var e in this.groups)if(this.groups.hasOwnProperty(e)){var i=this.groups[e];1!=i.visible||void 0!==this.options.groups.visibility[e]&&1!=this.options.groups.visibility[e]||t.push({id:e,zIndex:i.options.zIndex})}bh.insertSort(t,(function(t,e){var i=t.zIndex,n=e.zIndex;return void 0===i&&(i=0),void 0===n&&(n=0),i==n?0:i<n?-1:1}));for(var n=new Array(t.length),r=0;r<t.length;r++)n[r]=t[r].id;return n},vf.prototype._updateGraph=function(){if(wh(this.svgElements),0!=this.props.width&&null!=this.itemsData){var t,e,i={},n=this.body.util.toGlobalTime(-this.body.domProps.root.width),r=this.body.util.toGlobalTime(2*this.body.domProps.root.width),o=this._getSortedGroupIds();if(o.length>0){var s={};for(this._getRelevantData(o,s,n,r),this._applySampling(o,s),e=0;e<o.length;e++)this._convertXcoordinates(s[o[e]]);if(this._getYRanges(o,s,i),1==this._updateYAxis(o,i))return kh(this.svgElements),this.abortedGraphUpdate=!0,!0;this.abortedGraphUpdate=!1;var a=void 0;for(e=0;e<o.length;e++)t=this.groups[o[e]],!0===this.options.stack&&"line"===this.options.style&&(null!=t.options.excludeFromStacking&&t.options.excludeFromStacking||(null!=a&&(this._stack(s[t.id],s[a.id]),1==t.options.shaded.enabled&&"group"!==t.options.shaded.orientation&&("top"==t.options.shaded.orientation&&"group"!==a.options.shaded.orientation?(a.options.shaded.orientation="group",a.options.shaded.groupId=t.id):(t.options.shaded.orientation="group",t.options.shaded.groupId=a.id))),a=t)),this._convertYcoordinates(s[o[e]],t);var h={};for(e=0;e<o.length;e++)if("line"===(t=this.groups[o[e]]).options.style&&1==t.options.shaded.enabled){var l=s[o[e]];if(null==l||0==l.length)continue;if(h.hasOwnProperty(o[e])||(h[o[e]]=pf.calcPath(l,t)),"group"===t.options.shaded.orientation){var u=t.options.shaded.groupId;if(-1===o.indexOf(u)){console.log(t.id+": Unknown shading group target given:"+u);continue}h.hasOwnProperty(u)||(h[u]=pf.calcPath(s[u],this.groups[u])),pf.drawShading(h[o[e]],t,h[u],this.framework)}else pf.drawShading(h[o[e]],t,void 0,this.framework)}for(ff.draw(o,s,this.framework),e=0;e<o.length;e++)if(t=this.groups[o[e]],s[o[e]].length>0)switch(t.options.style){case"line":h.hasOwnProperty(o[e])||(h[o[e]]=pf.calcPath(s[o[e]],t)),pf.draw(h[o[e]],t,this.framework);case"point":case"points":"point"!=t.options.style&&"points"!=t.options.style&&1!=t.options.drawPoints.enabled||df.draw(s[o[e]],t,this.framework)}}}return kh(this.svgElements),!1},vf.prototype._stack=function(t,e){var i,n,r,o,s;i=0;for(var a=0;a<t.length;a++){o=void 0,s=void 0;for(var h=i;h<e.length;h++){if(e[h].x===t[a].x){o=e[h],s=e[h],i=h;break}if(e[h].x>t[a].x){s=e[h],o=0==h?s:e[h-1],i=h;break}}void 0===s&&(o=e[e.length-1],s=e[e.length-1]),n=s.x-o.x,r=s.y-o.y,t[a].y=0==n?t[a].orginalY+s.y:t[a].orginalY+r/n*(t[a].x-o.x)+o.y}},vf.prototype._getRelevantData=function(t,e,i,n){var r,o,s,a;if(t.length>0)for(o=0;o<t.length;o++){var h=(r=this.groups[t[o]]).getItems();if(1==r.options.sort){var l=function(t,e){return t.getTime()==e.getTime()?0:t<e?-1:1},u=Math.max(0,bh.binarySearchValue(h,i,"x","before",l)),d=Math.min(h.length,bh.binarySearchValue(h,n,"x","after",l)+1);d<=0&&(d=h.length);var c=new Array(d-u);for(s=u;s<d;s++)a=r.itemsData[s],c[s-u]=a;e[t[o]]=c}else e[t[o]]=r.itemsData}},vf.prototype._applySampling=function(t,e){if(t.length>0)for(var i=0;i<t.length;i++)if(1==this.groups[t[i]].options.sampling){var n=e[t[i]];if(n.length>0){var r,o=n.length,s=o/(this.body.util.toGlobalScreen(n[n.length-1].x)-this.body.util.toGlobalScreen(n[0].x));r=Math.min(Math.ceil(.2*o),Math.max(1,Math.round(s)));for(var a=new Array(o),h=0;h<o;h+=r){a[Math.round(h/r)]=n[h]}e[t[i]]=a.splice(0,Math.round(o/r))}}},vf.prototype._getYRanges=function(t,e,i){var n,r,o,s,a=[],h=[];if(t.length>0){for(o=0;o<t.length;o++)n=e[t[o]],s=this.groups[t[o]].options,n.length>0&&(r=this.groups[t[o]],!0===s.stack&&"bar"===s.style?"left"===s.yAxisOrientation?a=a.concat(n):h=h.concat(n):i[t[o]]=r.getYRange(n,t[o]));ff.getStackedYRange(a,i,t,"__barStackLeft","left"),ff.getStackedYRange(h,i,t,"__barStackRight","right")}},vf.prototype._updateYAxis=function(t,e){var i,n,r=!1,o=!1,s=!1,a=1e9,h=1e9,l=-1e9,u=-1e9;if(t.length>0){for(var d=0;d<t.length;d++){var c=this.groups[t[d]];c&&"right"!=c.options.yAxisOrientation?(o=!0,a=1e9,l=-1e9):c&&c.options.yAxisOrientation&&(s=!0,h=1e9,u=-1e9)}for(d=0;d<t.length;d++)e.hasOwnProperty(t[d])&&!0!==e[t[d]].ignore&&(i=e[t[d]].min,n=e[t[d]].max,"right"!=e[t[d]].yAxisOrientation?(o=!0,a=a>i?i:a,l=l<n?n:l):(s=!0,h=h>i?i:h,u=u<n?n:u));1==o&&this.yAxisLeft.setRange(a,l),1==s&&this.yAxisRight.setRange(h,u)}r=this._toggleAxisVisiblity(o,this.yAxisLeft)||r,r=this._toggleAxisVisiblity(s,this.yAxisRight)||r,1==s&&1==o?(this.yAxisLeft.drawIcons=!0,this.yAxisRight.drawIcons=!0):(this.yAxisLeft.drawIcons=!1,this.yAxisRight.drawIcons=!1),this.yAxisRight.master=!o,this.yAxisRight.masterAxis=this.yAxisLeft,0==this.yAxisRight.master?(this.yAxisLeft.lineOffset=1==s?this.yAxisRight.width:0,r=this.yAxisLeft.redraw()||r,r=this.yAxisRight.redraw()||r):r=this.yAxisRight.redraw()||r;var f=["__barStackLeft","__barStackRight","__lineStackLeft","__lineStackRight"];for(d=0;d<f.length;d++)-1!=t.indexOf(f[d])&&t.splice(t.indexOf(f[d]),1);return r},vf.prototype._toggleAxisVisiblity=function(t,e){var i=!1;return 0==t?e.dom.frame.parentNode&&0==e.hidden&&(e.hide(),i=!0):e.dom.frame.parentNode||1!=e.hidden||(e.show(),i=!0),i},vf.prototype._convertXcoordinates=function(t){for(var e=this.body.util.toScreen,i=0;i<t.length;i++)t[i].screen_x=e(t[i].x)+this.props.width,t[i].screen_y=t[i].y,null!=t[i].end?t[i].screen_end=e(t[i].end)+this.props.width:t[i].screen_end=void 0},vf.prototype._convertYcoordinates=function(t,e){var i=this.yAxisLeft,n=Number(this.svg.style.height.replace("px",""));"right"==e.options.yAxisOrientation&&(i=this.yAxisRight);for(var r=0;r<t.length;r++)t[r].screen_y=Math.round(i.convertValue(t[r].y));e.setZeroPosition(Math.min(n,i.convertValue(0)))};var yf="boolean",_f={configure:{enabled:{boolean:yf},filter:{boolean:yf,function:"function"},container:{dom:"dom"},__type__:{object:"object",boolean:yf,function:"function"}},alignCurrentTime:{string:"string",undefined:"undefined"},yAxisOrientation:{string:["left","right"]},defaultGroup:{string:"string"},sort:{boolean:yf},sampling:{boolean:yf},stack:{boolean:yf},graphHeight:{string:"string",number:"number"},shaded:{enabled:{boolean:yf},orientation:{string:["bottom","top","zero","group"]},groupId:{object:"object"},__type__:{boolean:yf,object:"object"}},style:{string:["line","bar","points"]},barChart:{width:{number:"number"},minWidth:{number:"number"},sideBySide:{boolean:yf},align:{string:["left","center","right"]},__type__:{object:"object"}},interpolation:{enabled:{boolean:yf},parametrization:{string:["centripetal","chordal","uniform"]},alpha:{number:"number"},__type__:{object:"object",boolean:yf}},drawPoints:{enabled:{boolean:yf},onRender:{function:"function"},size:{number:"number"},style:{string:["square","circle"]},__type__:{object:"object",boolean:yf,function:"function"}},dataAxis:{showMinorLabels:{boolean:yf},showMajorLabels:{boolean:yf},icons:{boolean:yf},width:{string:"string",number:"number"},visible:{boolean:yf},alignZeros:{boolean:yf},left:{range:{min:{number:"number",undefined:"undefined"},max:{number:"number",undefined:"undefined"},__type__:{object:"object"}},format:{function:"function"},title:{text:{string:"string",number:"number",undefined:"undefined"},style:{string:"string",undefined:"undefined"},__type__:{object:"object"}},__type__:{object:"object"}},right:{range:{min:{number:"number",undefined:"undefined"},max:{number:"number",undefined:"undefined"},__type__:{object:"object"}},format:{function:"function"},title:{text:{string:"string",number:"number",undefined:"undefined"},style:{string:"string",undefined:"undefined"},__type__:{object:"object"}},__type__:{object:"object"}},__type__:{object:"object"}},legend:{enabled:{boolean:yf},icons:{boolean:yf},left:{visible:{boolean:yf},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:"object"}},right:{visible:{boolean:yf},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:"object"}},__type__:{object:"object",boolean:yf}},groups:{visibility:{any:"any"},__type__:{object:"object"}},autoResize:{boolean:yf},throttleRedraw:{number:"number"},clickToUse:{boolean:yf},end:{number:"number",date:"date",string:"string",moment:"moment"},format:{minorLabels:{millisecond:{string:"string",undefined:"undefined"},second:{string:"string",undefined:"undefined"},minute:{string:"string",undefined:"undefined"},hour:{string:"string",undefined:"undefined"},weekday:{string:"string",undefined:"undefined"},day:{string:"string",undefined:"undefined"},month:{string:"string",undefined:"undefined"},quarter:{string:"string",undefined:"undefined"},year:{string:"string",undefined:"undefined"},__type__:{object:"object"}},majorLabels:{millisecond:{string:"string",undefined:"undefined"},second:{string:"string",undefined:"undefined"},minute:{string:"string",undefined:"undefined"},hour:{string:"string",undefined:"undefined"},weekday:{string:"string",undefined:"undefined"},day:{string:"string",undefined:"undefined"},month:{string:"string",undefined:"undefined"},quarter:{string:"string",undefined:"undefined"},year:{string:"string",undefined:"undefined"},__type__:{object:"object"}},__type__:{object:"object"}},moment:{function:"function"},height:{string:"string",number:"number"},hiddenDates:{start:{date:"date",number:"number",string:"string",moment:"moment"},end:{date:"date",number:"number",string:"string",moment:"moment"},repeat:{string:"string"},__type__:{object:"object",array:"array"}},locale:{string:"string"},locales:{__any__:{any:"any"},__type__:{object:"object"}},max:{date:"date",number:"number",string:"string",moment:"moment"},maxHeight:{number:"number",string:"string"},maxMinorChars:{number:"number"},min:{date:"date",number:"number",string:"string",moment:"moment"},minHeight:{number:"number",string:"string"},moveable:{boolean:yf},multiselect:{boolean:yf},orientation:{string:"string"},showCurrentTime:{boolean:yf},showMajorLabels:{boolean:yf},showMinorLabels:{boolean:yf},start:{date:"date",number:"number",string:"string",moment:"moment"},timeAxis:{scale:{string:"string",undefined:"undefined"},step:{number:"number",undefined:"undefined"},__type__:{object:"object"}},width:{string:"string",number:"number"},zoomable:{boolean:yf},zoomKey:{string:["ctrlKey","altKey","metaKey",""]},zoomMax:{number:"number"},zoomMin:{number:"number"},zIndex:{number:"number"},__type__:{object:"object"}},bf={global:{alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],sort:!0,sampling:!0,stack:!1,shaded:{enabled:!1,orientation:["zero","top","bottom","group"]},style:["line","bar","points"],barChart:{width:[50,5,100,5],minWidth:[50,5,100,5],sideBySide:!1,align:["left","center","right"]},interpolation:{enabled:!0,parametrization:["centripetal","chordal","uniform"]},drawPoints:{enabled:!0,size:[6,2,30,1],style:["square","circle"]},dataAxis:{showMinorLabels:!0,showMajorLabels:!0,icons:!1,width:[40,0,200,1],visible:!0,alignZeros:!0,left:{title:{text:"",style:""}},right:{title:{text:"",style:""}}},legend:{enabled:!1,icons:!0,left:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]},right:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]}},autoResize:!0,clickToUse:!1,end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",month:"MMM",quarter:"[Q]Q",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",month:"YYYY",quarter:"YYYY",year:""}},height:"",locale:"",max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!0,orientation:["both","bottom","top"],showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,start:"",width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],zIndex:0}};function wf(t,e,i,n){if(!(Array.isArray(i)||i instanceof bl||i instanceof wl)&&i instanceof Object){var r=n;n=i,i=r}n&&n.throttleRedraw&&console.warn('Graph2d option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var o=this;this.defaultOptions={start:null,end:null,autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:Dl,width:null,height:null,maxHeight:null,minHeight:null},this.options=bh.deepExtend({},this.defaultOptions),this._create(t),this.components=[],this.body={dom:this.dom,domProps:this.props,emitter:{on:this.on.bind(this),off:this.off.bind(this),emit:this.emit.bind(this)},hiddenDates:[],util:{toScreen:o._toScreen.bind(o),toGlobalScreen:o._toGlobalScreen.bind(o),toTime:o._toTime.bind(o),toGlobalTime:o._toGlobalTime.bind(o)}},this.range=new Fl(this.body),this.components.push(this.range),this.body.range=this.range,this.timeAxis=new Qd(this.body),this.components.push(this.timeAxis),this.currentTime=new sc(this.body),this.components.push(this.currentTime),this.linegraph=new vf(this.body),this.components.push(this.linegraph),this.itemsData=null,this.groupsData=null,this.on("tap",(function(t){o.emit("click",o.getEventProperties(t))})),this.on("doubletap",(function(t){o.emit("doubleClick",o.getEventProperties(t))})),this.dom.root.oncontextmenu=function(t){o.emit("contextmenu",o.getEventProperties(t))},this.initialFitDone=!1,this.on("changed",(function(){if(null!=o.itemsData){if(!o.initialFitDone&&!o.options.rollingMode)if(o.initialFitDone=!0,null!=o.options.start||null!=o.options.end){if(null==o.options.start||null==o.options.end)var t=o.getItemRange();var e=null!=o.options.start?o.options.start:t.min,i=null!=o.options.end?o.options.end:t.max;o.setWindow(e,i,{animation:!1})}else o.fit({animation:!1});o.initialDrawDone||!o.initialRangeChangeDone&&(o.options.start||o.options.end)&&!o.options.rollingMode||(o.initialDrawDone=!0,o.dom.root.style.visibility="visible",o.dom.loadingScreen.parentNode.removeChild(o.dom.loadingScreen),o.options.onInitialDrawComplete&&setTimeout((function(){return o.options.onInitialDrawComplete()}),0))}})),n&&this.setOptions(n),i&&this.setGroups(i),e&&this.setItems(e),this._redraw()}wf.prototype=new oc,wf.prototype.setOptions=function(t){!0===Bc.validate(t,_f)&&console.log("%cErrors have been found in the supplied options object.",Vc),oc.prototype.setOptions.call(this,t)},wf.prototype.setItems=function(t){var e,i=null==this.itemsData;if(e=t?t instanceof bl||t instanceof wl?t:new bl(t,{type:{start:"Date",end:"Date"}}):null,this.itemsData=e,this.linegraph&&this.linegraph.setItems(e),i)if(null!=this.options.start||null!=this.options.end){var n=null!=this.options.start?this.options.start:null,r=null!=this.options.end?this.options.end:null;this.setWindow(n,r,{animation:!1})}else this.fit({animation:!1})},wf.prototype.setGroups=function(t){var e;e=t?t instanceof bl||t instanceof wl?t:new bl(t):null,this.groupsData=e,this.linegraph.setGroups(e)},wf.prototype.getLegend=function(t,e,i){return void 0===e&&(e=15),void 0===i&&(i=15),void 0!==this.linegraph.groups[t]?this.linegraph.groups[t].getLegend(e,i):"cannot find group:'"+t+"'"},wf.prototype.isGroupVisible=function(t){return void 0!==this.linegraph.groups[t]&&(this.linegraph.groups[t].visible&&(void 0===this.linegraph.options.groups.visibility[t]||1==this.linegraph.options.groups.visibility[t]))},wf.prototype.getDataRange=function(){var t=null,e=null;for(var i in this.linegraph.groups)if(this.linegraph.groups.hasOwnProperty(i)&&1==this.linegraph.groups[i].visible)for(var n=0;n<this.linegraph.groups[i].itemsData.length;n++){var r=this.linegraph.groups[i].itemsData[n],o=bh.convert(r.x,"Date").valueOf();t=null==t?o:t>o?o:t,e=null==e?o:e<o?o:e}return{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}},wf.prototype.getEventProperties=function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=e-bh.getAbsoluteLeft(this.dom.centerContainer),r=i-bh.getAbsoluteTop(this.dom.centerContainer),o=this._toTime(n),s=rc.customTimeFromTarget(t),a=bh.getTarget(t),h=null;bh.hasParent(a,this.timeAxis.dom.foreground)?h="axis":this.timeAxis2&&bh.hasParent(a,this.timeAxis2.dom.foreground)?h="axis":bh.hasParent(a,this.linegraph.yAxisLeft.dom.frame)?h="data-axis":bh.hasParent(a,this.linegraph.yAxisRight.dom.frame)?h="data-axis":bh.hasParent(a,this.linegraph.legendLeft.dom.frame)?h="legend":bh.hasParent(a,this.linegraph.legendRight.dom.frame)?h="legend":null!=s?h="custom-time":bh.hasParent(a,this.currentTime.bar)?h="current-time":bh.hasParent(a,this.dom.center)&&(h="background");var l=[],u=this.linegraph.yAxisLeft,d=this.linegraph.yAxisRight;return!u.hidden&&this.itemsData.length>0&&l.push(u.screenToValue(r)),!d.hidden&&this.itemsData.length>0&&l.push(d.screenToValue(r)),{event:t,customTime:s?s.options.id:null,what:h,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:n,y:r,time:o,value:l}},wf.prototype._createConfigurator=function(){return new ef(this,this.dom.container,bf)},Dl.locale("en");var kf={Core:oc,DateUtil:jl,Range:Fl,stack:Tc,TimeStep:Kd,components:{items:{Item:Yc,BackgroundItem:Lc,BoxItem:Pc,PointItem:Ic,RangeItem:Ac},BackgroundGroup:Ec,Component:Sl,CurrentTime:sc,CustomTime:rc,DataAxis:uf,DataScale:lf,GraphGroup:mf,Group:Cc,ItemSet:Gc,Legend:gf,LineGraph:vf,TimeAxis:Qd}},Df={util:bh,DOMutil:Oh,DataSet:bl,DataView:wl,Queue:fl,Timeline:nf,Graph2d:wf,timeline:kf,moment:Dl,Hammer:$d,keycharm:ec};t.DOMutil=Oh,t.DataSet=bl,t.DataView=wl,t.Graph2d=wf,t.Hammer=$d,t.Queue=fl,t.Timeline=nf,t.default=Df,t.keycharm=ec,t.moment=Dl,t.timeline=kf,t.util=bh,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-timeline-graph2d.min.js.map
